/* boni.c generated by valac 0.56.16, the Vala compiler
 * generated from boni.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Coding style.
 *
 * To help you comply with the coding style in this project use the
 * following greps. Any lines returned should be adjusted so they
 * don't match. The convoluted regular expressions are so they don't 
 * match them self.
 *
 * grep -ne '[^][)(_!$ "](' *.vala
 * grep -ne '[(] ' *.vala
 * grep -ne '[ ])' *.vala
 *
 */

#include <glib-object.h>
#include <glib.h>
#include <gee.h>

#define BONI_MAX_BONUSES ((guint8) 100)
#define BONI_MAX_MISSED ((guint8) 2)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;
typedef struct _BonusPrivate BonusPrivate;
enum  {
	BONUS_0_PROPERTY,
	BONUS_X_PROPERTY,
	BONUS_Y_PROPERTY,
	BONUS_BONUS_TYPE_PROPERTY,
	BONUS_FAKE_PROPERTY,
	BONUS_COUNTDOWN_PROPERTY,
	BONUS_NUM_PROPERTIES
};
static GParamSpec* bonus_properties[BONUS_NUM_PROPERTIES];

#define TYPE_BONI (boni_get_type ())
#define BONI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONI, Boni))
#define BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONI, BoniClass))
#define IS_BONI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONI))
#define IS_BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONI))
#define BONI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONI, BoniClass))

typedef struct _Boni Boni;
typedef struct _BoniClass BoniClass;
typedef struct _BoniPrivate BoniPrivate;
enum  {
	BONI_0_PROPERTY,
	BONI_NUM_PROPERTIES
};
static GParamSpec* boni_properties[BONI_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	BONI_BONUS_REMOVED_SIGNAL,
	BONI_NUM_SIGNALS
};
static guint boni_signals[BONI_NUM_SIGNALS] = {0};

struct _Bonus {
	GObject parent_instance;
	BonusPrivate * priv;
};

struct _BonusClass {
	GObjectClass parent_class;
};

struct _BonusPrivate {
	guint8 _x;
	guint8 _y;
	BonusType _bonus_type;
	gboolean _fake;
	guint16 _countdown;
};

struct _Boni {
	GObject parent_instance;
	BoniPrivate * priv;
};

struct _BoniClass {
	GObjectClass parent_class;
};

struct _BoniPrivate {
	GeeLinkedList* bonuses;
	guint8 regular_bonus_left;
	guint8 regular_bonus_maxi;
	guint8 total_bonus_number;
	guint8 missed;
};

static gint Bonus_private_offset;
static gpointer bonus_parent_class = NULL;
static gint Boni_private_offset;
static gpointer boni_parent_class = NULL;

VALA_EXTERN GType bonus_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType bonus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bonus, g_object_unref)
VALA_EXTERN Bonus* bonus_new (guint8 x,
                  guint8 y,
                  BonusType bonus_type,
                  gboolean fake,
                  guint16 countdown);
VALA_EXTERN Bonus* bonus_construct (GType object_type,
                        guint8 x,
                        guint8 y,
                        BonusType bonus_type,
                        gboolean fake,
                        guint16 countdown);
VALA_EXTERN guint8 bonus_get_x (Bonus* self);
static void bonus_set_x (Bonus* self,
                  guint8 value);
VALA_EXTERN guint8 bonus_get_y (Bonus* self);
static void bonus_set_y (Bonus* self,
                  guint8 value);
VALA_EXTERN BonusType bonus_get_bonus_type (Bonus* self);
static void bonus_set_bonus_type (Bonus* self,
                           BonusType value);
VALA_EXTERN gboolean bonus_get_fake (Bonus* self);
static void bonus_set_fake (Bonus* self,
                     gboolean value);
VALA_EXTERN guint16 bonus_get_countdown (Bonus* self);
VALA_EXTERN void bonus_set_countdown (Bonus* self,
                          guint16 value);
static void bonus_finalize (GObject * obj);
static GType bonus_get_type_once (void);
static void _vala_bonus_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_bonus_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
VALA_EXTERN GType boni_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Boni, g_object_unref)
VALA_EXTERN gboolean boni_add_bonus (Boni* self,
                         Bonus* bonus);
VALA_EXTERN void boni_remove_bonus (Boni* self,
                        Bonus* bonus);
VALA_EXTERN void boni_reset (Boni* self,
                 guint8 regular_bonus);
static inline void boni_reset_missed (Boni* self);
VALA_EXTERN Bonus* boni_get_bonus (Boni* self,
                       guint8 x,
                       guint8 y);
VALA_EXTERN GeeList* boni_get_bonuses (Boni* self);
VALA_EXTERN void boni_on_worms_move (Boni* self,
                         guint8* missed_bonuses_to_replace);
static inline void boni_increase_missed (Boni* self);
VALA_EXTERN guint8 boni_new_regular_bonus_eaten (Boni* self);
VALA_EXTERN gboolean boni_last_regular_bonus (Boni* self);
VALA_EXTERN gboolean boni_too_many_missed (Boni* self);
VALA_EXTERN Boni* boni_new (void);
VALA_EXTERN Boni* boni_construct (GType object_type);
static void boni_finalize (GObject * obj);
static GType boni_get_type_once (void);

 G_GNUC_NO_INLINE static GType
bonus_type_get_type_once (void)
{
	static const GEnumValue values[] = {{BONUS_TYPE_REGULAR, "BONUS_TYPE_REGULAR", "regular"}, {BONUS_TYPE_HALF, "BONUS_TYPE_HALF", "half"}, {BONUS_TYPE_DOUBLE, "BONUS_TYPE_DOUBLE", "double"}, {BONUS_TYPE_LIFE, "BONUS_TYPE_LIFE", "life"}, {BONUS_TYPE_REVERSE, "BONUS_TYPE_REVERSE", "reverse"}, {BONUS_TYPE_WARP, "BONUS_TYPE_WARP", "warp"}, {0, NULL, NULL}};
	GType bonus_type_type_id;
	bonus_type_type_id = g_enum_register_static ("BonusType", values);
	return bonus_type_type_id;
}

GType
bonus_type_get_type (void)
{
	static gsize bonus_type_type_id__once = 0;
	if (g_once_init_enter (&bonus_type_type_id__once)) {
		GType bonus_type_type_id;
		bonus_type_type_id = bonus_type_get_type_once ();
		g_once_init_leave (&bonus_type_type_id__once, bonus_type_type_id);
	}
	return bonus_type_type_id__once;
}

static inline gpointer
bonus_get_instance_private (Bonus* self)
{
	return G_STRUCT_MEMBER_P (self, Bonus_private_offset);
}

Bonus*
bonus_construct (GType object_type,
                 guint8 x,
                 guint8 y,
                 BonusType bonus_type,
                 gboolean fake,
                 guint16 countdown)
{
	Bonus * self = NULL;
#line 54 "../src/boni.vala"
	self = (Bonus*) g_object_new (object_type, "x", x, "y", y, "bonus-type", bonus_type, "fake", fake, "countdown", countdown, NULL);
#line 52 "../src/boni.vala"
	return self;
#line 256 "boni.c"
}

Bonus*
bonus_new (guint8 x,
           guint8 y,
           BonusType bonus_type,
           gboolean fake,
           guint16 countdown)
{
#line 52 "../src/boni.vala"
	return bonus_construct (TYPE_BONUS, x, y, bonus_type, fake, countdown);
#line 268 "boni.c"
}

guint8
bonus_get_x (Bonus* self)
{
	guint8 result;
#line 45 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 45 "../src/boni.vala"
	result = self->priv->_x;
#line 45 "../src/boni.vala"
	return result;
#line 281 "boni.c"
}

static void
bonus_set_x (Bonus* self,
             guint8 value)
{
	guint8 old_value;
#line 45 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/boni.vala"
	old_value = bonus_get_x (self);
#line 45 "../src/boni.vala"
	if (old_value != value) {
#line 45 "../src/boni.vala"
		self->priv->_x = value;
#line 45 "../src/boni.vala"
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_X_PROPERTY]);
#line 299 "boni.c"
	}
}

guint8
bonus_get_y (Bonus* self)
{
	guint8 result;
#line 46 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 46 "../src/boni.vala"
	result = self->priv->_y;
#line 46 "../src/boni.vala"
	return result;
#line 313 "boni.c"
}

static void
bonus_set_y (Bonus* self,
             guint8 value)
{
	guint8 old_value;
#line 46 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/boni.vala"
	old_value = bonus_get_y (self);
#line 46 "../src/boni.vala"
	if (old_value != value) {
#line 46 "../src/boni.vala"
		self->priv->_y = value;
#line 46 "../src/boni.vala"
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_Y_PROPERTY]);
#line 331 "boni.c"
	}
}

BonusType
bonus_get_bonus_type (Bonus* self)
{
	BonusType result;
#line 47 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../src/boni.vala"
	result = self->priv->_bonus_type;
#line 47 "../src/boni.vala"
	return result;
#line 345 "boni.c"
}

static void
bonus_set_bonus_type (Bonus* self,
                      BonusType value)
{
	BonusType old_value;
#line 47 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/boni.vala"
	old_value = bonus_get_bonus_type (self);
#line 47 "../src/boni.vala"
	if (old_value != value) {
#line 47 "../src/boni.vala"
		self->priv->_bonus_type = value;
#line 47 "../src/boni.vala"
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_BONUS_TYPE_PROPERTY]);
#line 363 "boni.c"
	}
}

gboolean
bonus_get_fake (Bonus* self)
{
	gboolean result;
#line 48 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/boni.vala"
	result = self->priv->_fake;
#line 48 "../src/boni.vala"
	return result;
#line 377 "boni.c"
}

static void
bonus_set_fake (Bonus* self,
                gboolean value)
{
	gboolean old_value;
#line 48 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/boni.vala"
	old_value = bonus_get_fake (self);
#line 48 "../src/boni.vala"
	if (old_value != value) {
#line 48 "../src/boni.vala"
		self->priv->_fake = value;
#line 48 "../src/boni.vala"
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_FAKE_PROPERTY]);
#line 395 "boni.c"
	}
}

guint16
bonus_get_countdown (Bonus* self)
{
	guint16 result;
#line 50 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 50 "../src/boni.vala"
	result = self->priv->_countdown;
#line 50 "../src/boni.vala"
	return result;
#line 409 "boni.c"
}

void
bonus_set_countdown (Bonus* self,
                     guint16 value)
{
	guint16 old_value;
#line 50 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/boni.vala"
	old_value = bonus_get_countdown (self);
#line 50 "../src/boni.vala"
	if (old_value != value) {
#line 50 "../src/boni.vala"
		self->priv->_countdown = value;
#line 50 "../src/boni.vala"
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_COUNTDOWN_PROPERTY]);
#line 427 "boni.c"
	}
}

static void
bonus_class_init (BonusClass * klass,
                  gpointer klass_data)
{
#line 43 "../src/boni.vala"
	bonus_parent_class = g_type_class_peek_parent (klass);
#line 43 "../src/boni.vala"
	g_type_class_adjust_private_offset (klass, &Bonus_private_offset);
#line 43 "../src/boni.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bonus_get_property;
#line 43 "../src/boni.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bonus_set_property;
#line 43 "../src/boni.vala"
	G_OBJECT_CLASS (klass)->finalize = bonus_finalize;
#line 43 "../src/boni.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_X_PROPERTY, bonus_properties[BONUS_X_PROPERTY] = g_param_spec_uchar ("x", "x", "x", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 43 "../src/boni.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_Y_PROPERTY, bonus_properties[BONUS_Y_PROPERTY] = g_param_spec_uchar ("y", "y", "y", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 43 "../src/boni.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_BONUS_TYPE_PROPERTY, bonus_properties[BONUS_BONUS_TYPE_PROPERTY] = g_param_spec_enum ("bonus-type", "bonus-type", "bonus-type", TYPE_BONUS_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 43 "../src/boni.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_FAKE_PROPERTY, bonus_properties[BONUS_FAKE_PROPERTY] = g_param_spec_boolean ("fake", "fake", "fake", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 43 "../src/boni.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_COUNTDOWN_PROPERTY, bonus_properties[BONUS_COUNTDOWN_PROPERTY] = g_param_spec_uint ("countdown", "countdown", "countdown", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 455 "boni.c"
}

static void
bonus_instance_init (Bonus * self,
                     gpointer klass)
{
#line 43 "../src/boni.vala"
	self->priv = bonus_get_instance_private (self);
#line 464 "boni.c"
}

static void
bonus_finalize (GObject * obj)
{
	Bonus * self;
#line 43 "../src/boni.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BONUS, Bonus);
#line 43 "../src/boni.vala"
	G_OBJECT_CLASS (bonus_parent_class)->finalize (obj);
#line 475 "boni.c"
}

 G_GNUC_NO_INLINE static GType
bonus_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BonusClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bonus_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bonus), 0, (GInstanceInitFunc) bonus_instance_init, NULL };
	GType bonus_type_id;
	bonus_type_id = g_type_register_static (G_TYPE_OBJECT, "Bonus", &g_define_type_info, 0);
	Bonus_private_offset = g_type_add_instance_private (bonus_type_id, sizeof (BonusPrivate));
	return bonus_type_id;
}

GType
bonus_get_type (void)
{
	static gsize bonus_type_id__once = 0;
	if (g_once_init_enter (&bonus_type_id__once)) {
		GType bonus_type_id;
		bonus_type_id = bonus_get_type_once ();
		g_once_init_leave (&bonus_type_id__once, bonus_type_id);
	}
	return bonus_type_id__once;
}

static void
_vala_bonus_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Bonus * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BONUS, Bonus);
#line 43 "../src/boni.vala"
	switch (property_id) {
#line 43 "../src/boni.vala"
		case BONUS_X_PROPERTY:
#line 43 "../src/boni.vala"
		g_value_set_uchar (value, bonus_get_x (self));
#line 43 "../src/boni.vala"
		break;
#line 43 "../src/boni.vala"
		case BONUS_Y_PROPERTY:
#line 43 "../src/boni.vala"
		g_value_set_uchar (value, bonus_get_y (self));
#line 43 "../src/boni.vala"
		break;
#line 43 "../src/boni.vala"
		case BONUS_BONUS_TYPE_PROPERTY:
#line 43 "../src/boni.vala"
		g_value_set_enum (value, bonus_get_bonus_type (self));
#line 43 "../src/boni.vala"
		break;
#line 43 "../src/boni.vala"
		case BONUS_FAKE_PROPERTY:
#line 43 "../src/boni.vala"
		g_value_set_boolean (value, bonus_get_fake (self));
#line 43 "../src/boni.vala"
		break;
#line 43 "../src/boni.vala"
		case BONUS_COUNTDOWN_PROPERTY:
#line 43 "../src/boni.vala"
		g_value_set_uint (value, bonus_get_countdown (self));
#line 43 "../src/boni.vala"
		break;
#line 540 "boni.c"
		default:
#line 43 "../src/boni.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 43 "../src/boni.vala"
		break;
#line 546 "boni.c"
	}
}

static void
_vala_bonus_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Bonus * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BONUS, Bonus);
#line 43 "../src/boni.vala"
	switch (property_id) {
#line 43 "../src/boni.vala"
		case BONUS_X_PROPERTY:
#line 43 "../src/boni.vala"
		bonus_set_x (self, g_value_get_uchar (value));
#line 43 "../src/boni.vala"
		break;
#line 43 "../src/boni.vala"
		case BONUS_Y_PROPERTY:
#line 43 "../src/boni.vala"
		bonus_set_y (self, g_value_get_uchar (value));
#line 43 "../src/boni.vala"
		break;
#line 43 "../src/boni.vala"
		case BONUS_BONUS_TYPE_PROPERTY:
#line 43 "../src/boni.vala"
		bonus_set_bonus_type (self, g_value_get_enum (value));
#line 43 "../src/boni.vala"
		break;
#line 43 "../src/boni.vala"
		case BONUS_FAKE_PROPERTY:
#line 43 "../src/boni.vala"
		bonus_set_fake (self, g_value_get_boolean (value));
#line 43 "../src/boni.vala"
		break;
#line 43 "../src/boni.vala"
		case BONUS_COUNTDOWN_PROPERTY:
#line 43 "../src/boni.vala"
		bonus_set_countdown (self, g_value_get_uint (value));
#line 43 "../src/boni.vala"
		break;
#line 590 "boni.c"
		default:
#line 43 "../src/boni.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 43 "../src/boni.vala"
		break;
#line 596 "boni.c"
	}
}

static inline gpointer
boni_get_instance_private (Boni* self)
{
	return G_STRUCT_MEMBER_P (self, Boni_private_offset);
}

gboolean
boni_add_bonus (Boni* self,
                Bonus* bonus)
{
	GeeLinkedList* _tmp0_;
	guint8 _tmp1_;
	gboolean result;
#line 70 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 70 "../src/boni.vala"
	g_return_val_if_fail (bonus != NULL, FALSE);
#line 72 "../src/boni.vala"
	if (self->priv->total_bonus_number >= BONI_MAX_BONUSES) {
#line 73 "../src/boni.vala"
		result = FALSE;
#line 73 "../src/boni.vala"
		_g_object_unref0 (bonus);
#line 73 "../src/boni.vala"
		return result;
#line 625 "boni.c"
	}
#line 75 "../src/boni.vala"
	_tmp0_ = self->priv->bonuses;
#line 75 "../src/boni.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, bonus);
#line 76 "../src/boni.vala"
	_tmp1_ = self->priv->total_bonus_number;
#line 76 "../src/boni.vala"
	self->priv->total_bonus_number = _tmp1_ + 1;
#line 77 "../src/boni.vala"
	result = TRUE;
#line 77 "../src/boni.vala"
	_g_object_unref0 (bonus);
#line 77 "../src/boni.vala"
	return result;
#line 641 "boni.c"
}

void
boni_remove_bonus (Boni* self,
                   Bonus* bonus)
{
	GeeLinkedList* _tmp0_;
#line 80 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/boni.vala"
	g_return_if_fail (bonus != NULL);
#line 82 "../src/boni.vala"
	g_signal_emit (self, boni_signals[BONI_BONUS_REMOVED_SIGNAL], 0, bonus);
#line 83 "../src/boni.vala"
	_tmp0_ = self->priv->bonuses;
#line 83 "../src/boni.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, bonus);
#line 659 "boni.c"
}

void
boni_reset (Boni* self,
            guint8 regular_bonus)
{
	GeeLinkedList* _tmp0_;
	guint8 _tmp1_ = 0U;
#line 86 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/boni.vala"
	_tmp0_ = self->priv->bonuses;
#line 88 "../src/boni.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 89 "../src/boni.vala"
	boni_reset_missed (self);
#line 90 "../src/boni.vala"
	if (regular_bonus < BONI_MAX_BONUSES) {
#line 90 "../src/boni.vala"
		_tmp1_ = regular_bonus;
#line 680 "boni.c"
	} else {
#line 90 "../src/boni.vala"
		_tmp1_ = BONI_MAX_BONUSES;
#line 684 "boni.c"
	}
#line 90 "../src/boni.vala"
	self->priv->regular_bonus_maxi = _tmp1_;
#line 91 "../src/boni.vala"
	self->priv->regular_bonus_left = self->priv->regular_bonus_maxi;
#line 92 "../src/boni.vala"
	self->priv->total_bonus_number = (guint8) 0;
#line 692 "boni.c"
}

Bonus*
boni_get_bonus (Boni* self,
                guint8 x,
                guint8 y)
{
	Bonus* result;
#line 95 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 703 "boni.c"
	{
		GeeLinkedList* _bonus_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _bonus_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _bonus_index = 0;
#line 97 "../src/boni.vala"
		_tmp0_ = self->priv->bonuses;
#line 97 "../src/boni.vala"
		_bonus_list = _tmp0_;
#line 97 "../src/boni.vala"
		_tmp1_ = _bonus_list;
#line 97 "../src/boni.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 97 "../src/boni.vala"
		_tmp3_ = _tmp2_;
#line 97 "../src/boni.vala"
		_bonus_size = _tmp3_;
#line 97 "../src/boni.vala"
		_bonus_index = -1;
#line 97 "../src/boni.vala"
		while (TRUE) {
#line 728 "boni.c"
			gint _tmp4_;
			gint _tmp5_;
			Bonus* bonus = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
			Bonus* _tmp12_;
			guint8 _tmp13_;
			guint8 _tmp14_;
#line 97 "../src/boni.vala"
			_bonus_index = _bonus_index + 1;
#line 97 "../src/boni.vala"
			_tmp4_ = _bonus_index;
#line 97 "../src/boni.vala"
			_tmp5_ = _bonus_size;
#line 97 "../src/boni.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 97 "../src/boni.vala"
				break;
#line 751 "boni.c"
			}
#line 97 "../src/boni.vala"
			_tmp6_ = _bonus_list;
#line 97 "../src/boni.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _bonus_index);
#line 97 "../src/boni.vala"
			bonus = (Bonus*) _tmp7_;
#line 99 "../src/boni.vala"
			_tmp12_ = bonus;
#line 99 "../src/boni.vala"
			_tmp13_ = bonus_get_x (_tmp12_);
#line 99 "../src/boni.vala"
			_tmp14_ = _tmp13_;
#line 99 "../src/boni.vala"
			if (((gint) x) == (_tmp14_ + 0)) {
#line 767 "boni.c"
				Bonus* _tmp15_;
				guint8 _tmp16_;
				guint8 _tmp17_;
#line 99 "../src/boni.vala"
				_tmp15_ = bonus;
#line 99 "../src/boni.vala"
				_tmp16_ = bonus_get_y (_tmp15_);
#line 99 "../src/boni.vala"
				_tmp17_ = _tmp16_;
#line 99 "../src/boni.vala"
				_tmp11_ = ((gint) y) == (_tmp17_ + 0);
#line 779 "boni.c"
			} else {
#line 99 "../src/boni.vala"
				_tmp11_ = FALSE;
#line 783 "boni.c"
			}
#line 99 "../src/boni.vala"
			if (_tmp11_) {
#line 99 "../src/boni.vala"
				_tmp10_ = TRUE;
#line 789 "boni.c"
			} else {
				gboolean _tmp18_ = FALSE;
				Bonus* _tmp19_;
				guint8 _tmp20_;
				guint8 _tmp21_;
#line 100 "../src/boni.vala"
				_tmp19_ = bonus;
#line 100 "../src/boni.vala"
				_tmp20_ = bonus_get_x (_tmp19_);
#line 100 "../src/boni.vala"
				_tmp21_ = _tmp20_;
#line 100 "../src/boni.vala"
				if (((gint) x) == (_tmp21_ + 1)) {
#line 803 "boni.c"
					Bonus* _tmp22_;
					guint8 _tmp23_;
					guint8 _tmp24_;
#line 100 "../src/boni.vala"
					_tmp22_ = bonus;
#line 100 "../src/boni.vala"
					_tmp23_ = bonus_get_y (_tmp22_);
#line 100 "../src/boni.vala"
					_tmp24_ = _tmp23_;
#line 100 "../src/boni.vala"
					_tmp18_ = ((gint) y) == (_tmp24_ + 0);
#line 815 "boni.c"
				} else {
#line 100 "../src/boni.vala"
					_tmp18_ = FALSE;
#line 819 "boni.c"
				}
#line 100 "../src/boni.vala"
				_tmp10_ = _tmp18_;
#line 823 "boni.c"
			}
#line 99 "../src/boni.vala"
			if (_tmp10_) {
#line 99 "../src/boni.vala"
				_tmp9_ = TRUE;
#line 829 "boni.c"
			} else {
				gboolean _tmp25_ = FALSE;
				Bonus* _tmp26_;
				guint8 _tmp27_;
				guint8 _tmp28_;
#line 101 "../src/boni.vala"
				_tmp26_ = bonus;
#line 101 "../src/boni.vala"
				_tmp27_ = bonus_get_x (_tmp26_);
#line 101 "../src/boni.vala"
				_tmp28_ = _tmp27_;
#line 101 "../src/boni.vala"
				if (((gint) x) == (_tmp28_ + 0)) {
#line 843 "boni.c"
					Bonus* _tmp29_;
					guint8 _tmp30_;
					guint8 _tmp31_;
#line 101 "../src/boni.vala"
					_tmp29_ = bonus;
#line 101 "../src/boni.vala"
					_tmp30_ = bonus_get_y (_tmp29_);
#line 101 "../src/boni.vala"
					_tmp31_ = _tmp30_;
#line 101 "../src/boni.vala"
					_tmp25_ = ((gint) y) == (_tmp31_ + 1);
#line 855 "boni.c"
				} else {
#line 101 "../src/boni.vala"
					_tmp25_ = FALSE;
#line 859 "boni.c"
				}
#line 101 "../src/boni.vala"
				_tmp9_ = _tmp25_;
#line 863 "boni.c"
			}
#line 99 "../src/boni.vala"
			if (_tmp9_) {
#line 99 "../src/boni.vala"
				_tmp8_ = TRUE;
#line 869 "boni.c"
			} else {
				gboolean _tmp32_ = FALSE;
				Bonus* _tmp33_;
				guint8 _tmp34_;
				guint8 _tmp35_;
#line 102 "../src/boni.vala"
				_tmp33_ = bonus;
#line 102 "../src/boni.vala"
				_tmp34_ = bonus_get_x (_tmp33_);
#line 102 "../src/boni.vala"
				_tmp35_ = _tmp34_;
#line 102 "../src/boni.vala"
				if (((gint) x) == (_tmp35_ + 1)) {
#line 883 "boni.c"
					Bonus* _tmp36_;
					guint8 _tmp37_;
					guint8 _tmp38_;
#line 102 "../src/boni.vala"
					_tmp36_ = bonus;
#line 102 "../src/boni.vala"
					_tmp37_ = bonus_get_y (_tmp36_);
#line 102 "../src/boni.vala"
					_tmp38_ = _tmp37_;
#line 102 "../src/boni.vala"
					_tmp32_ = ((gint) y) == (_tmp38_ + 1);
#line 895 "boni.c"
				} else {
#line 102 "../src/boni.vala"
					_tmp32_ = FALSE;
#line 899 "boni.c"
				}
#line 102 "../src/boni.vala"
				_tmp8_ = _tmp32_;
#line 903 "boni.c"
			}
#line 99 "../src/boni.vala"
			if (_tmp8_) {
#line 104 "../src/boni.vala"
				result = bonus;
#line 104 "../src/boni.vala"
				return result;
#line 911 "boni.c"
			}
#line 97 "../src/boni.vala"
			_g_object_unref0 (bonus);
#line 915 "boni.c"
		}
	}
#line 108 "../src/boni.vala"
	result = NULL;
#line 108 "../src/boni.vala"
	return result;
#line 922 "boni.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 113 "../src/boni.vala"
	return self ? g_object_ref (self) : NULL;
#line 930 "boni.c"
}

GeeList*
boni_get_bonuses (Boni* self)
{
	GeeLinkedList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* result;
#line 111 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "../src/boni.vala"
	_tmp0_ = self->priv->bonuses;
#line 113 "../src/boni.vala"
	_tmp1_ = _g_object_ref0 ((GeeList*) _tmp0_);
#line 113 "../src/boni.vala"
	result = _tmp1_;
#line 113 "../src/boni.vala"
	return result;
#line 949 "boni.c"
}

void
boni_on_worms_move (Boni* self,
                    guint8* missed_bonuses_to_replace)
{
	guint8 _vala_missed_bonuses_to_replace = 0U;
#line 116 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/boni.vala"
	_vala_missed_bonuses_to_replace = (guint8) 0;
#line 961 "boni.c"
	{
		gint i = 0;
		GeeLinkedList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
#line 120 "../src/boni.vala"
		_tmp0_ = self->priv->bonuses;
#line 120 "../src/boni.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 120 "../src/boni.vala"
		_tmp2_ = _tmp1_;
#line 120 "../src/boni.vala"
		i = _tmp2_;
#line 975 "boni.c"
		{
			gboolean _tmp3_ = FALSE;
#line 120 "../src/boni.vala"
			_tmp3_ = TRUE;
#line 120 "../src/boni.vala"
			while (TRUE) {
#line 982 "boni.c"
				Bonus* bonus = NULL;
				GeeLinkedList* _tmp5_;
				gpointer _tmp6_;
				Bonus* _tmp7_;
				guint16 _tmp8_;
				guint16 _tmp9_;
#line 120 "../src/boni.vala"
				if (!_tmp3_) {
#line 991 "boni.c"
					gint _tmp4_;
#line 120 "../src/boni.vala"
					_tmp4_ = i;
#line 120 "../src/boni.vala"
					i = _tmp4_ - 1;
#line 997 "boni.c"
				}
#line 120 "../src/boni.vala"
				_tmp3_ = FALSE;
#line 120 "../src/boni.vala"
				if (!(i > 0)) {
#line 120 "../src/boni.vala"
					break;
#line 1005 "boni.c"
				}
#line 122 "../src/boni.vala"
				_tmp5_ = self->priv->bonuses;
#line 122 "../src/boni.vala"
				_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, i - 1);
#line 122 "../src/boni.vala"
				bonus = (Bonus*) _tmp6_;
#line 123 "../src/boni.vala"
				_tmp7_ = bonus;
#line 123 "../src/boni.vala"
				_tmp8_ = bonus_get_countdown (_tmp7_);
#line 123 "../src/boni.vala"
				_tmp9_ = _tmp8_;
#line 123 "../src/boni.vala"
				if (((gint) _tmp9_) > 0) {
#line 1021 "boni.c"
					Bonus* _tmp10_;
					guint16 _tmp11_;
					guint16 _tmp12_;
#line 124 "../src/boni.vala"
					_tmp10_ = bonus;
#line 124 "../src/boni.vala"
					_tmp11_ = bonus_get_countdown (_tmp10_);
#line 124 "../src/boni.vala"
					_tmp12_ = _tmp11_;
#line 124 "../src/boni.vala"
					bonus_set_countdown (_tmp10_, _tmp12_ - 1);
#line 1033 "boni.c"
				} else {
					Bonus* _tmp13_;
					gboolean _tmp14_ = FALSE;
					Bonus* _tmp15_;
					BonusType _tmp16_;
					BonusType _tmp17_;
#line 127 "../src/boni.vala"
					_tmp13_ = bonus;
#line 127 "../src/boni.vala"
					boni_remove_bonus (self, _tmp13_);
#line 128 "../src/boni.vala"
					_tmp15_ = bonus;
#line 128 "../src/boni.vala"
					_tmp16_ = bonus_get_bonus_type (_tmp15_);
#line 128 "../src/boni.vala"
					_tmp17_ = _tmp16_;
#line 128 "../src/boni.vala"
					if (_tmp17_ == BONUS_TYPE_REGULAR) {
#line 1052 "boni.c"
						Bonus* _tmp18_;
						gboolean _tmp19_;
						gboolean _tmp20_;
#line 128 "../src/boni.vala"
						_tmp18_ = bonus;
#line 128 "../src/boni.vala"
						_tmp19_ = bonus_get_fake (_tmp18_);
#line 128 "../src/boni.vala"
						_tmp20_ = _tmp19_;
#line 128 "../src/boni.vala"
						_tmp14_ = !_tmp20_;
#line 1064 "boni.c"
					} else {
#line 128 "../src/boni.vala"
						_tmp14_ = FALSE;
#line 1068 "boni.c"
					}
#line 128 "../src/boni.vala"
					if (_tmp14_) {
#line 1072 "boni.c"
						guint8 _tmp21_;
#line 130 "../src/boni.vala"
						boni_increase_missed (self);
#line 131 "../src/boni.vala"
						_tmp21_ = _vala_missed_bonuses_to_replace;
#line 131 "../src/boni.vala"
						_vala_missed_bonuses_to_replace = _tmp21_ + 1;
#line 1080 "boni.c"
					}
				}
#line 120 "../src/boni.vala"
				_g_object_unref0 (bonus);
#line 1085 "boni.c"
			}
		}
	}
#line 116 "../src/boni.vala"
	if (missed_bonuses_to_replace) {
#line 116 "../src/boni.vala"
		*missed_bonuses_to_replace = _vala_missed_bonuses_to_replace;
#line 1093 "boni.c"
	}
}

inline guint8
boni_new_regular_bonus_eaten (Boni* self)
{
	guint8 _tmp0_;
	guint8 result;
#line 137 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 139 "../src/boni.vala"
	boni_reset_missed (self);
#line 142 "../src/boni.vala"
	if (((gint) self->priv->regular_bonus_left) == 0) {
#line 143 "../src/boni.vala"
		g_assert_not_reached ();
#line 1110 "boni.c"
	}
#line 144 "../src/boni.vala"
	_tmp0_ = self->priv->regular_bonus_left;
#line 144 "../src/boni.vala"
	self->priv->regular_bonus_left = _tmp0_ - 1;
#line 145 "../src/boni.vala"
	result = self->priv->regular_bonus_maxi - self->priv->regular_bonus_left;
#line 145 "../src/boni.vala"
	return result;
#line 1120 "boni.c"
}

inline gboolean
boni_last_regular_bonus (Boni* self)
{
	gboolean result;
#line 148 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 150 "../src/boni.vala"
	result = ((gint) self->priv->regular_bonus_left) == 0;
#line 150 "../src/boni.vala"
	return result;
#line 1133 "boni.c"
}

inline gboolean
boni_too_many_missed (Boni* self)
{
	gboolean result;
#line 160 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 162 "../src/boni.vala"
	result = self->priv->missed > BONI_MAX_MISSED;
#line 162 "../src/boni.vala"
	return result;
#line 1146 "boni.c"
}

static inline void
boni_increase_missed (Boni* self)
{
	guint8 _tmp0_;
#line 165 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/boni.vala"
	_tmp0_ = self->priv->missed;
#line 167 "../src/boni.vala"
	self->priv->missed = _tmp0_ + 1;
#line 1159 "boni.c"
}

static inline void
boni_reset_missed (Boni* self)
{
#line 170 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/boni.vala"
	self->priv->missed = (guint8) 0;
#line 1169 "boni.c"
}

Boni*
boni_construct (GType object_type)
{
	Boni * self = NULL;
#line 58 "../src/boni.vala"
	self = (Boni*) g_object_new (object_type, NULL);
#line 58 "../src/boni.vala"
	return self;
#line 1180 "boni.c"
}

Boni*
boni_new (void)
{
#line 58 "../src/boni.vala"
	return boni_construct (TYPE_BONI);
#line 1188 "boni.c"
}

static void
boni_class_init (BoniClass * klass,
                 gpointer klass_data)
{
#line 58 "../src/boni.vala"
	boni_parent_class = g_type_class_peek_parent (klass);
#line 58 "../src/boni.vala"
	g_type_class_adjust_private_offset (klass, &Boni_private_offset);
#line 58 "../src/boni.vala"
	G_OBJECT_CLASS (klass)->finalize = boni_finalize;
#line 58 "../src/boni.vala"
	boni_signals[BONI_BONUS_REMOVED_SIGNAL] = g_signal_new ("bonus-removed", TYPE_BONI, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 1203 "boni.c"
}

static void
boni_instance_init (Boni * self,
                    gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 58 "../src/boni.vala"
	self->priv = boni_get_instance_private (self);
#line 60 "../src/boni.vala"
	_tmp0_ = gee_linked_list_new (TYPE_BONUS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 60 "../src/boni.vala"
	self->priv->bonuses = _tmp0_;
#line 62 "../src/boni.vala"
	self->priv->regular_bonus_left = (guint8) 0;
#line 63 "../src/boni.vala"
	self->priv->regular_bonus_maxi = (guint8) 0;
#line 64 "../src/boni.vala"
	self->priv->total_bonus_number = (guint8) 0;
#line 157 "../src/boni.vala"
	self->priv->missed = (guint8) 0;
#line 1225 "boni.c"
}

static void
boni_finalize (GObject * obj)
{
	Boni * self;
#line 58 "../src/boni.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BONI, Boni);
#line 60 "../src/boni.vala"
	_g_object_unref0 (self->priv->bonuses);
#line 58 "../src/boni.vala"
	G_OBJECT_CLASS (boni_parent_class)->finalize (obj);
#line 1238 "boni.c"
}

 G_GNUC_NO_INLINE static GType
boni_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BoniClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boni_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Boni), 0, (GInstanceInitFunc) boni_instance_init, NULL };
	GType boni_type_id;
	boni_type_id = g_type_register_static (G_TYPE_OBJECT, "Boni", &g_define_type_info, 0);
	Boni_private_offset = g_type_add_instance_private (boni_type_id, sizeof (BoniPrivate));
	return boni_type_id;
}

GType
boni_get_type (void)
{
	static gsize boni_type_id__once = 0;
	if (g_once_init_enter (&boni_type_id__once)) {
		GType boni_type_id;
		boni_type_id = boni_get_type_once ();
		g_once_init_leave (&boni_type_id__once, boni_type_id);
	}
	return boni_type_id__once;
}

