/* gnome-nibbles.c generated by valac 0.56.16, the Vala compiler
 * generated from gnome-nibbles.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Coding style.
 *
 * To help you comply with the coding style in this project use the
 * following greps. Any lines returned should be adjusted so they
 * don't match. The convoluted regular expressions are so they don't 
 * match them self.
 *
 * grep -ne '[^][)(_!$ "](' *.vala
 * grep -ne '[(] ' *.vala
 * grep -ne '[ ])' *.vala
 *
 */
/* designed for Gtk 4, link with libgtk-4-dev or gtk4-devel */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <locale.h>
#include <stdio.h>
#include <gdk/gdk.h>

#define NIBBLES_PROGRAM_NAME _ ("Nibbles")
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_NIBBLES (nibbles_get_type ())
#define NIBBLES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES, Nibbles))
#define NIBBLES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES, NibblesClass))
#define IS_NIBBLES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES))
#define IS_NIBBLES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES))
#define NIBBLES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES, NibblesClass))

typedef struct _Nibbles Nibbles;
typedef struct _NibblesClass NibblesClass;
typedef struct _NibblesPrivate NibblesPrivate;

#define TYPE_NIBBLES_WINDOW (nibbles_window_get_type ())
#define NIBBLES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES_WINDOW, NibblesWindow))
#define NIBBLES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES_WINDOW, NibblesWindowClass))
#define IS_NIBBLES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES_WINDOW))
#define IS_NIBBLES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES_WINDOW))
#define NIBBLES_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES_WINDOW, NibblesWindowClass))

typedef struct _NibblesWindow NibblesWindow;
typedef struct _NibblesWindowClass NibblesWindowClass;
enum  {
	NIBBLES_0_PROPERTY,
	NIBBLES_NUM_PROPERTIES
};
static GParamSpec* nibbles_properties[NIBBLES_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	SETUP_SCREEN_USUAL,
	SETUP_SCREEN_SPEED,
	SETUP_SCREEN_CONTROLS,
	SETUP_SCREEN_GAME
} SetupScreen;

#define TYPE_SETUP_SCREEN (setup_screen_get_type ())

struct _Nibbles {
	GtkApplication parent_instance;
	NibblesPrivate * priv;
};

struct _NibblesClass {
	GtkApplicationClass parent_class;
};

struct _NibblesPrivate {
	NibblesWindow* window;
};

struct _Block5Data {
	int _ref_count_;
	Nibbles* application;
};

static gint Nibbles_private_offset;
static gpointer nibbles_parent_class = NULL;
static gint nibbles_level;
static gint nibbles_nibbles;
static gint nibbles_players;
static gint nibbles_speed;
static gboolean nibbles_disable_fakes;
static gboolean nibbles_disable_fakes = FALSE;
static gboolean nibbles_enable_fakes;
static gboolean nibbles_enable_fakes = FALSE;
static gboolean nibbles_start;
static gboolean nibbles_start = FALSE;
static gint nibbles_level = G_MININT;
static gint nibbles_nibbles = G_MININT;
static gint nibbles_players = G_MININT;
static gint nibbles_speed = G_MININT;
static gboolean* nibbles_three_dimensional_view;
static gboolean* nibbles_three_dimensional_view = NULL;
static gboolean* nibbles_sound;
static gboolean* nibbles_sound = NULL;

VALA_EXTERN GType nibbles_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Nibbles, g_object_unref)
VALA_EXTERN GType nibbles_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesWindow, g_object_unref)
static inline void nibbles_help_cb (Nibbles* self);
static void _nibbles_help_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                        GVariant* parameter,
                                                        gpointer self);
static inline void nibbles_about_cb (Nibbles* self);
static void _nibbles_about_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                         GVariant* parameter,
                                                         gpointer self);
static void _g_application_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self);
static gint nibbles_main (gchar** args,
                   gint args_length1);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static Nibbles* nibbles_new (void);
static Nibbles* nibbles_construct (GType object_type);
static void __lambda52_ (Block5Data* _data5_);
static void nibbles_setup (Nibbles* self);
static void ___lambda52__g_application_activate (GApplication* _sender,
                                          gpointer self);
static gint nibbles_real_handle_local_options (GApplication* base,
                                        GVariantDict* options);
static gboolean* _bool_dup (gboolean* self);
VALA_EXTERN GType setup_screen_get_type (void) G_GNUC_CONST ;
VALA_EXTERN NibblesWindow* nibbles_window_new (gint cli_start_level,
                                   SetupScreen start_screen);
VALA_EXTERN NibblesWindow* nibbles_window_construct (GType object_type,
                                         gint cli_start_level,
                                         SetupScreen start_screen);
static void nibbles_real_activate (GApplication* base);
static void nibbles_real_shutdown (GApplication* base);
VALA_EXTERN void nibbles_window_on_shutdown (NibblesWindow* self);
VALA_EXTERN gboolean nibbles_window_get_game_paused (NibblesWindow* self);
static void nibbles_finalize (GObject * obj);
static GType nibbles_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry NIBBLES_action_entries[3] = {{"help", _nibbles_help_cb_gsimple_action_activate_callback}, {"about", _nibbles_about_cb_gsimple_action_activate_callback}, {"quit", _g_application_quit_gsimple_action_activate_callback}};
static const GOptionEntry NIBBLES_option_entries[13] = {{"disable-fakes", 'd', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, NULL, N_ ("Disable fake bonuses"), NULL}, {"enable-fakes", 'e', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, NULL, N_ ("Enable fake bonuses"), NULL}, {"level", 'l', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_INT, &nibbles_level, N_ ("Start at given level (1-26)"), N_ ("NUMBER")}, {"mute", (gchar) 0, (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, NULL, N_ ("Turn off the sound"), NULL}, {"nibbles", 'n', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_INT, &nibbles_nibbles, N_ ("Set number of nibbles (4-6)"), N_ ("NUMBER")}, {"players", 'p', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_INT, &nibbles_players, N_ ("Set number of players (1-4)"), N_ ("NUMBER")}, {"speed", 's', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_INT, &nibbles_speed, N_ ("Set worms speed (4-1, 4 for slow)"), N_ ("NUMBER")}, {"3D", '3', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, NULL, N_ ("Set three dimensional view"), NULL}, {"2D", '2', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, NULL, N_ ("Set two dimensional view"), NULL}, {"start", (gchar) 0, (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, NULL, N_ ("Start playing"), NULL}, {"unmute", (gchar) 0, (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, NULL, N_ ("Turn on the sound"), NULL}, {"version", 'v', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, NULL, N_ ("Show release version"), NULL}, {0}};

static inline gpointer
nibbles_get_instance_private (Nibbles* self)
{
	return G_STRUCT_MEMBER_P (self, Nibbles_private_offset);
}

static void
_nibbles_help_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                   GVariant* parameter,
                                                   gpointer self)
{
#line 43 "../src/gnome-nibbles.vala"
	nibbles_help_cb ((Nibbles*) self);
#line 207 "gnome-nibbles.c"
}

static void
_nibbles_about_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                    GVariant* parameter,
                                                    gpointer self)
{
#line 43 "../src/gnome-nibbles.vala"
	nibbles_about_cb ((Nibbles*) self);
#line 217 "gnome-nibbles.c"
}

static void
_g_application_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 43 "../src/gnome-nibbles.vala"
	g_application_quit ((GApplication*) self);
#line 227 "gnome-nibbles.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 111 "../src/gnome-nibbles.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 111 "../src/gnome-nibbles.vala"
	return _data5_;
#line 237 "gnome-nibbles.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 111 "../src/gnome-nibbles.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 111 "../src/gnome-nibbles.vala"
		_g_object_unref0 (_data5_->application);
#line 111 "../src/gnome-nibbles.vala"
		g_slice_free (Block5Data, _data5_);
#line 251 "gnome-nibbles.c"
	}
}

static void
__lambda52_ (Block5Data* _data5_)
{
#line 123 "../src/gnome-nibbles.vala"
	nibbles_setup (_data5_->application);
#line 260 "gnome-nibbles.c"
}

static void
___lambda52__g_application_activate (GApplication* _sender,
                                     gpointer self)
{
#line 121 "../src/gnome-nibbles.vala"
	__lambda52_ (self);
#line 269 "gnome-nibbles.c"
}

static gint
nibbles_main (gchar** args,
              gint args_length1)
{
	Block5Data* _data5_;
	Nibbles* _tmp0_;
	gint result;
#line 111 "../src/gnome-nibbles.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 111 "../src/gnome-nibbles.vala"
	_data5_->_ref_count_ = 1;
#line 113 "../src/gnome-nibbles.vala"
	setlocale (LC_ALL, "");
#line 114 "../src/gnome-nibbles.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 115 "../src/gnome-nibbles.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 116 "../src/gnome-nibbles.vala"
	textdomain (GETTEXT_PACKAGE);
#line 118 "../src/gnome-nibbles.vala"
	gtk_init ();
#line 120 "../src/gnome-nibbles.vala"
	_tmp0_ = nibbles_new ();
#line 120 "../src/gnome-nibbles.vala"
	_data5_->application = _tmp0_;
#line 121 "../src/gnome-nibbles.vala"
	g_signal_connect_data ((GApplication*) _data5_->application, "activate", (GCallback) ___lambda52__g_application_activate, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 126 "../src/gnome-nibbles.vala"
	result = g_application_run ((GApplication*) _data5_->application, (gint) args_length1, args);
#line 126 "../src/gnome-nibbles.vala"
	block5_data_unref (_data5_);
#line 126 "../src/gnome-nibbles.vala"
	_data5_ = NULL;
#line 126 "../src/gnome-nibbles.vala"
	return result;
#line 307 "gnome-nibbles.c"
}

int
main (int argc,
      char ** argv)
{
#line 111 "../src/gnome-nibbles.vala"
	return nibbles_main (argv, argc);
#line 316 "gnome-nibbles.c"
}

static Nibbles*
nibbles_construct (GType object_type)
{
	Nibbles * self = NULL;
#line 131 "../src/gnome-nibbles.vala"
	self = (Nibbles*) g_object_new (object_type, "application-id", "org.gnome.Nibbles", "flags", G_APPLICATION_FLAGS_NONE, NULL);
#line 133 "../src/gnome-nibbles.vala"
	g_application_add_main_option_entries ((GApplication*) self, NIBBLES_option_entries);
#line 129 "../src/gnome-nibbles.vala"
	return self;
#line 329 "gnome-nibbles.c"
}

static Nibbles*
nibbles_new (void)
{
#line 129 "../src/gnome-nibbles.vala"
	return nibbles_construct (TYPE_NIBBLES);
#line 337 "gnome-nibbles.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 180 "../src/gnome-nibbles.vala"
	dup = g_new0 (gboolean, 1);
#line 180 "../src/gnome-nibbles.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 180 "../src/gnome-nibbles.vala"
	return dup;
#line 350 "gnome-nibbles.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 180 "../src/gnome-nibbles.vala"
	return self ? _bool_dup (self) : NULL;
#line 358 "gnome-nibbles.c"
}

static gint
nibbles_real_handle_local_options (GApplication* base,
                                   GVariantDict* options)
{
	Nibbles * self;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gint result;
#line 136 "../src/gnome-nibbles.vala"
	self = (Nibbles*) base;
#line 136 "../src/gnome-nibbles.vala"
	g_return_val_if_fail (options != NULL, 0);
#line 138 "../src/gnome-nibbles.vala"
	if (g_variant_dict_contains (options, "version")) {
#line 379 "gnome-nibbles.c"
		FILE* _tmp0_;
#line 141 "../src/gnome-nibbles.vala"
		_tmp0_ = stderr;
#line 141 "../src/gnome-nibbles.vala"
		fprintf (_tmp0_, "gnome-nibbles %s\n", VERSION);
#line 142 "../src/gnome-nibbles.vala"
		result = EXIT_SUCCESS;
#line 142 "../src/gnome-nibbles.vala"
		return result;
#line 389 "gnome-nibbles.c"
	}
#line 145 "../src/gnome-nibbles.vala"
	if (nibbles_level != G_MININT) {
#line 393 "gnome-nibbles.c"
		gboolean _tmp2_ = FALSE;
#line 145 "../src/gnome-nibbles.vala"
		if (nibbles_level < 1) {
#line 145 "../src/gnome-nibbles.vala"
			_tmp2_ = TRUE;
#line 399 "gnome-nibbles.c"
		} else {
#line 145 "../src/gnome-nibbles.vala"
			_tmp2_ = nibbles_level > 26;
#line 403 "gnome-nibbles.c"
		}
#line 145 "../src/gnome-nibbles.vala"
		_tmp1_ = _tmp2_;
#line 407 "gnome-nibbles.c"
	} else {
#line 145 "../src/gnome-nibbles.vala"
		_tmp1_ = FALSE;
#line 411 "gnome-nibbles.c"
	}
#line 145 "../src/gnome-nibbles.vala"
	if (_tmp1_) {
#line 415 "gnome-nibbles.c"
		FILE* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 148 "../src/gnome-nibbles.vala"
		_tmp3_ = stderr;
#line 148 "../src/gnome-nibbles.vala"
		_tmp4_ = g_strconcat (_ ("Start level should only be between 1 and 26."), "\n", NULL);
#line 148 "../src/gnome-nibbles.vala"
		_tmp5_ = _tmp4_;
#line 148 "../src/gnome-nibbles.vala"
		fprintf (_tmp3_, "%s", _tmp5_);
#line 148 "../src/gnome-nibbles.vala"
		_g_free0 (_tmp5_);
#line 149 "../src/gnome-nibbles.vala"
		result = EXIT_FAILURE;
#line 149 "../src/gnome-nibbles.vala"
		return result;
#line 433 "gnome-nibbles.c"
	}
#line 151 "../src/gnome-nibbles.vala"
	if (nibbles_nibbles != G_MININT) {
#line 437 "gnome-nibbles.c"
		gboolean _tmp7_ = FALSE;
#line 151 "../src/gnome-nibbles.vala"
		if (nibbles_nibbles < 4) {
#line 151 "../src/gnome-nibbles.vala"
			_tmp7_ = TRUE;
#line 443 "gnome-nibbles.c"
		} else {
#line 151 "../src/gnome-nibbles.vala"
			_tmp7_ = nibbles_nibbles > 6;
#line 447 "gnome-nibbles.c"
		}
#line 151 "../src/gnome-nibbles.vala"
		_tmp6_ = _tmp7_;
#line 451 "gnome-nibbles.c"
	} else {
#line 151 "../src/gnome-nibbles.vala"
		_tmp6_ = FALSE;
#line 455 "gnome-nibbles.c"
	}
#line 151 "../src/gnome-nibbles.vala"
	if (_tmp6_) {
#line 459 "gnome-nibbles.c"
		FILE* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 154 "../src/gnome-nibbles.vala"
		_tmp8_ = stderr;
#line 154 "../src/gnome-nibbles.vala"
		_tmp9_ = g_strconcat (_ ("There could only be between 4 and 6 nibbles."), "\n", NULL);
#line 154 "../src/gnome-nibbles.vala"
		_tmp10_ = _tmp9_;
#line 154 "../src/gnome-nibbles.vala"
		fprintf (_tmp8_, "%s", _tmp10_);
#line 154 "../src/gnome-nibbles.vala"
		_g_free0 (_tmp10_);
#line 155 "../src/gnome-nibbles.vala"
		result = EXIT_FAILURE;
#line 155 "../src/gnome-nibbles.vala"
		return result;
#line 477 "gnome-nibbles.c"
	}
#line 157 "../src/gnome-nibbles.vala"
	if (nibbles_players != G_MININT) {
#line 481 "gnome-nibbles.c"
		gboolean _tmp12_ = FALSE;
#line 157 "../src/gnome-nibbles.vala"
		if (nibbles_players < 1) {
#line 157 "../src/gnome-nibbles.vala"
			_tmp12_ = TRUE;
#line 487 "gnome-nibbles.c"
		} else {
#line 157 "../src/gnome-nibbles.vala"
			_tmp12_ = nibbles_players > 4;
#line 491 "gnome-nibbles.c"
		}
#line 157 "../src/gnome-nibbles.vala"
		_tmp11_ = _tmp12_;
#line 495 "gnome-nibbles.c"
	} else {
#line 157 "../src/gnome-nibbles.vala"
		_tmp11_ = FALSE;
#line 499 "gnome-nibbles.c"
	}
#line 157 "../src/gnome-nibbles.vala"
	if (_tmp11_) {
#line 503 "gnome-nibbles.c"
		FILE* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 160 "../src/gnome-nibbles.vala"
		_tmp13_ = stderr;
#line 160 "../src/gnome-nibbles.vala"
		_tmp14_ = g_strconcat (_ ("There could only be between 1 and 4 players."), "\n", NULL);
#line 160 "../src/gnome-nibbles.vala"
		_tmp15_ = _tmp14_;
#line 160 "../src/gnome-nibbles.vala"
		fprintf (_tmp13_, "%s", _tmp15_);
#line 160 "../src/gnome-nibbles.vala"
		_g_free0 (_tmp15_);
#line 161 "../src/gnome-nibbles.vala"
		result = EXIT_FAILURE;
#line 161 "../src/gnome-nibbles.vala"
		return result;
#line 521 "gnome-nibbles.c"
	}
#line 163 "../src/gnome-nibbles.vala"
	if (nibbles_speed != G_MININT) {
#line 525 "gnome-nibbles.c"
		gboolean _tmp17_ = FALSE;
#line 163 "../src/gnome-nibbles.vala"
		if (nibbles_speed < 1) {
#line 163 "../src/gnome-nibbles.vala"
			_tmp17_ = TRUE;
#line 531 "gnome-nibbles.c"
		} else {
#line 163 "../src/gnome-nibbles.vala"
			_tmp17_ = nibbles_speed > 4;
#line 535 "gnome-nibbles.c"
		}
#line 163 "../src/gnome-nibbles.vala"
		_tmp16_ = _tmp17_;
#line 539 "gnome-nibbles.c"
	} else {
#line 163 "../src/gnome-nibbles.vala"
		_tmp16_ = FALSE;
#line 543 "gnome-nibbles.c"
	}
#line 163 "../src/gnome-nibbles.vala"
	if (_tmp16_) {
#line 547 "gnome-nibbles.c"
		FILE* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 166 "../src/gnome-nibbles.vala"
		_tmp18_ = stderr;
#line 166 "../src/gnome-nibbles.vala"
		_tmp19_ = g_strconcat (_ ("Speed should be between 4 (slow) and 1 (fast)."), "\n", NULL);
#line 166 "../src/gnome-nibbles.vala"
		_tmp20_ = _tmp19_;
#line 166 "../src/gnome-nibbles.vala"
		fprintf (_tmp18_, "%s", _tmp20_);
#line 166 "../src/gnome-nibbles.vala"
		_g_free0 (_tmp20_);
#line 167 "../src/gnome-nibbles.vala"
		result = EXIT_FAILURE;
#line 167 "../src/gnome-nibbles.vala"
		return result;
#line 565 "gnome-nibbles.c"
	}
#line 170 "../src/gnome-nibbles.vala"
	nibbles_disable_fakes = g_variant_dict_contains (options, "disable-fakes");
#line 171 "../src/gnome-nibbles.vala"
	nibbles_enable_fakes = g_variant_dict_contains (options, "enable-fakes");
#line 172 "../src/gnome-nibbles.vala"
	if (nibbles_disable_fakes) {
#line 172 "../src/gnome-nibbles.vala"
		_tmp21_ = nibbles_enable_fakes;
#line 575 "gnome-nibbles.c"
	} else {
#line 172 "../src/gnome-nibbles.vala"
		_tmp21_ = FALSE;
#line 579 "gnome-nibbles.c"
	}
#line 172 "../src/gnome-nibbles.vala"
	if (_tmp21_) {
#line 583 "gnome-nibbles.c"
		FILE* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 175 "../src/gnome-nibbles.vala"
		_tmp22_ = stderr;
#line 175 "../src/gnome-nibbles.vala"
		_tmp23_ = g_strconcat (_ ("Options --disable-fakes (-d) and --enable-fakes (-e) are mutually excl" \
"usive."), "\n", NULL);
#line 175 "../src/gnome-nibbles.vala"
		_tmp24_ = _tmp23_;
#line 175 "../src/gnome-nibbles.vala"
		fprintf (_tmp22_, "%s", _tmp24_);
#line 175 "../src/gnome-nibbles.vala"
		_g_free0 (_tmp24_);
#line 176 "../src/gnome-nibbles.vala"
		result = EXIT_FAILURE;
#line 176 "../src/gnome-nibbles.vala"
		return result;
#line 601 "gnome-nibbles.c"
	}
#line 179 "../src/gnome-nibbles.vala"
	if (g_variant_dict_contains (options, "mute")) {
#line 605 "gnome-nibbles.c"
		gboolean _tmp25_;
		gboolean* _tmp26_;
#line 180 "../src/gnome-nibbles.vala"
		_tmp25_ = FALSE;
#line 180 "../src/gnome-nibbles.vala"
		_tmp26_ = __bool_dup0 (&_tmp25_);
#line 180 "../src/gnome-nibbles.vala"
		_g_free0 (nibbles_sound);
#line 180 "../src/gnome-nibbles.vala"
		nibbles_sound = _tmp26_;
#line 616 "gnome-nibbles.c"
	} else {
#line 181 "../src/gnome-nibbles.vala"
		if (g_variant_dict_contains (options, "unmute")) {
#line 620 "gnome-nibbles.c"
			gboolean _tmp27_;
			gboolean* _tmp28_;
#line 182 "../src/gnome-nibbles.vala"
			_tmp27_ = TRUE;
#line 182 "../src/gnome-nibbles.vala"
			_tmp28_ = __bool_dup0 (&_tmp27_);
#line 182 "../src/gnome-nibbles.vala"
			_g_free0 (nibbles_sound);
#line 182 "../src/gnome-nibbles.vala"
			nibbles_sound = _tmp28_;
#line 631 "gnome-nibbles.c"
		}
	}
#line 184 "../src/gnome-nibbles.vala"
	if (g_variant_dict_contains (options, "3D")) {
#line 184 "../src/gnome-nibbles.vala"
		_tmp29_ = g_variant_dict_contains (options, "2D");
#line 638 "gnome-nibbles.c"
	} else {
#line 184 "../src/gnome-nibbles.vala"
		_tmp29_ = FALSE;
#line 642 "gnome-nibbles.c"
	}
#line 184 "../src/gnome-nibbles.vala"
	if (_tmp29_) {
#line 646 "gnome-nibbles.c"
		FILE* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
#line 187 "../src/gnome-nibbles.vala"
		_tmp30_ = stderr;
#line 187 "../src/gnome-nibbles.vala"
		_tmp31_ = g_strconcat (_ ("Options --3D (-3) and --2D (-2) are mutually exclusive."), "\n", NULL);
#line 187 "../src/gnome-nibbles.vala"
		_tmp32_ = _tmp31_;
#line 187 "../src/gnome-nibbles.vala"
		fprintf (_tmp30_, "%s", _tmp32_);
#line 187 "../src/gnome-nibbles.vala"
		_g_free0 (_tmp32_);
#line 188 "../src/gnome-nibbles.vala"
		result = EXIT_FAILURE;
#line 188 "../src/gnome-nibbles.vala"
		return result;
#line 664 "gnome-nibbles.c"
	} else {
#line 190 "../src/gnome-nibbles.vala"
		if (g_variant_dict_contains (options, "3D")) {
#line 668 "gnome-nibbles.c"
			gboolean _tmp33_;
			gboolean* _tmp34_;
#line 191 "../src/gnome-nibbles.vala"
			_tmp33_ = TRUE;
#line 191 "../src/gnome-nibbles.vala"
			_tmp34_ = __bool_dup0 (&_tmp33_);
#line 191 "../src/gnome-nibbles.vala"
			_g_free0 (nibbles_three_dimensional_view);
#line 191 "../src/gnome-nibbles.vala"
			nibbles_three_dimensional_view = _tmp34_;
#line 679 "gnome-nibbles.c"
		} else {
#line 192 "../src/gnome-nibbles.vala"
			if (g_variant_dict_contains (options, "2D")) {
#line 683 "gnome-nibbles.c"
				gboolean _tmp35_;
				gboolean* _tmp36_;
#line 193 "../src/gnome-nibbles.vala"
				_tmp35_ = FALSE;
#line 193 "../src/gnome-nibbles.vala"
				_tmp36_ = __bool_dup0 (&_tmp35_);
#line 193 "../src/gnome-nibbles.vala"
				_g_free0 (nibbles_three_dimensional_view);
#line 193 "../src/gnome-nibbles.vala"
				nibbles_three_dimensional_view = _tmp36_;
#line 694 "gnome-nibbles.c"
			}
		}
	}
#line 195 "../src/gnome-nibbles.vala"
	if (g_variant_dict_contains (options, "start")) {
#line 196 "../src/gnome-nibbles.vala"
		nibbles_start = TRUE;
#line 702 "gnome-nibbles.c"
	}
#line 199 "../src/gnome-nibbles.vala"
	result = -1;
#line 199 "../src/gnome-nibbles.vala"
	return result;
#line 708 "gnome-nibbles.c"
}

static void
nibbles_setup (Nibbles* self)
{
	GtkSettings* _tmp0_;
#line 214 "../src/gnome-nibbles.vala"
	static const gchar* newgame[1] = {"<Primary>n"};
#line 215 "../src/gnome-nibbles.vala"
	static const gchar* pause[2] = {"<Primary>p", "Pause"};
#line 216 "../src/gnome-nibbles.vala"
	static const gchar* appquit[1] = {"<Primary>q"};
#line 217 "../src/gnome-nibbles.vala"
	static const gchar* back[1] = {"Escape"};
#line 218 "../src/gnome-nibbles.vala"
	static const gchar* hamburger[2] = {"F10", "Menu"};
#line 725 "gnome-nibbles.c"
	gboolean nibbles_changed = FALSE;
	gboolean players_changed = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	SetupScreen setup = 0;
	gint _tmp31_ = 0;
	NibblesWindow* _tmp32_;
	NibblesWindow* _tmp33_;
#line 202 "../src/gnome-nibbles.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/gnome-nibbles.vala"
	g_set_prgname ("org.gnome.Nibbles");
#line 205 "../src/gnome-nibbles.vala"
	g_set_application_name (NIBBLES_PROGRAM_NAME);
#line 207 "../src/gnome-nibbles.vala"
	gtk_window_set_default_icon_name ("org.gnome.Nibbles");
#line 209 "../src/gnome-nibbles.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 209 "../src/gnome-nibbles.vala"
	g_object_set ((GObject*) _tmp0_, "gtk-application-prefer-dark-theme", TRUE, NULL);
#line 211 "../src/gnome-nibbles.vala"
	g_action_map_add_action_entries ((GActionMap*) self, NIBBLES_action_entries, (gint) G_N_ELEMENTS (NIBBLES_action_entries), self);
#line 219 "../src/gnome-nibbles.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.new-game", newgame);
#line 220 "../src/gnome-nibbles.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.pause", pause);
#line 221 "../src/gnome-nibbles.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.quit", appquit);
#line 222 "../src/gnome-nibbles.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.back", back);
#line 223 "../src/gnome-nibbles.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.hamburger", hamburger);
#line 224 "../src/gnome-nibbles.vala"
	nibbles_changed = nibbles_nibbles != G_MININT;
#line 225 "../src/gnome-nibbles.vala"
	players_changed = nibbles_players != G_MININT;
#line 226 "../src/gnome-nibbles.vala"
	if (nibbles_changed) {
#line 226 "../src/gnome-nibbles.vala"
		_tmp6_ = TRUE;
#line 770 "gnome-nibbles.c"
	} else {
#line 227 "../src/gnome-nibbles.vala"
		_tmp6_ = players_changed;
#line 774 "gnome-nibbles.c"
	}
#line 226 "../src/gnome-nibbles.vala"
	if (_tmp6_) {
#line 226 "../src/gnome-nibbles.vala"
		_tmp5_ = TRUE;
#line 780 "gnome-nibbles.c"
	} else {
#line 228 "../src/gnome-nibbles.vala"
		_tmp5_ = nibbles_speed != G_MININT;
#line 784 "gnome-nibbles.c"
	}
#line 226 "../src/gnome-nibbles.vala"
	if (_tmp5_) {
#line 226 "../src/gnome-nibbles.vala"
		_tmp4_ = TRUE;
#line 790 "gnome-nibbles.c"
	} else {
#line 229 "../src/gnome-nibbles.vala"
		_tmp4_ = nibbles_disable_fakes;
#line 794 "gnome-nibbles.c"
	}
#line 226 "../src/gnome-nibbles.vala"
	if (_tmp4_) {
#line 226 "../src/gnome-nibbles.vala"
		_tmp3_ = TRUE;
#line 800 "gnome-nibbles.c"
	} else {
#line 230 "../src/gnome-nibbles.vala"
		_tmp3_ = nibbles_enable_fakes;
#line 804 "gnome-nibbles.c"
	}
#line 226 "../src/gnome-nibbles.vala"
	if (_tmp3_) {
#line 226 "../src/gnome-nibbles.vala"
		_tmp2_ = TRUE;
#line 810 "gnome-nibbles.c"
	} else {
		gboolean* _tmp7_;
#line 231 "../src/gnome-nibbles.vala"
		_tmp7_ = nibbles_three_dimensional_view;
#line 231 "../src/gnome-nibbles.vala"
		_tmp2_ = _tmp7_ != NULL;
#line 817 "gnome-nibbles.c"
	}
#line 226 "../src/gnome-nibbles.vala"
	if (_tmp2_) {
#line 226 "../src/gnome-nibbles.vala"
		_tmp1_ = TRUE;
#line 823 "gnome-nibbles.c"
	} else {
		gboolean* _tmp8_;
#line 232 "../src/gnome-nibbles.vala"
		_tmp8_ = nibbles_sound;
#line 232 "../src/gnome-nibbles.vala"
		_tmp1_ = _tmp8_ != NULL;
#line 830 "gnome-nibbles.c"
	}
#line 226 "../src/gnome-nibbles.vala"
	if (_tmp1_) {
#line 834 "gnome-nibbles.c"
		GSettings* settings = NULL;
		GSettings* _tmp9_;
		gboolean _tmp10_ = FALSE;
		gboolean* _tmp22_;
		gboolean* _tmp25_;
#line 234 "../src/gnome-nibbles.vala"
		_tmp9_ = g_settings_new ("org.gnome.Nibbles");
#line 234 "../src/gnome-nibbles.vala"
		settings = _tmp9_;
#line 235 "../src/gnome-nibbles.vala"
		if (nibbles_changed) {
#line 235 "../src/gnome-nibbles.vala"
			_tmp10_ = players_changed;
#line 848 "gnome-nibbles.c"
		} else {
#line 235 "../src/gnome-nibbles.vala"
			_tmp10_ = FALSE;
#line 852 "gnome-nibbles.c"
		}
#line 235 "../src/gnome-nibbles.vala"
		if (_tmp10_) {
#line 856 "gnome-nibbles.c"
			GSettings* _tmp11_;
			GSettings* _tmp12_;
#line 237 "../src/gnome-nibbles.vala"
			_tmp11_ = settings;
#line 237 "../src/gnome-nibbles.vala"
			g_settings_set_int (_tmp11_, "players", nibbles_players);
#line 238 "../src/gnome-nibbles.vala"
			_tmp12_ = settings;
#line 238 "../src/gnome-nibbles.vala"
			g_settings_set_int (_tmp12_, "ai", nibbles_nibbles - nibbles_players);
#line 867 "gnome-nibbles.c"
		} else {
#line 240 "../src/gnome-nibbles.vala"
			if (players_changed) {
#line 871 "gnome-nibbles.c"
				gint old_ai = 0;
				GSettings* _tmp13_;
				gint old_players = 0;
				GSettings* _tmp14_;
				GSettings* _tmp15_;
				gint new_ai = 0;
#line 242 "../src/gnome-nibbles.vala"
				_tmp13_ = settings;
#line 242 "../src/gnome-nibbles.vala"
				old_ai = g_settings_get_int (_tmp13_, "ai");
#line 243 "../src/gnome-nibbles.vala"
				_tmp14_ = settings;
#line 243 "../src/gnome-nibbles.vala"
				old_players = g_settings_get_int (_tmp14_, "players");
#line 244 "../src/gnome-nibbles.vala"
				_tmp15_ = settings;
#line 244 "../src/gnome-nibbles.vala"
				g_settings_set_int (_tmp15_, "players", nibbles_players);
#line 245 "../src/gnome-nibbles.vala"
				new_ai = CLAMP (CLAMP (old_ai + old_players, 4, 6) - nibbles_players, 0, 5);
#line 246 "../src/gnome-nibbles.vala"
				if (old_ai != new_ai) {
#line 894 "gnome-nibbles.c"
					GSettings* _tmp16_;
#line 247 "../src/gnome-nibbles.vala"
					_tmp16_ = settings;
#line 247 "../src/gnome-nibbles.vala"
					g_settings_set_int (_tmp16_, "ai", new_ai);
#line 900 "gnome-nibbles.c"
				}
			} else {
#line 249 "../src/gnome-nibbles.vala"
				if (nibbles_changed) {
#line 905 "gnome-nibbles.c"
					GSettings* _tmp17_;
					GSettings* _tmp18_;
#line 250 "../src/gnome-nibbles.vala"
					_tmp17_ = settings;
#line 250 "../src/gnome-nibbles.vala"
					_tmp18_ = settings;
#line 250 "../src/gnome-nibbles.vala"
					g_settings_set_int (_tmp17_, "ai", nibbles_nibbles - g_settings_get_int (_tmp18_, "players"));
#line 914 "gnome-nibbles.c"
				}
			}
		}
#line 252 "../src/gnome-nibbles.vala"
		if (nibbles_speed != G_MININT) {
#line 920 "gnome-nibbles.c"
			GSettings* _tmp19_;
#line 253 "../src/gnome-nibbles.vala"
			_tmp19_ = settings;
#line 253 "../src/gnome-nibbles.vala"
			g_settings_set_int (_tmp19_, "speed", nibbles_speed);
#line 926 "gnome-nibbles.c"
		}
#line 255 "../src/gnome-nibbles.vala"
		if (nibbles_disable_fakes) {
#line 930 "gnome-nibbles.c"
			GSettings* _tmp20_;
#line 256 "../src/gnome-nibbles.vala"
			_tmp20_ = settings;
#line 256 "../src/gnome-nibbles.vala"
			g_settings_set_boolean (_tmp20_, "fakes", FALSE);
#line 936 "gnome-nibbles.c"
		} else {
#line 257 "../src/gnome-nibbles.vala"
			if (nibbles_enable_fakes) {
#line 940 "gnome-nibbles.c"
				GSettings* _tmp21_;
#line 258 "../src/gnome-nibbles.vala"
				_tmp21_ = settings;
#line 258 "../src/gnome-nibbles.vala"
				g_settings_set_boolean (_tmp21_, "fakes", TRUE);
#line 946 "gnome-nibbles.c"
			}
		}
#line 260 "../src/gnome-nibbles.vala"
		_tmp22_ = nibbles_three_dimensional_view;
#line 260 "../src/gnome-nibbles.vala"
		if (_tmp22_ != NULL) {
#line 953 "gnome-nibbles.c"
			GSettings* _tmp23_;
			gboolean* _tmp24_;
#line 261 "../src/gnome-nibbles.vala"
			_tmp23_ = settings;
#line 261 "../src/gnome-nibbles.vala"
			_tmp24_ = nibbles_three_dimensional_view;
#line 261 "../src/gnome-nibbles.vala"
			g_settings_set_boolean (_tmp23_, "three-dimensional-view", (gboolean) (*_tmp24_));
#line 962 "gnome-nibbles.c"
		}
#line 263 "../src/gnome-nibbles.vala"
		_tmp25_ = nibbles_sound;
#line 263 "../src/gnome-nibbles.vala"
		if (_tmp25_ != NULL) {
#line 968 "gnome-nibbles.c"
			GSettings* _tmp26_;
			gboolean* _tmp27_;
#line 264 "../src/gnome-nibbles.vala"
			_tmp26_ = settings;
#line 264 "../src/gnome-nibbles.vala"
			_tmp27_ = nibbles_sound;
#line 264 "../src/gnome-nibbles.vala"
			g_settings_set_boolean (_tmp26_, "sound", (gboolean) (*_tmp27_));
#line 977 "gnome-nibbles.c"
		}
#line 226 "../src/gnome-nibbles.vala"
		_g_object_unref0 (settings);
#line 981 "gnome-nibbles.c"
	}
#line 268 "../src/gnome-nibbles.vala"
	if (nibbles_start) {
#line 269 "../src/gnome-nibbles.vala"
		setup = SETUP_SCREEN_GAME;
#line 987 "gnome-nibbles.c"
	} else {
		gboolean _tmp28_ = FALSE;
#line 270 "../src/gnome-nibbles.vala"
		if (nibbles_changed) {
#line 270 "../src/gnome-nibbles.vala"
			_tmp28_ = players_changed;
#line 994 "gnome-nibbles.c"
		} else {
#line 270 "../src/gnome-nibbles.vala"
			_tmp28_ = FALSE;
#line 998 "gnome-nibbles.c"
		}
#line 270 "../src/gnome-nibbles.vala"
		if (_tmp28_) {
#line 1002 "gnome-nibbles.c"
			gboolean _tmp29_ = FALSE;
#line 272 "../src/gnome-nibbles.vala"
			if (nibbles_speed != G_MININT) {
#line 1006 "gnome-nibbles.c"
				gboolean _tmp30_ = FALSE;
#line 272 "../src/gnome-nibbles.vala"
				if (nibbles_disable_fakes) {
#line 272 "../src/gnome-nibbles.vala"
					_tmp30_ = TRUE;
#line 1012 "gnome-nibbles.c"
				} else {
#line 272 "../src/gnome-nibbles.vala"
					_tmp30_ = nibbles_enable_fakes;
#line 1016 "gnome-nibbles.c"
				}
#line 272 "../src/gnome-nibbles.vala"
				_tmp29_ = _tmp30_;
#line 1020 "gnome-nibbles.c"
			} else {
#line 272 "../src/gnome-nibbles.vala"
				_tmp29_ = FALSE;
#line 1024 "gnome-nibbles.c"
			}
#line 272 "../src/gnome-nibbles.vala"
			if (_tmp29_) {
#line 273 "../src/gnome-nibbles.vala"
				setup = SETUP_SCREEN_CONTROLS;
#line 1030 "gnome-nibbles.c"
			} else {
#line 275 "../src/gnome-nibbles.vala"
				setup = SETUP_SCREEN_SPEED;
#line 1034 "gnome-nibbles.c"
			}
		} else {
#line 278 "../src/gnome-nibbles.vala"
			setup = SETUP_SCREEN_USUAL;
#line 1039 "gnome-nibbles.c"
		}
	}
#line 280 "../src/gnome-nibbles.vala"
	if (nibbles_level == G_MININT) {
#line 280 "../src/gnome-nibbles.vala"
		_tmp31_ = 0;
#line 1046 "gnome-nibbles.c"
	} else {
#line 280 "../src/gnome-nibbles.vala"
		_tmp31_ = nibbles_level;
#line 1050 "gnome-nibbles.c"
	}
#line 280 "../src/gnome-nibbles.vala"
	_tmp32_ = nibbles_window_new (_tmp31_, setup);
#line 280 "../src/gnome-nibbles.vala"
	g_object_ref_sink (_tmp32_);
#line 280 "../src/gnome-nibbles.vala"
	_g_object_unref0 (self->priv->window);
#line 280 "../src/gnome-nibbles.vala"
	self->priv->window = _tmp32_;
#line 281 "../src/gnome-nibbles.vala"
	_tmp33_ = self->priv->window;
#line 281 "../src/gnome-nibbles.vala"
	gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp33_);
#line 1064 "gnome-nibbles.c"
}

static void
nibbles_real_activate (GApplication* base)
{
	Nibbles * self;
	NibblesWindow* _tmp0_;
#line 284 "../src/gnome-nibbles.vala"
	self = (Nibbles*) base;
#line 286 "../src/gnome-nibbles.vala"
	_tmp0_ = self->priv->window;
#line 286 "../src/gnome-nibbles.vala"
	gtk_window_present ((GtkWindow*) _tmp0_);
#line 287 "../src/gnome-nibbles.vala"
	G_APPLICATION_CLASS (nibbles_parent_class)->activate ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 1080 "gnome-nibbles.c"
}

static void
nibbles_real_shutdown (GApplication* base)
{
	Nibbles * self;
	NibblesWindow* _tmp0_;
#line 290 "../src/gnome-nibbles.vala"
	self = (Nibbles*) base;
#line 292 "../src/gnome-nibbles.vala"
	_tmp0_ = self->priv->window;
#line 292 "../src/gnome-nibbles.vala"
	nibbles_window_on_shutdown (_tmp0_);
#line 293 "../src/gnome-nibbles.vala"
	G_APPLICATION_CLASS (nibbles_parent_class)->shutdown ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 1096 "gnome-nibbles.c"
}

static inline void
nibbles_help_cb (Nibbles* self)
{
	gboolean _tmp0_ = FALSE;
	NibblesWindow* _tmp1_;
	NibblesWindow* _tmp6_;
#line 296 "../src/gnome-nibbles.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/gnome-nibbles.vala"
	_tmp1_ = self->priv->window;
#line 298 "../src/gnome-nibbles.vala"
	if (_tmp1_ != NULL) {
#line 1111 "gnome-nibbles.c"
		NibblesWindow* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 298 "../src/gnome-nibbles.vala"
		_tmp2_ = self->priv->window;
#line 298 "../src/gnome-nibbles.vala"
		_tmp3_ = nibbles_window_get_game_paused (_tmp2_);
#line 298 "../src/gnome-nibbles.vala"
		_tmp4_ = _tmp3_;
#line 298 "../src/gnome-nibbles.vala"
		_tmp0_ = !_tmp4_;
#line 1123 "gnome-nibbles.c"
	} else {
#line 298 "../src/gnome-nibbles.vala"
		_tmp0_ = FALSE;
#line 1127 "gnome-nibbles.c"
	}
#line 298 "../src/gnome-nibbles.vala"
	if (_tmp0_) {
#line 1131 "gnome-nibbles.c"
		NibblesWindow* _tmp5_;
#line 299 "../src/gnome-nibbles.vala"
		_tmp5_ = self->priv->window;
#line 299 "../src/gnome-nibbles.vala"
		g_action_group_activate_action ((GActionGroup*) _tmp5_, "pause", NULL);
#line 1137 "gnome-nibbles.c"
	}
#line 306 "../src/gnome-nibbles.vala"
	_tmp6_ = self->priv->window;
#line 306 "../src/gnome-nibbles.vala"
	gtk_show_uri ((GtkWindow*) _tmp6_, "help:gnome-nibbles", (guint32) GDK_CURRENT_TIME);
#line 1143 "gnome-nibbles.c"
}

static inline void
nibbles_about_cb (Nibbles* self)
{
	gboolean _tmp0_ = FALSE;
	NibblesWindow* _tmp1_;
	gchar** authors = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gint authors_length1;
	gint _authors_size_;
	gchar** documenters = NULL;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gint documenters_length1;
	gint _documenters_size_;
	gchar** artists = NULL;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gint artists_length1;
	gint _artists_size_;
	NibblesWindow* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
#line 325 "../src/gnome-nibbles.vala"
	g_return_if_fail (self != NULL);
#line 327 "../src/gnome-nibbles.vala"
	_tmp1_ = self->priv->window;
#line 327 "../src/gnome-nibbles.vala"
	if (_tmp1_ != NULL) {
#line 1194 "gnome-nibbles.c"
		NibblesWindow* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 327 "../src/gnome-nibbles.vala"
		_tmp2_ = self->priv->window;
#line 327 "../src/gnome-nibbles.vala"
		_tmp3_ = nibbles_window_get_game_paused (_tmp2_);
#line 327 "../src/gnome-nibbles.vala"
		_tmp4_ = _tmp3_;
#line 327 "../src/gnome-nibbles.vala"
		_tmp0_ = !_tmp4_;
#line 1206 "gnome-nibbles.c"
	} else {
#line 327 "../src/gnome-nibbles.vala"
		_tmp0_ = FALSE;
#line 1210 "gnome-nibbles.c"
	}
#line 327 "../src/gnome-nibbles.vala"
	if (_tmp0_) {
#line 1214 "gnome-nibbles.c"
		NibblesWindow* _tmp5_;
#line 328 "../src/gnome-nibbles.vala"
		_tmp5_ = self->priv->window;
#line 328 "../src/gnome-nibbles.vala"
		g_action_group_activate_action ((GActionGroup*) _tmp5_, "pause", NULL);
#line 1220 "gnome-nibbles.c"
	}
#line 330 "../src/gnome-nibbles.vala"
	_tmp6_ = g_strdup (_ ("Sean MacIsaac"));
#line 330 "../src/gnome-nibbles.vala"
	_tmp7_ = g_strdup (_ ("Ian Peters"));
#line 330 "../src/gnome-nibbles.vala"
	_tmp8_ = g_strdup (_ ("Andreas Røsdal"));
#line 330 "../src/gnome-nibbles.vala"
	_tmp9_ = g_strdup (_ ("Guillaume Beland"));
#line 330 "../src/gnome-nibbles.vala"
	_tmp10_ = g_strdup (_ ("Iulian-Gabriel Radu"));
#line 330 "../src/gnome-nibbles.vala"
	_tmp11_ = g_strdup (_ ("Ben Corby"));
#line 330 "../src/gnome-nibbles.vala"
	_tmp12_ = g_new0 (gchar*, 6 + 1);
#line 330 "../src/gnome-nibbles.vala"
	_tmp12_[0] = _tmp6_;
#line 330 "../src/gnome-nibbles.vala"
	_tmp12_[1] = _tmp7_;
#line 330 "../src/gnome-nibbles.vala"
	_tmp12_[2] = _tmp8_;
#line 330 "../src/gnome-nibbles.vala"
	_tmp12_[3] = _tmp9_;
#line 330 "../src/gnome-nibbles.vala"
	_tmp12_[4] = _tmp10_;
#line 330 "../src/gnome-nibbles.vala"
	_tmp12_[5] = _tmp11_;
#line 330 "../src/gnome-nibbles.vala"
	authors = _tmp12_;
#line 330 "../src/gnome-nibbles.vala"
	authors_length1 = 6;
#line 330 "../src/gnome-nibbles.vala"
	_authors_size_ = authors_length1;
#line 356 "../src/gnome-nibbles.vala"
	_tmp13_ = g_strdup (_ ("Kevin Breit"));
#line 356 "../src/gnome-nibbles.vala"
	_tmp14_ = g_new0 (gchar*, 1 + 1);
#line 356 "../src/gnome-nibbles.vala"
	_tmp14_[0] = _tmp13_;
#line 356 "../src/gnome-nibbles.vala"
	documenters = _tmp14_;
#line 356 "../src/gnome-nibbles.vala"
	documenters_length1 = 1;
#line 356 "../src/gnome-nibbles.vala"
	_documenters_size_ = documenters_length1;
#line 360 "../src/gnome-nibbles.vala"
	_tmp15_ = g_strdup (_ ("Allan Day"));
#line 360 "../src/gnome-nibbles.vala"
	_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 360 "../src/gnome-nibbles.vala"
	_tmp16_[0] = _tmp15_;
#line 360 "../src/gnome-nibbles.vala"
	artists = _tmp16_;
#line 360 "../src/gnome-nibbles.vala"
	artists_length1 = 1;
#line 360 "../src/gnome-nibbles.vala"
	_artists_size_ = artists_length1;
#line 362 "../src/gnome-nibbles.vala"
	_tmp17_ = self->priv->window;
#line 362 "../src/gnome-nibbles.vala"
	_tmp18_ = g_strconcat (_ ("Copyright © 1999-2008 – Sean MacIsaac, Ian Peters, Andreas Røsdal"), "\n", NULL);
#line 362 "../src/gnome-nibbles.vala"
	_tmp19_ = _tmp18_;
#line 362 "../src/gnome-nibbles.vala"
	_tmp20_ = g_strconcat (_tmp19_, _ ("Copyright © 2009 – Guillaume Beland"), NULL);
#line 362 "../src/gnome-nibbles.vala"
	_tmp21_ = _tmp20_;
#line 362 "../src/gnome-nibbles.vala"
	_tmp22_ = g_strconcat (_tmp21_, "\n", NULL);
#line 362 "../src/gnome-nibbles.vala"
	_tmp23_ = _tmp22_;
#line 362 "../src/gnome-nibbles.vala"
	_tmp24_ = g_strdup_printf (_ ("Copyright © %u-%u – Iulian-Gabriel Radu"), (guint) 2015, (guint) 2020);
#line 362 "../src/gnome-nibbles.vala"
	_tmp25_ = _tmp24_;
#line 362 "../src/gnome-nibbles.vala"
	_tmp26_ = g_strconcat (_tmp23_, _tmp25_, NULL);
#line 362 "../src/gnome-nibbles.vala"
	_tmp27_ = _tmp26_;
#line 362 "../src/gnome-nibbles.vala"
	_tmp28_ = g_strconcat (_tmp27_, "\n", NULL);
#line 362 "../src/gnome-nibbles.vala"
	_tmp29_ = _tmp28_;
#line 362 "../src/gnome-nibbles.vala"
	_tmp30_ = g_strdup_printf (_ ("Copyright © %u-%u – Ben Corby"), (guint) 2022, (guint) 2023);
#line 362 "../src/gnome-nibbles.vala"
	_tmp31_ = _tmp30_;
#line 362 "../src/gnome-nibbles.vala"
	_tmp32_ = g_strconcat (_tmp29_, _tmp31_, NULL);
#line 362 "../src/gnome-nibbles.vala"
	_tmp33_ = _tmp32_;
#line 362 "../src/gnome-nibbles.vala"
	gtk_show_about_dialog ((GtkWindow*) _tmp17_, "program-name", NIBBLES_PROGRAM_NAME, "version", VERSION, "comments", _ ("A worm game for GNOME"), "logo-icon-name", "org.gnome.Nibbles", "copyright", _tmp33_, "license-type", GTK_LICENSE_GPL_3_0, "authors", authors, "documenters", documenters, "artists", artists, "translator-credits", _ ("translator-credits"), "website", "https://wiki.gnome.org/Apps/Nibbles/", NULL);
#line 362 "../src/gnome-nibbles.vala"
	_g_free0 (_tmp33_);
#line 362 "../src/gnome-nibbles.vala"
	_g_free0 (_tmp31_);
#line 362 "../src/gnome-nibbles.vala"
	_g_free0 (_tmp29_);
#line 362 "../src/gnome-nibbles.vala"
	_g_free0 (_tmp27_);
#line 362 "../src/gnome-nibbles.vala"
	_g_free0 (_tmp25_);
#line 362 "../src/gnome-nibbles.vala"
	_g_free0 (_tmp23_);
#line 362 "../src/gnome-nibbles.vala"
	_g_free0 (_tmp21_);
#line 362 "../src/gnome-nibbles.vala"
	_g_free0 (_tmp19_);
#line 325 "../src/gnome-nibbles.vala"
	artists = (_vala_array_free (artists, artists_length1, (GDestroyNotify) g_free), NULL);
#line 325 "../src/gnome-nibbles.vala"
	documenters = (_vala_array_free (documenters, documenters_length1, (GDestroyNotify) g_free), NULL);
#line 325 "../src/gnome-nibbles.vala"
	authors = (_vala_array_free (authors, authors_length1, (GDestroyNotify) g_free), NULL);
#line 1336 "gnome-nibbles.c"
}

static void
nibbles_class_init (NibblesClass * klass,
                    gpointer klass_data)
{
#line 36 "../src/gnome-nibbles.vala"
	nibbles_parent_class = g_type_class_peek_parent (klass);
#line 36 "../src/gnome-nibbles.vala"
	g_type_class_adjust_private_offset (klass, &Nibbles_private_offset);
#line 36 "../src/gnome-nibbles.vala"
	((GApplicationClass *) klass)->handle_local_options = (gint (*) (GApplication*, GVariantDict*)) nibbles_real_handle_local_options;
#line 36 "../src/gnome-nibbles.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) nibbles_real_activate;
#line 36 "../src/gnome-nibbles.vala"
	((GApplicationClass *) klass)->shutdown = (void (*) (GApplication*)) nibbles_real_shutdown;
#line 36 "../src/gnome-nibbles.vala"
	G_OBJECT_CLASS (klass)->finalize = nibbles_finalize;
#line 1355 "gnome-nibbles.c"
}

static void
nibbles_instance_init (Nibbles * self,
                       gpointer klass)
{
#line 36 "../src/gnome-nibbles.vala"
	self->priv = nibbles_get_instance_private (self);
#line 1364 "gnome-nibbles.c"
}

static void
nibbles_finalize (GObject * obj)
{
	Nibbles * self;
#line 36 "../src/gnome-nibbles.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES, Nibbles);
#line 41 "../src/gnome-nibbles.vala"
	_g_object_unref0 (self->priv->window);
#line 36 "../src/gnome-nibbles.vala"
	G_OBJECT_CLASS (nibbles_parent_class)->finalize (obj);
#line 1377 "gnome-nibbles.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NibblesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Nibbles), 0, (GInstanceInitFunc) nibbles_instance_init, NULL };
	GType nibbles_type_id;
	nibbles_type_id = g_type_register_static (gtk_application_get_type (), "Nibbles", &g_define_type_info, 0);
	Nibbles_private_offset = g_type_add_instance_private (nibbles_type_id, sizeof (NibblesPrivate));
	return nibbles_type_id;
}

GType
nibbles_get_type (void)
{
	static gsize nibbles_type_id__once = 0;
	if (g_once_init_enter (&nibbles_type_id__once)) {
		GType nibbles_type_id;
		nibbles_type_id = nibbles_get_type_once ();
		g_once_init_leave (&nibbles_type_id__once, nibbles_type_id);
	}
	return nibbles_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

