/* worm.c generated by valac 0.56.16, the Vala compiler
 * generated from worm.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 * Copyright (C) 2022-23 Ben Corby <bcorby@new-ms.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Coding style.
 *
 * To help you comply with the coding style in this project use the
 * following greps. Any lines returned should be adjusted so they
 * don't match. The convoluted regular expressions are so they don't 
 * match them self.
 *
 * grep -ne '[^][)(_!$ "](' *.vala
 * grep -ne '[(] ' *.vala
 * grep -ne '[ ])' *.vala
 *
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <gdk/gdk.h>

#define WORM_MAP_bits ((guint8) (sizeof (guint64) * 8))
#define ANGLE_step_multiplier_2n 38
#define ANGLE_step_multiplier 274877906944LL
#define NIBBLES_GAME_EMPTYCHAR 'a'
#define WORM_STARTING_LIVES ((guint8) 6)
#define WORM_STARTING_LENGTH 5
#define WORM_MAX_LIVES ((guint8) 12)
#define WORM_GROW_FACTOR 4
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_EAST = WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_SOUTH = WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_WEST = WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP,
	WORM_DIRECTION_NORTH = WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;

#define TYPE_SIGNED_POSITION (signed_position_get_type ())
typedef struct _SignedPosition SignedPosition;

#define TYPE_WORM_MAP (worm_map_get_type ())
#define WORM_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_MAP, WormMap))
#define WORM_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_MAP, WormMapClass))
#define IS_WORM_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_MAP))
#define IS_WORM_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_MAP))
#define WORM_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_MAP, WormMapClass))

typedef struct _WormMap WormMap;
typedef struct _WormMapClass WormMapClass;
typedef struct _WormMapPrivate WormMapPrivate;
enum  {
	WORM_MAP_0_PROPERTY,
	WORM_MAP_NUM_PROPERTIES
};
static GParamSpec* worm_map_properties[WORM_MAP_NUM_PROPERTIES];

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;

#define TYPE_WORM_POSITIONS (worm_positions_get_type ())
#define WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_POSITIONS, WormPositions))
#define WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_POSITIONS, WormPositionsClass))
#define IS_WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_POSITIONS))
#define IS_WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_POSITIONS))
#define WORM_POSITIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_POSITIONS, WormPositionsClass))

typedef struct _WormPositions WormPositions;
typedef struct _WormPositionsClass WormPositionsClass;
typedef struct _WormPrivate WormPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_INT128 (int128_get_type ())
typedef struct _int128 int128;

#define TYPE_ANGLE_ITERATOR (angle_iterator_get_type ())
#define ANGLE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANGLE_ITERATOR, AngleIterator))
#define ANGLE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANGLE_ITERATOR, AngleIteratorClass))
#define IS_ANGLE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANGLE_ITERATOR))
#define IS_ANGLE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANGLE_ITERATOR))
#define ANGLE_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANGLE_ITERATOR, AngleIteratorClass))

typedef struct _AngleIterator AngleIterator;
typedef struct _AngleIteratorClass AngleIteratorClass;
typedef struct _AngleIteratorPrivate AngleIteratorPrivate;

#define TYPE_ANGLE (angle_get_type ())
typedef struct _Angle Angle;
typedef struct _ParamSpecAngleIterator ParamSpecAngleIterator;
typedef enum  {
	QUARTER_Q0,
	QUARTER_Q1,
	QUARTER_Q2,
	QUARTER_Q3
} Quarter;

#define TYPE_QUARTER (quarter_get_type ())

#define TYPE_SLICE (slice_get_type ())
#define SLICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SLICE, Slice))
#define SLICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SLICE, SliceClass))
#define IS_SLICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SLICE))
#define IS_SLICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SLICE))
#define SLICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SLICE, SliceClass))

typedef struct _Slice Slice;
typedef struct _SliceClass SliceClass;
typedef struct _SlicePrivate SlicePrivate;
enum  {
	SLICE_0_PROPERTY,
	SLICE_NUM_PROPERTIES
};
static GParamSpec* slice_properties[SLICE_NUM_PROPERTIES];

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;
#define _angle_iterator_unref0(var) ((var == NULL) ? NULL : (var = (angle_iterator_unref (var), NULL)))

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
#define WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_PROPERTIES, WormProperties))
#define WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_PROPERTIES, WormPropertiesClass))
#define IS_WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_PROPERTIES))
#define IS_WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_PROPERTIES))
#define WORM_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_PROPERTIES, WormPropertiesClass))

typedef struct _WormProperties WormProperties;
typedef struct _WormPropertiesClass WormPropertiesClass;
typedef struct _WormPropertiesPrivate WormPropertiesPrivate;
enum  {
	WORM_PROPERTIES_0_PROPERTY,
	WORM_PROPERTIES_COLOR_PROPERTY,
	WORM_PROPERTIES_UP_PROPERTY,
	WORM_PROPERTIES_DOWN_PROPERTY,
	WORM_PROPERTIES_LEFT_PROPERTY,
	WORM_PROPERTIES_RIGHT_PROPERTY,
	WORM_PROPERTIES_RAW_UP_PROPERTY,
	WORM_PROPERTIES_RAW_DOWN_PROPERTY,
	WORM_PROPERTIES_RAW_LEFT_PROPERTY,
	WORM_PROPERTIES_RAW_RIGHT_PROPERTY,
	WORM_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* worm_properties_properties[WORM_PROPERTIES_NUM_PROPERTIES];
typedef struct _WormPositionsPrivate WormPositionsPrivate;
enum  {
	WORM_POSITIONS_0_PROPERTY,
	WORM_POSITIONS_NUM_PROPERTIES
};
static GParamSpec* worm_positions_properties[WORM_POSITIONS_NUM_PROPERTIES];
typedef GeeList* (*WormGetOtherWormsType) (Worm* _self_, gpointer user_data);
typedef GeeList* (*WormGetBonusesType) (gpointer user_data);
enum  {
	WORM_0_PROPERTY,
	WORM_STARTING_POSITION_PROPERTY,
	WORM_ID_PROPERTY,
	WORM_IS_MATERIALIZED_PROPERTY,
	WORM_LIVES_PROPERTY,
	WORM_CHANGE_PROPERTY,
	WORM_SCORE_PROPERTY,
	WORM_LENGTH_PROPERTY,
	WORM_HEAD_PROPERTY,
	WORM_DIRECTION_PROPERTY,
	WORM_WIDTH_PROPERTY,
	WORM_HEIGHT_PROPERTY,
	WORM_CAPACITY_PROPERTY,
	WORM_NUM_PROPERTIES
};
static GParamSpec* worm_properties[WORM_NUM_PROPERTIES];
typedef struct _Block11Data Block11Data;
typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())
enum  {
	WORM_BONUS_FOUND_SIGNAL,
	WORM_NUM_SIGNALS
};
static guint worm_signals[WORM_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Position {
	guint8 x;
	guint8 y;
};

struct _SignedPosition {
	gint64 x;
	gint64 y;
	gint64 x_max;
	gint64 y_max;
};

struct _WormMap {
	GObject parent_instance;
	WormMapPrivate * priv;
};

struct _WormMapClass {
	GObjectClass parent_class;
};

struct _WormMapPrivate {
	guint64* map;
	gint map_length1;
	gint map_length2;
};

struct _Worm {
	GObject parent_instance;
	WormPrivate * priv;
	gboolean is_human;
	gboolean keypress;
	gint rounds_to_stay_still;
	gboolean is_stopped;
	WormPositions* list;
};

struct _WormClass {
	GObjectClass parent_class;
};

struct _int128 {
	guint64 hi;
	guint64 lo;
	gboolean negative;
	guint64 remainder;
};

struct _AngleIterator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AngleIteratorPrivate * priv;
};

struct _AngleIteratorClass {
	GTypeClass parent_class;
	void (*finalize) (AngleIterator *self);
};

struct _Angle {
	gint64 x;
	gint64 y;
	gint64 origin_x;
	gint64 origin_y;
	gint64 x_max;
	gint64 y_max;
};

struct _AngleIteratorPrivate {
	Angle pAngle;
	guint64 index;
};

struct _ParamSpecAngleIterator {
	GParamSpec parent_instance;
};

struct _Slice {
	GObject parent_instance;
	SlicePrivate * priv;
	Angle min;
	Angle max;
};

struct _SliceClass {
	GObjectClass parent_class;
};

struct _SlicePrivate {
	gboolean min_set;
	gboolean max_set;
};

struct _WormProperties {
	GObject parent_instance;
	WormPropertiesPrivate * priv;
};

struct _WormPropertiesClass {
	GObjectClass parent_class;
};

struct _WormPropertiesPrivate {
	gint _color;
	guint _up;
	guint _down;
	guint _left;
	guint _right;
	gint _raw_up;
	gint _raw_down;
	gint _raw_left;
	gint _raw_right;
};

struct _WormPositions {
	GeeLinkedList parent_instance;
	WormPositionsPrivate * priv;
};

struct _WormPositionsClass {
	GeeLinkedListClass parent_class;
};

struct _WormPrivate {
	Position _starting_position;
	gint _id;
	gint rounds_to_stay_dematerialized;
	guint8 _lives;
	gint _change;
	gint _score;
	WormDirection _direction;
	WormDirection starting_direction;
	GeeArrayQueue* key_queue;
	GeeArrayList* bonus_eaten;
	WormGetOtherWormsType get_other_worms;
	gpointer get_other_worms_target;
	GDestroyNotify get_other_worms_target_destroy_notify;
	WormGetBonusesType get_bonuses;
	gpointer get_bonuses_target;
	GDestroyNotify get_bonuses_target_destroy_notify;
	guint8 _width;
	guint8 _height;
	gint _capacity;
	gboolean LastUturnA;
};

struct _Block11Data {
	int _ref_count_;
	Worm* self;
	WormGetOtherWormsType cb0;
	gpointer cb0_target;
	WormGetBonusesType cb1;
	gpointer cb1_target;
};

static gint WormMap_private_offset;
static gpointer worm_map_parent_class = NULL;
static gint AngleIterator_private_offset;
static gpointer angle_iterator_parent_class = NULL;
static gint Slice_private_offset;
static gpointer slice_parent_class = NULL;
static gint WormProperties_private_offset;
static gpointer worm_properties_parent_class = NULL;
static gpointer worm_positions_parent_class = NULL;
static gint Worm_private_offset;
static gpointer worm_parent_class = NULL;
static guint* worm_deadend_board;
static gint worm_deadend_board_length1;
static gint worm_deadend_board_length2;
static guint* worm_deadend_board = NULL;
static gint worm_deadend_board_length1 = 0;
static gint worm_deadend_board_length2 = 0;
static guint worm_deadend_runnumber;
static guint worm_deadend_runnumber = (guint) 0;

VALA_EXTERN GType worm_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN WormDirection worm_direction_turn_left (WormDirection self);
VALA_EXTERN WormDirection worm_direction_turn_right (WormDirection self);
VALA_EXTERN WormDirection* worm_direction_get_space_fill_array (WormDirection self,
                                                    gint* result_length1);
VALA_EXTERN GType position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Position* position_dup (const Position* self);
VALA_EXTERN void position_free (Position* self);
VALA_EXTERN void position_move (Position *self,
                    WormDirection direction,
                    guint8 width,
                    guint8 height);
VALA_EXTERN GType signed_position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SignedPosition* signed_position_dup (const SignedPosition* self);
VALA_EXTERN void signed_position_free (SignedPosition* self);
VALA_EXTERN guint8 signed_position_wrap_x (SignedPosition *self);
VALA_EXTERN guint8 signed_position_wrap_y (SignedPosition *self);
VALA_EXTERN guint16 signed_position_wrap_xy (SignedPosition *self);
VALA_EXTERN GType worm_map_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormMap, g_object_unref)
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN WormMap* worm_map_new (GeeList* worms,
                       guint8 map_width,
                       guint8 map_height);
VALA_EXTERN WormMap* worm_map_construct (GType object_type,
                             GeeList* worms,
                             guint8 map_width,
                             guint8 map_height);
static void worm_map_add (WormMap* self,
                   GeeList* worms);
VALA_EXTERN gboolean worm_map_contain (WormMap* self,
                           guint16 p);
VALA_EXTERN gboolean worm_map_contain_position (WormMap* self,
                                    Position* p);
VALA_EXTERN GType worm_positions_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormPositions, g_object_unref)
VALA_EXTERN gboolean worm_map_contains (WormMap* self,
                            WormPositions* position_list);
VALA_EXTERN gboolean worm_get_is_materialized (Worm* self);
static void worm_map_finalize (GObject * obj);
static GType worm_map_get_type_once (void);
VALA_EXTERN GType int128_get_type (void) G_GNUC_CONST ;
VALA_EXTERN int128* int128_dup (const int128* self);
VALA_EXTERN void int128_free (int128* self);
VALA_EXTERN void int128_left_shift_assign (int128 *self,
                               gint shift);
VALA_EXTERN void int128_left_shift (int128 *self,
                        gint shift,
                        int128* result);
VALA_EXTERN void int128_right_shift_assign (int128 *self,
                                gint shift);
VALA_EXTERN void int128_add_assign (int128 *self,
                        int128* a);
VALA_EXTERN gboolean int128_greater_than (int128 *self,
                              int128* a);
VALA_EXTERN gboolean int128_less_than_or_equal_to (int128 *self,
                                       int128* a);
VALA_EXTERN gboolean int128_less_than (int128 *self,
                           int128* a);
VALA_EXTERN gboolean int128_equal_to (int128 *self,
                          int128* a);
VALA_EXTERN void int128_divide_by (int128 *self,
                       gint64 x,
                       int128* result);
static void int128_minus (int128 *self,
                   int128* a);
static void int128_multiply (int128 *self,
                      guint64 _a,
                      int128* result);
static gboolean int128_is_valid_int64 (int128 *self);
VALA_EXTERN gint64 int128_get_int64 (int128 *self);
VALA_EXTERN void multiply (gint64 _a,
               gint64 _b,
               int128* result);
VALA_EXTERN void multiply_by_2n (gint64 a,
                     gint n,
                     int128* result);
VALA_EXTERN gpointer angle_iterator_ref (gpointer instance);
VALA_EXTERN void angle_iterator_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_angle_iterator (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_angle_iterator (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_angle_iterator (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_angle_iterator (const GValue* value);
VALA_EXTERN GType angle_iterator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AngleIterator, angle_iterator_unref)
VALA_EXTERN GType angle_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Angle* angle_dup (const Angle* self);
VALA_EXTERN void angle_free (Angle* self);
VALA_EXTERN AngleIterator* angle_iterator_new (Angle* p);
VALA_EXTERN AngleIterator* angle_iterator_construct (GType object_type,
                                         Angle* p);
VALA_EXTERN gboolean angle_iterator_next (AngleIterator* self);
VALA_EXTERN void angle_iterator_get (AngleIterator* self,
                         SignedPosition* result);
VALA_EXTERN void angle_get (Angle *self,
                guint64 i,
                SignedPosition* result);
static void angle_iterator_finalize (AngleIterator * obj);
static GType angle_iterator_get_type_once (void);
VALA_EXTERN GType quarter_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void angle_assign (Angle *self,
                   Angle* o);
VALA_EXTERN gboolean angle_less_than_or_equal_to (Angle *self,
                                      Angle* o);
VALA_EXTERN gboolean angle_greater_than (Angle *self,
                             Angle* o);
static Quarter angle_get_quarter (Angle *self);
VALA_EXTERN gboolean angle_less_than (Angle *self,
                          Angle* o);
VALA_EXTERN gboolean angle_equal_to (Angle *self,
                         Angle* o);
VALA_EXTERN gboolean angle_greater_than_or_equal_to (Angle *self,
                                         Angle* o);
VALA_EXTERN void angle_set_origin (Angle *self,
                       Position* origin);
VALA_EXTERN void angle_set_wrapping (Angle *self,
                         gint x,
                         gint y);
VALA_EXTERN gboolean angle_step_along_x (Angle *self);
static gint64 angle_set_delta_x_sign (Angle *self,
                               gint64 _x);
static gint64 angle_set_delta_y_sign (Angle *self,
                               gint64 _y);
VALA_EXTERN AngleIterator* angle_iterator (Angle *self);
VALA_EXTERN GType slice_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Slice, g_object_unref)
VALA_EXTERN Slice* slice_new (Slice* copy);
VALA_EXTERN Slice* slice_construct (GType object_type,
                        Slice* copy);
VALA_EXTERN void slice_assign (Slice* self,
                   Slice* o);
VALA_EXTERN void slice_set_direction_view (Slice* self,
                               WormDirection d,
                               gint* board,
                               gint board_length1,
                               gint board_length2);
VALA_EXTERN void slice_add_angle (Slice* self,
                      Angle* a);
VALA_EXTERN void slice_set_from_position (Slice* self,
                              Position* origin,
                              gint64 x,
                              gint64 y,
                              gint size);
VALA_EXTERN void slice_intersection_by_position (Slice* self,
                                     Position* origin,
                                     guint8 _x,
                                     guint8 _y,
                                     gint size);
VALA_EXTERN gboolean slice_is_empty (Slice* self);
VALA_EXTERN GType bonus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bonus, g_object_unref)
static gboolean slice_is_bonus_at (Slice* self,
                            guint8 x,
                            guint8 y,
                            Bonus* b);
VALA_EXTERN guint8 bonus_get_x (Bonus* self);
VALA_EXTERN guint8 bonus_get_y (Bonus* self);
static gboolean slice_is_position_occupied (Slice* self,
                                     Position* p,
                                     gint* board,
                                     gint board_length1,
                                     gint board_length2,
                                     WormMap* worm_map);
VALA_EXTERN gint64 slice_is_visible (Slice* self,
                         Position* origin,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         WormMap* worm_map,
                         Bonus* bonus);
static void slice_finalize (GObject * obj);
static GType slice_get_type_once (void);
VALA_EXTERN GType worm_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormProperties, g_object_unref)
VALA_EXTERN WormProperties* worm_properties_new (void);
VALA_EXTERN WormProperties* worm_properties_construct (GType object_type);
VALA_EXTERN gint worm_properties_get_color (WormProperties* self);
VALA_EXTERN void worm_properties_set_color (WormProperties* self,
                                gint value);
VALA_EXTERN guint worm_properties_get_up (WormProperties* self);
VALA_EXTERN void worm_properties_set_up (WormProperties* self,
                             guint value);
VALA_EXTERN guint worm_properties_get_down (WormProperties* self);
VALA_EXTERN void worm_properties_set_down (WormProperties* self,
                               guint value);
VALA_EXTERN guint worm_properties_get_left (WormProperties* self);
VALA_EXTERN void worm_properties_set_left (WormProperties* self,
                               guint value);
VALA_EXTERN guint worm_properties_get_right (WormProperties* self);
VALA_EXTERN void worm_properties_set_right (WormProperties* self,
                                guint value);
VALA_EXTERN gint worm_properties_get_raw_up (WormProperties* self);
VALA_EXTERN void worm_properties_set_raw_up (WormProperties* self,
                                 gint value);
VALA_EXTERN gint worm_properties_get_raw_down (WormProperties* self);
VALA_EXTERN void worm_properties_set_raw_down (WormProperties* self,
                                   gint value);
VALA_EXTERN gint worm_properties_get_raw_left (WormProperties* self);
VALA_EXTERN void worm_properties_set_raw_left (WormProperties* self,
                                   gint value);
VALA_EXTERN gint worm_properties_get_raw_right (WormProperties* self);
VALA_EXTERN void worm_properties_set_raw_right (WormProperties* self,
                                    gint value);
static void worm_properties_finalize (GObject * obj);
static GType worm_properties_get_type_once (void);
static void _vala_worm_properties_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_worm_properties_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
VALA_EXTERN gboolean worm_positions_append_position (WormPositions* self,
                                         Position* p);
VALA_EXTERN void worm_positions_get_head (WormPositions* self,
                              Position* result);
VALA_EXTERN void worm_positions_set_head (WormPositions* self,
                              Position* p);
VALA_EXTERN gboolean worm_positions_prepend_position (WormPositions* self,
                                          Position* p);
VALA_EXTERN void worm_positions_remove_tail (WormPositions* self,
                                 Position* result);
VALA_EXTERN WormPositions* worm_positions_new (void);
VALA_EXTERN WormPositions* worm_positions_construct (GType object_type);
static GType worm_positions_get_type_once (void);
VALA_EXTERN Worm* worm_new (gint id,
                guint8 width,
                guint8 height,
                WormGetOtherWormsType cb0,
                gpointer cb0_target,
                WormGetBonusesType cb1,
                gpointer cb1_target);
VALA_EXTERN Worm* worm_construct (GType object_type,
                      gint id,
                      guint8 width,
                      guint8 height,
                      WormGetOtherWormsType cb0,
                      gpointer cb0_target,
                      WormGetBonusesType cb1,
                      gpointer cb1_target);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static GeeList* __lambda9_ (Block11Data* _data11_,
                     Worm* worm);
static GeeList* ___lambda9__worm_get_other_worms_type (Worm* _self_,
                                                gpointer self);
static GeeList* __lambda10_ (Block11Data* _data11_);
static GeeList* ___lambda10__worm_get_bonuses_type (gpointer self);
VALA_EXTERN void worm_set_start (Worm* self,
                     guint8 x,
                     guint8 y,
                     WormDirection direction);
static void worm_set_starting_position (Worm* self,
                                 Position * value);
VALA_EXTERN void worm_get_starting_position (Worm* self,
                                 Position * result);
static void worm_set_direction (Worm* self,
                         WormDirection value);
VALA_EXTERN void worm_set_change (Worm* self,
                      gint value);
VALA_EXTERN void worm_move_part_1 (Worm* self);
VALA_EXTERN void worm_get_head (Worm* self,
                    Position * result);
VALA_EXTERN WormDirection worm_get_direction (Worm* self);
static guint8 worm_get_width (Worm* self);
static guint8 worm_get_height (Worm* self);
VALA_EXTERN void worm_move_part_2 (Worm* self,
                       Position* head_position);
static void worm_set_head (Worm* self,
                    Position * value);
VALA_EXTERN gint worm_get_change (Worm* self);
VALA_EXTERN void worm_remove_bonus_eaten_position (Worm* self,
                                       Position* p);
static void worm_dequeue_keypress (Worm* self);
static void worm_materialize (Worm* self);
VALA_EXTERN void worm_add_bonus_eaten_position (Worm* self,
                                    guint8 x,
                                    guint8 y);
VALA_EXTERN gboolean worm_was_bonus_eaten_at_this_position (Worm* self,
                                                guint16 position);
VALA_EXTERN void worm_reduce_tail (Worm* self,
                       gint erase_size);
VALA_EXTERN void worm_reverse (Worm* self);
static gboolean worm_does_list_contain_position (WormPositions* position_list,
                                          guint16 position);
VALA_EXTERN gboolean worm_is_position_clear_of_materialized_worms (Worm* self,
                                                       GeeLinkedList* worms,
                                                       Position* position);
static gboolean worm_is_board_position_occupied (Position* p,
                                          gint* board,
                                          gint board_length1,
                                          gint board_length2);
VALA_EXTERN gboolean worm_can_move_to (Worm* self,
                           gint* board,
                           gint board_length1,
                           gint board_length2,
                           GeeLinkedList* worms,
                           Position* position);
VALA_EXTERN gboolean worm_can_move_to_map (Worm* self,
                               gint* board,
                               gint board_length1,
                               gint board_length2,
                               WormMap* worm_map,
                               Position* position);
VALA_EXTERN gboolean worm_can_move_direction (Worm* self,
                                  gint* board,
                                  gint board_length1,
                                  gint board_length2,
                                  GeeLinkedList* worms,
                                  WormDirection direction);
VALA_EXTERN void worm_spawn (Worm* self);
VALA_EXTERN void worm_dematerialize (Worm* self,
                         gint rounds,
                         gint gamedelay);
VALA_EXTERN void worm_add_life (Worm* self);
VALA_EXTERN guint8 worm_get_lives (Worm* self);
VALA_EXTERN void worm_set_lives (Worm* self,
                     guint8 value);
static inline void worm_lose_life (Worm* self);
VALA_EXTERN void worm_reset (Worm* self);
VALA_EXTERN void worm_position_move (Worm* self,
                         Position* result);
VALA_EXTERN void worm_get_position_after_direction_move (Worm* self,
                                             Position* origin,
                                             WormDirection direction,
                                             Position* result);
static void worm_direction_set (Worm* self,
                         WormDirection dir);
static void worm_queue_keypress (Worm* self,
                          WormDirection dir);
static WormDirection worm_uturn (Worm* self,
                          gint* board,
                          gint board_length1,
                          gint board_length2,
                          GeeLinkedList* worms,
                          WormDirection direction);
static gint worm_get_raw_key (Worm* self,
                       guint keyval);
VALA_EXTERN gboolean worm_handle_keypress (Worm* self,
                               guint keycode,
                               GeeHashMap* worm_props,
                               gint* board,
                               gint board_length1,
                               gint board_length2,
                               GeeLinkedList* worms);
static gint worm_ai_deadend (gint* board,
                      gint board_length1,
                      gint board_length2,
                      WormMap* worm_map,
                      Position* position,
                      gint length);
static void _vala_array_add6 (Position* * array,
                       gint* length,
                       gint* size,
                       const Position* value);
static gint worm_ai_deadend_after (gint* board,
                            gint board_length1,
                            gint board_length2,
                            GeeLinkedList* worms,
                            WormMap* worm_map,
                            Position* old_position,
                            WormDirection direction,
                            gint length);
static inline gboolean worm_ai_too_close (Worm* self,
                            GeeLinkedList* worms,
                            WormDirection direction);
VALA_EXTERN GType bonus_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean worm_ai_is_bonus_more_attractive (Worm* self,
                                           BonusType b0,
                                           gint64 d0,
                                           BonusType b1,
                                           gint64 d1);
VALA_EXTERN gboolean worm_ai_can_see_bonus (Worm* self,
                                gint* board,
                                gint board_length1,
                                gint board_length2,
                                Position* origin,
                                Bonus* bonus,
                                WormDirection direction);
VALA_EXTERN gint64 worm_ai_count_distance_to_a_bonus_in_direction (Worm* self,
                                                       gint* board,
                                                       gint board_length1,
                                                       gint board_length2,
                                                       WormMap* worm_map,
                                                       Position* origin,
                                                       WormDirection direction,
                                                       BonusType* bonus_type);
VALA_EXTERN BonusType bonus_get_bonus_type (Bonus* self);
VALA_EXTERN void worm_ai_move (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   GeeLinkedList* worms);
static gint worm_get_capacity (Worm* self);
VALA_EXTERN gint worm_get_length (Worm* self);
static gboolean _position_equal (const Position * s1,
                          const Position * s2);
VALA_EXTERN gint worm_get_id (Worm* self);
static void worm_set_id (Worm* self,
                  gint value);
VALA_EXTERN gint worm_get_score (Worm* self);
VALA_EXTERN void worm_set_score (Worm* self,
                     gint value);
static void worm_set_width (Worm* self,
                     guint8 value);
static void worm_set_height (Worm* self,
                      guint8 value);
static void worm_set_capacity (Worm* self,
                        gint value);
static GObject * worm_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void worm_finalize (GObject * obj);
static GType worm_get_type_once (void);
static void _vala_worm_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_worm_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);

WormDirection
worm_direction_turn_left (WormDirection self)
{
	WormDirection result;
#line 47 "../src/worm.vala"
	switch (self) {
#line 47 "../src/worm.vala"
		case WORM_DIRECTION_EAST:
#line 866 "worm.c"
		{
#line 50 "../src/worm.vala"
			result = WORM_DIRECTION_NORTH;
#line 50 "../src/worm.vala"
			return result;
#line 872 "worm.c"
		}
#line 47 "../src/worm.vala"
		case WORM_DIRECTION_NORTH:
#line 876 "worm.c"
		{
#line 52 "../src/worm.vala"
			result = WORM_DIRECTION_WEST;
#line 52 "../src/worm.vala"
			return result;
#line 882 "worm.c"
		}
#line 47 "../src/worm.vala"
		case WORM_DIRECTION_WEST:
#line 886 "worm.c"
		{
#line 54 "../src/worm.vala"
			result = WORM_DIRECTION_SOUTH;
#line 54 "../src/worm.vala"
			return result;
#line 892 "worm.c"
		}
#line 47 "../src/worm.vala"
		case WORM_DIRECTION_SOUTH:
#line 896 "worm.c"
		{
#line 56 "../src/worm.vala"
			result = WORM_DIRECTION_EAST;
#line 56 "../src/worm.vala"
			return result;
#line 902 "worm.c"
		}
		default:
		{
#line 58 "../src/worm.vala"
			g_assert_not_reached ();
#line 908 "worm.c"
		}
	}
}

WormDirection
worm_direction_turn_right (WormDirection self)
{
	WormDirection result;
#line 64 "../src/worm.vala"
	switch (self) {
#line 64 "../src/worm.vala"
		case WORM_DIRECTION_EAST:
#line 921 "worm.c"
		{
#line 67 "../src/worm.vala"
			result = WORM_DIRECTION_SOUTH;
#line 67 "../src/worm.vala"
			return result;
#line 927 "worm.c"
		}
#line 64 "../src/worm.vala"
		case WORM_DIRECTION_SOUTH:
#line 931 "worm.c"
		{
#line 69 "../src/worm.vala"
			result = WORM_DIRECTION_WEST;
#line 69 "../src/worm.vala"
			return result;
#line 937 "worm.c"
		}
#line 64 "../src/worm.vala"
		case WORM_DIRECTION_WEST:
#line 941 "worm.c"
		{
#line 71 "../src/worm.vala"
			result = WORM_DIRECTION_NORTH;
#line 71 "../src/worm.vala"
			return result;
#line 947 "worm.c"
		}
#line 64 "../src/worm.vala"
		case WORM_DIRECTION_NORTH:
#line 951 "worm.c"
		{
#line 73 "../src/worm.vala"
			result = WORM_DIRECTION_EAST;
#line 73 "../src/worm.vala"
			return result;
#line 957 "worm.c"
		}
		default:
		{
#line 75 "../src/worm.vala"
			g_assert_not_reached ();
#line 963 "worm.c"
		}
	}
}

WormDirection*
worm_direction_get_space_fill_array (WormDirection self,
                                     gint* result_length1)
{
	WormDirection* result;
#line 81 "../src/worm.vala"
	switch (self) {
#line 81 "../src/worm.vala"
		case WORM_DIRECTION_WEST:
#line 977 "worm.c"
		{
			WormDirection* _tmp0_;
			WormDirection* _tmp1_;
			gint _tmp1__length1;
#line 84 "../src/worm.vala"
			_tmp0_ = g_new0 (WormDirection, 3);
#line 84 "../src/worm.vala"
			_tmp0_[0] = WORM_DIRECTION_SOUTH;
#line 84 "../src/worm.vala"
			_tmp0_[1] = WORM_DIRECTION_WEST;
#line 84 "../src/worm.vala"
			_tmp0_[2] = WORM_DIRECTION_NORTH;
#line 84 "../src/worm.vala"
			_tmp1_ = _tmp0_;
#line 84 "../src/worm.vala"
			_tmp1__length1 = 3;
#line 84 "../src/worm.vala"
			if (result_length1) {
#line 84 "../src/worm.vala"
				*result_length1 = _tmp1__length1;
#line 998 "worm.c"
			}
#line 84 "../src/worm.vala"
			result = _tmp1_;
#line 84 "../src/worm.vala"
			return result;
#line 1004 "worm.c"
		}
#line 81 "../src/worm.vala"
		case WORM_DIRECTION_NORTH:
#line 1008 "worm.c"
		{
			WormDirection* _tmp2_;
			WormDirection* _tmp3_;
			gint _tmp3__length1;
#line 86 "../src/worm.vala"
			_tmp2_ = g_new0 (WormDirection, 3);
#line 86 "../src/worm.vala"
			_tmp2_[0] = WORM_DIRECTION_EAST;
#line 86 "../src/worm.vala"
			_tmp2_[1] = WORM_DIRECTION_WEST;
#line 86 "../src/worm.vala"
			_tmp2_[2] = WORM_DIRECTION_NORTH;
#line 86 "../src/worm.vala"
			_tmp3_ = _tmp2_;
#line 86 "../src/worm.vala"
			_tmp3__length1 = 3;
#line 86 "../src/worm.vala"
			if (result_length1) {
#line 86 "../src/worm.vala"
				*result_length1 = _tmp3__length1;
#line 1029 "worm.c"
			}
#line 86 "../src/worm.vala"
			result = _tmp3_;
#line 86 "../src/worm.vala"
			return result;
#line 1035 "worm.c"
		}
#line 81 "../src/worm.vala"
		case WORM_DIRECTION_EAST:
#line 1039 "worm.c"
		{
			WormDirection* _tmp4_;
			WormDirection* _tmp5_;
			gint _tmp5__length1;
#line 88 "../src/worm.vala"
			_tmp4_ = g_new0 (WormDirection, 3);
#line 88 "../src/worm.vala"
			_tmp4_[0] = WORM_DIRECTION_EAST;
#line 88 "../src/worm.vala"
			_tmp4_[1] = WORM_DIRECTION_SOUTH;
#line 88 "../src/worm.vala"
			_tmp4_[2] = WORM_DIRECTION_NORTH;
#line 88 "../src/worm.vala"
			_tmp5_ = _tmp4_;
#line 88 "../src/worm.vala"
			_tmp5__length1 = 3;
#line 88 "../src/worm.vala"
			if (result_length1) {
#line 88 "../src/worm.vala"
				*result_length1 = _tmp5__length1;
#line 1060 "worm.c"
			}
#line 88 "../src/worm.vala"
			result = _tmp5_;
#line 88 "../src/worm.vala"
			return result;
#line 1066 "worm.c"
		}
#line 81 "../src/worm.vala"
		case WORM_DIRECTION_SOUTH:
#line 1070 "worm.c"
		{
			WormDirection* _tmp6_;
			WormDirection* _tmp7_;
			gint _tmp7__length1;
#line 90 "../src/worm.vala"
			_tmp6_ = g_new0 (WormDirection, 3);
#line 90 "../src/worm.vala"
			_tmp6_[0] = WORM_DIRECTION_EAST;
#line 90 "../src/worm.vala"
			_tmp6_[1] = WORM_DIRECTION_SOUTH;
#line 90 "../src/worm.vala"
			_tmp6_[2] = WORM_DIRECTION_WEST;
#line 90 "../src/worm.vala"
			_tmp7_ = _tmp6_;
#line 90 "../src/worm.vala"
			_tmp7__length1 = 3;
#line 90 "../src/worm.vala"
			if (result_length1) {
#line 90 "../src/worm.vala"
				*result_length1 = _tmp7__length1;
#line 1091 "worm.c"
			}
#line 90 "../src/worm.vala"
			result = _tmp7_;
#line 90 "../src/worm.vala"
			return result;
#line 1097 "worm.c"
		}
		default:
		{
#line 92 "../src/worm.vala"
			g_assert_not_reached ();
#line 1103 "worm.c"
		}
	}
}

 G_GNUC_NO_INLINE static GType
worm_direction_get_type_once (void)
{
	static const GEnumValue values[] = {{WORM_DIRECTION_NONE, "WORM_DIRECTION_NONE", "none"}, {WORM_DIRECTION_RIGHT, "WORM_DIRECTION_RIGHT", "right"}, {WORM_DIRECTION_EAST, "WORM_DIRECTION_EAST", "east"}, {WORM_DIRECTION_DOWN, "WORM_DIRECTION_DOWN", "down"}, {WORM_DIRECTION_SOUTH, "WORM_DIRECTION_SOUTH", "south"}, {WORM_DIRECTION_LEFT, "WORM_DIRECTION_LEFT", "left"}, {WORM_DIRECTION_WEST, "WORM_DIRECTION_WEST", "west"}, {WORM_DIRECTION_UP, "WORM_DIRECTION_UP", "up"}, {WORM_DIRECTION_NORTH, "WORM_DIRECTION_NORTH", "north"}, {0, NULL, NULL}};
	GType worm_direction_type_id;
	worm_direction_type_id = g_enum_register_static ("WormDirection", values);
	return worm_direction_type_id;
}

GType
worm_direction_get_type (void)
{
	static gsize worm_direction_type_id__once = 0;
	if (g_once_init_enter (&worm_direction_type_id__once)) {
		GType worm_direction_type_id;
		worm_direction_type_id = worm_direction_get_type_once ();
		g_once_init_leave (&worm_direction_type_id__once, worm_direction_type_id);
	}
	return worm_direction_type_id__once;
}

void
position_move (Position *self,
               WormDirection direction,
               guint8 width,
               guint8 height)
{
#line 104 "../src/worm.vala"
	switch (direction) {
#line 104 "../src/worm.vala"
		case WORM_DIRECTION_NORTH:
#line 1139 "worm.c"
		{
#line 107 "../src/worm.vala"
			if (((gint) (*self).y) == 0) {
#line 108 "../src/worm.vala"
				(*self).y = (guint8) (height - 1);
#line 1145 "worm.c"
			} else {
				guint8 _tmp0_;
#line 110 "../src/worm.vala"
				_tmp0_ = (*self).y;
#line 110 "../src/worm.vala"
				(*self).y = _tmp0_ - 1;
#line 1152 "worm.c"
			}
#line 111 "../src/worm.vala"
			break;
#line 1156 "worm.c"
		}
#line 104 "../src/worm.vala"
		case WORM_DIRECTION_SOUTH:
#line 1160 "worm.c"
		{
#line 113 "../src/worm.vala"
			if (((gint) (*self).y) >= (height - 1)) {
#line 114 "../src/worm.vala"
				(*self).y = (guint8) 0;
#line 1166 "worm.c"
			} else {
				guint8 _tmp1_;
#line 116 "../src/worm.vala"
				_tmp1_ = (*self).y;
#line 116 "../src/worm.vala"
				(*self).y = _tmp1_ + 1;
#line 1173 "worm.c"
			}
#line 117 "../src/worm.vala"
			break;
#line 1177 "worm.c"
		}
#line 104 "../src/worm.vala"
		case WORM_DIRECTION_WEST:
#line 1181 "worm.c"
		{
#line 119 "../src/worm.vala"
			if (((gint) (*self).x) == 0) {
#line 120 "../src/worm.vala"
				(*self).x = (guint8) (width - 1);
#line 1187 "worm.c"
			} else {
				guint8 _tmp2_;
#line 122 "../src/worm.vala"
				_tmp2_ = (*self).x;
#line 122 "../src/worm.vala"
				(*self).x = _tmp2_ - 1;
#line 1194 "worm.c"
			}
#line 123 "../src/worm.vala"
			break;
#line 1198 "worm.c"
		}
#line 104 "../src/worm.vala"
		case WORM_DIRECTION_EAST:
#line 1202 "worm.c"
		{
#line 125 "../src/worm.vala"
			if (((gint) (*self).x) >= (width - 1)) {
#line 126 "../src/worm.vala"
				(*self).x = (guint8) 0;
#line 1208 "worm.c"
			} else {
				guint8 _tmp3_;
#line 128 "../src/worm.vala"
				_tmp3_ = (*self).x;
#line 128 "../src/worm.vala"
				(*self).x = _tmp3_ + 1;
#line 1215 "worm.c"
			}
#line 129 "../src/worm.vala"
			break;
#line 1219 "worm.c"
		}
		default:
		{
#line 131 "../src/worm.vala"
			g_assert_not_reached ();
#line 1225 "worm.c"
		}
	}
}

Position*
position_dup (const Position* self)
{
	Position* dup;
#line 97 "../src/worm.vala"
	dup = g_new0 (Position, 1);
#line 97 "../src/worm.vala"
	memcpy (dup, self, sizeof (Position));
#line 97 "../src/worm.vala"
	return dup;
#line 1240 "worm.c"
}

void
position_free (Position* self)
{
#line 97 "../src/worm.vala"
	g_free (self);
#line 1248 "worm.c"
}

 G_GNUC_NO_INLINE static GType
position_get_type_once (void)
{
	GType position_type_id;
	position_type_id = g_boxed_type_register_static ("Position", (GBoxedCopyFunc) position_dup, (GBoxedFreeFunc) position_free);
	return position_type_id;
}

GType
position_get_type (void)
{
	static gsize position_type_id__once = 0;
	if (g_once_init_enter (&position_type_id__once)) {
		GType position_type_id;
		position_type_id = position_get_type_once ();
		g_once_init_leave (&position_type_id__once, position_type_id);
	}
	return position_type_id__once;
}

guint8
signed_position_wrap_x (SignedPosition *self)
{
	guint8 result;
#line 151 "../src/worm.vala"
	_vala_assert ((*self).x_max > ((gint64) 0), "x_max > 0");
#line 152 "../src/worm.vala"
	if ((*self).x > (*self).x_max) {
#line 153 "../src/worm.vala"
		result = (guint8) ((*self).x % (*self).x_max);
#line 153 "../src/worm.vala"
		return result;
#line 1283 "worm.c"
	} else {
#line 154 "../src/worm.vala"
		if ((*self).x < ((gint64) 0)) {
#line 155 "../src/worm.vala"
			result = (guint8) ((*self).x + (((llabs ((*self).x) / (*self).x_max) + 1) * (*self).x_max));
#line 155 "../src/worm.vala"
			return result;
#line 1291 "worm.c"
		} else {
#line 157 "../src/worm.vala"
			result = (guint8) (*self).x;
#line 157 "../src/worm.vala"
			return result;
#line 1297 "worm.c"
		}
	}
}

guint8
signed_position_wrap_y (SignedPosition *self)
{
	guint8 result;
#line 162 "../src/worm.vala"
	_vala_assert ((*self).y_max > ((gint64) 0), "y_max > 0");
#line 163 "../src/worm.vala"
	if ((*self).y > (*self).y_max) {
#line 164 "../src/worm.vala"
		result = (guint8) ((*self).y % (*self).y_max);
#line 164 "../src/worm.vala"
		return result;
#line 1314 "worm.c"
	} else {
#line 165 "../src/worm.vala"
		if ((*self).y < ((gint64) 0)) {
#line 166 "../src/worm.vala"
			result = (guint8) ((*self).y + (((llabs ((*self).y) / (*self).y_max) + 1) * (*self).y_max));
#line 166 "../src/worm.vala"
			return result;
#line 1322 "worm.c"
		} else {
#line 168 "../src/worm.vala"
			result = (guint8) (*self).y;
#line 168 "../src/worm.vala"
			return result;
#line 1328 "worm.c"
		}
	}
}

guint16
signed_position_wrap_xy (SignedPosition *self)
{
	guint16 result;
#line 173 "../src/worm.vala"
	result = (guint16) ((((guint16) signed_position_wrap_x (&(*self))) << 8) | signed_position_wrap_y (&(*self)));
#line 173 "../src/worm.vala"
	return result;
#line 1341 "worm.c"
}

SignedPosition*
signed_position_dup (const SignedPosition* self)
{
	SignedPosition* dup;
#line 140 "../src/worm.vala"
	dup = g_new0 (SignedPosition, 1);
#line 140 "../src/worm.vala"
	memcpy (dup, self, sizeof (SignedPosition));
#line 140 "../src/worm.vala"
	return dup;
#line 1354 "worm.c"
}

void
signed_position_free (SignedPosition* self)
{
#line 140 "../src/worm.vala"
	g_free (self);
#line 1362 "worm.c"
}

 G_GNUC_NO_INLINE static GType
signed_position_get_type_once (void)
{
	GType signed_position_type_id;
	signed_position_type_id = g_boxed_type_register_static ("SignedPosition", (GBoxedCopyFunc) signed_position_dup, (GBoxedFreeFunc) signed_position_free);
	return signed_position_type_id;
}

GType
signed_position_get_type (void)
{
	static gsize signed_position_type_id__once = 0;
	if (g_once_init_enter (&signed_position_type_id__once)) {
		GType signed_position_type_id;
		signed_position_type_id = signed_position_get_type_once ();
		g_once_init_leave (&signed_position_type_id__once, signed_position_type_id);
	}
	return signed_position_type_id__once;
}

static inline gpointer
worm_map_get_instance_private (WormMap* self)
{
	return G_STRUCT_MEMBER_P (self, WormMap_private_offset);
}

WormMap*
worm_map_construct (GType object_type,
                    GeeList* worms,
                    guint8 map_width,
                    guint8 map_height)
{
	WormMap * self = NULL;
	guint64* _tmp0_;
#line 193 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, NULL);
#line 193 "../src/worm.vala"
	self = (WormMap*) g_object_new (object_type, NULL);
#line 221 "../src/worm.vala"
	_tmp0_ = g_new0 (guint64, (((map_width - 1) / WORM_MAP_bits) + 1) * map_height);
#line 221 "../src/worm.vala"
	self->priv->map = (g_free (self->priv->map), NULL);
#line 221 "../src/worm.vala"
	self->priv->map = _tmp0_;
#line 221 "../src/worm.vala"
	self->priv->map_length1 = ((map_width - 1) / WORM_MAP_bits) + 1;
#line 221 "../src/worm.vala"
	self->priv->map_length2 = map_height;
#line 222 "../src/worm.vala"
	worm_map_add (self, worms);
#line 193 "../src/worm.vala"
	return self;
#line 1417 "worm.c"
}

WormMap*
worm_map_new (GeeList* worms,
              guint8 map_width,
              guint8 map_height)
{
#line 193 "../src/worm.vala"
	return worm_map_construct (TYPE_WORM_MAP, worms, map_width, map_height);
#line 1427 "worm.c"
}

gboolean
worm_map_contain (WormMap* self,
                  guint16 p)
{
	guint8 quotient = 0U;
	guint8 remainder = 0U;
	guint64* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint64 _tmp1_;
	gboolean result;
#line 225 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 244 "../src/worm.vala"
	quotient = (guint8) ((p >> 8) / WORM_MAP_bits);
#line 245 "../src/worm.vala"
	remainder = (guint8) ((p >> 8) % WORM_MAP_bits);
#line 247 "../src/worm.vala"
	_tmp0_ = self->priv->map;
#line 247 "../src/worm.vala"
	_tmp0__length1 = self->priv->map_length1;
#line 247 "../src/worm.vala"
	_tmp0__length2 = self->priv->map_length2;
#line 247 "../src/worm.vala"
	_tmp1_ = _tmp0_[(quotient * _tmp0__length2) + ((guint8) p)];
#line 247 "../src/worm.vala"
	result = ((_tmp1_ >> remainder) & 1) > ((guint64) 0);
#line 247 "../src/worm.vala"
	return result;
#line 1459 "worm.c"
}

gboolean
worm_map_contain_position (WormMap* self,
                           Position* p)
{
	Position _tmp0_;
	Position _tmp1_;
	gboolean result;
#line 250 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 250 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 252 "../src/worm.vala"
	_tmp0_ = *p;
#line 252 "../src/worm.vala"
	_tmp1_ = *p;
#line 252 "../src/worm.vala"
	result = worm_map_contain (self, (guint16) ((((guint16) _tmp0_.x) << 8) | _tmp1_.y));
#line 252 "../src/worm.vala"
	return result;
#line 1481 "worm.c"
}

gboolean
worm_map_contains (WormMap* self,
                   WormPositions* position_list)
{
	gboolean result;
#line 255 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 255 "../src/worm.vala"
	g_return_val_if_fail (position_list != NULL, FALSE);
#line 1493 "worm.c"
	{
		WormPositions* _p_list = NULL;
		gint _p_size = 0;
		WormPositions* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _p_index = 0;
#line 257 "../src/worm.vala"
		_p_list = position_list;
#line 257 "../src/worm.vala"
		_tmp0_ = _p_list;
#line 257 "../src/worm.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 257 "../src/worm.vala"
		_tmp2_ = _tmp1_;
#line 257 "../src/worm.vala"
		_p_size = _tmp2_;
#line 257 "../src/worm.vala"
		_p_index = -1;
#line 257 "../src/worm.vala"
		while (TRUE) {
#line 1515 "worm.c"
			gint _tmp3_;
			gint _tmp4_;
			guint16 p = 0U;
			WormPositions* _tmp5_;
			gpointer _tmp6_;
#line 257 "../src/worm.vala"
			_p_index = _p_index + 1;
#line 257 "../src/worm.vala"
			_tmp3_ = _p_index;
#line 257 "../src/worm.vala"
			_tmp4_ = _p_size;
#line 257 "../src/worm.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 257 "../src/worm.vala"
				break;
#line 1531 "worm.c"
			}
#line 257 "../src/worm.vala"
			_tmp5_ = _p_list;
#line 257 "../src/worm.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _p_index);
#line 257 "../src/worm.vala"
			p = (guint16) ((guintptr) _tmp6_);
#line 258 "../src/worm.vala"
			if (worm_map_contain (self, p)) {
#line 259 "../src/worm.vala"
				result = TRUE;
#line 259 "../src/worm.vala"
				return result;
#line 1545 "worm.c"
			}
		}
	}
#line 260 "../src/worm.vala"
	result = FALSE;
#line 260 "../src/worm.vala"
	return result;
#line 1553 "worm.c"
}

static void
worm_map_add (WormMap* self,
              GeeList* worms)
{
#line 265 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/worm.vala"
	g_return_if_fail (worms != NULL);
#line 1564 "worm.c"
	{
		GeeList* _worm_list = NULL;
		gint _worm_size = 0;
		GeeList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _worm_index = 0;
#line 267 "../src/worm.vala"
		_worm_list = worms;
#line 267 "../src/worm.vala"
		_tmp0_ = _worm_list;
#line 267 "../src/worm.vala"
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 267 "../src/worm.vala"
		_tmp2_ = _tmp1_;
#line 267 "../src/worm.vala"
		_worm_size = _tmp2_;
#line 267 "../src/worm.vala"
		_worm_index = -1;
#line 267 "../src/worm.vala"
		while (TRUE) {
#line 1586 "worm.c"
			gint _tmp3_;
			gint _tmp4_;
			Worm* worm = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			gboolean _tmp7_ = FALSE;
			Worm* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 267 "../src/worm.vala"
			_worm_index = _worm_index + 1;
#line 267 "../src/worm.vala"
			_tmp3_ = _worm_index;
#line 267 "../src/worm.vala"
			_tmp4_ = _worm_size;
#line 267 "../src/worm.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 267 "../src/worm.vala"
				break;
#line 1606 "worm.c"
			}
#line 267 "../src/worm.vala"
			_tmp5_ = _worm_list;
#line 267 "../src/worm.vala"
			_tmp6_ = gee_list_get (_tmp5_, _worm_index);
#line 267 "../src/worm.vala"
			worm = (Worm*) _tmp6_;
#line 269 "../src/worm.vala"
			_tmp8_ = worm;
#line 269 "../src/worm.vala"
			_tmp9_ = worm_get_is_materialized (_tmp8_);
#line 269 "../src/worm.vala"
			_tmp10_ = _tmp9_;
#line 269 "../src/worm.vala"
			if (_tmp10_) {
#line 1622 "worm.c"
				Worm* _tmp11_;
#line 269 "../src/worm.vala"
				_tmp11_ = worm;
#line 269 "../src/worm.vala"
				_tmp7_ = !_tmp11_->is_stopped;
#line 1628 "worm.c"
			} else {
#line 269 "../src/worm.vala"
				_tmp7_ = FALSE;
#line 1632 "worm.c"
			}
#line 269 "../src/worm.vala"
			if (_tmp7_) {
#line 1636 "worm.c"
				{
					WormPositions* _p_list = NULL;
					Worm* _tmp12_;
					WormPositions* _tmp13_;
					gint _p_size = 0;
					WormPositions* _tmp14_;
					gint _tmp15_;
					gint _tmp16_;
					gint _p_index = 0;
#line 271 "../src/worm.vala"
					_tmp12_ = worm;
#line 271 "../src/worm.vala"
					_tmp13_ = _tmp12_->list;
#line 271 "../src/worm.vala"
					_p_list = _tmp13_;
#line 271 "../src/worm.vala"
					_tmp14_ = _p_list;
#line 271 "../src/worm.vala"
					_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 271 "../src/worm.vala"
					_tmp16_ = _tmp15_;
#line 271 "../src/worm.vala"
					_p_size = _tmp16_;
#line 271 "../src/worm.vala"
					_p_index = -1;
#line 271 "../src/worm.vala"
					while (TRUE) {
#line 1664 "worm.c"
						gint _tmp17_;
						gint _tmp18_;
						guint16 p = 0U;
						WormPositions* _tmp19_;
						gpointer _tmp20_;
						guint8 x = 0U;
						guint8 y = 0U;
						guint64* _tmp21_;
						gint _tmp21__length1;
						gint _tmp21__length2;
#line 271 "../src/worm.vala"
						_p_index = _p_index + 1;
#line 271 "../src/worm.vala"
						_tmp17_ = _p_index;
#line 271 "../src/worm.vala"
						_tmp18_ = _p_size;
#line 271 "../src/worm.vala"
						if (!(_tmp17_ < _tmp18_)) {
#line 271 "../src/worm.vala"
							break;
#line 1685 "worm.c"
						}
#line 271 "../src/worm.vala"
						_tmp19_ = _p_list;
#line 271 "../src/worm.vala"
						_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _p_index);
#line 271 "../src/worm.vala"
						p = (guint16) ((guintptr) _tmp20_);
#line 279 "../src/worm.vala"
						x = (guint8) (p >> 8);
#line 280 "../src/worm.vala"
						y = (guint8) p;
#line 281 "../src/worm.vala"
						_tmp21_ = self->priv->map;
#line 281 "../src/worm.vala"
						_tmp21__length1 = self->priv->map_length1;
#line 281 "../src/worm.vala"
						_tmp21__length2 = self->priv->map_length2;
#line 281 "../src/worm.vala"
						_tmp21_[((x / WORM_MAP_bits) * _tmp21__length2) + y] |= ((guint64) 1) << (x % WORM_MAP_bits);
#line 1705 "worm.c"
					}
				}
			}
#line 267 "../src/worm.vala"
			_g_object_unref0 (worm);
#line 1711 "worm.c"
		}
	}
}

static void
worm_map_class_init (WormMapClass * klass,
                     gpointer klass_data)
{
#line 182 "../src/worm.vala"
	worm_map_parent_class = g_type_class_peek_parent (klass);
#line 182 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &WormMap_private_offset);
#line 182 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->finalize = worm_map_finalize;
#line 1726 "worm.c"
}

static void
worm_map_instance_init (WormMap * self,
                        gpointer klass)
{
#line 182 "../src/worm.vala"
	self->priv = worm_map_get_instance_private (self);
#line 1735 "worm.c"
}

static void
worm_map_finalize (GObject * obj)
{
	WormMap * self;
#line 182 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM_MAP, WormMap);
#line 185 "../src/worm.vala"
	self->priv->map = (g_free (self->priv->map), NULL);
#line 182 "../src/worm.vala"
	G_OBJECT_CLASS (worm_map_parent_class)->finalize (obj);
#line 1748 "worm.c"
}

 G_GNUC_NO_INLINE static GType
worm_map_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WormMap), 0, (GInstanceInitFunc) worm_map_instance_init, NULL };
	GType worm_map_type_id;
	worm_map_type_id = g_type_register_static (G_TYPE_OBJECT, "WormMap", &g_define_type_info, 0);
	WormMap_private_offset = g_type_add_instance_private (worm_map_type_id, sizeof (WormMapPrivate));
	return worm_map_type_id;
}

GType
worm_map_get_type (void)
{
	static gsize worm_map_type_id__once = 0;
	if (g_once_init_enter (&worm_map_type_id__once)) {
		GType worm_map_type_id;
		worm_map_type_id = worm_map_get_type_once ();
		g_once_init_leave (&worm_map_type_id__once, worm_map_type_id);
	}
	return worm_map_type_id__once;
}

void
int128_left_shift_assign (int128 *self,
                          gint shift)
{
#line 302 "../src/worm.vala"
	if (shift >= 64) {
#line 304 "../src/worm.vala"
		(*self).hi = (*self).lo;
#line 305 "../src/worm.vala"
		(*self).lo = (guint64) 0;
#line 306 "../src/worm.vala"
		shift = shift - 64;
#line 1785 "worm.c"
	}
#line 308 "../src/worm.vala"
	if (shift > 0) {
#line 310 "../src/worm.vala"
		(*self).hi = (*self).hi << shift;
#line 311 "../src/worm.vala"
		(*self).hi = (*self).hi | ((*self).lo >> (64 - shift));
#line 312 "../src/worm.vala"
		(*self).lo = (*self).lo << shift;
#line 1795 "worm.c"
	}
}

void
int128_left_shift (int128 *self,
                   gint shift,
                   int128* result)
{
	int128 r = {0};
	int128 _tmp0_ = {0};
#line 319 "../src/worm.vala"
	_tmp0_.hi = (*self).hi;
#line 319 "../src/worm.vala"
	_tmp0_.lo = (*self).lo;
#line 319 "../src/worm.vala"
	_tmp0_.negative = (*self).negative;
#line 319 "../src/worm.vala"
	r = _tmp0_;
#line 320 "../src/worm.vala"
	int128_left_shift_assign (&r, shift);
#line 321 "../src/worm.vala"
	*result = r;
#line 321 "../src/worm.vala"
	return;
#line 1820 "worm.c"
}

void
int128_right_shift_assign (int128 *self,
                           gint shift)
{
#line 327 "../src/worm.vala"
	if (shift >= 64) {
#line 329 "../src/worm.vala"
		(*self).lo = (*self).hi;
#line 330 "../src/worm.vala"
		(*self).hi = (guint64) 0;
#line 331 "../src/worm.vala"
		shift = shift - 64;
#line 1835 "worm.c"
	}
#line 333 "../src/worm.vala"
	if (shift > 0) {
#line 335 "../src/worm.vala"
		(*self).lo = (*self).lo >> shift;
#line 336 "../src/worm.vala"
		(*self).lo = (*self).lo | ((*self).hi << (64 - shift));
#line 337 "../src/worm.vala"
		(*self).hi = (*self).hi >> shift;
#line 1845 "worm.c"
	}
}

void
int128_add_assign (int128 *self,
                   int128* a)
{
	int128 _tmp0_;
	guint64 o = 0ULL;
	int128 _tmp1_;
#line 342 "../src/worm.vala"
	g_return_if_fail (a != NULL);
#line 344 "../src/worm.vala"
	_tmp0_ = *a;
#line 344 "../src/worm.vala"
	(*self).hi = (*self).hi + _tmp0_.hi;
#line 345 "../src/worm.vala"
	o = (*self).lo;
#line 346 "../src/worm.vala"
	_tmp1_ = *a;
#line 346 "../src/worm.vala"
	(*self).lo = (*self).lo + _tmp1_.lo;
#line 347 "../src/worm.vala"
	if ((*self).lo < o) {
#line 348 "../src/worm.vala"
		(*self).hi = (*self).hi + 1;
#line 1872 "worm.c"
	}
}

gboolean
int128_greater_than (int128 *self,
                     int128* a)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 352 "../src/worm.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 354 "../src/worm.vala"
	if (!(*self).negative) {
#line 1886 "worm.c"
		int128 _tmp1_;
#line 354 "../src/worm.vala"
		_tmp1_ = *a;
#line 354 "../src/worm.vala"
		_tmp0_ = !_tmp1_.negative;
#line 1892 "worm.c"
	} else {
#line 354 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 1896 "worm.c"
	}
#line 354 "../src/worm.vala"
	if (_tmp0_) {
#line 1900 "worm.c"
		gboolean _tmp2_ = FALSE;
		int128 _tmp3_;
#line 355 "../src/worm.vala"
		_tmp3_ = *a;
#line 355 "../src/worm.vala"
		if ((*self).hi > _tmp3_.hi) {
#line 355 "../src/worm.vala"
			_tmp2_ = TRUE;
#line 1909 "worm.c"
		} else {
			gboolean _tmp4_ = FALSE;
			int128 _tmp5_;
#line 355 "../src/worm.vala"
			_tmp5_ = *a;
#line 355 "../src/worm.vala"
			if ((*self).hi == _tmp5_.hi) {
#line 1917 "worm.c"
				int128 _tmp6_;
#line 355 "../src/worm.vala"
				_tmp6_ = *a;
#line 355 "../src/worm.vala"
				_tmp4_ = (*self).lo > _tmp6_.lo;
#line 1923 "worm.c"
			} else {
#line 355 "../src/worm.vala"
				_tmp4_ = FALSE;
#line 1927 "worm.c"
			}
#line 355 "../src/worm.vala"
			_tmp2_ = _tmp4_;
#line 1931 "worm.c"
		}
#line 355 "../src/worm.vala"
		result = _tmp2_;
#line 355 "../src/worm.vala"
		return result;
#line 1937 "worm.c"
	} else {
		gboolean _tmp7_ = FALSE;
#line 356 "../src/worm.vala"
		if (!(*self).negative) {
#line 1942 "worm.c"
			int128 _tmp8_;
#line 356 "../src/worm.vala"
			_tmp8_ = *a;
#line 356 "../src/worm.vala"
			_tmp7_ = _tmp8_.negative;
#line 1948 "worm.c"
		} else {
#line 356 "../src/worm.vala"
			_tmp7_ = FALSE;
#line 1952 "worm.c"
		}
#line 356 "../src/worm.vala"
		if (_tmp7_) {
#line 357 "../src/worm.vala"
			result = TRUE;
#line 357 "../src/worm.vala"
			return result;
#line 1960 "worm.c"
		} else {
			gboolean _tmp9_ = FALSE;
#line 358 "../src/worm.vala"
			if ((*self).negative) {
#line 1965 "worm.c"
				int128 _tmp10_;
#line 358 "../src/worm.vala"
				_tmp10_ = *a;
#line 358 "../src/worm.vala"
				_tmp9_ = !_tmp10_.negative;
#line 1971 "worm.c"
			} else {
#line 358 "../src/worm.vala"
				_tmp9_ = FALSE;
#line 1975 "worm.c"
			}
#line 358 "../src/worm.vala"
			if (_tmp9_) {
#line 359 "../src/worm.vala"
				result = FALSE;
#line 359 "../src/worm.vala"
				return result;
#line 1983 "worm.c"
			} else {
				gboolean _tmp11_ = FALSE;
				int128 _tmp12_;
#line 361 "../src/worm.vala"
				_tmp12_ = *a;
#line 361 "../src/worm.vala"
				if ((*self).hi < _tmp12_.hi) {
#line 361 "../src/worm.vala"
					_tmp11_ = TRUE;
#line 1993 "worm.c"
				} else {
					gboolean _tmp13_ = FALSE;
					int128 _tmp14_;
#line 361 "../src/worm.vala"
					_tmp14_ = *a;
#line 361 "../src/worm.vala"
					if ((*self).hi == _tmp14_.hi) {
#line 2001 "worm.c"
						int128 _tmp15_;
#line 361 "../src/worm.vala"
						_tmp15_ = *a;
#line 361 "../src/worm.vala"
						_tmp13_ = (*self).lo < _tmp15_.lo;
#line 2007 "worm.c"
					} else {
#line 361 "../src/worm.vala"
						_tmp13_ = FALSE;
#line 2011 "worm.c"
					}
#line 361 "../src/worm.vala"
					_tmp11_ = _tmp13_;
#line 2015 "worm.c"
				}
#line 361 "../src/worm.vala"
				result = _tmp11_;
#line 361 "../src/worm.vala"
				return result;
#line 2021 "worm.c"
			}
		}
	}
}

gboolean
int128_less_than_or_equal_to (int128 *self,
                              int128* a)
{
	int128 _tmp0_;
	gboolean result;
#line 365 "../src/worm.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 367 "../src/worm.vala"
	_tmp0_ = *a;
#line 367 "../src/worm.vala"
	result = !int128_greater_than (&(*self), &_tmp0_);
#line 367 "../src/worm.vala"
	return result;
#line 2041 "worm.c"
}

gboolean
int128_less_than (int128 *self,
                  int128* a)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 371 "../src/worm.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 373 "../src/worm.vala"
	if (!(*self).negative) {
#line 2054 "worm.c"
		int128 _tmp1_;
#line 373 "../src/worm.vala"
		_tmp1_ = *a;
#line 373 "../src/worm.vala"
		_tmp0_ = !_tmp1_.negative;
#line 2060 "worm.c"
	} else {
#line 373 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 2064 "worm.c"
	}
#line 373 "../src/worm.vala"
	if (_tmp0_) {
#line 2068 "worm.c"
		gboolean _tmp2_ = FALSE;
		int128 _tmp3_;
#line 374 "../src/worm.vala"
		_tmp3_ = *a;
#line 374 "../src/worm.vala"
		if ((*self).hi < _tmp3_.hi) {
#line 374 "../src/worm.vala"
			_tmp2_ = TRUE;
#line 2077 "worm.c"
		} else {
			gboolean _tmp4_ = FALSE;
			int128 _tmp5_;
#line 374 "../src/worm.vala"
			_tmp5_ = *a;
#line 374 "../src/worm.vala"
			if ((*self).hi == _tmp5_.hi) {
#line 2085 "worm.c"
				int128 _tmp6_;
#line 374 "../src/worm.vala"
				_tmp6_ = *a;
#line 374 "../src/worm.vala"
				_tmp4_ = (*self).lo < _tmp6_.lo;
#line 2091 "worm.c"
			} else {
#line 374 "../src/worm.vala"
				_tmp4_ = FALSE;
#line 2095 "worm.c"
			}
#line 374 "../src/worm.vala"
			_tmp2_ = _tmp4_;
#line 2099 "worm.c"
		}
#line 374 "../src/worm.vala"
		result = _tmp2_;
#line 374 "../src/worm.vala"
		return result;
#line 2105 "worm.c"
	} else {
		gboolean _tmp7_ = FALSE;
#line 375 "../src/worm.vala"
		if (!(*self).negative) {
#line 2110 "worm.c"
			int128 _tmp8_;
#line 375 "../src/worm.vala"
			_tmp8_ = *a;
#line 375 "../src/worm.vala"
			_tmp7_ = _tmp8_.negative;
#line 2116 "worm.c"
		} else {
#line 375 "../src/worm.vala"
			_tmp7_ = FALSE;
#line 2120 "worm.c"
		}
#line 375 "../src/worm.vala"
		if (_tmp7_) {
#line 376 "../src/worm.vala"
			result = FALSE;
#line 376 "../src/worm.vala"
			return result;
#line 2128 "worm.c"
		} else {
			gboolean _tmp9_ = FALSE;
#line 377 "../src/worm.vala"
			if ((*self).negative) {
#line 2133 "worm.c"
				int128 _tmp10_;
#line 377 "../src/worm.vala"
				_tmp10_ = *a;
#line 377 "../src/worm.vala"
				_tmp9_ = !_tmp10_.negative;
#line 2139 "worm.c"
			} else {
#line 377 "../src/worm.vala"
				_tmp9_ = FALSE;
#line 2143 "worm.c"
			}
#line 377 "../src/worm.vala"
			if (_tmp9_) {
#line 378 "../src/worm.vala"
				result = TRUE;
#line 378 "../src/worm.vala"
				return result;
#line 2151 "worm.c"
			} else {
				gboolean _tmp11_ = FALSE;
				int128 _tmp12_;
#line 380 "../src/worm.vala"
				_tmp12_ = *a;
#line 380 "../src/worm.vala"
				if ((*self).hi > _tmp12_.hi) {
#line 380 "../src/worm.vala"
					_tmp11_ = TRUE;
#line 2161 "worm.c"
				} else {
					gboolean _tmp13_ = FALSE;
					int128 _tmp14_;
#line 380 "../src/worm.vala"
					_tmp14_ = *a;
#line 380 "../src/worm.vala"
					if ((*self).hi == _tmp14_.hi) {
#line 2169 "worm.c"
						int128 _tmp15_;
#line 380 "../src/worm.vala"
						_tmp15_ = *a;
#line 380 "../src/worm.vala"
						_tmp13_ = (*self).lo > _tmp15_.lo;
#line 2175 "worm.c"
					} else {
#line 380 "../src/worm.vala"
						_tmp13_ = FALSE;
#line 2179 "worm.c"
					}
#line 380 "../src/worm.vala"
					_tmp11_ = _tmp13_;
#line 2183 "worm.c"
				}
#line 380 "../src/worm.vala"
				result = _tmp11_;
#line 380 "../src/worm.vala"
				return result;
#line 2189 "worm.c"
			}
		}
	}
}

gboolean
int128_equal_to (int128 *self,
                 int128* a)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	int128 _tmp2_;
	gboolean result;
#line 384 "../src/worm.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 386 "../src/worm.vala"
	_tmp2_ = *a;
#line 386 "../src/worm.vala"
	if ((*self).negative == _tmp2_.negative) {
#line 2209 "worm.c"
		int128 _tmp3_;
#line 386 "../src/worm.vala"
		_tmp3_ = *a;
#line 386 "../src/worm.vala"
		_tmp1_ = (*self).hi == _tmp3_.hi;
#line 2215 "worm.c"
	} else {
#line 386 "../src/worm.vala"
		_tmp1_ = FALSE;
#line 2219 "worm.c"
	}
#line 386 "../src/worm.vala"
	if (_tmp1_) {
#line 2223 "worm.c"
		int128 _tmp4_;
#line 386 "../src/worm.vala"
		_tmp4_ = *a;
#line 386 "../src/worm.vala"
		_tmp0_ = (*self).lo == _tmp4_.lo;
#line 2229 "worm.c"
	} else {
#line 386 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 2233 "worm.c"
	}
#line 386 "../src/worm.vala"
	result = _tmp0_;
#line 386 "../src/worm.vala"
	return result;
#line 2239 "worm.c"
}

void
int128_divide_by (int128 *self,
                  gint64 x,
                  int128* result)
{
	guint64 div = 0ULL;
	int128 s = {0};
	int128 _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	int128 d = {0};
	int128 _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	int128 _tmp6_;
	int128 _tmp24_;
#line 395 "../src/worm.vala"
	div = (guint64) llabs (x);
#line 396 "../src/worm.vala"
	_tmp0_.hi = (*self).hi;
#line 396 "../src/worm.vala"
	_tmp0_.lo = (*self).lo;
#line 396 "../src/worm.vala"
	s = _tmp0_;
#line 397 "../src/worm.vala"
	if ((*self).negative) {
#line 397 "../src/worm.vala"
		_tmp2_ = x >= ((gint64) 0);
#line 2269 "worm.c"
	} else {
#line 397 "../src/worm.vala"
		_tmp2_ = FALSE;
#line 2273 "worm.c"
	}
#line 397 "../src/worm.vala"
	if (_tmp2_) {
#line 397 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 2279 "worm.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 397 "../src/worm.vala"
		if (!(*self).negative) {
#line 397 "../src/worm.vala"
			_tmp3_ = x < ((gint64) 0);
#line 2286 "worm.c"
		} else {
#line 397 "../src/worm.vala"
			_tmp3_ = FALSE;
#line 2290 "worm.c"
		}
#line 397 "../src/worm.vala"
		_tmp1_ = _tmp3_;
#line 2294 "worm.c"
	}
#line 397 "../src/worm.vala"
	_tmp4_.hi = (guint64) 0;
#line 397 "../src/worm.vala"
	_tmp4_.lo = (guint64) 0;
#line 397 "../src/worm.vala"
	_tmp4_.negative = _tmp1_;
#line 397 "../src/worm.vala"
	d = _tmp4_;
#line 400 "../src/worm.vala"
	_tmp6_ = s;
#line 400 "../src/worm.vala"
	if (_tmp6_.hi == ((guint64) 0)) {
#line 2308 "worm.c"
		int128 _tmp7_;
#line 400 "../src/worm.vala"
		_tmp7_ = s;
#line 400 "../src/worm.vala"
		_tmp5_ = _tmp7_.lo == ((guint64) 0);
#line 2314 "worm.c"
	} else {
#line 400 "../src/worm.vala"
		_tmp5_ = FALSE;
#line 2318 "worm.c"
	}
#line 400 "../src/worm.vala"
	if (_tmp5_) {
#line 2322 "worm.c"
		int128 _tmp8_ = {0};
#line 402 "../src/worm.vala"
		_tmp8_.hi = (guint64) 0;
#line 402 "../src/worm.vala"
		_tmp8_.lo = (guint64) 0;
#line 402 "../src/worm.vala"
		_tmp8_.negative = FALSE;
#line 402 "../src/worm.vala"
		d = _tmp8_;
#line 403 "../src/worm.vala"
		*result = d;
#line 403 "../src/worm.vala"
		return;
#line 2336 "worm.c"
	} else {
#line 405 "../src/worm.vala"
		if (div == ((guint64) 0)) {
#line 407 "../src/worm.vala"
			d.hi = (guint64) 0xffffffffffffffffLL;
#line 408 "../src/worm.vala"
			d.lo = (guint64) 0xffffffffffffffffLL;
#line 409 "../src/worm.vala"
			*result = d;
#line 409 "../src/worm.vala"
			return;
#line 2348 "worm.c"
		}
	}
	{
		gboolean _tmp9_ = FALSE;
#line 413 "../src/worm.vala"
		_tmp9_ = TRUE;
#line 413 "../src/worm.vala"
		while (TRUE) {
#line 2357 "worm.c"
			gboolean _tmp10_ = FALSE;
			int128 _tmp11_;
#line 413 "../src/worm.vala"
			if (!_tmp9_) {
#line 413 "../src/worm.vala"
				int128_right_shift_assign (&s, 1);
#line 413 "../src/worm.vala"
				div >>= (guint64) 1;
#line 2366 "worm.c"
			}
#line 413 "../src/worm.vala"
			_tmp9_ = FALSE;
#line 413 "../src/worm.vala"
			_tmp11_ = s;
#line 413 "../src/worm.vala"
			if ((_tmp11_.lo & 1) == ((guint64) 0)) {
#line 413 "../src/worm.vala"
				_tmp10_ = (div & 1) == ((guint64) 0);
#line 2376 "worm.c"
			} else {
#line 413 "../src/worm.vala"
				_tmp10_ = FALSE;
#line 2380 "worm.c"
			}
#line 413 "../src/worm.vala"
			if (!_tmp10_) {
#line 413 "../src/worm.vala"
				break;
#line 2386 "worm.c"
			}
		}
	}
#line 415 "../src/worm.vala"
	if (div == ((guint64) 1)) {
#line 2392 "worm.c"
		int128 _tmp12_;
#line 417 "../src/worm.vala"
		_tmp12_ = d;
#line 417 "../src/worm.vala"
		s.negative = _tmp12_.negative;
#line 418 "../src/worm.vala"
		*result = s;
#line 418 "../src/worm.vala"
		return;
#line 2402 "worm.c"
	}
	{
		gboolean _tmp13_ = FALSE;
#line 421 "../src/worm.vala"
		_tmp13_ = TRUE;
#line 421 "../src/worm.vala"
		while (TRUE) {
#line 2410 "worm.c"
			int128 _tmp14_;
			gint shift = 0;
			int128 a = {0};
			int128 _tmp15_;
			int128 _tmp16_;
			int128 _tmp17_ = {0};
			int128 _tmp18_;
			int128 _tmp22_ = {0};
			int128 _tmp23_;
#line 421 "../src/worm.vala"
			if (!_tmp13_) {
#line 2422 "worm.c"
			}
#line 421 "../src/worm.vala"
			_tmp13_ = FALSE;
#line 421 "../src/worm.vala"
			_tmp14_ = s;
#line 421 "../src/worm.vala"
			if (!(_tmp14_.hi > ((guint64) 0))) {
#line 421 "../src/worm.vala"
				break;
#line 2432 "worm.c"
			}
#line 423 "../src/worm.vala"
			shift = 0;
#line 424 "../src/worm.vala"
			_tmp15_ = s;
#line 424 "../src/worm.vala"
			_tmp16_ = s;
#line 424 "../src/worm.vala"
			_tmp17_.hi = _tmp15_.hi;
#line 424 "../src/worm.vala"
			_tmp17_.lo = _tmp16_.lo;
#line 424 "../src/worm.vala"
			a = _tmp17_;
#line 425 "../src/worm.vala"
			_tmp18_ = a;
#line 425 "../src/worm.vala"
			if (_tmp18_.hi < div) {
#line 2450 "worm.c"
				{
					gboolean _tmp19_ = FALSE;
#line 426 "../src/worm.vala"
					_tmp19_ = TRUE;
#line 426 "../src/worm.vala"
					while (TRUE) {
#line 2457 "worm.c"
						int128 _tmp21_;
#line 426 "../src/worm.vala"
						if (!_tmp19_) {
#line 2461 "worm.c"
							gint _tmp20_;
#line 426 "../src/worm.vala"
							int128_right_shift_assign (&a, 1);
#line 426 "../src/worm.vala"
							shift = shift + 1;
#line 426 "../src/worm.vala"
							_tmp20_ = shift;
#line 2469 "worm.c"
						}
#line 426 "../src/worm.vala"
						_tmp19_ = FALSE;
#line 426 "../src/worm.vala"
						_tmp21_ = a;
#line 426 "../src/worm.vala"
						if (!(_tmp21_.hi > ((guint64) 0))) {
#line 426 "../src/worm.vala"
							break;
#line 2479 "worm.c"
						}
					}
				}
			}
#line 428 "../src/worm.vala"
			a.hi = a.hi / div;
#line 429 "../src/worm.vala"
			a.lo = a.lo / div;
#line 430 "../src/worm.vala"
			int128_left_shift_assign (&a, shift);
#line 432 "../src/worm.vala"
			int128_multiply (&a, div, &_tmp22_);
#line 432 "../src/worm.vala"
			int128_minus (&s, &_tmp22_);
#line 434 "../src/worm.vala"
			_tmp23_ = a;
#line 434 "../src/worm.vala"
			int128_add_assign (&d, &_tmp23_);
#line 2498 "worm.c"
		}
	}
#line 436 "../src/worm.vala"
	_tmp24_ = s;
#line 436 "../src/worm.vala"
	if (_tmp24_.lo >= div) {
#line 2505 "worm.c"
		int128 a = {0};
		int128 _tmp25_;
		int128 _tmp26_ = {0};
		int128 _tmp27_;
		int128 _tmp28_;
#line 438 "../src/worm.vala"
		_tmp25_ = s;
#line 438 "../src/worm.vala"
		_tmp26_.hi = (guint64) 0;
#line 438 "../src/worm.vala"
		_tmp26_.lo = _tmp25_.lo / div;
#line 438 "../src/worm.vala"
		a = _tmp26_;
#line 439 "../src/worm.vala"
		_tmp27_ = a;
#line 439 "../src/worm.vala"
		int128_add_assign (&d, &_tmp27_);
#line 440 "../src/worm.vala"
		_tmp28_ = s;
#line 440 "../src/worm.vala"
		d.remainder = _tmp28_.lo % div;
#line 2527 "worm.c"
	} else {
		int128 _tmp29_;
#line 443 "../src/worm.vala"
		_tmp29_ = s;
#line 443 "../src/worm.vala"
		d.remainder = _tmp29_.lo;
#line 2534 "worm.c"
	}
#line 444 "../src/worm.vala"
	*result = d;
#line 444 "../src/worm.vala"
	return;
#line 2540 "worm.c"
}

static gboolean
int128_is_valid_int64 (int128 *self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 450 "../src/worm.vala"
	if ((*self).hi == ((guint64) 0)) {
#line 2550 "worm.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
#line 451 "../src/worm.vala"
		if (!(*self).negative) {
#line 451 "../src/worm.vala"
			_tmp2_ = ((*self).lo & 0x8000000000000000LL) == ((guint64) 0);
#line 2557 "worm.c"
		} else {
#line 451 "../src/worm.vala"
			_tmp2_ = FALSE;
#line 2561 "worm.c"
		}
#line 451 "../src/worm.vala"
		if (_tmp2_) {
#line 451 "../src/worm.vala"
			_tmp1_ = TRUE;
#line 2567 "worm.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 452 "../src/worm.vala"
			if ((*self).negative) {
#line 452 "../src/worm.vala"
				_tmp3_ = (*self).lo <= ((guint64) 0x8000000000000000LL);
#line 2574 "worm.c"
			} else {
#line 452 "../src/worm.vala"
				_tmp3_ = FALSE;
#line 2578 "worm.c"
			}
#line 452 "../src/worm.vala"
			_tmp1_ = _tmp3_;
#line 2582 "worm.c"
		}
#line 451 "../src/worm.vala"
		_tmp0_ = _tmp1_;
#line 2586 "worm.c"
	} else {
#line 450 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 2590 "worm.c"
	}
#line 450 "../src/worm.vala"
	result = _tmp0_;
#line 450 "../src/worm.vala"
	return result;
#line 2596 "worm.c"
}

gint64
int128_get_int64 (int128 *self)
{
	gint64 _tmp0_ = 0LL;
	gint64 result;
#line 458 "../src/worm.vala"
	_vala_assert (int128_is_valid_int64 (&(*self)), "is_valid_int64 ()");
#line 459 "../src/worm.vala"
	if ((*self).negative) {
#line 459 "../src/worm.vala"
		_tmp0_ = (gint64) (-(*self).lo);
#line 2610 "worm.c"
	} else {
#line 459 "../src/worm.vala"
		_tmp0_ = (gint64) (*self).lo;
#line 2614 "worm.c"
	}
#line 459 "../src/worm.vala"
	result = _tmp0_;
#line 459 "../src/worm.vala"
	return result;
#line 2620 "worm.c"
}

static void
int128_multiply (int128 *self,
                 guint64 _a,
                 int128* result)
{
	int128 a = {0};
	int128 _tmp0_ = {0};
	int128 r = {0};
	int128 _tmp1_ = {0};
#line 465 "../src/worm.vala"
	_tmp0_.hi = (guint64) 0;
#line 465 "../src/worm.vala"
	_tmp0_.lo = _a;
#line 465 "../src/worm.vala"
	_tmp0_.negative = FALSE;
#line 465 "../src/worm.vala"
	a = _tmp0_;
#line 466 "../src/worm.vala"
	_tmp1_.hi = (guint64) 0;
#line 466 "../src/worm.vala"
	_tmp1_.lo = (guint64) 0;
#line 466 "../src/worm.vala"
	_tmp1_.negative = FALSE;
#line 466 "../src/worm.vala"
	r = _tmp1_;
#line 2648 "worm.c"
	{
		gint shift = 0;
#line 467 "../src/worm.vala"
		shift = 0;
#line 2653 "worm.c"
		{
			gboolean _tmp2_ = FALSE;
#line 467 "../src/worm.vala"
			_tmp2_ = TRUE;
#line 467 "../src/worm.vala"
			while (TRUE) {
#line 2660 "worm.c"
				gboolean _tmp4_ = FALSE;
				int128 _tmp5_;
				int128 _tmp7_;
#line 467 "../src/worm.vala"
				if (!_tmp2_) {
#line 2666 "worm.c"
					gint _tmp3_;
#line 467 "../src/worm.vala"
					int128_right_shift_assign (&a, 1);
#line 467 "../src/worm.vala"
					_tmp3_ = shift;
#line 467 "../src/worm.vala"
					shift = _tmp3_ + 1;
#line 2674 "worm.c"
				}
#line 467 "../src/worm.vala"
				_tmp2_ = FALSE;
#line 467 "../src/worm.vala"
				_tmp5_ = a;
#line 467 "../src/worm.vala"
				if (_tmp5_.hi > ((guint64) 0)) {
#line 467 "../src/worm.vala"
					_tmp4_ = TRUE;
#line 2684 "worm.c"
				} else {
					int128 _tmp6_;
#line 467 "../src/worm.vala"
					_tmp6_ = a;
#line 467 "../src/worm.vala"
					_tmp4_ = _tmp6_.lo > ((guint64) 0);
#line 2691 "worm.c"
				}
#line 467 "../src/worm.vala"
				if (!_tmp4_) {
#line 467 "../src/worm.vala"
					break;
#line 2697 "worm.c"
				}
#line 469 "../src/worm.vala"
				_tmp7_ = a;
#line 469 "../src/worm.vala"
				if ((_tmp7_.lo & 1) > ((guint64) 0)) {
#line 2703 "worm.c"
					int128 _tmp8_ = {0};
#line 470 "../src/worm.vala"
					int128_left_shift (&(*self), shift, &_tmp8_);
#line 470 "../src/worm.vala"
					int128_add_assign (&r, &_tmp8_);
#line 2709 "worm.c"
				}
			}
		}
	}
#line 472 "../src/worm.vala"
	*result = r;
#line 472 "../src/worm.vala"
	return;
#line 2718 "worm.c"
}

static void
int128_minus (int128 *self,
              int128* a)
{
	int128 _tmp0_;
	int128 _tmp1_;
	int128 _tmp3_;
#line 476 "../src/worm.vala"
	g_return_if_fail (a != NULL);
#line 479 "../src/worm.vala"
	_tmp0_ = *a;
#line 479 "../src/worm.vala"
	(*self).hi = (*self).hi - _tmp0_.hi;
#line 480 "../src/worm.vala"
	_tmp1_ = *a;
#line 480 "../src/worm.vala"
	if ((*self).lo < _tmp1_.lo) {
#line 2738 "worm.c"
		guint64 _tmp2_;
#line 481 "../src/worm.vala"
		(*self).hi = (*self).hi - 1;
#line 481 "../src/worm.vala"
		_tmp2_ = (*self).hi;
#line 2744 "worm.c"
	}
#line 482 "../src/worm.vala"
	_tmp3_ = *a;
#line 482 "../src/worm.vala"
	(*self).lo = (*self).lo - _tmp3_.lo;
#line 2750 "worm.c"
}

int128*
int128_dup (const int128* self)
{
	int128* dup;
#line 289 "../src/worm.vala"
	dup = g_new0 (int128, 1);
#line 289 "../src/worm.vala"
	memcpy (dup, self, sizeof (int128));
#line 289 "../src/worm.vala"
	return dup;
#line 2763 "worm.c"
}

void
int128_free (int128* self)
{
#line 289 "../src/worm.vala"
	g_free (self);
#line 2771 "worm.c"
}

 G_GNUC_NO_INLINE static GType
int128_get_type_once (void)
{
	GType int128_type_id;
	int128_type_id = g_boxed_type_register_static ("int128", (GBoxedCopyFunc) int128_dup, (GBoxedFreeFunc) int128_free);
	return int128_type_id;
}

GType
int128_get_type (void)
{
	static gsize int128_type_id__once = 0;
	if (g_once_init_enter (&int128_type_id__once)) {
		GType int128_type_id;
		int128_type_id = int128_get_type_once ();
		g_once_init_leave (&int128_type_id__once, int128_type_id);
	}
	return int128_type_id__once;
}

void
multiply (gint64 _a,
          gint64 _b,
          int128* result)
{
	gint64 _tmp0_ = 0LL;
	int128 a = {0};
	int128 _tmp1_ = {0};
	gint64 _tmp2_ = 0LL;
	int128 b = {0};
	int128 _tmp3_ = {0};
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	int128 r = {0};
	int128 _tmp7_ = {0};
#line 489 "../src/worm.vala"
	if (llabs (_a) < llabs (_b)) {
#line 489 "../src/worm.vala"
		_tmp0_ = llabs (_b);
#line 2813 "worm.c"
	} else {
#line 489 "../src/worm.vala"
		_tmp0_ = llabs (_a);
#line 2817 "worm.c"
	}
#line 489 "../src/worm.vala"
	_tmp1_.hi = (guint64) 0;
#line 489 "../src/worm.vala"
	_tmp1_.lo = (guint64) _tmp0_;
#line 489 "../src/worm.vala"
	a = _tmp1_;
#line 490 "../src/worm.vala"
	if (llabs (_a) >= llabs (_b)) {
#line 490 "../src/worm.vala"
		_tmp2_ = llabs (_b);
#line 2829 "worm.c"
	} else {
#line 490 "../src/worm.vala"
		_tmp2_ = llabs (_a);
#line 2833 "worm.c"
	}
#line 490 "../src/worm.vala"
	_tmp3_.hi = (guint64) 0;
#line 490 "../src/worm.vala"
	_tmp3_.lo = (guint64) _tmp2_;
#line 490 "../src/worm.vala"
	b = _tmp3_;
#line 491 "../src/worm.vala"
	if (_a < ((gint64) 0)) {
#line 491 "../src/worm.vala"
		_tmp5_ = _b >= ((gint64) 0);
#line 2845 "worm.c"
	} else {
#line 491 "../src/worm.vala"
		_tmp5_ = FALSE;
#line 2849 "worm.c"
	}
#line 491 "../src/worm.vala"
	if (_tmp5_) {
#line 491 "../src/worm.vala"
		_tmp4_ = TRUE;
#line 2855 "worm.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 491 "../src/worm.vala"
		if (_a >= ((gint64) 0)) {
#line 491 "../src/worm.vala"
			_tmp6_ = _b < ((gint64) 0);
#line 2862 "worm.c"
		} else {
#line 491 "../src/worm.vala"
			_tmp6_ = FALSE;
#line 2866 "worm.c"
		}
#line 491 "../src/worm.vala"
		_tmp4_ = _tmp6_;
#line 2870 "worm.c"
	}
#line 491 "../src/worm.vala"
	_tmp7_.hi = (guint64) 0;
#line 491 "../src/worm.vala"
	_tmp7_.lo = (guint64) 0;
#line 491 "../src/worm.vala"
	_tmp7_.negative = _tmp4_;
#line 491 "../src/worm.vala"
	r = _tmp7_;
#line 2880 "worm.c"
	{
		gint shift = 0;
#line 492 "../src/worm.vala"
		shift = 0;
#line 2885 "worm.c"
		{
			gboolean _tmp8_ = FALSE;
#line 492 "../src/worm.vala"
			_tmp8_ = TRUE;
#line 492 "../src/worm.vala"
			while (TRUE) {
#line 2892 "worm.c"
				gboolean _tmp10_ = FALSE;
				int128 _tmp11_;
				int128 _tmp13_;
#line 492 "../src/worm.vala"
				if (!_tmp8_) {
#line 2898 "worm.c"
					gint _tmp9_;
#line 492 "../src/worm.vala"
					int128_right_shift_assign (&b, 1);
#line 492 "../src/worm.vala"
					_tmp9_ = shift;
#line 492 "../src/worm.vala"
					shift = _tmp9_ + 1;
#line 2906 "worm.c"
				}
#line 492 "../src/worm.vala"
				_tmp8_ = FALSE;
#line 492 "../src/worm.vala"
				_tmp11_ = b;
#line 492 "../src/worm.vala"
				if (_tmp11_.hi > ((guint64) 0)) {
#line 492 "../src/worm.vala"
					_tmp10_ = TRUE;
#line 2916 "worm.c"
				} else {
					int128 _tmp12_;
#line 492 "../src/worm.vala"
					_tmp12_ = b;
#line 492 "../src/worm.vala"
					_tmp10_ = _tmp12_.lo > ((guint64) 0);
#line 2923 "worm.c"
				}
#line 492 "../src/worm.vala"
				if (!_tmp10_) {
#line 492 "../src/worm.vala"
					break;
#line 2929 "worm.c"
				}
#line 494 "../src/worm.vala"
				_tmp13_ = b;
#line 494 "../src/worm.vala"
				if ((_tmp13_.lo & 1) > ((guint64) 0)) {
#line 2935 "worm.c"
					int128 _tmp14_ = {0};
#line 495 "../src/worm.vala"
					int128_left_shift (&a, shift, &_tmp14_);
#line 495 "../src/worm.vala"
					int128_add_assign (&r, &_tmp14_);
#line 2941 "worm.c"
				}
			}
		}
	}
#line 497 "../src/worm.vala"
	*result = r;
#line 497 "../src/worm.vala"
	return;
#line 2950 "worm.c"
}

void
multiply_by_2n (gint64 a,
                gint n,
                int128* result)
{
	int128 r = {0};
	int128 _tmp0_ = {0};
#line 503 "../src/worm.vala"
	_tmp0_.hi = (guint64) 0;
#line 503 "../src/worm.vala"
	_tmp0_.lo = (guint64) llabs (a);
#line 503 "../src/worm.vala"
	_tmp0_.negative = a < ((gint64) 0);
#line 503 "../src/worm.vala"
	r = _tmp0_;
#line 504 "../src/worm.vala"
	int128_left_shift_assign (&r, n);
#line 505 "../src/worm.vala"
	*result = r;
#line 505 "../src/worm.vala"
	return;
#line 2974 "worm.c"
}

static inline gpointer
angle_iterator_get_instance_private (AngleIterator* self)
{
	return G_STRUCT_MEMBER_P (self, AngleIterator_private_offset);
}

AngleIterator*
angle_iterator_construct (GType object_type,
                          Angle* p)
{
	AngleIterator* self = NULL;
	Angle _tmp0_;
#line 516 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, NULL);
#line 516 "../src/worm.vala"
	self = (AngleIterator*) g_type_create_instance (object_type);
#line 518 "../src/worm.vala"
	_tmp0_ = *p;
#line 518 "../src/worm.vala"
	self->priv->pAngle = _tmp0_;
#line 519 "../src/worm.vala"
	self->priv->index = (guint64) 0;
#line 516 "../src/worm.vala"
	return self;
#line 3001 "worm.c"
}

AngleIterator*
angle_iterator_new (Angle* p)
{
#line 516 "../src/worm.vala"
	return angle_iterator_construct (TYPE_ANGLE_ITERATOR, p);
#line 3009 "worm.c"
}

gboolean
angle_iterator_next (AngleIterator* self)
{
	guint64 _tmp0_;
	gboolean result;
#line 522 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 524 "../src/worm.vala"
	self->priv->index = self->priv->index + 1;
#line 524 "../src/worm.vala"
	_tmp0_ = self->priv->index;
#line 525 "../src/worm.vala"
	result = TRUE;
#line 525 "../src/worm.vala"
	return result;
#line 3027 "worm.c"
}

void
angle_iterator_get (AngleIterator* self,
                    SignedPosition* result)
{
	SignedPosition _tmp0_ = {0};
#line 528 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 530 "../src/worm.vala"
	angle_get (&self->priv->pAngle, self->priv->index, &_tmp0_);
#line 530 "../src/worm.vala"
	*result = _tmp0_;
#line 530 "../src/worm.vala"
	return;
#line 3043 "worm.c"
}

static void
value_angle_iterator_init (GValue* value)
{
#line 509 "../src/worm.vala"
	value->data[0].v_pointer = NULL;
#line 3051 "worm.c"
}

static void
value_angle_iterator_free_value (GValue* value)
{
#line 509 "../src/worm.vala"
	if (value->data[0].v_pointer) {
#line 509 "../src/worm.vala"
		angle_iterator_unref (value->data[0].v_pointer);
#line 3061 "worm.c"
	}
}

static void
value_angle_iterator_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 509 "../src/worm.vala"
	if (src_value->data[0].v_pointer) {
#line 509 "../src/worm.vala"
		dest_value->data[0].v_pointer = angle_iterator_ref (src_value->data[0].v_pointer);
#line 3073 "worm.c"
	} else {
#line 509 "../src/worm.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3077 "worm.c"
	}
}

static gpointer
value_angle_iterator_peek_pointer (const GValue* value)
{
#line 509 "../src/worm.vala"
	return value->data[0].v_pointer;
#line 3086 "worm.c"
}

static gchar*
value_angle_iterator_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 509 "../src/worm.vala"
	if (collect_values[0].v_pointer) {
#line 3097 "worm.c"
		AngleIterator * object;
		object = collect_values[0].v_pointer;
#line 509 "../src/worm.vala"
		if (object->parent_instance.g_class == NULL) {
#line 509 "../src/worm.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3104 "worm.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 509 "../src/worm.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3108 "worm.c"
		}
#line 509 "../src/worm.vala"
		value->data[0].v_pointer = angle_iterator_ref (object);
#line 3112 "worm.c"
	} else {
#line 509 "../src/worm.vala"
		value->data[0].v_pointer = NULL;
#line 3116 "worm.c"
	}
#line 509 "../src/worm.vala"
	return NULL;
#line 3120 "worm.c"
}

static gchar*
value_angle_iterator_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	AngleIterator ** object_p;
	object_p = collect_values[0].v_pointer;
#line 509 "../src/worm.vala"
	if (!object_p) {
#line 509 "../src/worm.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3135 "worm.c"
	}
#line 509 "../src/worm.vala"
	if (!value->data[0].v_pointer) {
#line 509 "../src/worm.vala"
		*object_p = NULL;
#line 3141 "worm.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 509 "../src/worm.vala"
		*object_p = value->data[0].v_pointer;
#line 3145 "worm.c"
	} else {
#line 509 "../src/worm.vala"
		*object_p = angle_iterator_ref (value->data[0].v_pointer);
#line 3149 "worm.c"
	}
#line 509 "../src/worm.vala"
	return NULL;
#line 3153 "worm.c"
}

GParamSpec*
param_spec_angle_iterator (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecAngleIterator* spec;
#line 509 "../src/worm.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ANGLE_ITERATOR), NULL);
#line 509 "../src/worm.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 509 "../src/worm.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 509 "../src/worm.vala"
	return G_PARAM_SPEC (spec);
#line 3172 "worm.c"
}

gpointer
value_get_angle_iterator (const GValue* value)
{
#line 509 "../src/worm.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ANGLE_ITERATOR), NULL);
#line 509 "../src/worm.vala"
	return value->data[0].v_pointer;
#line 3182 "worm.c"
}

void
value_set_angle_iterator (GValue* value,
                          gpointer v_object)
{
	AngleIterator * old;
#line 509 "../src/worm.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ANGLE_ITERATOR));
#line 509 "../src/worm.vala"
	old = value->data[0].v_pointer;
#line 509 "../src/worm.vala"
	if (v_object) {
#line 509 "../src/worm.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ANGLE_ITERATOR));
#line 509 "../src/worm.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 509 "../src/worm.vala"
		value->data[0].v_pointer = v_object;
#line 509 "../src/worm.vala"
		angle_iterator_ref (value->data[0].v_pointer);
#line 3204 "worm.c"
	} else {
#line 509 "../src/worm.vala"
		value->data[0].v_pointer = NULL;
#line 3208 "worm.c"
	}
#line 509 "../src/worm.vala"
	if (old) {
#line 509 "../src/worm.vala"
		angle_iterator_unref (old);
#line 3214 "worm.c"
	}
}

void
value_take_angle_iterator (GValue* value,
                           gpointer v_object)
{
	AngleIterator * old;
#line 509 "../src/worm.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ANGLE_ITERATOR));
#line 509 "../src/worm.vala"
	old = value->data[0].v_pointer;
#line 509 "../src/worm.vala"
	if (v_object) {
#line 509 "../src/worm.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ANGLE_ITERATOR));
#line 509 "../src/worm.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 509 "../src/worm.vala"
		value->data[0].v_pointer = v_object;
#line 3235 "worm.c"
	} else {
#line 509 "../src/worm.vala"
		value->data[0].v_pointer = NULL;
#line 3239 "worm.c"
	}
#line 509 "../src/worm.vala"
	if (old) {
#line 509 "../src/worm.vala"
		angle_iterator_unref (old);
#line 3245 "worm.c"
	}
}

static void
angle_iterator_class_init (AngleIteratorClass * klass,
                           gpointer klass_data)
{
#line 509 "../src/worm.vala"
	angle_iterator_parent_class = g_type_class_peek_parent (klass);
#line 509 "../src/worm.vala"
	((AngleIteratorClass *) klass)->finalize = angle_iterator_finalize;
#line 509 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &AngleIterator_private_offset);
#line 3259 "worm.c"
}

static void
angle_iterator_instance_init (AngleIterator * self,
                              gpointer klass)
{
#line 509 "../src/worm.vala"
	self->priv = angle_iterator_get_instance_private (self);
#line 509 "../src/worm.vala"
	self->ref_count = 1;
#line 3270 "worm.c"
}

static void
angle_iterator_finalize (AngleIterator * obj)
{
	AngleIterator * self;
#line 509 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ANGLE_ITERATOR, AngleIterator);
#line 509 "../src/worm.vala"
	g_signal_handlers_destroy (self);
#line 3281 "worm.c"
}

 G_GNUC_NO_INLINE static GType
angle_iterator_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_angle_iterator_init, value_angle_iterator_free_value, value_angle_iterator_copy_value, value_angle_iterator_peek_pointer, "p", value_angle_iterator_collect_value, "p", value_angle_iterator_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (AngleIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) angle_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AngleIterator), 0, (GInstanceInitFunc) angle_iterator_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType angle_iterator_type_id;
	angle_iterator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AngleIterator", &g_define_type_info, &g_define_type_fundamental_info, 0);
	AngleIterator_private_offset = g_type_add_instance_private (angle_iterator_type_id, sizeof (AngleIteratorPrivate));
	return angle_iterator_type_id;
}

GType
angle_iterator_get_type (void)
{
	static gsize angle_iterator_type_id__once = 0;
	if (g_once_init_enter (&angle_iterator_type_id__once)) {
		GType angle_iterator_type_id;
		angle_iterator_type_id = angle_iterator_get_type_once ();
		g_once_init_leave (&angle_iterator_type_id__once, angle_iterator_type_id);
	}
	return angle_iterator_type_id__once;
}

gpointer
angle_iterator_ref (gpointer instance)
{
	AngleIterator * self;
	self = instance;
#line 509 "../src/worm.vala"
	g_atomic_int_inc (&self->ref_count);
#line 509 "../src/worm.vala"
	return instance;
#line 3317 "worm.c"
}

void
angle_iterator_unref (gpointer instance)
{
	AngleIterator * self;
	self = instance;
#line 509 "../src/worm.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 509 "../src/worm.vala"
		ANGLE_ITERATOR_GET_CLASS (self)->finalize (self);
#line 509 "../src/worm.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3331 "worm.c"
	}
}

 G_GNUC_NO_INLINE static GType
quarter_get_type_once (void)
{
	static const GEnumValue values[] = {{QUARTER_Q0, "QUARTER_Q0", "q0"}, {QUARTER_Q1, "QUARTER_Q1", "q1"}, {QUARTER_Q2, "QUARTER_Q2", "q2"}, {QUARTER_Q3, "QUARTER_Q3", "q3"}, {0, NULL, NULL}};
	GType quarter_type_id;
	quarter_type_id = g_enum_register_static ("Quarter", values);
	return quarter_type_id;
}

GType
quarter_get_type (void)
{
	static gsize quarter_type_id__once = 0;
	if (g_once_init_enter (&quarter_type_id__once)) {
		GType quarter_type_id;
		quarter_type_id = quarter_get_type_once ();
		g_once_init_leave (&quarter_type_id__once, quarter_type_id);
	}
	return quarter_type_id__once;
}

void
angle_assign (Angle *self,
              Angle* o)
{
	Angle _tmp0_;
	Angle _tmp1_;
	Angle _tmp2_;
	Angle _tmp3_;
	Angle _tmp4_;
	Angle _tmp5_;
#line 564 "../src/worm.vala"
	g_return_if_fail (o != NULL);
#line 566 "../src/worm.vala"
	_tmp0_ = *o;
#line 566 "../src/worm.vala"
	(*self).x = _tmp0_.x;
#line 567 "../src/worm.vala"
	_tmp1_ = *o;
#line 567 "../src/worm.vala"
	(*self).y = _tmp1_.y;
#line 568 "../src/worm.vala"
	_tmp2_ = *o;
#line 568 "../src/worm.vala"
	(*self).origin_x = _tmp2_.origin_x;
#line 569 "../src/worm.vala"
	_tmp3_ = *o;
#line 569 "../src/worm.vala"
	(*self).origin_y = _tmp3_.origin_y;
#line 570 "../src/worm.vala"
	_tmp4_ = *o;
#line 570 "../src/worm.vala"
	(*self).x_max = _tmp4_.x_max;
#line 571 "../src/worm.vala"
	_tmp5_ = *o;
#line 571 "../src/worm.vala"
	(*self).y_max = _tmp5_.y_max;
#line 3392 "worm.c"
}

gboolean
angle_less_than_or_equal_to (Angle *self,
                             Angle* o)
{
	Angle _tmp0_;
	gboolean result;
#line 575 "../src/worm.vala"
	g_return_val_if_fail (o != NULL, FALSE);
#line 577 "../src/worm.vala"
	_tmp0_ = *o;
#line 577 "../src/worm.vala"
	result = !angle_greater_than (&(*self), &_tmp0_);
#line 577 "../src/worm.vala"
	return result;
#line 3409 "worm.c"
}

gboolean
angle_greater_than (Angle *self,
                    Angle* o)
{
	Quarter q = 0;
	gboolean result;
#line 581 "../src/worm.vala"
	g_return_val_if_fail (o != NULL, FALSE);
#line 583 "../src/worm.vala"
	q = angle_get_quarter (o);
#line 584 "../src/worm.vala"
	switch (angle_get_quarter (&(*self))) {
#line 584 "../src/worm.vala"
		case QUARTER_Q0:
#line 3426 "worm.c"
		{
#line 587 "../src/worm.vala"
			if (q == QUARTER_Q3) {
#line 588 "../src/worm.vala"
				result = TRUE;
#line 588 "../src/worm.vala"
				return result;
#line 3434 "worm.c"
			} else {
#line 589 "../src/worm.vala"
				if (q == QUARTER_Q1) {
#line 590 "../src/worm.vala"
					result = FALSE;
#line 590 "../src/worm.vala"
					return result;
#line 3442 "worm.c"
				} else {
					Angle _tmp0_;
					int128 _tmp1_ = {0};
					Angle _tmp2_;
					int128 _tmp3_ = {0};
#line 592 "../src/worm.vala"
					_tmp0_ = *o;
#line 592 "../src/worm.vala"
					multiply ((*self).x, _tmp0_.y, &_tmp1_);
#line 592 "../src/worm.vala"
					_tmp2_ = *o;
#line 592 "../src/worm.vala"
					multiply (_tmp2_.x, (*self).y, &_tmp3_);
#line 592 "../src/worm.vala"
					result = int128_less_than (&_tmp1_, &_tmp3_);
#line 592 "../src/worm.vala"
					return result;
#line 3460 "worm.c"
				}
			}
		}
#line 584 "../src/worm.vala"
		case QUARTER_Q1:
#line 3466 "worm.c"
		{
#line 594 "../src/worm.vala"
			if (q == QUARTER_Q0) {
#line 595 "../src/worm.vala"
				result = TRUE;
#line 595 "../src/worm.vala"
				return result;
#line 3474 "worm.c"
			} else {
#line 596 "../src/worm.vala"
				if (q == QUARTER_Q2) {
#line 597 "../src/worm.vala"
					result = FALSE;
#line 597 "../src/worm.vala"
					return result;
#line 3482 "worm.c"
				} else {
					Angle _tmp4_;
					int128 _tmp5_ = {0};
					Angle _tmp6_;
					int128 _tmp7_ = {0};
#line 599 "../src/worm.vala"
					_tmp4_ = *o;
#line 599 "../src/worm.vala"
					multiply ((*self).x, _tmp4_.y, &_tmp5_);
#line 599 "../src/worm.vala"
					_tmp6_ = *o;
#line 599 "../src/worm.vala"
					multiply (_tmp6_.x, (*self).y, &_tmp7_);
#line 599 "../src/worm.vala"
					result = int128_less_than (&_tmp5_, &_tmp7_);
#line 599 "../src/worm.vala"
					return result;
#line 3500 "worm.c"
				}
			}
		}
#line 584 "../src/worm.vala"
		case QUARTER_Q2:
#line 3506 "worm.c"
		{
#line 601 "../src/worm.vala"
			if (q == QUARTER_Q1) {
#line 602 "../src/worm.vala"
				result = TRUE;
#line 602 "../src/worm.vala"
				return result;
#line 3514 "worm.c"
			} else {
#line 603 "../src/worm.vala"
				if (q == QUARTER_Q3) {
#line 604 "../src/worm.vala"
					result = FALSE;
#line 604 "../src/worm.vala"
					return result;
#line 3522 "worm.c"
				} else {
					Angle _tmp8_;
					int128 _tmp9_ = {0};
					Angle _tmp10_;
					int128 _tmp11_ = {0};
#line 606 "../src/worm.vala"
					_tmp8_ = *o;
#line 606 "../src/worm.vala"
					multiply ((*self).x, _tmp8_.y, &_tmp9_);
#line 606 "../src/worm.vala"
					_tmp10_ = *o;
#line 606 "../src/worm.vala"
					multiply (_tmp10_.x, (*self).y, &_tmp11_);
#line 606 "../src/worm.vala"
					result = int128_less_than (&_tmp9_, &_tmp11_);
#line 606 "../src/worm.vala"
					return result;
#line 3540 "worm.c"
				}
			}
		}
#line 584 "../src/worm.vala"
		case QUARTER_Q3:
#line 3546 "worm.c"
		{
#line 608 "../src/worm.vala"
			if (q == QUARTER_Q2) {
#line 609 "../src/worm.vala"
				result = TRUE;
#line 609 "../src/worm.vala"
				return result;
#line 3554 "worm.c"
			} else {
#line 610 "../src/worm.vala"
				if (q == QUARTER_Q0) {
#line 611 "../src/worm.vala"
					result = FALSE;
#line 611 "../src/worm.vala"
					return result;
#line 3562 "worm.c"
				} else {
					Angle _tmp12_;
					int128 _tmp13_ = {0};
					Angle _tmp14_;
					int128 _tmp15_ = {0};
#line 613 "../src/worm.vala"
					_tmp12_ = *o;
#line 613 "../src/worm.vala"
					multiply ((*self).x, _tmp12_.y, &_tmp13_);
#line 613 "../src/worm.vala"
					_tmp14_ = *o;
#line 613 "../src/worm.vala"
					multiply (_tmp14_.x, (*self).y, &_tmp15_);
#line 613 "../src/worm.vala"
					result = int128_less_than (&_tmp13_, &_tmp15_);
#line 613 "../src/worm.vala"
					return result;
#line 3580 "worm.c"
				}
			}
		}
		default:
		{
#line 615 "../src/worm.vala"
			result = FALSE;
#line 615 "../src/worm.vala"
			return result;
#line 3590 "worm.c"
		}
	}
}

gboolean
angle_less_than (Angle *self,
                 Angle* o)
{
	gboolean _tmp0_ = FALSE;
	Angle _tmp1_;
	gboolean result;
#line 620 "../src/worm.vala"
	g_return_val_if_fail (o != NULL, FALSE);
#line 622 "../src/worm.vala"
	_tmp1_ = *o;
#line 622 "../src/worm.vala"
	if (!angle_equal_to (&(*self), &_tmp1_)) {
#line 3608 "worm.c"
		Angle _tmp2_;
#line 622 "../src/worm.vala"
		_tmp2_ = *o;
#line 622 "../src/worm.vala"
		_tmp0_ = angle_less_than_or_equal_to (&(*self), &_tmp2_);
#line 3614 "worm.c"
	} else {
#line 622 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 3618 "worm.c"
	}
#line 622 "../src/worm.vala"
	result = _tmp0_;
#line 622 "../src/worm.vala"
	return result;
#line 3624 "worm.c"
}

gboolean
angle_greater_than_or_equal_to (Angle *self,
                                Angle* o)
{
	Quarter q = 0;
	gboolean result;
#line 626 "../src/worm.vala"
	g_return_val_if_fail (o != NULL, FALSE);
#line 628 "../src/worm.vala"
	q = angle_get_quarter (o);
#line 629 "../src/worm.vala"
	switch (angle_get_quarter (&(*self))) {
#line 629 "../src/worm.vala"
		case QUARTER_Q0:
#line 3641 "worm.c"
		{
#line 632 "../src/worm.vala"
			if (q == QUARTER_Q3) {
#line 633 "../src/worm.vala"
				result = TRUE;
#line 633 "../src/worm.vala"
				return result;
#line 3649 "worm.c"
			} else {
#line 634 "../src/worm.vala"
				if (q == QUARTER_Q1) {
#line 635 "../src/worm.vala"
					result = FALSE;
#line 635 "../src/worm.vala"
					return result;
#line 3657 "worm.c"
				} else {
#line 636 "../src/worm.vala"
					if (q == QUARTER_Q2) {
#line 3661 "worm.c"
						Angle _tmp0_;
						int128 _tmp1_ = {0};
						Angle _tmp2_;
						int128 _tmp3_ = {0};
#line 637 "../src/worm.vala"
						_tmp0_ = *o;
#line 637 "../src/worm.vala"
						multiply ((*self).x, _tmp0_.y, &_tmp1_);
#line 637 "../src/worm.vala"
						_tmp2_ = *o;
#line 637 "../src/worm.vala"
						multiply (_tmp2_.x, (*self).y, &_tmp3_);
#line 637 "../src/worm.vala"
						result = int128_less_than (&_tmp1_, &_tmp3_);
#line 637 "../src/worm.vala"
						return result;
#line 3678 "worm.c"
					} else {
						Angle _tmp4_;
						int128 _tmp5_ = {0};
						Angle _tmp6_;
						int128 _tmp7_ = {0};
#line 639 "../src/worm.vala"
						_tmp4_ = *o;
#line 639 "../src/worm.vala"
						multiply ((*self).x, _tmp4_.y, &_tmp5_);
#line 639 "../src/worm.vala"
						_tmp6_ = *o;
#line 639 "../src/worm.vala"
						multiply (_tmp6_.x, (*self).y, &_tmp7_);
#line 639 "../src/worm.vala"
						result = int128_less_than_or_equal_to (&_tmp5_, &_tmp7_);
#line 639 "../src/worm.vala"
						return result;
#line 3696 "worm.c"
					}
				}
			}
		}
#line 629 "../src/worm.vala"
		case QUARTER_Q1:
#line 3703 "worm.c"
		{
#line 641 "../src/worm.vala"
			if (q == QUARTER_Q0) {
#line 642 "../src/worm.vala"
				result = TRUE;
#line 642 "../src/worm.vala"
				return result;
#line 3711 "worm.c"
			} else {
#line 643 "../src/worm.vala"
				if (q == QUARTER_Q2) {
#line 644 "../src/worm.vala"
					result = FALSE;
#line 644 "../src/worm.vala"
					return result;
#line 3719 "worm.c"
				} else {
#line 645 "../src/worm.vala"
					if (q == QUARTER_Q3) {
#line 3723 "worm.c"
						Angle _tmp8_;
						int128 _tmp9_ = {0};
						Angle _tmp10_;
						int128 _tmp11_ = {0};
#line 646 "../src/worm.vala"
						_tmp8_ = *o;
#line 646 "../src/worm.vala"
						multiply ((*self).x, _tmp8_.y, &_tmp9_);
#line 646 "../src/worm.vala"
						_tmp10_ = *o;
#line 646 "../src/worm.vala"
						multiply (_tmp10_.x, (*self).y, &_tmp11_);
#line 646 "../src/worm.vala"
						result = int128_less_than (&_tmp9_, &_tmp11_);
#line 646 "../src/worm.vala"
						return result;
#line 3740 "worm.c"
					} else {
						Angle _tmp12_;
						int128 _tmp13_ = {0};
						Angle _tmp14_;
						int128 _tmp15_ = {0};
#line 648 "../src/worm.vala"
						_tmp12_ = *o;
#line 648 "../src/worm.vala"
						multiply ((*self).x, _tmp12_.y, &_tmp13_);
#line 648 "../src/worm.vala"
						_tmp14_ = *o;
#line 648 "../src/worm.vala"
						multiply (_tmp14_.x, (*self).y, &_tmp15_);
#line 648 "../src/worm.vala"
						result = int128_less_than_or_equal_to (&_tmp13_, &_tmp15_);
#line 648 "../src/worm.vala"
						return result;
#line 3758 "worm.c"
					}
				}
			}
		}
#line 629 "../src/worm.vala"
		case QUARTER_Q2:
#line 3765 "worm.c"
		{
#line 650 "../src/worm.vala"
			if (q == QUARTER_Q1) {
#line 651 "../src/worm.vala"
				result = TRUE;
#line 651 "../src/worm.vala"
				return result;
#line 3773 "worm.c"
			} else {
#line 652 "../src/worm.vala"
				if (q == QUARTER_Q3) {
#line 653 "../src/worm.vala"
					result = FALSE;
#line 653 "../src/worm.vala"
					return result;
#line 3781 "worm.c"
				} else {
#line 654 "../src/worm.vala"
					if (q == QUARTER_Q0) {
#line 3785 "worm.c"
						Angle _tmp16_;
						int128 _tmp17_ = {0};
						Angle _tmp18_;
						int128 _tmp19_ = {0};
#line 655 "../src/worm.vala"
						_tmp16_ = *o;
#line 655 "../src/worm.vala"
						multiply ((*self).x, _tmp16_.y, &_tmp17_);
#line 655 "../src/worm.vala"
						_tmp18_ = *o;
#line 655 "../src/worm.vala"
						multiply (_tmp18_.x, (*self).y, &_tmp19_);
#line 655 "../src/worm.vala"
						result = int128_less_than (&_tmp17_, &_tmp19_);
#line 655 "../src/worm.vala"
						return result;
#line 3802 "worm.c"
					} else {
						Angle _tmp20_;
						int128 _tmp21_ = {0};
						Angle _tmp22_;
						int128 _tmp23_ = {0};
#line 657 "../src/worm.vala"
						_tmp20_ = *o;
#line 657 "../src/worm.vala"
						multiply ((*self).x, _tmp20_.y, &_tmp21_);
#line 657 "../src/worm.vala"
						_tmp22_ = *o;
#line 657 "../src/worm.vala"
						multiply (_tmp22_.x, (*self).y, &_tmp23_);
#line 657 "../src/worm.vala"
						result = int128_less_than_or_equal_to (&_tmp21_, &_tmp23_);
#line 657 "../src/worm.vala"
						return result;
#line 3820 "worm.c"
					}
				}
			}
		}
#line 629 "../src/worm.vala"
		case QUARTER_Q3:
#line 3827 "worm.c"
		{
#line 659 "../src/worm.vala"
			if (q == QUARTER_Q2) {
#line 660 "../src/worm.vala"
				result = TRUE;
#line 660 "../src/worm.vala"
				return result;
#line 3835 "worm.c"
			} else {
#line 661 "../src/worm.vala"
				if (q == QUARTER_Q0) {
#line 662 "../src/worm.vala"
					result = FALSE;
#line 662 "../src/worm.vala"
					return result;
#line 3843 "worm.c"
				} else {
#line 663 "../src/worm.vala"
					if (q == QUARTER_Q1) {
#line 3847 "worm.c"
						Angle _tmp24_;
						int128 _tmp25_ = {0};
						Angle _tmp26_;
						int128 _tmp27_ = {0};
#line 664 "../src/worm.vala"
						_tmp24_ = *o;
#line 664 "../src/worm.vala"
						multiply ((*self).x, _tmp24_.y, &_tmp25_);
#line 664 "../src/worm.vala"
						_tmp26_ = *o;
#line 664 "../src/worm.vala"
						multiply (_tmp26_.x, (*self).y, &_tmp27_);
#line 664 "../src/worm.vala"
						result = int128_less_than (&_tmp25_, &_tmp27_);
#line 664 "../src/worm.vala"
						return result;
#line 3864 "worm.c"
					} else {
						Angle _tmp28_;
						int128 _tmp29_ = {0};
						Angle _tmp30_;
						int128 _tmp31_ = {0};
#line 666 "../src/worm.vala"
						_tmp28_ = *o;
#line 666 "../src/worm.vala"
						multiply ((*self).x, _tmp28_.y, &_tmp29_);
#line 666 "../src/worm.vala"
						_tmp30_ = *o;
#line 666 "../src/worm.vala"
						multiply (_tmp30_.x, (*self).y, &_tmp31_);
#line 666 "../src/worm.vala"
						result = int128_less_than_or_equal_to (&_tmp29_, &_tmp31_);
#line 666 "../src/worm.vala"
						return result;
#line 3882 "worm.c"
					}
				}
			}
		}
		default:
		{
#line 668 "../src/worm.vala"
			result = FALSE;
#line 668 "../src/worm.vala"
			return result;
#line 3893 "worm.c"
		}
	}
}

gboolean
angle_equal_to (Angle *self,
                Angle* o)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 673 "../src/worm.vala"
	g_return_val_if_fail (o != NULL, FALSE);
#line 675 "../src/worm.vala"
	if (angle_get_quarter (&(*self)) == angle_get_quarter (o)) {
#line 3908 "worm.c"
		Angle _tmp1_;
		int128 _tmp2_ = {0};
		Angle _tmp3_;
		int128 _tmp4_ = {0};
#line 676 "../src/worm.vala"
		_tmp1_ = *o;
#line 676 "../src/worm.vala"
		multiply ((*self).x, _tmp1_.y, &_tmp2_);
#line 676 "../src/worm.vala"
		_tmp3_ = *o;
#line 676 "../src/worm.vala"
		multiply (_tmp3_.x, (*self).y, &_tmp4_);
#line 676 "../src/worm.vala"
		_tmp0_ = int128_equal_to (&_tmp2_, &_tmp4_);
#line 3923 "worm.c"
	} else {
#line 675 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 3927 "worm.c"
	}
#line 675 "../src/worm.vala"
	result = _tmp0_;
#line 675 "../src/worm.vala"
	return result;
#line 3933 "worm.c"
}

void
angle_set_origin (Angle *self,
                  Position* origin)
{
	Position _tmp0_;
	Position _tmp1_;
#line 679 "../src/worm.vala"
	g_return_if_fail (origin != NULL);
#line 681 "../src/worm.vala"
	_tmp0_ = *origin;
#line 681 "../src/worm.vala"
	(*self).origin_x = ((_tmp0_.x * 2) + 1) * (ANGLE_step_multiplier / 2);
#line 682 "../src/worm.vala"
	_tmp1_ = *origin;
#line 682 "../src/worm.vala"
	(*self).origin_y = ((_tmp1_.y * 2) + 1) * (ANGLE_step_multiplier / 2);
#line 3952 "worm.c"
}

void
angle_set_wrapping (Angle *self,
                    gint x,
                    gint y)
{
#line 687 "../src/worm.vala"
	(*self).x_max = (gint64) x;
#line 688 "../src/worm.vala"
	(*self).y_max = (gint64) y;
#line 3964 "worm.c"
}

gboolean
angle_step_along_x (Angle *self)
{
	gboolean result;
#line 693 "../src/worm.vala"
	result = llabs ((*self).x) > llabs ((*self).y);
#line 693 "../src/worm.vala"
	return result;
#line 3975 "worm.c"
}

void
angle_get (Angle *self,
           guint64 i,
           SignedPosition* result)
{
	gint64 _tmp0_ = 0LL;
	gint64 delta_x = 0LL;
	gint64 _tmp3_ = 0LL;
	gint64 delta_y = 0LL;
	gint64 x_i = 0LL;
	gint64 y_i = 0LL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	SignedPosition _tmp8_ = {0};
#line 700 "../src/worm.vala"
	if (angle_step_along_x (&(*self))) {
#line 700 "../src/worm.vala"
		_tmp0_ = angle_set_delta_x_sign (&(*self), ANGLE_step_multiplier);
#line 3996 "worm.c"
	} else {
		int128 _tmp1_ = {0};
		int128 _tmp2_ = {0};
#line 701 "../src/worm.vala"
		multiply_by_2n ((*self).x, ANGLE_step_multiplier_2n, &_tmp1_);
#line 701 "../src/worm.vala"
		int128_divide_by (&_tmp1_, (*self).y, &_tmp2_);
#line 701 "../src/worm.vala"
		_tmp0_ = angle_set_delta_x_sign (&(*self), int128_get_int64 (&_tmp2_));
#line 4006 "worm.c"
	}
#line 700 "../src/worm.vala"
	delta_x = _tmp0_;
#line 702 "../src/worm.vala"
	if (angle_step_along_x (&(*self))) {
#line 4012 "worm.c"
		int128 _tmp4_ = {0};
		int128 _tmp5_ = {0};
#line 702 "../src/worm.vala"
		multiply_by_2n ((*self).y, ANGLE_step_multiplier_2n, &_tmp4_);
#line 702 "../src/worm.vala"
		int128_divide_by (&_tmp4_, (*self).x, &_tmp5_);
#line 702 "../src/worm.vala"
		_tmp3_ = angle_set_delta_y_sign (&(*self), int128_get_int64 (&_tmp5_));
#line 4021 "worm.c"
	} else {
#line 703 "../src/worm.vala"
		_tmp3_ = angle_set_delta_y_sign (&(*self), ANGLE_step_multiplier);
#line 4025 "worm.c"
	}
#line 702 "../src/worm.vala"
	delta_y = _tmp3_;
#line 706 "../src/worm.vala"
	x_i = (*self).origin_x + (delta_x * ((gint64) i));
#line 707 "../src/worm.vala"
	y_i = (*self).origin_y + (delta_y * ((gint64) i));
#line 709 "../src/worm.vala"
	if (x_i < ((gint64) 0)) {
#line 709 "../src/worm.vala"
		_tmp6_ = -1;
#line 4037 "worm.c"
	} else {
#line 709 "../src/worm.vala"
		_tmp6_ = 0;
#line 4041 "worm.c"
	}
#line 710 "../src/worm.vala"
	if (y_i < ((gint64) 0)) {
#line 710 "../src/worm.vala"
		_tmp7_ = -1;
#line 4047 "worm.c"
	} else {
#line 710 "../src/worm.vala"
		_tmp7_ = 0;
#line 4051 "worm.c"
	}
#line 709 "../src/worm.vala"
	_tmp8_.x = (x_i >> ANGLE_step_multiplier_2n) + _tmp6_;
#line 709 "../src/worm.vala"
	_tmp8_.y = (y_i >> ANGLE_step_multiplier_2n) + _tmp7_;
#line 709 "../src/worm.vala"
	_tmp8_.x_max = (*self).x_max;
#line 709 "../src/worm.vala"
	_tmp8_.y_max = (*self).y_max;
#line 709 "../src/worm.vala"
	*result = _tmp8_;
#line 709 "../src/worm.vala"
	return;
#line 4065 "worm.c"
}

AngleIterator*
angle_iterator (Angle *self)
{
	AngleIterator* _tmp0_;
	AngleIterator* result;
#line 715 "../src/worm.vala"
	_tmp0_ = angle_iterator_new (&(*self));
#line 715 "../src/worm.vala"
	result = _tmp0_;
#line 715 "../src/worm.vala"
	return result;
#line 4079 "worm.c"
}

static Quarter
angle_get_quarter (Angle *self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Quarter result;
#line 734 "../src/worm.vala"
	if ((*self).x >= ((gint64) 0)) {
#line 734 "../src/worm.vala"
		_tmp0_ = (*self).y < ((gint64) 0);
#line 4092 "worm.c"
	} else {
#line 734 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 4096 "worm.c"
	}
#line 734 "../src/worm.vala"
	if (_tmp0_) {
#line 735 "../src/worm.vala"
		result = QUARTER_Q0;
#line 735 "../src/worm.vala"
		return result;
#line 4104 "worm.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 736 "../src/worm.vala"
		if ((*self).x > ((gint64) 0)) {
#line 736 "../src/worm.vala"
			_tmp1_ = (*self).y >= ((gint64) 0);
#line 4111 "worm.c"
		} else {
#line 736 "../src/worm.vala"
			_tmp1_ = FALSE;
#line 4115 "worm.c"
		}
#line 736 "../src/worm.vala"
		if (_tmp1_) {
#line 737 "../src/worm.vala"
			result = QUARTER_Q1;
#line 737 "../src/worm.vala"
			return result;
#line 4123 "worm.c"
		}
	}
#line 738 "../src/worm.vala"
	if ((*self).x <= ((gint64) 0)) {
#line 738 "../src/worm.vala"
		_tmp2_ = (*self).y > ((gint64) 0);
#line 4130 "worm.c"
	} else {
#line 738 "../src/worm.vala"
		_tmp2_ = FALSE;
#line 4134 "worm.c"
	}
#line 738 "../src/worm.vala"
	if (_tmp2_) {
#line 739 "../src/worm.vala"
		result = QUARTER_Q2;
#line 739 "../src/worm.vala"
		return result;
#line 4142 "worm.c"
	} else {
#line 741 "../src/worm.vala"
		result = QUARTER_Q3;
#line 741 "../src/worm.vala"
		return result;
#line 4148 "worm.c"
	}
}

static gint64
angle_set_delta_x_sign (Angle *self,
                        gint64 _x)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint64 result;
#line 747 "../src/worm.vala"
	if ((*self).x >= ((gint64) 0)) {
#line 747 "../src/worm.vala"
		_tmp1_ = _x < ((gint64) 0);
#line 4163 "worm.c"
	} else {
#line 747 "../src/worm.vala"
		_tmp1_ = FALSE;
#line 4167 "worm.c"
	}
#line 747 "../src/worm.vala"
	if (_tmp1_) {
#line 747 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 4173 "worm.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 747 "../src/worm.vala"
		if ((*self).x < ((gint64) 0)) {
#line 747 "../src/worm.vala"
			_tmp2_ = _x >= ((gint64) 0);
#line 4180 "worm.c"
		} else {
#line 747 "../src/worm.vala"
			_tmp2_ = FALSE;
#line 4184 "worm.c"
		}
#line 747 "../src/worm.vala"
		_tmp0_ = _tmp2_;
#line 4188 "worm.c"
	}
#line 747 "../src/worm.vala"
	if (_tmp0_) {
#line 748 "../src/worm.vala"
		result = -_x;
#line 748 "../src/worm.vala"
		return result;
#line 4196 "worm.c"
	} else {
#line 750 "../src/worm.vala"
		result = _x;
#line 750 "../src/worm.vala"
		return result;
#line 4202 "worm.c"
	}
}

static gint64
angle_set_delta_y_sign (Angle *self,
                        gint64 _y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint64 result;
#line 756 "../src/worm.vala"
	if ((*self).y >= ((gint64) 0)) {
#line 756 "../src/worm.vala"
		_tmp1_ = _y < ((gint64) 0);
#line 4217 "worm.c"
	} else {
#line 756 "../src/worm.vala"
		_tmp1_ = FALSE;
#line 4221 "worm.c"
	}
#line 756 "../src/worm.vala"
	if (_tmp1_) {
#line 756 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 4227 "worm.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 756 "../src/worm.vala"
		if ((*self).y < ((gint64) 0)) {
#line 756 "../src/worm.vala"
			_tmp2_ = _y >= ((gint64) 0);
#line 4234 "worm.c"
		} else {
#line 756 "../src/worm.vala"
			_tmp2_ = FALSE;
#line 4238 "worm.c"
		}
#line 756 "../src/worm.vala"
		_tmp0_ = _tmp2_;
#line 4242 "worm.c"
	}
#line 756 "../src/worm.vala"
	if (_tmp0_) {
#line 757 "../src/worm.vala"
		result = -_y;
#line 757 "../src/worm.vala"
		return result;
#line 4250 "worm.c"
	} else {
#line 759 "../src/worm.vala"
		result = _y;
#line 759 "../src/worm.vala"
		return result;
#line 4256 "worm.c"
	}
}

Angle*
angle_dup (const Angle* self)
{
	Angle* dup;
#line 544 "../src/worm.vala"
	dup = g_new0 (Angle, 1);
#line 544 "../src/worm.vala"
	memcpy (dup, self, sizeof (Angle));
#line 544 "../src/worm.vala"
	return dup;
#line 4270 "worm.c"
}

void
angle_free (Angle* self)
{
#line 544 "../src/worm.vala"
	g_free (self);
#line 4278 "worm.c"
}

 G_GNUC_NO_INLINE static GType
angle_get_type_once (void)
{
	GType angle_type_id;
	angle_type_id = g_boxed_type_register_static ("Angle", (GBoxedCopyFunc) angle_dup, (GBoxedFreeFunc) angle_free);
	return angle_type_id;
}

GType
angle_get_type (void)
{
	static gsize angle_type_id__once = 0;
	if (g_once_init_enter (&angle_type_id__once)) {
		GType angle_type_id;
		angle_type_id = angle_get_type_once ();
		g_once_init_leave (&angle_type_id__once, angle_type_id);
	}
	return angle_type_id__once;
}

static inline gpointer
slice_get_instance_private (Slice* self)
{
	return G_STRUCT_MEMBER_P (self, Slice_private_offset);
}

Slice*
slice_construct (GType object_type,
                 Slice* copy)
{
	Slice * self = NULL;
#line 793 "../src/worm.vala"
	self = (Slice*) g_object_new (object_type, NULL);
#line 795 "../src/worm.vala"
	if (copy == NULL) {
#line 797 "../src/worm.vala"
		self->priv->min_set = FALSE;
#line 798 "../src/worm.vala"
		self->priv->max_set = FALSE;
#line 4320 "worm.c"
	} else {
#line 801 "../src/worm.vala"
		slice_assign (self, copy);
#line 4324 "worm.c"
	}
#line 793 "../src/worm.vala"
	return self;
#line 4328 "worm.c"
}

Slice*
slice_new (Slice* copy)
{
#line 793 "../src/worm.vala"
	return slice_construct (TYPE_SLICE, copy);
#line 4336 "worm.c"
}

void
slice_assign (Slice* self,
              Slice* o)
{
	Angle _tmp0_;
	Angle _tmp1_;
#line 805 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 805 "../src/worm.vala"
	g_return_if_fail (o != NULL);
#line 807 "../src/worm.vala"
	_tmp0_ = o->min;
#line 807 "../src/worm.vala"
	angle_assign (&self->min, &_tmp0_);
#line 808 "../src/worm.vala"
	_tmp1_ = o->max;
#line 808 "../src/worm.vala"
	angle_assign (&self->max, &_tmp1_);
#line 809 "../src/worm.vala"
	self->priv->min_set = o->priv->min_set;
#line 810 "../src/worm.vala"
	self->priv->max_set = o->priv->max_set;
#line 4361 "worm.c"
}

void
slice_set_direction_view (Slice* self,
                          WormDirection d,
                          gint* board,
                          gint board_length1,
                          gint board_length2)
{
#line 819 "../src/worm.vala"
	static const gint64 x = (gint64) 369665159;
#line 820 "../src/worm.vala"
	static const gint64 y = -14116942878LL;
#line 4375 "worm.c"
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 813 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 821 "../src/worm.vala"
	switch (d) {
#line 821 "../src/worm.vala"
		case WORM_DIRECTION_EAST:
#line 4386 "worm.c"
		{
			Angle _tmp0_ = {0};
			Angle _tmp1_ = {0};
#line 835 "../src/worm.vala"
			_tmp0_.x = -y;
#line 835 "../src/worm.vala"
			_tmp0_.y = -x;
#line 835 "../src/worm.vala"
			self->min = _tmp0_;
#line 836 "../src/worm.vala"
			_tmp1_.x = -y;
#line 836 "../src/worm.vala"
			_tmp1_.y = +x;
#line 836 "../src/worm.vala"
			self->max = _tmp1_;
#line 837 "../src/worm.vala"
			break;
#line 4404 "worm.c"
		}
#line 821 "../src/worm.vala"
		case WORM_DIRECTION_SOUTH:
#line 4408 "worm.c"
		{
			Angle _tmp2_ = {0};
			Angle _tmp3_ = {0};
#line 846 "../src/worm.vala"
			_tmp2_.x = +x;
#line 846 "../src/worm.vala"
			_tmp2_.y = -y;
#line 846 "../src/worm.vala"
			self->min = _tmp2_;
#line 847 "../src/worm.vala"
			_tmp3_.x = -x;
#line 847 "../src/worm.vala"
			_tmp3_.y = -y;
#line 847 "../src/worm.vala"
			self->max = _tmp3_;
#line 848 "../src/worm.vala"
			break;
#line 4426 "worm.c"
		}
#line 821 "../src/worm.vala"
		case WORM_DIRECTION_WEST:
#line 4430 "worm.c"
		{
			Angle _tmp4_ = {0};
			Angle _tmp5_ = {0};
#line 861 "../src/worm.vala"
			_tmp4_.x = +y;
#line 861 "../src/worm.vala"
			_tmp4_.y = +x;
#line 861 "../src/worm.vala"
			self->min = _tmp4_;
#line 862 "../src/worm.vala"
			_tmp5_.x = +y;
#line 862 "../src/worm.vala"
			_tmp5_.y = -x;
#line 862 "../src/worm.vala"
			self->max = _tmp5_;
#line 863 "../src/worm.vala"
			break;
#line 4448 "worm.c"
		}
#line 821 "../src/worm.vala"
		case WORM_DIRECTION_NORTH:
#line 4452 "worm.c"
		{
			Angle _tmp6_ = {0};
			Angle _tmp7_ = {0};
#line 872 "../src/worm.vala"
			_tmp6_.x = -x;
#line 872 "../src/worm.vala"
			_tmp6_.y = +y;
#line 872 "../src/worm.vala"
			self->min = _tmp6_;
#line 873 "../src/worm.vala"
			_tmp7_.x = +x;
#line 873 "../src/worm.vala"
			_tmp7_.y = +y;
#line 873 "../src/worm.vala"
			self->max = _tmp7_;
#line 874 "../src/worm.vala"
			break;
#line 4470 "worm.c"
		}
		default:
		{
#line 876 "../src/worm.vala"
			break;
#line 4476 "worm.c"
		}
	}
#line 878 "../src/worm.vala"
	self->priv->min_set = TRUE;
#line 879 "../src/worm.vala"
	self->priv->max_set = TRUE;
#line 880 "../src/worm.vala"
	_tmp8_ = board_length1;
#line 880 "../src/worm.vala"
	_tmp9_ = board_length2;
#line 880 "../src/worm.vala"
	angle_set_wrapping (&self->min, _tmp8_, _tmp9_);
#line 881 "../src/worm.vala"
	_tmp10_ = board_length1;
#line 881 "../src/worm.vala"
	_tmp11_ = board_length2;
#line 881 "../src/worm.vala"
	angle_set_wrapping (&self->max, _tmp10_, _tmp11_);
#line 4495 "worm.c"
}

void
slice_add_angle (Slice* self,
                 Angle* a)
{
	gboolean _tmp0_ = FALSE;
#line 884 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 884 "../src/worm.vala"
	g_return_if_fail (a != NULL);
#line 886 "../src/worm.vala"
	if (!self->priv->min_set) {
#line 886 "../src/worm.vala"
		_tmp0_ = !self->priv->max_set;
#line 4511 "worm.c"
	} else {
#line 886 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 4515 "worm.c"
	}
#line 886 "../src/worm.vala"
	if (_tmp0_) {
#line 4519 "worm.c"
		Angle _tmp1_;
#line 888 "../src/worm.vala"
		_tmp1_ = *a;
#line 888 "../src/worm.vala"
		angle_assign (&self->min, &_tmp1_);
#line 889 "../src/worm.vala"
		self->priv->min_set = TRUE;
#line 4527 "worm.c"
	} else {
#line 891 "../src/worm.vala"
		if (!self->priv->min_set) {
#line 4531 "worm.c"
			Angle _tmp2_;
#line 893 "../src/worm.vala"
			_tmp2_ = self->max;
#line 893 "../src/worm.vala"
			if (angle_greater_than (a, &_tmp2_)) {
#line 4537 "worm.c"
				Angle _tmp3_;
				Angle _tmp4_;
#line 895 "../src/worm.vala"
				_tmp3_ = self->max;
#line 895 "../src/worm.vala"
				angle_assign (&self->min, &_tmp3_);
#line 896 "../src/worm.vala"
				_tmp4_ = *a;
#line 896 "../src/worm.vala"
				angle_assign (&self->max, &_tmp4_);
#line 4548 "worm.c"
			} else {
				Angle _tmp5_;
#line 899 "../src/worm.vala"
				_tmp5_ = *a;
#line 899 "../src/worm.vala"
				angle_assign (&self->min, &_tmp5_);
#line 4555 "worm.c"
			}
#line 900 "../src/worm.vala"
			self->priv->min_set = TRUE;
#line 4559 "worm.c"
		} else {
#line 902 "../src/worm.vala"
			if (!self->priv->max_set) {
#line 4563 "worm.c"
				Angle _tmp6_;
#line 904 "../src/worm.vala"
				_tmp6_ = self->min;
#line 904 "../src/worm.vala"
				if (angle_greater_than (a, &_tmp6_)) {
#line 4569 "worm.c"
					Angle _tmp7_;
#line 905 "../src/worm.vala"
					_tmp7_ = *a;
#line 905 "../src/worm.vala"
					angle_assign (&self->max, &_tmp7_);
#line 4575 "worm.c"
				} else {
					Angle _tmp8_;
					Angle _tmp9_;
#line 908 "../src/worm.vala"
					_tmp8_ = self->min;
#line 908 "../src/worm.vala"
					angle_assign (&self->max, &_tmp8_);
#line 909 "../src/worm.vala"
					_tmp9_ = *a;
#line 909 "../src/worm.vala"
					angle_assign (&self->min, &_tmp9_);
#line 4587 "worm.c"
				}
#line 911 "../src/worm.vala"
				self->priv->max_set = TRUE;
#line 4591 "worm.c"
			} else {
				Angle _tmp10_;
#line 915 "../src/worm.vala"
				_tmp10_ = self->min;
#line 915 "../src/worm.vala"
				if (angle_less_than (a, &_tmp10_)) {
#line 4598 "worm.c"
					Angle _tmp11_;
#line 916 "../src/worm.vala"
					_tmp11_ = *a;
#line 916 "../src/worm.vala"
					angle_assign (&self->min, &_tmp11_);
#line 4604 "worm.c"
				} else {
					Angle _tmp12_;
#line 917 "../src/worm.vala"
					_tmp12_ = self->max;
#line 917 "../src/worm.vala"
					if (angle_greater_than (a, &_tmp12_)) {
#line 4611 "worm.c"
						Angle _tmp13_;
#line 918 "../src/worm.vala"
						_tmp13_ = *a;
#line 918 "../src/worm.vala"
						angle_assign (&self->max, &_tmp13_);
#line 4617 "worm.c"
					}
				}
			}
		}
	}
}

void
slice_set_from_position (Slice* self,
                         Position* origin,
                         gint64 x,
                         gint64 y,
                         gint size)
{
	Position _tmp0_;
	Position _tmp1_;
	Angle _tmp2_ = {0};
	Position _tmp3_;
	Position _tmp4_;
	Angle _tmp5_ = {0};
	Position _tmp6_;
	Position _tmp7_;
	Angle _tmp8_ = {0};
	Position _tmp9_;
	Position _tmp10_;
	Angle _tmp11_ = {0};
#line 922 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 922 "../src/worm.vala"
	g_return_if_fail (origin != NULL);
#line 930 "../src/worm.vala"
	self->priv->min_set = FALSE;
#line 931 "../src/worm.vala"
	self->priv->max_set = FALSE;
#line 946 "../src/worm.vala"
	_tmp0_ = *origin;
#line 946 "../src/worm.vala"
	_tmp1_ = *origin;
#line 946 "../src/worm.vala"
	_tmp2_.x = (x * 2) - ((_tmp0_.x * 2) + 1);
#line 946 "../src/worm.vala"
	_tmp2_.y = (y * 2) - ((_tmp1_.y * 2) + 1);
#line 946 "../src/worm.vala"
	slice_add_angle (self, &_tmp2_);
#line 947 "../src/worm.vala"
	_tmp3_ = *origin;
#line 947 "../src/worm.vala"
	_tmp4_ = *origin;
#line 947 "../src/worm.vala"
	_tmp5_.x = ((x + (1 * size)) * 2) - ((_tmp3_.x * 2) + 1);
#line 947 "../src/worm.vala"
	_tmp5_.y = (y * 2) - ((_tmp4_.y * 2) + 1);
#line 947 "../src/worm.vala"
	slice_add_angle (self, &_tmp5_);
#line 948 "../src/worm.vala"
	_tmp6_ = *origin;
#line 948 "../src/worm.vala"
	_tmp7_ = *origin;
#line 948 "../src/worm.vala"
	_tmp8_.x = (x * 2) - ((_tmp6_.x * 2) + 1);
#line 948 "../src/worm.vala"
	_tmp8_.y = ((y + (1 * size)) * 2) - ((_tmp7_.y * 2) + 1);
#line 948 "../src/worm.vala"
	slice_add_angle (self, &_tmp8_);
#line 949 "../src/worm.vala"
	_tmp9_ = *origin;
#line 949 "../src/worm.vala"
	_tmp10_ = *origin;
#line 949 "../src/worm.vala"
	_tmp11_.x = ((x + (1 * size)) * 2) - ((_tmp9_.x * 2) + 1);
#line 949 "../src/worm.vala"
	_tmp11_.y = ((y + (1 * size)) * 2) - ((_tmp10_.y * 2) + 1);
#line 949 "../src/worm.vala"
	slice_add_angle (self, &_tmp11_);
#line 4692 "worm.c"
}

void
slice_intersection_by_position (Slice* self,
                                Position* origin,
                                guint8 _x,
                                guint8 _y,
                                gint size)
{
	gint64 x = 0LL;
	gint64 y = 0LL;
	gboolean _tmp0_ = FALSE;
	Angle _tmp1_;
	Angle old_min = {0};
	Angle _tmp20_ = {0};
	Angle _tmp21_;
	Angle old_max = {0};
	Angle _tmp22_ = {0};
	Angle _tmp23_;
	Position _tmp24_;
	Angle _tmp25_;
	Angle _tmp27_;
#line 952 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 952 "../src/worm.vala"
	g_return_if_fail (origin != NULL);
#line 959 "../src/worm.vala"
	x = (gint64) _x;
#line 960 "../src/worm.vala"
	y = (gint64) _y;
#line 961 "../src/worm.vala"
	_tmp1_ = self->min;
#line 961 "../src/worm.vala"
	if (_tmp1_.x >= ((gint64) 0)) {
#line 4727 "worm.c"
		Angle _tmp2_;
#line 961 "../src/worm.vala"
		_tmp2_ = self->max;
#line 961 "../src/worm.vala"
		_tmp0_ = _tmp2_.x >= ((gint64) 0);
#line 4733 "worm.c"
	} else {
#line 961 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 4737 "worm.c"
	}
#line 961 "../src/worm.vala"
	if (_tmp0_) {
#line 4741 "worm.c"
		Position _tmp3_;
#line 963 "../src/worm.vala"
		_tmp3_ = *origin;
#line 963 "../src/worm.vala"
		if (!((x + (size - 1)) > ((gint64) _tmp3_.x))) {
#line 4747 "worm.c"
			Angle _tmp4_;
#line 964 "../src/worm.vala"
			_tmp4_ = self->min;
#line 964 "../src/worm.vala"
			x += _tmp4_.x_max;
#line 4753 "worm.c"
		}
	} else {
		gboolean _tmp5_ = FALSE;
		Angle _tmp6_;
#line 966 "../src/worm.vala"
		_tmp6_ = self->min;
#line 966 "../src/worm.vala"
		if (_tmp6_.x < ((gint64) 0)) {
#line 4762 "worm.c"
			Angle _tmp7_;
#line 966 "../src/worm.vala"
			_tmp7_ = self->max;
#line 966 "../src/worm.vala"
			_tmp5_ = _tmp7_.x < ((gint64) 0);
#line 4768 "worm.c"
		} else {
#line 966 "../src/worm.vala"
			_tmp5_ = FALSE;
#line 4772 "worm.c"
		}
#line 966 "../src/worm.vala"
		if (_tmp5_) {
#line 4776 "worm.c"
			Position _tmp8_;
#line 968 "../src/worm.vala"
			_tmp8_ = *origin;
#line 968 "../src/worm.vala"
			if (!(x < ((gint64) _tmp8_.x))) {
#line 4782 "worm.c"
				Angle _tmp9_;
#line 969 "../src/worm.vala"
				_tmp9_ = self->min;
#line 969 "../src/worm.vala"
				x -= _tmp9_.x_max;
#line 4788 "worm.c"
			}
		} else {
			gboolean _tmp10_ = FALSE;
			Angle _tmp11_;
#line 971 "../src/worm.vala"
			_tmp11_ = self->min;
#line 971 "../src/worm.vala"
			if (_tmp11_.y >= ((gint64) 0)) {
#line 4797 "worm.c"
				Angle _tmp12_;
#line 971 "../src/worm.vala"
				_tmp12_ = self->max;
#line 971 "../src/worm.vala"
				_tmp10_ = _tmp12_.y >= ((gint64) 0);
#line 4803 "worm.c"
			} else {
#line 971 "../src/worm.vala"
				_tmp10_ = FALSE;
#line 4807 "worm.c"
			}
#line 971 "../src/worm.vala"
			if (_tmp10_) {
#line 4811 "worm.c"
				Position _tmp13_;
#line 973 "../src/worm.vala"
				_tmp13_ = *origin;
#line 973 "../src/worm.vala"
				if (!((y + (size - 1)) > ((gint64) _tmp13_.y))) {
#line 4817 "worm.c"
					Angle _tmp14_;
#line 974 "../src/worm.vala"
					_tmp14_ = self->min;
#line 974 "../src/worm.vala"
					y += _tmp14_.y_max;
#line 4823 "worm.c"
				}
			} else {
				gboolean _tmp15_ = FALSE;
				Angle _tmp16_;
#line 976 "../src/worm.vala"
				_tmp16_ = self->min;
#line 976 "../src/worm.vala"
				if (_tmp16_.y < ((gint64) 0)) {
#line 4832 "worm.c"
					Angle _tmp17_;
#line 976 "../src/worm.vala"
					_tmp17_ = self->max;
#line 976 "../src/worm.vala"
					_tmp15_ = _tmp17_.y < ((gint64) 0);
#line 4838 "worm.c"
				} else {
#line 976 "../src/worm.vala"
					_tmp15_ = FALSE;
#line 4842 "worm.c"
				}
#line 976 "../src/worm.vala"
				if (_tmp15_) {
#line 4846 "worm.c"
					Position _tmp18_;
#line 978 "../src/worm.vala"
					_tmp18_ = *origin;
#line 978 "../src/worm.vala"
					if (!(y < ((gint64) _tmp18_.y))) {
#line 4852 "worm.c"
						Angle _tmp19_;
#line 979 "../src/worm.vala"
						_tmp19_ = self->min;
#line 979 "../src/worm.vala"
						y -= _tmp19_.y_max;
#line 4858 "worm.c"
					}
				}
			}
		}
	}
#line 981 "../src/worm.vala"
	old_min = _tmp20_;
#line 982 "../src/worm.vala"
	_tmp21_ = self->min;
#line 982 "../src/worm.vala"
	angle_assign (&old_min, &_tmp21_);
#line 983 "../src/worm.vala"
	old_max = _tmp22_;
#line 984 "../src/worm.vala"
	_tmp23_ = self->max;
#line 984 "../src/worm.vala"
	angle_assign (&old_max, &_tmp23_);
#line 985 "../src/worm.vala"
	_tmp24_ = *origin;
#line 985 "../src/worm.vala"
	slice_set_from_position (self, &_tmp24_, x, y, size);
#line 986 "../src/worm.vala"
	_tmp25_ = self->min;
#line 986 "../src/worm.vala"
	if (angle_greater_than (&old_min, &_tmp25_)) {
#line 4884 "worm.c"
		Angle _tmp26_;
#line 987 "../src/worm.vala"
		_tmp26_ = old_min;
#line 987 "../src/worm.vala"
		angle_assign (&self->min, &_tmp26_);
#line 4890 "worm.c"
	}
#line 988 "../src/worm.vala"
	_tmp27_ = self->max;
#line 988 "../src/worm.vala"
	if (angle_less_than (&old_max, &_tmp27_)) {
#line 4896 "worm.c"
		Angle _tmp28_;
#line 989 "../src/worm.vala"
		_tmp28_ = old_max;
#line 989 "../src/worm.vala"
		angle_assign (&self->max, &_tmp28_);
#line 4902 "worm.c"
	}
}

gboolean
slice_is_empty (Slice* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 992 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 995 "../src/worm.vala"
	if (!self->priv->min_set) {
#line 995 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 4918 "worm.c"
	} else {
#line 995 "../src/worm.vala"
		_tmp1_ = !self->priv->max_set;
#line 4922 "worm.c"
	}
#line 995 "../src/worm.vala"
	if (_tmp1_) {
#line 995 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 4928 "worm.c"
	} else {
		Angle _tmp2_;
#line 995 "../src/worm.vala"
		_tmp2_ = self->max;
#line 995 "../src/worm.vala"
		_tmp0_ = angle_greater_than_or_equal_to (&self->min, &_tmp2_);
#line 4935 "worm.c"
	}
#line 995 "../src/worm.vala"
	result = _tmp0_;
#line 995 "../src/worm.vala"
	return result;
#line 4941 "worm.c"
}

static gboolean
slice_is_bonus_at (Slice* self,
                   guint8 x,
                   guint8 y,
                   Bonus* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	guint8 _tmp4_;
	guint8 _tmp5_;
	gboolean result;
#line 998 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 998 "../src/worm.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 1000 "../src/worm.vala"
	_tmp4_ = bonus_get_x (b);
#line 1000 "../src/worm.vala"
	_tmp5_ = _tmp4_;
#line 1000 "../src/worm.vala"
	if (_tmp5_ == x) {
#line 4967 "worm.c"
		guint8 _tmp6_;
		guint8 _tmp7_;
#line 1000 "../src/worm.vala"
		_tmp6_ = bonus_get_y (b);
#line 1000 "../src/worm.vala"
		_tmp7_ = _tmp6_;
#line 1000 "../src/worm.vala"
		_tmp3_ = _tmp7_ == y;
#line 4976 "worm.c"
	} else {
#line 1000 "../src/worm.vala"
		_tmp3_ = FALSE;
#line 4980 "worm.c"
	}
#line 1000 "../src/worm.vala"
	if (_tmp3_) {
#line 1000 "../src/worm.vala"
		_tmp2_ = TRUE;
#line 4986 "worm.c"
	} else {
		gboolean _tmp8_ = FALSE;
		guint8 _tmp9_;
		guint8 _tmp10_;
#line 1001 "../src/worm.vala"
		_tmp9_ = bonus_get_x (b);
#line 1001 "../src/worm.vala"
		_tmp10_ = _tmp9_;
#line 1001 "../src/worm.vala"
		if ((_tmp10_ + 1) == ((gint) x)) {
#line 4997 "worm.c"
			guint8 _tmp11_;
			guint8 _tmp12_;
#line 1001 "../src/worm.vala"
			_tmp11_ = bonus_get_y (b);
#line 1001 "../src/worm.vala"
			_tmp12_ = _tmp11_;
#line 1001 "../src/worm.vala"
			_tmp8_ = _tmp12_ == y;
#line 5006 "worm.c"
		} else {
#line 1001 "../src/worm.vala"
			_tmp8_ = FALSE;
#line 5010 "worm.c"
		}
#line 1001 "../src/worm.vala"
		_tmp2_ = _tmp8_;
#line 5014 "worm.c"
	}
#line 1000 "../src/worm.vala"
	if (_tmp2_) {
#line 1000 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 5020 "worm.c"
	} else {
		gboolean _tmp13_ = FALSE;
		guint8 _tmp14_;
		guint8 _tmp15_;
#line 1002 "../src/worm.vala"
		_tmp14_ = bonus_get_x (b);
#line 1002 "../src/worm.vala"
		_tmp15_ = _tmp14_;
#line 1002 "../src/worm.vala"
		if (_tmp15_ == x) {
#line 5031 "worm.c"
			guint8 _tmp16_;
			guint8 _tmp17_;
#line 1002 "../src/worm.vala"
			_tmp16_ = bonus_get_y (b);
#line 1002 "../src/worm.vala"
			_tmp17_ = _tmp16_;
#line 1002 "../src/worm.vala"
			_tmp13_ = (_tmp17_ + 1) == ((gint) y);
#line 5040 "worm.c"
		} else {
#line 1002 "../src/worm.vala"
			_tmp13_ = FALSE;
#line 5044 "worm.c"
		}
#line 1002 "../src/worm.vala"
		_tmp1_ = _tmp13_;
#line 5048 "worm.c"
	}
#line 1000 "../src/worm.vala"
	if (_tmp1_) {
#line 1000 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 5054 "worm.c"
	} else {
		gboolean _tmp18_ = FALSE;
		guint8 _tmp19_;
		guint8 _tmp20_;
#line 1003 "../src/worm.vala"
		_tmp19_ = bonus_get_x (b);
#line 1003 "../src/worm.vala"
		_tmp20_ = _tmp19_;
#line 1003 "../src/worm.vala"
		if ((_tmp20_ + 1) == ((gint) x)) {
#line 5065 "worm.c"
			guint8 _tmp21_;
			guint8 _tmp22_;
#line 1003 "../src/worm.vala"
			_tmp21_ = bonus_get_y (b);
#line 1003 "../src/worm.vala"
			_tmp22_ = _tmp21_;
#line 1003 "../src/worm.vala"
			_tmp18_ = (_tmp22_ + 1) == ((gint) y);
#line 5074 "worm.c"
		} else {
#line 1003 "../src/worm.vala"
			_tmp18_ = FALSE;
#line 5078 "worm.c"
		}
#line 1003 "../src/worm.vala"
		_tmp0_ = _tmp18_;
#line 5082 "worm.c"
	}
#line 1000 "../src/worm.vala"
	result = _tmp0_;
#line 1000 "../src/worm.vala"
	return result;
#line 5088 "worm.c"
}

static gboolean
slice_is_position_occupied (Slice* self,
                            Position* p,
                            gint* board,
                            gint board_length1,
                            gint board_length2,
                            WormMap* worm_map)
{
	gboolean _tmp0_ = FALSE;
	Position _tmp1_;
	Position _tmp2_;
	gint _tmp3_;
	gboolean result;
#line 1006 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1006 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 1006 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, FALSE);
#line 1008 "../src/worm.vala"
	_tmp1_ = *p;
#line 1008 "../src/worm.vala"
	_tmp2_ = *p;
#line 1008 "../src/worm.vala"
	_tmp3_ = board[(_tmp1_.x * board_length2) + _tmp2_.y];
#line 1008 "../src/worm.vala"
	if (_tmp3_ > ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 1008 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 5120 "worm.c"
	} else {
		Position _tmp4_;
#line 1008 "../src/worm.vala"
		_tmp4_ = *p;
#line 1008 "../src/worm.vala"
		_tmp0_ = worm_map_contain_position (worm_map, &_tmp4_);
#line 5127 "worm.c"
	}
#line 1008 "../src/worm.vala"
	result = _tmp0_;
#line 1008 "../src/worm.vala"
	return result;
#line 5133 "worm.c"
}

gint64
slice_is_visible (Slice* self,
                  Position* origin,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  WormMap* worm_map,
                  Bonus* bonus)
{
	GeeArrayList* checked_positions = NULL;
	GeeArrayList* _tmp0_;
	gint64 result;
#line 1011 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 1011 "../src/worm.vala"
	g_return_val_if_fail (origin != NULL, 0LL);
#line 1011 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, 0LL);
#line 1011 "../src/worm.vala"
	g_return_val_if_fail (bonus != NULL, 0LL);
#line 1019 "../src/worm.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
#line 1019 "../src/worm.vala"
	checked_positions = _tmp0_;
#line 5160 "worm.c"
	{
		gboolean _tmp1_ = FALSE;
#line 1022 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 1022 "../src/worm.vala"
		while (TRUE) {
#line 5167 "worm.c"
			gint64 distance = 0LL;
			Position _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
#line 1022 "../src/worm.vala"
			if (!_tmp1_) {
#line 5174 "worm.c"
			}
#line 1022 "../src/worm.vala"
			_tmp1_ = FALSE;
#line 1022 "../src/worm.vala"
			if (!(!slice_is_empty (self))) {
#line 1022 "../src/worm.vala"
				break;
#line 5182 "worm.c"
			}
#line 1024 "../src/worm.vala"
			distance = (gint64) 0;
#line 1025 "../src/worm.vala"
			_tmp2_ = *origin;
#line 1025 "../src/worm.vala"
			angle_set_origin (&self->min, &_tmp2_);
#line 1026 "../src/worm.vala"
			_tmp3_ = board_length1;
#line 1026 "../src/worm.vala"
			_tmp4_ = board_length2;
#line 1026 "../src/worm.vala"
			angle_set_wrapping (&self->min, _tmp3_, _tmp4_);
#line 5196 "worm.c"
			{
				AngleIterator* _p_it = NULL;
				AngleIterator* _tmp5_;
#line 1027 "../src/worm.vala"
				_tmp5_ = angle_iterator (&self->min);
#line 1027 "../src/worm.vala"
				_p_it = _tmp5_;
#line 1027 "../src/worm.vala"
				while (TRUE) {
#line 5206 "worm.c"
					AngleIterator* _tmp6_;
					SignedPosition p = {0};
					AngleIterator* _tmp7_;
					SignedPosition _tmp8_ = {0};
					gint64 _tmp9_;
					GeeArrayList* _tmp10_;
#line 1027 "../src/worm.vala"
					_tmp6_ = _p_it;
#line 1027 "../src/worm.vala"
					if (!angle_iterator_next (_tmp6_)) {
#line 1027 "../src/worm.vala"
						break;
#line 5219 "worm.c"
					}
#line 1027 "../src/worm.vala"
					_tmp7_ = _p_it;
#line 1027 "../src/worm.vala"
					angle_iterator_get (_tmp7_, &_tmp8_);
#line 1027 "../src/worm.vala"
					p = _tmp8_;
#line 1029 "../src/worm.vala"
					_tmp9_ = distance;
#line 1029 "../src/worm.vala"
					distance = _tmp9_ + 1;
#line 1030 "../src/worm.vala"
					_tmp10_ = checked_positions;
#line 1030 "../src/worm.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp10_, (gpointer) ((guintptr) signed_position_wrap_xy (&p)))) {
#line 1032 "../src/worm.vala"
						if (slice_is_bonus_at (self, signed_position_wrap_x (&p), signed_position_wrap_y (&p), bonus)) {
#line 5237 "worm.c"
							gint64 _tmp11_ = 0LL;
#line 1034 "../src/worm.vala"
							if (angle_step_along_x (&self->min)) {
#line 5241 "worm.c"
								Position _tmp12_;
								SignedPosition _tmp13_;
#line 1034 "../src/worm.vala"
								_tmp12_ = *origin;
#line 1034 "../src/worm.vala"
								_tmp13_ = p;
#line 1034 "../src/worm.vala"
								_tmp11_ = distance + llabs (_tmp12_.y - _tmp13_.y);
#line 5250 "worm.c"
							} else {
								Position _tmp14_;
								SignedPosition _tmp15_;
#line 1035 "../src/worm.vala"
								_tmp14_ = *origin;
#line 1035 "../src/worm.vala"
								_tmp15_ = p;
#line 1035 "../src/worm.vala"
								_tmp11_ = distance + llabs (_tmp14_.x - _tmp15_.x);
#line 5260 "worm.c"
							}
#line 1034 "../src/worm.vala"
							result = _tmp11_;
#line 1034 "../src/worm.vala"
							_angle_iterator_unref0 (_p_it);
#line 1034 "../src/worm.vala"
							_g_object_unref0 (checked_positions);
#line 1034 "../src/worm.vala"
							return result;
#line 5270 "worm.c"
						} else {
							gboolean _tmp16_ = FALSE;
							gint _tmp17_ = 0;
#line 1037 "../src/worm.vala"
							if (angle_step_along_x (&self->min)) {
#line 5276 "worm.c"
								gint _tmp18_;
#line 1037 "../src/worm.vala"
								_tmp18_ = board_length1;
#line 1037 "../src/worm.vala"
								_tmp17_ = _tmp18_;
#line 5282 "worm.c"
							} else {
								gint _tmp19_;
#line 1037 "../src/worm.vala"
								_tmp19_ = board_length2;
#line 1037 "../src/worm.vala"
								_tmp17_ = _tmp19_;
#line 5289 "worm.c"
							}
#line 1037 "../src/worm.vala"
							if (distance > ((gint64) (_tmp17_ * 2))) {
#line 1037 "../src/worm.vala"
								_tmp16_ = TRUE;
#line 5295 "worm.c"
							} else {
								Position _tmp20_ = {0};
#line 1038 "../src/worm.vala"
								_tmp20_.x = signed_position_wrap_x (&p);
#line 1038 "../src/worm.vala"
								_tmp20_.y = signed_position_wrap_y (&p);
#line 1038 "../src/worm.vala"
								_tmp16_ = slice_is_position_occupied (self, &_tmp20_, board, (gint) board_length1, (gint) board_length2, worm_map);
#line 5304 "worm.c"
							}
#line 1037 "../src/worm.vala"
							if (_tmp16_) {
#line 5308 "worm.c"
								GeeArrayList* _tmp21_;
								Slice* s = NULL;
								Slice* _tmp22_;
								Slice* _tmp23_;
								Position _tmp24_;
								SignedPosition _tmp25_;
								SignedPosition _tmp26_;
								Slice* _tmp27_;
								Angle _tmp28_;
#line 1040 "../src/worm.vala"
								_tmp21_ = checked_positions;
#line 1040 "../src/worm.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, (gpointer) ((guintptr) signed_position_wrap_xy (&p)));
#line 1042 "../src/worm.vala"
								_tmp22_ = slice_new (NULL);
#line 1042 "../src/worm.vala"
								s = _tmp22_;
#line 1043 "../src/worm.vala"
								_tmp23_ = s;
#line 1043 "../src/worm.vala"
								_tmp24_ = *origin;
#line 1043 "../src/worm.vala"
								_tmp25_ = p;
#line 1043 "../src/worm.vala"
								_tmp26_ = p;
#line 1043 "../src/worm.vala"
								slice_set_from_position (_tmp23_, &_tmp24_, _tmp25_.x, _tmp26_.y, 1);
#line 1044 "../src/worm.vala"
								_tmp27_ = s;
#line 1044 "../src/worm.vala"
								_tmp28_ = _tmp27_->max;
#line 1044 "../src/worm.vala"
								angle_assign (&self->min, &_tmp28_);
#line 1045 "../src/worm.vala"
								_g_object_unref0 (s);
#line 1045 "../src/worm.vala"
								break;
#line 5346 "worm.c"
							}
						}
					}
				}
#line 1027 "../src/worm.vala"
				_angle_iterator_unref0 (_p_it);
#line 5353 "worm.c"
			}
		}
	}
#line 1050 "../src/worm.vala"
	result = G_MAXINT64;
#line 1050 "../src/worm.vala"
	_g_object_unref0 (checked_positions);
#line 1050 "../src/worm.vala"
	return result;
#line 5363 "worm.c"
}

static void
slice_class_init (SliceClass * klass,
                  gpointer klass_data)
{
#line 784 "../src/worm.vala"
	slice_parent_class = g_type_class_peek_parent (klass);
#line 784 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &Slice_private_offset);
#line 784 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->finalize = slice_finalize;
#line 5376 "worm.c"
}

static void
slice_instance_init (Slice * self,
                     gpointer klass)
{
#line 784 "../src/worm.vala"
	self->priv = slice_get_instance_private (self);
#line 5385 "worm.c"
}

static void
slice_finalize (GObject * obj)
{
	Slice * self;
#line 784 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SLICE, Slice);
#line 784 "../src/worm.vala"
	G_OBJECT_CLASS (slice_parent_class)->finalize (obj);
#line 5396 "worm.c"
}

 G_GNUC_NO_INLINE static GType
slice_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SliceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slice_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Slice), 0, (GInstanceInitFunc) slice_instance_init, NULL };
	GType slice_type_id;
	slice_type_id = g_type_register_static (G_TYPE_OBJECT, "Slice", &g_define_type_info, 0);
	Slice_private_offset = g_type_add_instance_private (slice_type_id, sizeof (SlicePrivate));
	return slice_type_id;
}

GType
slice_get_type (void)
{
	static gsize slice_type_id__once = 0;
	if (g_once_init_enter (&slice_type_id__once)) {
		GType slice_type_id;
		slice_type_id = slice_get_type_once ();
		g_once_init_leave (&slice_type_id__once, slice_type_id);
	}
	return slice_type_id__once;
}

static inline gpointer
worm_properties_get_instance_private (WormProperties* self)
{
	return G_STRUCT_MEMBER_P (self, WormProperties_private_offset);
}

WormProperties*
worm_properties_construct (GType object_type)
{
	WormProperties * self = NULL;
#line 1054 "../src/worm.vala"
	self = (WormProperties*) g_object_new (object_type, NULL);
#line 1054 "../src/worm.vala"
	return self;
#line 5435 "worm.c"
}

WormProperties*
worm_properties_new (void)
{
#line 1054 "../src/worm.vala"
	return worm_properties_construct (TYPE_WORM_PROPERTIES);
#line 5443 "worm.c"
}

gint
worm_properties_get_color (WormProperties* self)
{
	gint result;
#line 1056 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1056 "../src/worm.vala"
	result = self->priv->_color;
#line 1056 "../src/worm.vala"
	return result;
#line 5456 "worm.c"
}

void
worm_properties_set_color (WormProperties* self,
                           gint value)
{
	gint old_value;
#line 1056 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1056 "../src/worm.vala"
	old_value = worm_properties_get_color (self);
#line 1056 "../src/worm.vala"
	if (old_value != value) {
#line 1056 "../src/worm.vala"
		self->priv->_color = value;
#line 1056 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_COLOR_PROPERTY]);
#line 5474 "worm.c"
	}
}

guint
worm_properties_get_up (WormProperties* self)
{
	guint result;
#line 1057 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1057 "../src/worm.vala"
	result = self->priv->_up;
#line 1057 "../src/worm.vala"
	return result;
#line 5488 "worm.c"
}

void
worm_properties_set_up (WormProperties* self,
                        guint value)
{
	guint old_value;
#line 1057 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1057 "../src/worm.vala"
	old_value = worm_properties_get_up (self);
#line 1057 "../src/worm.vala"
	if (old_value != value) {
#line 1057 "../src/worm.vala"
		self->priv->_up = value;
#line 1057 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_UP_PROPERTY]);
#line 5506 "worm.c"
	}
}

guint
worm_properties_get_down (WormProperties* self)
{
	guint result;
#line 1058 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1058 "../src/worm.vala"
	result = self->priv->_down;
#line 1058 "../src/worm.vala"
	return result;
#line 5520 "worm.c"
}

void
worm_properties_set_down (WormProperties* self,
                          guint value)
{
	guint old_value;
#line 1058 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1058 "../src/worm.vala"
	old_value = worm_properties_get_down (self);
#line 1058 "../src/worm.vala"
	if (old_value != value) {
#line 1058 "../src/worm.vala"
		self->priv->_down = value;
#line 1058 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_DOWN_PROPERTY]);
#line 5538 "worm.c"
	}
}

guint
worm_properties_get_left (WormProperties* self)
{
	guint result;
#line 1059 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1059 "../src/worm.vala"
	result = self->priv->_left;
#line 1059 "../src/worm.vala"
	return result;
#line 5552 "worm.c"
}

void
worm_properties_set_left (WormProperties* self,
                          guint value)
{
	guint old_value;
#line 1059 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1059 "../src/worm.vala"
	old_value = worm_properties_get_left (self);
#line 1059 "../src/worm.vala"
	if (old_value != value) {
#line 1059 "../src/worm.vala"
		self->priv->_left = value;
#line 1059 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_LEFT_PROPERTY]);
#line 5570 "worm.c"
	}
}

guint
worm_properties_get_right (WormProperties* self)
{
	guint result;
#line 1060 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1060 "../src/worm.vala"
	result = self->priv->_right;
#line 1060 "../src/worm.vala"
	return result;
#line 5584 "worm.c"
}

void
worm_properties_set_right (WormProperties* self,
                           guint value)
{
	guint old_value;
#line 1060 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1060 "../src/worm.vala"
	old_value = worm_properties_get_right (self);
#line 1060 "../src/worm.vala"
	if (old_value != value) {
#line 1060 "../src/worm.vala"
		self->priv->_right = value;
#line 1060 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RIGHT_PROPERTY]);
#line 5602 "worm.c"
	}
}

gint
worm_properties_get_raw_up (WormProperties* self)
{
	gint result;
#line 1061 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1061 "../src/worm.vala"
	result = self->priv->_raw_up;
#line 1061 "../src/worm.vala"
	return result;
#line 5616 "worm.c"
}

void
worm_properties_set_raw_up (WormProperties* self,
                            gint value)
{
	gint old_value;
#line 1061 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1061 "../src/worm.vala"
	old_value = worm_properties_get_raw_up (self);
#line 1061 "../src/worm.vala"
	if (old_value != value) {
#line 1061 "../src/worm.vala"
		self->priv->_raw_up = value;
#line 1061 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RAW_UP_PROPERTY]);
#line 5634 "worm.c"
	}
}

gint
worm_properties_get_raw_down (WormProperties* self)
{
	gint result;
#line 1062 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1062 "../src/worm.vala"
	result = self->priv->_raw_down;
#line 1062 "../src/worm.vala"
	return result;
#line 5648 "worm.c"
}

void
worm_properties_set_raw_down (WormProperties* self,
                              gint value)
{
	gint old_value;
#line 1062 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1062 "../src/worm.vala"
	old_value = worm_properties_get_raw_down (self);
#line 1062 "../src/worm.vala"
	if (old_value != value) {
#line 1062 "../src/worm.vala"
		self->priv->_raw_down = value;
#line 1062 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RAW_DOWN_PROPERTY]);
#line 5666 "worm.c"
	}
}

gint
worm_properties_get_raw_left (WormProperties* self)
{
	gint result;
#line 1063 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1063 "../src/worm.vala"
	result = self->priv->_raw_left;
#line 1063 "../src/worm.vala"
	return result;
#line 5680 "worm.c"
}

void
worm_properties_set_raw_left (WormProperties* self,
                              gint value)
{
	gint old_value;
#line 1063 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1063 "../src/worm.vala"
	old_value = worm_properties_get_raw_left (self);
#line 1063 "../src/worm.vala"
	if (old_value != value) {
#line 1063 "../src/worm.vala"
		self->priv->_raw_left = value;
#line 1063 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RAW_LEFT_PROPERTY]);
#line 5698 "worm.c"
	}
}

gint
worm_properties_get_raw_right (WormProperties* self)
{
	gint result;
#line 1064 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1064 "../src/worm.vala"
	result = self->priv->_raw_right;
#line 1064 "../src/worm.vala"
	return result;
#line 5712 "worm.c"
}

void
worm_properties_set_raw_right (WormProperties* self,
                               gint value)
{
	gint old_value;
#line 1064 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1064 "../src/worm.vala"
	old_value = worm_properties_get_raw_right (self);
#line 1064 "../src/worm.vala"
	if (old_value != value) {
#line 1064 "../src/worm.vala"
		self->priv->_raw_right = value;
#line 1064 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RAW_RIGHT_PROPERTY]);
#line 5730 "worm.c"
	}
}

static void
worm_properties_class_init (WormPropertiesClass * klass,
                            gpointer klass_data)
{
#line 1054 "../src/worm.vala"
	worm_properties_parent_class = g_type_class_peek_parent (klass);
#line 1054 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &WormProperties_private_offset);
#line 1054 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_worm_properties_get_property;
#line 1054 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_worm_properties_set_property;
#line 1054 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->finalize = worm_properties_finalize;
#line 1054 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_COLOR_PROPERTY, worm_properties_properties[WORM_PROPERTIES_COLOR_PROPERTY] = g_param_spec_int ("color", "color", "color", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1054 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_UP_PROPERTY, worm_properties_properties[WORM_PROPERTIES_UP_PROPERTY] = g_param_spec_uint ("up", "up", "up", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1054 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_DOWN_PROPERTY, worm_properties_properties[WORM_PROPERTIES_DOWN_PROPERTY] = g_param_spec_uint ("down", "down", "down", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1054 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_LEFT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_LEFT_PROPERTY] = g_param_spec_uint ("left", "left", "left", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1054 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RIGHT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RIGHT_PROPERTY] = g_param_spec_uint ("right", "right", "right", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1054 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RAW_UP_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RAW_UP_PROPERTY] = g_param_spec_int ("raw-up", "raw-up", "raw-up", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1054 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RAW_DOWN_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RAW_DOWN_PROPERTY] = g_param_spec_int ("raw-down", "raw-down", "raw-down", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1054 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RAW_LEFT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RAW_LEFT_PROPERTY] = g_param_spec_int ("raw-left", "raw-left", "raw-left", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1054 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RAW_RIGHT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RAW_RIGHT_PROPERTY] = g_param_spec_int ("raw-right", "raw-right", "raw-right", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5766 "worm.c"
}

static void
worm_properties_instance_init (WormProperties * self,
                               gpointer klass)
{
#line 1054 "../src/worm.vala"
	self->priv = worm_properties_get_instance_private (self);
#line 5775 "worm.c"
}

static void
worm_properties_finalize (GObject * obj)
{
	WormProperties * self;
#line 1054 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM_PROPERTIES, WormProperties);
#line 1054 "../src/worm.vala"
	G_OBJECT_CLASS (worm_properties_parent_class)->finalize (obj);
#line 5786 "worm.c"
}

 G_GNUC_NO_INLINE static GType
worm_properties_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WormProperties), 0, (GInstanceInitFunc) worm_properties_instance_init, NULL };
	GType worm_properties_type_id;
	worm_properties_type_id = g_type_register_static (G_TYPE_OBJECT, "WormProperties", &g_define_type_info, 0);
	WormProperties_private_offset = g_type_add_instance_private (worm_properties_type_id, sizeof (WormPropertiesPrivate));
	return worm_properties_type_id;
}

GType
worm_properties_get_type (void)
{
	static gsize worm_properties_type_id__once = 0;
	if (g_once_init_enter (&worm_properties_type_id__once)) {
		GType worm_properties_type_id;
		worm_properties_type_id = worm_properties_get_type_once ();
		g_once_init_leave (&worm_properties_type_id__once, worm_properties_type_id);
	}
	return worm_properties_type_id__once;
}

static void
_vala_worm_properties_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	WormProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM_PROPERTIES, WormProperties);
#line 1054 "../src/worm.vala"
	switch (property_id) {
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_COLOR_PROPERTY:
#line 1054 "../src/worm.vala"
		g_value_set_int (value, worm_properties_get_color (self));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_UP_PROPERTY:
#line 1054 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_up (self));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_DOWN_PROPERTY:
#line 1054 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_down (self));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_LEFT_PROPERTY:
#line 1054 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_left (self));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_RIGHT_PROPERTY:
#line 1054 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_right (self));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_UP_PROPERTY:
#line 1054 "../src/worm.vala"
		g_value_set_int (value, worm_properties_get_raw_up (self));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_DOWN_PROPERTY:
#line 1054 "../src/worm.vala"
		g_value_set_int (value, worm_properties_get_raw_down (self));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_LEFT_PROPERTY:
#line 1054 "../src/worm.vala"
		g_value_set_int (value, worm_properties_get_raw_left (self));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_RIGHT_PROPERTY:
#line 1054 "../src/worm.vala"
		g_value_set_int (value, worm_properties_get_raw_right (self));
#line 1054 "../src/worm.vala"
		break;
#line 5875 "worm.c"
		default:
#line 1054 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1054 "../src/worm.vala"
		break;
#line 5881 "worm.c"
	}
}

static void
_vala_worm_properties_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	WormProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM_PROPERTIES, WormProperties);
#line 1054 "../src/worm.vala"
	switch (property_id) {
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_COLOR_PROPERTY:
#line 1054 "../src/worm.vala"
		worm_properties_set_color (self, g_value_get_int (value));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_UP_PROPERTY:
#line 1054 "../src/worm.vala"
		worm_properties_set_up (self, g_value_get_uint (value));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_DOWN_PROPERTY:
#line 1054 "../src/worm.vala"
		worm_properties_set_down (self, g_value_get_uint (value));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_LEFT_PROPERTY:
#line 1054 "../src/worm.vala"
		worm_properties_set_left (self, g_value_get_uint (value));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_RIGHT_PROPERTY:
#line 1054 "../src/worm.vala"
		worm_properties_set_right (self, g_value_get_uint (value));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_UP_PROPERTY:
#line 1054 "../src/worm.vala"
		worm_properties_set_raw_up (self, g_value_get_int (value));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_DOWN_PROPERTY:
#line 1054 "../src/worm.vala"
		worm_properties_set_raw_down (self, g_value_get_int (value));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_LEFT_PROPERTY:
#line 1054 "../src/worm.vala"
		worm_properties_set_raw_left (self, g_value_get_int (value));
#line 1054 "../src/worm.vala"
		break;
#line 1054 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_RIGHT_PROPERTY:
#line 1054 "../src/worm.vala"
		worm_properties_set_raw_right (self, g_value_get_int (value));
#line 1054 "../src/worm.vala"
		break;
#line 5949 "worm.c"
		default:
#line 1054 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1054 "../src/worm.vala"
		break;
#line 5955 "worm.c"
	}
}

gboolean
worm_positions_append_position (WormPositions* self,
                                Position* p)
{
	Position _tmp0_;
	Position _tmp1_;
	gboolean result;
#line 1069 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1069 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 1071 "../src/worm.vala"
	_tmp0_ = *p;
#line 1071 "../src/worm.vala"
	_tmp1_ = *p;
#line 1071 "../src/worm.vala"
	result = gee_abstract_collection_add ((GeeAbstractCollection*) self, (gpointer) ((guintptr) ((((guint16) _tmp0_.x) << 8) | _tmp1_.y)));
#line 1071 "../src/worm.vala"
	return result;
#line 5978 "worm.c"
}

void
worm_positions_get_head (WormPositions* self,
                         Position* result)
{
	guint16 head = 0U;
	gpointer _tmp0_;
	Position _tmp1_ = {0};
#line 1073 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1075 "../src/worm.vala"
	_tmp0_ = gee_linked_list_first ((GeeLinkedList*) self);
#line 1075 "../src/worm.vala"
	head = (guint16) ((guintptr) _tmp0_);
#line 1076 "../src/worm.vala"
	_tmp1_.x = (guint8) (head >> 8);
#line 1076 "../src/worm.vala"
	_tmp1_.y = (guint8) head;
#line 1076 "../src/worm.vala"
	*result = _tmp1_;
#line 1076 "../src/worm.vala"
	return;
#line 6002 "worm.c"
}

void
worm_positions_set_head (WormPositions* self,
                         Position* p)
{
	Position _tmp0_;
	Position _tmp1_;
#line 1078 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1078 "../src/worm.vala"
	g_return_if_fail (p != NULL);
#line 1080 "../src/worm.vala"
	_tmp0_ = *p;
#line 1080 "../src/worm.vala"
	_tmp1_ = *p;
#line 1080 "../src/worm.vala"
	gee_abstract_list_set ((GeeAbstractList*) self, 0, (gpointer) ((guintptr) ((((guint16) _tmp0_.x) << 8) | _tmp1_.y)));
#line 6021 "worm.c"
}

gboolean
worm_positions_prepend_position (WormPositions* self,
                                 Position* p)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean result;
#line 1082 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1082 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 1084 "../src/worm.vala"
	_tmp0_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) self);
#line 1084 "../src/worm.vala"
	_tmp1_ = _tmp0_;
#line 1084 "../src/worm.vala"
	if (_tmp1_ > 0) {
#line 6041 "worm.c"
		Position _tmp2_;
		Position _tmp3_;
#line 1085 "../src/worm.vala"
		_tmp2_ = *p;
#line 1085 "../src/worm.vala"
		_tmp3_ = *p;
#line 1085 "../src/worm.vala"
		result = gee_deque_offer_head ((GeeDeque*) self, (gpointer) ((guintptr) ((((guint16) _tmp2_.x) << 8) | _tmp3_.y)));
#line 1085 "../src/worm.vala"
		return result;
#line 6052 "worm.c"
	} else {
		Position _tmp4_;
#line 1087 "../src/worm.vala"
		_tmp4_ = *p;
#line 1087 "../src/worm.vala"
		result = worm_positions_append_position (self, &_tmp4_);
#line 1087 "../src/worm.vala"
		return result;
#line 6061 "worm.c"
	}
}

void
worm_positions_remove_tail (WormPositions* self,
                            Position* result)
{
	guint16 tail = 0U;
	gpointer _tmp0_;
	Position _tmp1_ = {0};
#line 1089 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1091 "../src/worm.vala"
	_tmp0_ = gee_deque_poll_tail ((GeeDeque*) self);
#line 1091 "../src/worm.vala"
	tail = (guint16) ((guintptr) _tmp0_);
#line 1092 "../src/worm.vala"
	_tmp1_.x = (guint8) (tail >> 8);
#line 1092 "../src/worm.vala"
	_tmp1_.y = (guint8) tail;
#line 1092 "../src/worm.vala"
	*result = _tmp1_;
#line 1092 "../src/worm.vala"
	return;
#line 6086 "worm.c"
}

WormPositions*
worm_positions_construct (GType object_type)
{
	WormPositions * self = NULL;
#line 1067 "../src/worm.vala"
	self = (WormPositions*) gee_linked_list_construct (object_type, G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
#line 1067 "../src/worm.vala"
	return self;
#line 6097 "worm.c"
}

WormPositions*
worm_positions_new (void)
{
#line 1067 "../src/worm.vala"
	return worm_positions_construct (TYPE_WORM_POSITIONS);
#line 6105 "worm.c"
}

static void
worm_positions_class_init (WormPositionsClass * klass,
                           gpointer klass_data)
{
#line 1067 "../src/worm.vala"
	worm_positions_parent_class = g_type_class_peek_parent (klass);
#line 6114 "worm.c"
}

static void
worm_positions_instance_init (WormPositions * self,
                              gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
worm_positions_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormPositionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_positions_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WormPositions), 0, (GInstanceInitFunc) worm_positions_instance_init, NULL };
	GType worm_positions_type_id;
	worm_positions_type_id = g_type_register_static (GEE_TYPE_LINKED_LIST, "WormPositions", &g_define_type_info, 0);
	return worm_positions_type_id;
}

GType
worm_positions_get_type (void)
{
	static gsize worm_positions_type_id__once = 0;
	if (g_once_init_enter (&worm_positions_type_id__once)) {
		GType worm_positions_type_id;
		worm_positions_type_id = worm_positions_get_type_once ();
		g_once_init_leave (&worm_positions_type_id__once, worm_positions_type_id);
	}
	return worm_positions_type_id__once;
}

static inline gpointer
worm_get_instance_private (Worm* self)
{
	return G_STRUCT_MEMBER_P (self, Worm_private_offset);
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 1164 "../src/worm.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 1164 "../src/worm.vala"
	return _data11_;
#line 6157 "worm.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 1164 "../src/worm.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 6167 "worm.c"
		Worm* self;
#line 1164 "../src/worm.vala"
		self = _data11_->self;
#line 1164 "../src/worm.vala"
		_g_object_unref0 (self);
#line 1164 "../src/worm.vala"
		g_slice_free (Block11Data, _data11_);
#line 6175 "worm.c"
	}
}

static GeeList*
__lambda9_ (Block11Data* _data11_,
            Worm* worm)
{
	Worm* self;
	GeeList* _tmp0_;
	GeeList* result;
#line 1168 "../src/worm.vala"
	self = _data11_->self;
#line 1168 "../src/worm.vala"
	g_return_val_if_fail (worm != NULL, NULL);
#line 1168 "../src/worm.vala"
	_tmp0_ = _data11_->cb0 (worm, _data11_->cb0_target);
#line 1168 "../src/worm.vala"
	result = _tmp0_;
#line 1168 "../src/worm.vala"
	return result;
#line 6196 "worm.c"
}

static GeeList*
___lambda9__worm_get_other_worms_type (Worm* _self_,
                                       gpointer self)
{
	GeeList* result;
	result = __lambda9_ (self, _self_);
#line 1168 "../src/worm.vala"
	return result;
#line 6207 "worm.c"
}

static GeeList*
__lambda10_ (Block11Data* _data11_)
{
	Worm* self;
	GeeList* _tmp0_;
	GeeList* result;
#line 1169 "../src/worm.vala"
	self = _data11_->self;
#line 1169 "../src/worm.vala"
	_tmp0_ = _data11_->cb1 (_data11_->cb1_target);
#line 1169 "../src/worm.vala"
	result = _tmp0_;
#line 1169 "../src/worm.vala"
	return result;
#line 6224 "worm.c"
}

static GeeList*
___lambda10__worm_get_bonuses_type (gpointer self)
{
	GeeList* result;
	result = __lambda10_ (self);
#line 1169 "../src/worm.vala"
	return result;
#line 6234 "worm.c"
}

Worm*
worm_construct (GType object_type,
                gint id,
                guint8 width,
                guint8 height,
                WormGetOtherWormsType cb0,
                gpointer cb0_target,
                WormGetBonusesType cb1,
                gpointer cb1_target)
{
	Worm * self = NULL;
	Block11Data* _data11_;
	gint capacity = 0;
#line 1164 "../src/worm.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 1164 "../src/worm.vala"
	_data11_->_ref_count_ = 1;
#line 1164 "../src/worm.vala"
	_data11_->cb0 = cb0;
#line 1164 "../src/worm.vala"
	_data11_->cb0_target = cb0_target;
#line 1164 "../src/worm.vala"
	_data11_->cb1 = cb1;
#line 1164 "../src/worm.vala"
	_data11_->cb1_target = cb1_target;
#line 1166 "../src/worm.vala"
	capacity = (gint) (width * height);
#line 1167 "../src/worm.vala"
	self = (Worm*) g_object_new (object_type, "id", id, "width", width, "height", height, "capacity", capacity, NULL);
#line 1167 "../src/worm.vala"
	_data11_->self = g_object_ref (self);
#line 1168 "../src/worm.vala"
	(self->priv->get_other_worms_target_destroy_notify == NULL) ? NULL : (self->priv->get_other_worms_target_destroy_notify (self->priv->get_other_worms_target), NULL);
#line 1168 "../src/worm.vala"
	self->priv->get_other_worms = NULL;
#line 1168 "../src/worm.vala"
	self->priv->get_other_worms_target = NULL;
#line 1168 "../src/worm.vala"
	self->priv->get_other_worms_target_destroy_notify = NULL;
#line 1168 "../src/worm.vala"
	self->priv->get_other_worms = ___lambda9__worm_get_other_worms_type;
#line 1168 "../src/worm.vala"
	self->priv->get_other_worms_target = block11_data_ref (_data11_);
#line 1168 "../src/worm.vala"
	self->priv->get_other_worms_target_destroy_notify = block11_data_unref;
#line 1169 "../src/worm.vala"
	(self->priv->get_bonuses_target_destroy_notify == NULL) ? NULL : (self->priv->get_bonuses_target_destroy_notify (self->priv->get_bonuses_target), NULL);
#line 1169 "../src/worm.vala"
	self->priv->get_bonuses = NULL;
#line 1169 "../src/worm.vala"
	self->priv->get_bonuses_target = NULL;
#line 1169 "../src/worm.vala"
	self->priv->get_bonuses_target_destroy_notify = NULL;
#line 1169 "../src/worm.vala"
	self->priv->get_bonuses = ___lambda10__worm_get_bonuses_type;
#line 1169 "../src/worm.vala"
	self->priv->get_bonuses_target = block11_data_ref (_data11_);
#line 1169 "../src/worm.vala"
	self->priv->get_bonuses_target_destroy_notify = block11_data_unref;
#line 1164 "../src/worm.vala"
	block11_data_unref (_data11_);
#line 1164 "../src/worm.vala"
	_data11_ = NULL;
#line 1164 "../src/worm.vala"
	return self;
#line 6302 "worm.c"
}

Worm*
worm_new (gint id,
          guint8 width,
          guint8 height,
          WormGetOtherWormsType cb0,
          gpointer cb0_target,
          WormGetBonusesType cb1,
          gpointer cb1_target)
{
#line 1164 "../src/worm.vala"
	return worm_construct (TYPE_WORM, id, width, height, cb0, cb0_target, cb1, cb1_target);
#line 6316 "worm.c"
}

void
worm_set_start (Worm* self,
                guint8 x,
                guint8 y,
                WormDirection direction)
{
	WormPositions* _tmp0_;
	GeeArrayList* _tmp1_;
	Position _tmp2_ = {0};
	WormPositions* _tmp3_;
	Position _tmp4_;
	GeeArrayQueue* _tmp5_;
#line 1172 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1174 "../src/worm.vala"
	_tmp0_ = self->list;
#line 1174 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 1176 "../src/worm.vala"
	_tmp1_ = self->priv->bonus_eaten;
#line 1176 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 1178 "../src/worm.vala"
	_tmp2_.x = x;
#line 1178 "../src/worm.vala"
	_tmp2_.y = y;
#line 1178 "../src/worm.vala"
	worm_set_starting_position (self, &_tmp2_);
#line 1179 "../src/worm.vala"
	_tmp3_ = self->list;
#line 1179 "../src/worm.vala"
	_tmp4_ = self->priv->_starting_position;
#line 1179 "../src/worm.vala"
	worm_positions_append_position (_tmp3_, &_tmp4_);
#line 1181 "../src/worm.vala"
	self->priv->starting_direction = direction;
#line 1182 "../src/worm.vala"
	worm_set_direction (self, direction);
#line 1183 "../src/worm.vala"
	worm_set_change (self, 0);
#line 1184 "../src/worm.vala"
	_tmp5_ = self->priv->key_queue;
#line 1184 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp5_);
#line 6363 "worm.c"
}

void
worm_move_part_1 (Worm* self)
{
	Position position = {0};
	Position _tmp0_ = {0};
	Position _tmp1_;
	WormDirection _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	WormPositions* _tmp5_;
	Position _tmp6_;
#line 1187 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1189 "../src/worm.vala"
	if (self->is_human) {
#line 1190 "../src/worm.vala"
		self->keypress = FALSE;
#line 6383 "worm.c"
	}
#line 1192 "../src/worm.vala"
	worm_get_head (self, &_tmp0_);
#line 1192 "../src/worm.vala"
	_tmp1_ = _tmp0_;
#line 1192 "../src/worm.vala"
	position = _tmp1_;
#line 1193 "../src/worm.vala"
	_tmp2_ = self->priv->_direction;
#line 1193 "../src/worm.vala"
	_tmp3_ = self->priv->_width;
#line 1193 "../src/worm.vala"
	_tmp4_ = self->priv->_height;
#line 1193 "../src/worm.vala"
	position_move (&position, _tmp2_, _tmp3_, _tmp4_);
#line 1196 "../src/worm.vala"
	_tmp5_ = self->list;
#line 1196 "../src/worm.vala"
	_tmp6_ = position;
#line 1196 "../src/worm.vala"
	worm_positions_prepend_position (_tmp5_, &_tmp6_);
#line 6405 "worm.c"
}

void
worm_move_part_2 (Worm* self,
                  Position* head_position)
{
	gint _tmp1_;
	GeeArrayQueue* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 1199 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1201 "../src/worm.vala"
	if (head_position != NULL) {
#line 6420 "worm.c"
		Position _tmp0_ = {0};
#line 1202 "../src/worm.vala"
		memset (&_tmp0_, 0, sizeof (Position));
#line 1202 "../src/worm.vala"
		_tmp0_.x = (*head_position).x;
#line 1202 "../src/worm.vala"
		_tmp0_.y = (*head_position).y;
#line 1202 "../src/worm.vala"
		worm_set_head (self, &_tmp0_);
#line 6430 "worm.c"
	}
#line 1204 "../src/worm.vala"
	_tmp1_ = self->priv->_change;
#line 1204 "../src/worm.vala"
	if (_tmp1_ > 0) {
#line 6436 "worm.c"
		gint _tmp2_;
#line 1207 "../src/worm.vala"
		_tmp2_ = self->priv->_change;
#line 1207 "../src/worm.vala"
		worm_set_change (self, _tmp2_ - 1);
#line 6442 "worm.c"
	} else {
		WormPositions* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		WormPositions* _tmp6_;
		Position _tmp7_ = {0};
#line 1212 "../src/worm.vala"
		_tmp3_ = self->list;
#line 1212 "../src/worm.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 1212 "../src/worm.vala"
		_tmp5_ = _tmp4_;
#line 1212 "../src/worm.vala"
		_vala_assert (_tmp5_ > 0, "list.size > 0");
#line 1213 "../src/worm.vala"
		_tmp6_ = self->list;
#line 1213 "../src/worm.vala"
		worm_positions_remove_tail (_tmp6_, &_tmp7_);
#line 1213 "../src/worm.vala"
		worm_remove_bonus_eaten_position (self, &_tmp7_);
#line 6463 "worm.c"
	}
#line 1217 "../src/worm.vala"
	g_signal_emit (self, worm_signals[WORM_BONUS_FOUND_SIGNAL], 0);
#line 1220 "../src/worm.vala"
	if (self->priv->rounds_to_stay_dematerialized > 1) {
#line 1221 "../src/worm.vala"
		self->priv->rounds_to_stay_dematerialized = self->priv->rounds_to_stay_dematerialized - 1;
#line 6471 "worm.c"
	}
#line 1223 "../src/worm.vala"
	_tmp8_ = self->priv->key_queue;
#line 1223 "../src/worm.vala"
	_tmp9_ = gee_array_queue_get_is_empty (_tmp8_);
#line 1223 "../src/worm.vala"
	_tmp10_ = _tmp9_;
#line 1223 "../src/worm.vala"
	if (!_tmp10_) {
#line 1224 "../src/worm.vala"
		worm_dequeue_keypress (self);
#line 6483 "worm.c"
	}
#line 1227 "../src/worm.vala"
	if (self->priv->rounds_to_stay_dematerialized == 1) {
#line 1228 "../src/worm.vala"
		worm_materialize (self);
#line 6489 "worm.c"
	}
}

void
worm_remove_bonus_eaten_position (Worm* self,
                                  Position* p)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 1231 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1231 "../src/worm.vala"
	g_return_if_fail (p != NULL);
#line 1233 "../src/worm.vala"
	_tmp0_ = self->priv->bonus_eaten;
#line 1233 "../src/worm.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 1233 "../src/worm.vala"
	_tmp2_ = _tmp1_;
#line 1233 "../src/worm.vala"
	if (_tmp2_ > 0) {
#line 6512 "worm.c"
		guint16 a = 0U;
		Position _tmp3_;
		Position _tmp4_;
		GeeArrayList* _tmp5_;
#line 1235 "../src/worm.vala"
		_tmp3_ = *p;
#line 1235 "../src/worm.vala"
		_tmp4_ = *p;
#line 1235 "../src/worm.vala"
		a = (guint16) ((((guint16) _tmp3_.x) << 8) | _tmp4_.y);
#line 1236 "../src/worm.vala"
		_tmp5_ = self->priv->bonus_eaten;
#line 1236 "../src/worm.vala"
		if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp5_, (gpointer) ((guintptr) a))) {
#line 6527 "worm.c"
			GeeArrayList* _tmp6_;
#line 1237 "../src/worm.vala"
			_tmp6_ = self->priv->bonus_eaten;
#line 1237 "../src/worm.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp6_, (gpointer) ((guintptr) a));
#line 6533 "worm.c"
		}
	}
}

void
worm_add_bonus_eaten_position (Worm* self,
                               guint8 x,
                               guint8 y)
{
	GeeArrayList* _tmp0_;
#line 1242 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1245 "../src/worm.vala"
	_tmp0_ = self->priv->bonus_eaten;
#line 1245 "../src/worm.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (gpointer) ((guintptr) ((((guint16) x) << 8) | y)));
#line 6550 "worm.c"
}

gboolean
worm_was_bonus_eaten_at_this_position (Worm* self,
                                       guint16 position)
{
	GeeArrayList* _tmp0_;
	gboolean result;
#line 1248 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1250 "../src/worm.vala"
	_tmp0_ = self->priv->bonus_eaten;
#line 1250 "../src/worm.vala"
	result = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (gpointer) ((guintptr) position));
#line 1250 "../src/worm.vala"
	return result;
#line 6567 "worm.c"
}

void
worm_reduce_tail (Worm* self,
                  gint erase_size)
{
#line 1254 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1256 "../src/worm.vala"
	if (erase_size > 0) {
#line 6578 "worm.c"
		{
			gint i = 0;
#line 1258 "../src/worm.vala"
			i = 0;
#line 6583 "worm.c"
			{
				gboolean _tmp0_ = FALSE;
#line 1258 "../src/worm.vala"
				_tmp0_ = TRUE;
#line 1258 "../src/worm.vala"
				while (TRUE) {
#line 6590 "worm.c"
					WormPositions* _tmp2_;
					gint _tmp3_;
					gint _tmp4_;
					WormPositions* _tmp5_;
					Position _tmp6_ = {0};
#line 1258 "../src/worm.vala"
					if (!_tmp0_) {
#line 6598 "worm.c"
						gint _tmp1_;
#line 1258 "../src/worm.vala"
						_tmp1_ = i;
#line 1258 "../src/worm.vala"
						i = _tmp1_ + 1;
#line 6604 "worm.c"
					}
#line 1258 "../src/worm.vala"
					_tmp0_ = FALSE;
#line 1258 "../src/worm.vala"
					if (!(i < erase_size)) {
#line 1258 "../src/worm.vala"
						break;
#line 6612 "worm.c"
					}
#line 1261 "../src/worm.vala"
					_tmp2_ = self->list;
#line 1261 "../src/worm.vala"
					_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 1261 "../src/worm.vala"
					_tmp4_ = _tmp3_;
#line 1261 "../src/worm.vala"
					_vala_assert (_tmp4_ > 0, "list.size > 0");
#line 1262 "../src/worm.vala"
					_tmp5_ = self->list;
#line 1262 "../src/worm.vala"
					worm_positions_remove_tail (_tmp5_, &_tmp6_);
#line 1262 "../src/worm.vala"
					worm_remove_bonus_eaten_position (self, &_tmp6_);
#line 6628 "worm.c"
				}
			}
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 1279 "../src/worm.vala"
	return self ? g_object_ref (self) : NULL;
#line 6640 "worm.c"
}

void
worm_reverse (Worm* self)
{
	gboolean _tmp0_ = FALSE;
#line 1267 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1269 "../src/worm.vala"
	if (!self->is_stopped) {
#line 6651 "worm.c"
		WormPositions* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 1269 "../src/worm.vala"
		_tmp1_ = self->list;
#line 1269 "../src/worm.vala"
		_tmp2_ = gee_collection_get_is_empty ((GeeCollection*) _tmp1_);
#line 1269 "../src/worm.vala"
		_tmp3_ = _tmp2_;
#line 1269 "../src/worm.vala"
		_tmp0_ = !_tmp3_;
#line 6663 "worm.c"
	} else {
#line 1269 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 6667 "worm.c"
	}
#line 1269 "../src/worm.vala"
	if (_tmp0_) {
#line 6671 "worm.c"
		WormPositions* reversed_list = NULL;
		WormPositions* _tmp4_;
		WormPositions* _tmp18_;
		WormPositions* _tmp19_;
		WormPositions* _tmp20_;
		gpointer _tmp21_;
		WormPositions* _tmp22_;
		gpointer _tmp23_;
#line 1271 "../src/worm.vala"
		_tmp4_ = worm_positions_new ();
#line 1271 "../src/worm.vala"
		reversed_list = _tmp4_;
#line 6684 "worm.c"
		{
			WormPositions* _pos_list = NULL;
			WormPositions* _tmp5_;
			gint _pos_size = 0;
			WormPositions* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _pos_index = 0;
#line 1272 "../src/worm.vala"
			_tmp5_ = self->list;
#line 1272 "../src/worm.vala"
			_pos_list = _tmp5_;
#line 1272 "../src/worm.vala"
			_tmp6_ = _pos_list;
#line 1272 "../src/worm.vala"
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 1272 "../src/worm.vala"
			_tmp8_ = _tmp7_;
#line 1272 "../src/worm.vala"
			_pos_size = _tmp8_;
#line 1272 "../src/worm.vala"
			_pos_index = -1;
#line 1272 "../src/worm.vala"
			while (TRUE) {
#line 6709 "worm.c"
				gint _tmp9_;
				gint _tmp10_;
				guint16 pos = 0U;
				WormPositions* _tmp11_;
				gpointer _tmp12_;
				WormPositions* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 1272 "../src/worm.vala"
				_pos_index = _pos_index + 1;
#line 1272 "../src/worm.vala"
				_tmp9_ = _pos_index;
#line 1272 "../src/worm.vala"
				_tmp10_ = _pos_size;
#line 1272 "../src/worm.vala"
				if (!(_tmp9_ < _tmp10_)) {
#line 1272 "../src/worm.vala"
					break;
#line 6728 "worm.c"
				}
#line 1272 "../src/worm.vala"
				_tmp11_ = _pos_list;
#line 1272 "../src/worm.vala"
				_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _pos_index);
#line 1272 "../src/worm.vala"
				pos = (guint16) ((guintptr) _tmp12_);
#line 1274 "../src/worm.vala"
				_tmp13_ = reversed_list;
#line 1274 "../src/worm.vala"
				_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
#line 1274 "../src/worm.vala"
				_tmp15_ = _tmp14_;
#line 1274 "../src/worm.vala"
				if (_tmp15_ > 0) {
#line 6744 "worm.c"
					WormPositions* _tmp16_;
#line 1275 "../src/worm.vala"
					_tmp16_ = reversed_list;
#line 1275 "../src/worm.vala"
					gee_deque_offer_head ((GeeDeque*) _tmp16_, (gpointer) ((guintptr) pos));
#line 6750 "worm.c"
				} else {
					WormPositions* _tmp17_;
#line 1277 "../src/worm.vala"
					_tmp17_ = reversed_list;
#line 1277 "../src/worm.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, (gpointer) ((guintptr) pos));
#line 6757 "worm.c"
				}
			}
		}
#line 1279 "../src/worm.vala"
		_tmp18_ = reversed_list;
#line 1279 "../src/worm.vala"
		_tmp19_ = _g_object_ref0 (_tmp18_);
#line 1279 "../src/worm.vala"
		_g_object_unref0 (self->list);
#line 1279 "../src/worm.vala"
		self->list = _tmp19_;
#line 1282 "../src/worm.vala"
		_tmp20_ = self->list;
#line 1282 "../src/worm.vala"
		_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, 0);
#line 1282 "../src/worm.vala"
		_tmp22_ = self->list;
#line 1282 "../src/worm.vala"
		_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, 1);
#line 1282 "../src/worm.vala"
		if (((guint8) ((guint16) ((guintptr) _tmp21_))) == ((guint8) ((guint16) ((guintptr) _tmp23_)))) {
#line 6779 "worm.c"
			WormDirection _tmp24_ = 0;
			WormPositions* _tmp25_;
			gpointer _tmp26_;
			WormPositions* _tmp27_;
			gpointer _tmp28_;
#line 1283 "../src/worm.vala"
			_tmp25_ = self->list;
#line 1283 "../src/worm.vala"
			_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, 0);
#line 1283 "../src/worm.vala"
			_tmp27_ = self->list;
#line 1283 "../src/worm.vala"
			_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, 1);
#line 1283 "../src/worm.vala"
			if ((((guint16) ((guintptr) _tmp26_)) >> 8) > (((guint16) ((guintptr) _tmp28_)) >> 8)) {
#line 1283 "../src/worm.vala"
				_tmp24_ = WORM_DIRECTION_RIGHT;
#line 6797 "worm.c"
			} else {
#line 1283 "../src/worm.vala"
				_tmp24_ = WORM_DIRECTION_LEFT;
#line 6801 "worm.c"
			}
#line 1283 "../src/worm.vala"
			worm_set_direction (self, _tmp24_);
#line 6805 "worm.c"
		} else {
			WormDirection _tmp29_ = 0;
			WormPositions* _tmp30_;
			gpointer _tmp31_;
			WormPositions* _tmp32_;
			gpointer _tmp33_;
#line 1285 "../src/worm.vala"
			_tmp30_ = self->list;
#line 1285 "../src/worm.vala"
			_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, 0);
#line 1285 "../src/worm.vala"
			_tmp32_ = self->list;
#line 1285 "../src/worm.vala"
			_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, 1);
#line 1285 "../src/worm.vala"
			if (((guint8) ((guint16) ((guintptr) _tmp31_))) > ((guint8) ((guint16) ((guintptr) _tmp33_)))) {
#line 1285 "../src/worm.vala"
				_tmp29_ = WORM_DIRECTION_DOWN;
#line 6824 "worm.c"
			} else {
#line 1285 "../src/worm.vala"
				_tmp29_ = WORM_DIRECTION_UP;
#line 6828 "worm.c"
			}
#line 1285 "../src/worm.vala"
			worm_set_direction (self, _tmp29_);
#line 6832 "worm.c"
		}
#line 1269 "../src/worm.vala"
		_g_object_unref0 (reversed_list);
#line 6836 "worm.c"
	}
}

static gboolean
worm_does_list_contain_position (WormPositions* position_list,
                                 guint16 position)
{
	gboolean result;
#line 1289 "../src/worm.vala"
	g_return_val_if_fail (position_list != NULL, FALSE);
#line 1291 "../src/worm.vala"
	if (position_list != NULL) {
#line 6849 "worm.c"
		{
			WormPositions* _p_list = NULL;
			gint _p_size = 0;
			WormPositions* _tmp0_;
			gint _tmp1_;
			gint _tmp2_;
			gint _p_index = 0;
#line 1292 "../src/worm.vala"
			_p_list = position_list;
#line 1292 "../src/worm.vala"
			_tmp0_ = _p_list;
#line 1292 "../src/worm.vala"
			_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 1292 "../src/worm.vala"
			_tmp2_ = _tmp1_;
#line 1292 "../src/worm.vala"
			_p_size = _tmp2_;
#line 1292 "../src/worm.vala"
			_p_index = -1;
#line 1292 "../src/worm.vala"
			while (TRUE) {
#line 6871 "worm.c"
				gint _tmp3_;
				gint _tmp4_;
				guint16 p = 0U;
				WormPositions* _tmp5_;
				gpointer _tmp6_;
#line 1292 "../src/worm.vala"
				_p_index = _p_index + 1;
#line 1292 "../src/worm.vala"
				_tmp3_ = _p_index;
#line 1292 "../src/worm.vala"
				_tmp4_ = _p_size;
#line 1292 "../src/worm.vala"
				if (!(_tmp3_ < _tmp4_)) {
#line 1292 "../src/worm.vala"
					break;
#line 6887 "worm.c"
				}
#line 1292 "../src/worm.vala"
				_tmp5_ = _p_list;
#line 1292 "../src/worm.vala"
				_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _p_index);
#line 1292 "../src/worm.vala"
				p = (guint16) ((guintptr) _tmp6_);
#line 1293 "../src/worm.vala"
				if (p == position) {
#line 1294 "../src/worm.vala"
					result = TRUE;
#line 1294 "../src/worm.vala"
					return result;
#line 6901 "worm.c"
				}
			}
		}
	}
#line 1295 "../src/worm.vala"
	result = FALSE;
#line 1295 "../src/worm.vala"
	return result;
#line 6910 "worm.c"
}

gboolean
worm_is_position_clear_of_materialized_worms (Worm* self,
                                              GeeLinkedList* worms,
                                              Position* position)
{
	gboolean result;
#line 1298 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1298 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 1298 "../src/worm.vala"
	g_return_val_if_fail (position != NULL, FALSE);
#line 6925 "worm.c"
	{
		GeeLinkedList* _worm_list = NULL;
		gint _worm_size = 0;
		GeeLinkedList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _worm_index = 0;
#line 1300 "../src/worm.vala"
		_worm_list = worms;
#line 1300 "../src/worm.vala"
		_tmp0_ = _worm_list;
#line 1300 "../src/worm.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 1300 "../src/worm.vala"
		_tmp2_ = _tmp1_;
#line 1300 "../src/worm.vala"
		_worm_size = _tmp2_;
#line 1300 "../src/worm.vala"
		_worm_index = -1;
#line 1300 "../src/worm.vala"
		while (TRUE) {
#line 6947 "worm.c"
			gint _tmp3_;
			gint _tmp4_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			gboolean _tmp7_ = FALSE;
			Worm* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 1300 "../src/worm.vala"
			_worm_index = _worm_index + 1;
#line 1300 "../src/worm.vala"
			_tmp3_ = _worm_index;
#line 1300 "../src/worm.vala"
			_tmp4_ = _worm_size;
#line 1300 "../src/worm.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 1300 "../src/worm.vala"
				break;
#line 6967 "worm.c"
			}
#line 1300 "../src/worm.vala"
			_tmp5_ = _worm_list;
#line 1300 "../src/worm.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _worm_index);
#line 1300 "../src/worm.vala"
			worm = (Worm*) _tmp6_;
#line 1301 "../src/worm.vala"
			_tmp8_ = worm;
#line 1301 "../src/worm.vala"
			_tmp9_ = worm_get_is_materialized (_tmp8_);
#line 1301 "../src/worm.vala"
			_tmp10_ = _tmp9_;
#line 1301 "../src/worm.vala"
			if (_tmp10_) {
#line 6983 "worm.c"
				Worm* _tmp11_;
				WormPositions* _tmp12_;
				Position _tmp13_;
				Position _tmp14_;
#line 1301 "../src/worm.vala"
				_tmp11_ = worm;
#line 1301 "../src/worm.vala"
				_tmp12_ = _tmp11_->list;
#line 1301 "../src/worm.vala"
				_tmp13_ = *position;
#line 1301 "../src/worm.vala"
				_tmp14_ = *position;
#line 1301 "../src/worm.vala"
				_tmp7_ = worm_does_list_contain_position (_tmp12_, (guint16) ((((guint16) _tmp13_.x) << 8) | _tmp14_.y));
#line 6998 "worm.c"
			} else {
#line 1301 "../src/worm.vala"
				_tmp7_ = FALSE;
#line 7002 "worm.c"
			}
#line 1301 "../src/worm.vala"
			if (_tmp7_) {
#line 1302 "../src/worm.vala"
				result = FALSE;
#line 1302 "../src/worm.vala"
				_g_object_unref0 (worm);
#line 1302 "../src/worm.vala"
				return result;
#line 7012 "worm.c"
			}
#line 1300 "../src/worm.vala"
			_g_object_unref0 (worm);
#line 7016 "worm.c"
		}
	}
#line 1303 "../src/worm.vala"
	result = TRUE;
#line 1303 "../src/worm.vala"
	return result;
#line 7023 "worm.c"
}

static gboolean
worm_is_board_position_occupied (Position* p,
                                 gint* board,
                                 gint board_length1,
                                 gint board_length2)
{
	Position _tmp0_;
	Position _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 1306 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 1308 "../src/worm.vala"
	_tmp0_ = *p;
#line 1308 "../src/worm.vala"
	_tmp1_ = *p;
#line 1308 "../src/worm.vala"
	_tmp2_ = board[(_tmp0_.x * board_length2) + _tmp1_.y];
#line 1308 "../src/worm.vala"
	result = _tmp2_ > ((gint) NIBBLES_GAME_EMPTYCHAR);
#line 1308 "../src/worm.vala"
	return result;
#line 7048 "worm.c"
}

gboolean
worm_can_move_to (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  GeeLinkedList* worms,
                  Position* position)
{
	Position _tmp0_;
	gboolean result;
#line 1311 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1311 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 1311 "../src/worm.vala"
	g_return_val_if_fail (position != NULL, FALSE);
#line 1313 "../src/worm.vala"
	_tmp0_ = *position;
#line 1313 "../src/worm.vala"
	if (worm_is_board_position_occupied (&_tmp0_, board, (gint) board_length1, (gint) board_length2)) {
#line 1314 "../src/worm.vala"
		result = FALSE;
#line 1314 "../src/worm.vala"
		return result;
#line 7075 "worm.c"
	} else {
		Position _tmp1_;
#line 1315 "../src/worm.vala"
		_tmp1_ = *position;
#line 1315 "../src/worm.vala"
		if (!worm_is_position_clear_of_materialized_worms (self, worms, &_tmp1_)) {
#line 7082 "worm.c"
			gboolean _tmp2_;
			gboolean _tmp3_;
#line 1316 "../src/worm.vala"
			_tmp2_ = worm_get_is_materialized (self);
#line 1316 "../src/worm.vala"
			_tmp3_ = _tmp2_;
#line 1316 "../src/worm.vala"
			result = !_tmp3_;
#line 1316 "../src/worm.vala"
			return result;
#line 7093 "worm.c"
		} else {
#line 1318 "../src/worm.vala"
			result = TRUE;
#line 1318 "../src/worm.vala"
			return result;
#line 7099 "worm.c"
		}
	}
}

gboolean
worm_can_move_to_map (Worm* self,
                      gint* board,
                      gint board_length1,
                      gint board_length2,
                      WormMap* worm_map,
                      Position* position)
{
	Position _tmp0_;
	gboolean result;
#line 1321 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1321 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, FALSE);
#line 1321 "../src/worm.vala"
	g_return_val_if_fail (position != NULL, FALSE);
#line 1323 "../src/worm.vala"
	_tmp0_ = *position;
#line 1323 "../src/worm.vala"
	if (worm_is_board_position_occupied (&_tmp0_, board, (gint) board_length1, (gint) board_length2)) {
#line 1324 "../src/worm.vala"
		result = FALSE;
#line 1324 "../src/worm.vala"
		return result;
#line 7128 "worm.c"
	} else {
		Position _tmp1_;
#line 1325 "../src/worm.vala"
		_tmp1_ = *position;
#line 1325 "../src/worm.vala"
		if (worm_map_contain_position (worm_map, &_tmp1_)) {
#line 7135 "worm.c"
			gboolean _tmp2_;
			gboolean _tmp3_;
#line 1326 "../src/worm.vala"
			_tmp2_ = worm_get_is_materialized (self);
#line 1326 "../src/worm.vala"
			_tmp3_ = _tmp2_;
#line 1326 "../src/worm.vala"
			result = !_tmp3_;
#line 1326 "../src/worm.vala"
			return result;
#line 7146 "worm.c"
		} else {
#line 1328 "../src/worm.vala"
			result = TRUE;
#line 1328 "../src/worm.vala"
			return result;
#line 7152 "worm.c"
		}
	}
}

gboolean
worm_can_move_direction (Worm* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         GeeLinkedList* worms,
                         WormDirection direction)
{
	Position position = {0};
	WormPositions* _tmp0_;
	Position _tmp1_ = {0};
	guint8 _tmp2_;
	guint8 _tmp3_;
	Position _tmp4_;
	gboolean result;
#line 1331 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1331 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 1333 "../src/worm.vala"
	_tmp0_ = self->list;
#line 1333 "../src/worm.vala"
	worm_positions_get_head (_tmp0_, &_tmp1_);
#line 1333 "../src/worm.vala"
	position = _tmp1_;
#line 1334 "../src/worm.vala"
	_tmp2_ = self->priv->_width;
#line 1334 "../src/worm.vala"
	_tmp3_ = self->priv->_height;
#line 1334 "../src/worm.vala"
	position_move (&position, direction, _tmp2_, _tmp3_);
#line 1335 "../src/worm.vala"
	_tmp4_ = position;
#line 1335 "../src/worm.vala"
	result = worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, worms, &_tmp4_);
#line 1335 "../src/worm.vala"
	return result;
#line 7194 "worm.c"
}

void
worm_spawn (Worm* self)
{
#line 1338 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1340 "../src/worm.vala"
	_vala_assert (WORM_STARTING_LENGTH > 0, "STARTING_LENGTH > 0");
#line 1341 "../src/worm.vala"
	worm_set_change (self, WORM_STARTING_LENGTH - 1);
#line 1342 "../src/worm.vala"
	self->priv->rounds_to_stay_dematerialized = WORM_STARTING_LENGTH;
#line 7208 "worm.c"
	{
		gint i = 0;
#line 1343 "../src/worm.vala"
		i = 0;
#line 7213 "worm.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1343 "../src/worm.vala"
			_tmp0_ = TRUE;
#line 1343 "../src/worm.vala"
			while (TRUE) {
#line 1343 "../src/worm.vala"
				if (!_tmp0_) {
#line 7222 "worm.c"
					gint _tmp1_;
#line 1343 "../src/worm.vala"
					_tmp1_ = i;
#line 1343 "../src/worm.vala"
					i = _tmp1_ + 1;
#line 7228 "worm.c"
				}
#line 1343 "../src/worm.vala"
				_tmp0_ = FALSE;
#line 1343 "../src/worm.vala"
				if (!(i < WORM_STARTING_LENGTH)) {
#line 1343 "../src/worm.vala"
					break;
#line 7236 "worm.c"
				}
#line 1345 "../src/worm.vala"
				worm_move_part_1 (self);
#line 1346 "../src/worm.vala"
				worm_move_part_2 (self, NULL);
#line 7242 "worm.c"
			}
		}
	}
}

static void
worm_materialize (Worm* self)
{
	WormMap* worm_map = NULL;
	WormGetOtherWormsType _tmp0_;
	gpointer _tmp0__target;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	WormMap* _tmp5_;
	WormMap* _tmp6_;
	WormMap* _tmp7_;
	WormPositions* _tmp8_;
#line 1350 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1358 "../src/worm.vala"
	_tmp0_ = self->priv->get_other_worms;
#line 1358 "../src/worm.vala"
	_tmp0__target = self->priv->get_other_worms_target;
#line 1358 "../src/worm.vala"
	_tmp1_ = _tmp0_ (self, _tmp0__target);
#line 1358 "../src/worm.vala"
	_tmp2_ = _tmp1_;
#line 1358 "../src/worm.vala"
	_tmp3_ = self->priv->_width;
#line 1358 "../src/worm.vala"
	_tmp4_ = self->priv->_height;
#line 1358 "../src/worm.vala"
	_tmp5_ = worm_map_new (_tmp2_, _tmp3_, _tmp4_);
#line 1358 "../src/worm.vala"
	_tmp6_ = _tmp5_;
#line 1358 "../src/worm.vala"
	_g_object_unref0 (_tmp2_);
#line 1358 "../src/worm.vala"
	worm_map = _tmp6_;
#line 1359 "../src/worm.vala"
	_tmp7_ = worm_map;
#line 1359 "../src/worm.vala"
	_tmp8_ = self->list;
#line 1359 "../src/worm.vala"
	if (worm_map_contains (_tmp7_, _tmp8_)) {
#line 1360 "../src/worm.vala"
		self->priv->rounds_to_stay_dematerialized = self->priv->rounds_to_stay_dematerialized + 1;
#line 7292 "worm.c"
	} else {
#line 1362 "../src/worm.vala"
		self->priv->rounds_to_stay_dematerialized = 0;
#line 7296 "worm.c"
	}
#line 1350 "../src/worm.vala"
	_g_object_unref0 (worm_map);
#line 7300 "worm.c"
}

void
worm_dematerialize (Worm* self,
                    gint rounds,
                    gint gamedelay)
{
	gint _tmp0_ = 0;
#line 1365 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1368 "../src/worm.vala"
	if (rounds > 1) {
#line 1368 "../src/worm.vala"
		_tmp0_ = rounds;
#line 7315 "worm.c"
	} else {
#line 1368 "../src/worm.vala"
		_tmp0_ = 1;
#line 7319 "worm.c"
	}
#line 1368 "../src/worm.vala"
	self->priv->rounds_to_stay_dematerialized = _tmp0_;
#line 1370 "../src/worm.vala"
	self->rounds_to_stay_still = 2;
#line 7325 "worm.c"
}

void
worm_add_life (Worm* self)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
#line 1373 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1375 "../src/worm.vala"
	_tmp0_ = self->priv->_lives;
#line 1375 "../src/worm.vala"
	if (_tmp0_ > WORM_MAX_LIVES) {
#line 1376 "../src/worm.vala"
		return;
#line 7341 "worm.c"
	}
#line 1378 "../src/worm.vala"
	_tmp1_ = self->priv->_lives;
#line 1378 "../src/worm.vala"
	worm_set_lives (self, _tmp1_ + 1);
#line 7347 "worm.c"
}

static inline void
worm_lose_life (Worm* self)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
#line 1381 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1383 "../src/worm.vala"
	_tmp0_ = self->priv->_lives;
#line 1383 "../src/worm.vala"
	if (((gint) _tmp0_) == 0) {
#line 1384 "../src/worm.vala"
		return;
#line 7363 "worm.c"
	}
#line 1386 "../src/worm.vala"
	_tmp1_ = self->priv->_lives;
#line 1386 "../src/worm.vala"
	worm_set_lives (self, _tmp1_ - 1);
#line 7369 "worm.c"
}

void
worm_reset (Worm* self)
{
	GeeArrayQueue* _tmp0_;
	WormPositions* _tmp1_;
	GeeArrayList* _tmp2_;
	guint8 _tmp3_;
#line 1389 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1391 "../src/worm.vala"
	self->is_stopped = TRUE;
#line 1392 "../src/worm.vala"
	self->priv->rounds_to_stay_dematerialized = 0;
#line 1394 "../src/worm.vala"
	_tmp0_ = self->priv->key_queue;
#line 1394 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 1396 "../src/worm.vala"
	worm_lose_life (self);
#line 1398 "../src/worm.vala"
	_tmp1_ = self->list;
#line 1398 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 1400 "../src/worm.vala"
	_tmp2_ = self->priv->bonus_eaten;
#line 1400 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp2_);
#line 1402 "../src/worm.vala"
	_tmp3_ = self->priv->_lives;
#line 1402 "../src/worm.vala"
	if (((gint) _tmp3_) > 0) {
#line 7403 "worm.c"
		WormPositions* _tmp4_;
		Position _tmp5_;
#line 1404 "../src/worm.vala"
		_tmp4_ = self->list;
#line 1404 "../src/worm.vala"
		_tmp5_ = self->priv->_starting_position;
#line 1404 "../src/worm.vala"
		worm_positions_append_position (_tmp4_, &_tmp5_);
#line 1406 "../src/worm.vala"
		worm_set_direction (self, self->priv->starting_direction);
#line 1407 "../src/worm.vala"
		worm_spawn (self);
#line 1409 "../src/worm.vala"
		worm_dematerialize (self, 3, 35);
#line 7418 "worm.c"
	}
}

void
worm_position_move (Worm* self,
                    Position* result)
{
	Position position = {0};
	Position _tmp0_ = {0};
	Position _tmp1_;
	Position _tmp2_ = {0};
	Position _tmp3_;
	Position _tmp4_ = {0};
	WormDirection _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
#line 1413 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1415 "../src/worm.vala"
	worm_get_head (self, &_tmp0_);
#line 1415 "../src/worm.vala"
	_tmp1_ = _tmp0_;
#line 1415 "../src/worm.vala"
	worm_get_head (self, &_tmp2_);
#line 1415 "../src/worm.vala"
	_tmp3_ = _tmp2_;
#line 1415 "../src/worm.vala"
	_tmp4_.x = _tmp1_.x;
#line 1415 "../src/worm.vala"
	_tmp4_.y = _tmp3_.y;
#line 1415 "../src/worm.vala"
	position = _tmp4_;
#line 1416 "../src/worm.vala"
	_tmp5_ = self->priv->_direction;
#line 1416 "../src/worm.vala"
	_tmp6_ = self->priv->_width;
#line 1416 "../src/worm.vala"
	_tmp7_ = self->priv->_height;
#line 1416 "../src/worm.vala"
	position_move (&position, _tmp5_, _tmp6_, _tmp7_);
#line 1417 "../src/worm.vala"
	*result = position;
#line 1417 "../src/worm.vala"
	return;
#line 7463 "worm.c"
}

void
worm_get_position_after_direction_move (Worm* self,
                                        Position* origin,
                                        WormDirection direction,
                                        Position* result)
{
	Position position = {0};
	Position _tmp0_;
	Position _tmp1_;
	Position _tmp2_ = {0};
	guint8 _tmp3_;
	guint8 _tmp4_;
#line 1420 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1420 "../src/worm.vala"
	g_return_if_fail (origin != NULL);
#line 1422 "../src/worm.vala"
	_tmp0_ = *origin;
#line 1422 "../src/worm.vala"
	_tmp1_ = *origin;
#line 1422 "../src/worm.vala"
	_tmp2_.x = _tmp0_.x;
#line 1422 "../src/worm.vala"
	_tmp2_.y = _tmp1_.y;
#line 1422 "../src/worm.vala"
	position = _tmp2_;
#line 1423 "../src/worm.vala"
	_tmp3_ = self->priv->_width;
#line 1423 "../src/worm.vala"
	_tmp4_ = self->priv->_height;
#line 1423 "../src/worm.vala"
	position_move (&position, direction, _tmp3_, _tmp4_);
#line 1424 "../src/worm.vala"
	*result = position;
#line 1424 "../src/worm.vala"
	return;
#line 7502 "worm.c"
}

static void
worm_direction_set (Worm* self,
                    WormDirection dir)
{
#line 1427 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1427 "../src/worm.vala"
	_vala_return_if_fail (dir != WORM_DIRECTION_NONE, "dir != WormDirection.NONE");
#line 1430 "../src/worm.vala"
	if (!self->is_human) {
#line 1431 "../src/worm.vala"
		return;
#line 7517 "worm.c"
	}
#line 1433 "../src/worm.vala"
	if (self->keypress) {
#line 1435 "../src/worm.vala"
		worm_queue_keypress (self, dir);
#line 1436 "../src/worm.vala"
		return;
#line 7525 "worm.c"
	}
#line 1439 "../src/worm.vala"
	worm_set_direction (self, dir);
#line 1440 "../src/worm.vala"
	self->keypress = TRUE;
#line 7531 "worm.c"
}

static WormDirection
worm_uturn (Worm* self,
            gint* board,
            gint board_length1,
            gint board_length2,
            GeeLinkedList* worms,
            WormDirection direction)
{
	Position tmp = {0};
	WormDirection dirA = 0;
	WormDirection dirB = 0;
	gint length_posA = 0;
	gint length_posB = 0;
	gboolean _tmp0_ = FALSE;
	WormDirection result;
#line 1449 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1449 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, 0);
#line 1455 "../src/worm.vala"
	length_posA = 0;
#line 1455 "../src/worm.vala"
	length_posB = 0;
#line 1456 "../src/worm.vala"
	if (direction == WORM_DIRECTION_DOWN) {
#line 1456 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 7561 "worm.c"
	} else {
#line 1456 "../src/worm.vala"
		_tmp0_ = direction == WORM_DIRECTION_UP;
#line 7565 "worm.c"
	}
#line 1456 "../src/worm.vala"
	if (_tmp0_) {
#line 7569 "worm.c"
		WormPositions* _tmp1_;
		gpointer _tmp2_;
		WormPositions* _tmp3_;
		gpointer _tmp4_;
		Position _tmp5_ = {0};
		guint8 _tmp6_;
		guint8 _tmp7_;
		WormPositions* _tmp15_;
		gpointer _tmp16_;
		WormPositions* _tmp17_;
		gpointer _tmp18_;
		Position _tmp19_ = {0};
		guint8 _tmp20_;
		guint8 _tmp21_;
#line 1459 "../src/worm.vala"
		_tmp1_ = self->list;
#line 1459 "../src/worm.vala"
		_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp1_, 0);
#line 1459 "../src/worm.vala"
		_tmp3_ = self->list;
#line 1459 "../src/worm.vala"
		_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, 0);
#line 1459 "../src/worm.vala"
		_tmp5_.x = (guint8) (((guint16) ((guintptr) _tmp2_)) >> 8);
#line 1459 "../src/worm.vala"
		_tmp5_.y = (guint8) ((guint16) ((guintptr) _tmp4_));
#line 1459 "../src/worm.vala"
		tmp = _tmp5_;
#line 1460 "../src/worm.vala"
		dirA = WORM_DIRECTION_LEFT;
#line 1461 "../src/worm.vala"
		_tmp6_ = self->priv->_width;
#line 1461 "../src/worm.vala"
		_tmp7_ = self->priv->_height;
#line 1461 "../src/worm.vala"
		position_move (&tmp, dirA, _tmp6_, _tmp7_);
#line 7606 "worm.c"
		{
			gboolean _tmp8_ = FALSE;
#line 1462 "../src/worm.vala"
			length_posA = 0;
#line 1462 "../src/worm.vala"
			_tmp8_ = TRUE;
#line 1462 "../src/worm.vala"
			while (TRUE) {
#line 7615 "worm.c"
				gboolean _tmp12_ = FALSE;
				guint8 _tmp13_;
#line 1462 "../src/worm.vala"
				if (!_tmp8_) {
#line 7620 "worm.c"
					gint _tmp9_;
					guint8 _tmp10_;
					guint8 _tmp11_;
#line 1462 "../src/worm.vala"
					_tmp9_ = length_posA;
#line 1462 "../src/worm.vala"
					length_posA = _tmp9_ + 1;
#line 1462 "../src/worm.vala"
					_tmp10_ = self->priv->_width;
#line 1462 "../src/worm.vala"
					_tmp11_ = self->priv->_height;
#line 1462 "../src/worm.vala"
					position_move (&tmp, direction, _tmp10_, _tmp11_);
#line 7634 "worm.c"
				}
#line 1462 "../src/worm.vala"
				_tmp8_ = FALSE;
#line 1462 "../src/worm.vala"
				_tmp13_ = self->priv->_height;
#line 1462 "../src/worm.vala"
				if (length_posA < ((gint) _tmp13_)) {
#line 7642 "worm.c"
					Position _tmp14_;
#line 1462 "../src/worm.vala"
					_tmp14_ = tmp;
#line 1462 "../src/worm.vala"
					_tmp12_ = worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, worms, &_tmp14_);
#line 7648 "worm.c"
				} else {
#line 1462 "../src/worm.vala"
					_tmp12_ = FALSE;
#line 7652 "worm.c"
				}
#line 1462 "../src/worm.vala"
				if (!_tmp12_) {
#line 1462 "../src/worm.vala"
					break;
#line 7658 "worm.c"
				}
			}
		}
#line 1464 "../src/worm.vala"
		_tmp15_ = self->list;
#line 1464 "../src/worm.vala"
		_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, 0);
#line 1464 "../src/worm.vala"
		_tmp17_ = self->list;
#line 1464 "../src/worm.vala"
		_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, 0);
#line 1464 "../src/worm.vala"
		_tmp19_.x = (guint8) (((guint16) ((guintptr) _tmp16_)) >> 8);
#line 1464 "../src/worm.vala"
		_tmp19_.y = (guint8) ((guint16) ((guintptr) _tmp18_));
#line 1464 "../src/worm.vala"
		tmp = _tmp19_;
#line 1465 "../src/worm.vala"
		dirB = WORM_DIRECTION_RIGHT;
#line 1466 "../src/worm.vala"
		_tmp20_ = self->priv->_width;
#line 1466 "../src/worm.vala"
		_tmp21_ = self->priv->_height;
#line 1466 "../src/worm.vala"
		position_move (&tmp, dirB, _tmp20_, _tmp21_);
#line 7684 "worm.c"
		{
			gboolean _tmp22_ = FALSE;
#line 1467 "../src/worm.vala"
			length_posB = 0;
#line 1467 "../src/worm.vala"
			_tmp22_ = TRUE;
#line 1467 "../src/worm.vala"
			while (TRUE) {
#line 7693 "worm.c"
				gboolean _tmp26_ = FALSE;
				guint8 _tmp27_;
#line 1467 "../src/worm.vala"
				if (!_tmp22_) {
#line 7698 "worm.c"
					gint _tmp23_;
					guint8 _tmp24_;
					guint8 _tmp25_;
#line 1467 "../src/worm.vala"
					_tmp23_ = length_posB;
#line 1467 "../src/worm.vala"
					length_posB = _tmp23_ + 1;
#line 1467 "../src/worm.vala"
					_tmp24_ = self->priv->_width;
#line 1467 "../src/worm.vala"
					_tmp25_ = self->priv->_height;
#line 1467 "../src/worm.vala"
					position_move (&tmp, direction, _tmp24_, _tmp25_);
#line 7712 "worm.c"
				}
#line 1467 "../src/worm.vala"
				_tmp22_ = FALSE;
#line 1467 "../src/worm.vala"
				_tmp27_ = self->priv->_height;
#line 1467 "../src/worm.vala"
				if (length_posB < ((gint) _tmp27_)) {
#line 7720 "worm.c"
					Position _tmp28_;
#line 1467 "../src/worm.vala"
					_tmp28_ = tmp;
#line 1467 "../src/worm.vala"
					_tmp26_ = worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, worms, &_tmp28_);
#line 7726 "worm.c"
				} else {
#line 1467 "../src/worm.vala"
					_tmp26_ = FALSE;
#line 7730 "worm.c"
				}
#line 1467 "../src/worm.vala"
				if (!_tmp26_) {
#line 1467 "../src/worm.vala"
					break;
#line 7736 "worm.c"
				}
			}
		}
	} else {
		WormPositions* _tmp29_;
		gpointer _tmp30_;
		WormPositions* _tmp31_;
		gpointer _tmp32_;
		Position _tmp33_ = {0};
		guint8 _tmp34_;
		guint8 _tmp35_;
		WormPositions* _tmp43_;
		gpointer _tmp44_;
		WormPositions* _tmp45_;
		gpointer _tmp46_;
		Position _tmp47_ = {0};
		guint8 _tmp48_;
		guint8 _tmp49_;
#line 1472 "../src/worm.vala"
		_tmp29_ = self->list;
#line 1472 "../src/worm.vala"
		_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, 0);
#line 1472 "../src/worm.vala"
		_tmp31_ = self->list;
#line 1472 "../src/worm.vala"
		_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, 0);
#line 1472 "../src/worm.vala"
		_tmp33_.x = (guint8) (((guint16) ((guintptr) _tmp30_)) >> 8);
#line 1472 "../src/worm.vala"
		_tmp33_.y = (guint8) ((guint16) ((guintptr) _tmp32_));
#line 1472 "../src/worm.vala"
		tmp = _tmp33_;
#line 1473 "../src/worm.vala"
		dirA = WORM_DIRECTION_UP;
#line 1474 "../src/worm.vala"
		_tmp34_ = self->priv->_width;
#line 1474 "../src/worm.vala"
		_tmp35_ = self->priv->_height;
#line 1474 "../src/worm.vala"
		position_move (&tmp, dirA, _tmp34_, _tmp35_);
#line 7777 "worm.c"
		{
			gboolean _tmp36_ = FALSE;
#line 1475 "../src/worm.vala"
			length_posA = 0;
#line 1475 "../src/worm.vala"
			_tmp36_ = TRUE;
#line 1475 "../src/worm.vala"
			while (TRUE) {
#line 7786 "worm.c"
				gboolean _tmp40_ = FALSE;
				guint8 _tmp41_;
#line 1475 "../src/worm.vala"
				if (!_tmp36_) {
#line 7791 "worm.c"
					gint _tmp37_;
					guint8 _tmp38_;
					guint8 _tmp39_;
#line 1475 "../src/worm.vala"
					_tmp37_ = length_posA;
#line 1475 "../src/worm.vala"
					length_posA = _tmp37_ + 1;
#line 1475 "../src/worm.vala"
					_tmp38_ = self->priv->_width;
#line 1475 "../src/worm.vala"
					_tmp39_ = self->priv->_height;
#line 1475 "../src/worm.vala"
					position_move (&tmp, direction, _tmp38_, _tmp39_);
#line 7805 "worm.c"
				}
#line 1475 "../src/worm.vala"
				_tmp36_ = FALSE;
#line 1475 "../src/worm.vala"
				_tmp41_ = self->priv->_width;
#line 1475 "../src/worm.vala"
				if (length_posA < ((gint) _tmp41_)) {
#line 7813 "worm.c"
					Position _tmp42_;
#line 1475 "../src/worm.vala"
					_tmp42_ = tmp;
#line 1475 "../src/worm.vala"
					_tmp40_ = worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, worms, &_tmp42_);
#line 7819 "worm.c"
				} else {
#line 1475 "../src/worm.vala"
					_tmp40_ = FALSE;
#line 7823 "worm.c"
				}
#line 1475 "../src/worm.vala"
				if (!_tmp40_) {
#line 1475 "../src/worm.vala"
					break;
#line 7829 "worm.c"
				}
			}
		}
#line 1477 "../src/worm.vala"
		_tmp43_ = self->list;
#line 1477 "../src/worm.vala"
		_tmp44_ = gee_abstract_list_get ((GeeAbstractList*) _tmp43_, 0);
#line 1477 "../src/worm.vala"
		_tmp45_ = self->list;
#line 1477 "../src/worm.vala"
		_tmp46_ = gee_abstract_list_get ((GeeAbstractList*) _tmp45_, 0);
#line 1477 "../src/worm.vala"
		_tmp47_.x = (guint8) (((guint16) ((guintptr) _tmp44_)) >> 8);
#line 1477 "../src/worm.vala"
		_tmp47_.y = (guint8) ((guint16) ((guintptr) _tmp46_));
#line 1477 "../src/worm.vala"
		tmp = _tmp47_;
#line 1478 "../src/worm.vala"
		dirB = WORM_DIRECTION_DOWN;
#line 1479 "../src/worm.vala"
		_tmp48_ = self->priv->_width;
#line 1479 "../src/worm.vala"
		_tmp49_ = self->priv->_height;
#line 1479 "../src/worm.vala"
		position_move (&tmp, dirB, _tmp48_, _tmp49_);
#line 7855 "worm.c"
		{
			gboolean _tmp50_ = FALSE;
#line 1480 "../src/worm.vala"
			length_posB = 0;
#line 1480 "../src/worm.vala"
			_tmp50_ = TRUE;
#line 1480 "../src/worm.vala"
			while (TRUE) {
#line 7864 "worm.c"
				gboolean _tmp54_ = FALSE;
				guint8 _tmp55_;
#line 1480 "../src/worm.vala"
				if (!_tmp50_) {
#line 7869 "worm.c"
					gint _tmp51_;
					guint8 _tmp52_;
					guint8 _tmp53_;
#line 1480 "../src/worm.vala"
					_tmp51_ = length_posB;
#line 1480 "../src/worm.vala"
					length_posB = _tmp51_ + 1;
#line 1480 "../src/worm.vala"
					_tmp52_ = self->priv->_width;
#line 1480 "../src/worm.vala"
					_tmp53_ = self->priv->_height;
#line 1480 "../src/worm.vala"
					position_move (&tmp, direction, _tmp52_, _tmp53_);
#line 7883 "worm.c"
				}
#line 1480 "../src/worm.vala"
				_tmp50_ = FALSE;
#line 1480 "../src/worm.vala"
				_tmp55_ = self->priv->_width;
#line 1480 "../src/worm.vala"
				if (length_posB < ((gint) _tmp55_)) {
#line 7891 "worm.c"
					Position _tmp56_;
#line 1480 "../src/worm.vala"
					_tmp56_ = tmp;
#line 1480 "../src/worm.vala"
					_tmp54_ = worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, worms, &_tmp56_);
#line 7897 "worm.c"
				} else {
#line 1480 "../src/worm.vala"
					_tmp54_ = FALSE;
#line 7901 "worm.c"
				}
#line 1480 "../src/worm.vala"
				if (!_tmp54_) {
#line 1480 "../src/worm.vala"
					break;
#line 7907 "worm.c"
				}
			}
		}
	}
#line 1482 "../src/worm.vala"
	if (length_posA > length_posB) {
#line 1484 "../src/worm.vala"
		self->priv->LastUturnA = TRUE;
#line 1485 "../src/worm.vala"
		result = dirA;
#line 1485 "../src/worm.vala"
		return result;
#line 7920 "worm.c"
	} else {
#line 1487 "../src/worm.vala"
		if (length_posA < length_posB) {
#line 1489 "../src/worm.vala"
			self->priv->LastUturnA = FALSE;
#line 1490 "../src/worm.vala"
			result = dirB;
#line 1490 "../src/worm.vala"
			return result;
#line 7930 "worm.c"
		} else {
#line 1492 "../src/worm.vala"
			if (length_posA > 0) {
#line 1494 "../src/worm.vala"
				if (self->priv->LastUturnA) {
#line 1495 "../src/worm.vala"
					result = dirA;
#line 1495 "../src/worm.vala"
					return result;
#line 7940 "worm.c"
				} else {
#line 1497 "../src/worm.vala"
					result = dirB;
#line 1497 "../src/worm.vala"
					return result;
#line 7946 "worm.c"
				}
			} else {
#line 1500 "../src/worm.vala"
				result = direction;
#line 1500 "../src/worm.vala"
				return result;
#line 7953 "worm.c"
			}
		}
	}
}

static gint
worm_get_raw_key (Worm* self,
                  guint keyval)
{
	GdkKeymapKey* keys = NULL;
	gint keys_length1 = 0;
	gint _keys_size_ = 0;
	GdkDisplay* _tmp0_;
	GdkKeymapKey* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
	gint result;
#line 1503 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1506 "../src/worm.vala"
	_tmp0_ = gdk_display_get_default ();
#line 1506 "../src/worm.vala"
	_tmp3_ = gdk_display_map_keyval (_tmp0_, keyval, &_tmp1_, &_tmp2_);
#line 1506 "../src/worm.vala"
	keys = (g_free (keys), NULL);
#line 1506 "../src/worm.vala"
	keys = _tmp1_;
#line 1506 "../src/worm.vala"
	keys_length1 = _tmp2_;
#line 1506 "../src/worm.vala"
	_keys_size_ = keys_length1;
#line 1506 "../src/worm.vala"
	if (_tmp3_) {
#line 7987 "worm.c"
		GdkKeymapKey* _tmp4_;
		gint _tmp4__length1;
#line 1508 "../src/worm.vala"
		_tmp4_ = keys;
#line 1508 "../src/worm.vala"
		_tmp4__length1 = keys_length1;
#line 1508 "../src/worm.vala"
		if (_tmp4__length1 > 0) {
#line 7996 "worm.c"
			GdkKeymapKey* _tmp5_;
			gint _tmp5__length1;
			GdkKeymapKey _tmp6_;
#line 1509 "../src/worm.vala"
			_tmp5_ = keys;
#line 1509 "../src/worm.vala"
			_tmp5__length1 = keys_length1;
#line 1509 "../src/worm.vala"
			_tmp6_ = _tmp5_[0];
#line 1509 "../src/worm.vala"
			result = (gint) _tmp6_.keycode;
#line 1509 "../src/worm.vala"
			keys = (g_free (keys), NULL);
#line 1509 "../src/worm.vala"
			return result;
#line 8012 "worm.c"
		}
	}
#line 1511 "../src/worm.vala"
	result = -1;
#line 1511 "../src/worm.vala"
	keys = (g_free (keys), NULL);
#line 1511 "../src/worm.vala"
	return result;
#line 8021 "worm.c"
}

gboolean
worm_handle_keypress (Worm* self,
                      guint keycode,
                      GeeHashMap* worm_props,
                      gint* board,
                      gint board_length1,
                      gint board_length2,
                      GeeLinkedList* worms)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint8 _tmp2_;
	WormProperties* properties = NULL;
	gpointer _tmp6_;
	WormProperties* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	WormProperties* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	WormProperties* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	WormProperties* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	WormProperties* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	WormProperties* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	WormProperties* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	WormProperties* _tmp50_;
	gint _tmp51_;
	gint _tmp52_;
	gboolean result;
#line 1514 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1514 "../src/worm.vala"
	g_return_val_if_fail (worm_props != NULL, FALSE);
#line 1514 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 1516 "../src/worm.vala"
	_tmp2_ = self->priv->_lives;
#line 1516 "../src/worm.vala"
	if (((gint) _tmp2_) == 0) {
#line 1516 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 8075 "worm.c"
	} else {
#line 1516 "../src/worm.vala"
		_tmp1_ = self->is_stopped;
#line 8079 "worm.c"
	}
#line 1516 "../src/worm.vala"
	if (_tmp1_) {
#line 1516 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 8085 "worm.c"
	} else {
		WormPositions* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 1516 "../src/worm.vala"
		_tmp3_ = self->list;
#line 1516 "../src/worm.vala"
		_tmp4_ = gee_collection_get_is_empty ((GeeCollection*) _tmp3_);
#line 1516 "../src/worm.vala"
		_tmp5_ = _tmp4_;
#line 1516 "../src/worm.vala"
		_tmp0_ = _tmp5_;
#line 8098 "worm.c"
	}
#line 1516 "../src/worm.vala"
	if (_tmp0_) {
#line 1517 "../src/worm.vala"
		result = FALSE;
#line 1517 "../src/worm.vala"
		return result;
#line 8106 "worm.c"
	}
#line 1519 "../src/worm.vala"
	_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) worm_props, self);
#line 1519 "../src/worm.vala"
	properties = (WormProperties*) _tmp6_;
#line 1521 "../src/worm.vala"
	_tmp7_ = properties;
#line 1521 "../src/worm.vala"
	_tmp8_ = worm_properties_get_raw_up (_tmp7_);
#line 1521 "../src/worm.vala"
	_tmp9_ = _tmp8_;
#line 1521 "../src/worm.vala"
	if (_tmp9_ < 0) {
#line 8120 "worm.c"
		WormProperties* _tmp10_;
		WormProperties* _tmp11_;
		guint _tmp12_;
		guint _tmp13_;
#line 1522 "../src/worm.vala"
		_tmp10_ = properties;
#line 1522 "../src/worm.vala"
		_tmp11_ = properties;
#line 1522 "../src/worm.vala"
		_tmp12_ = worm_properties_get_up (_tmp11_);
#line 1522 "../src/worm.vala"
		_tmp13_ = _tmp12_;
#line 1522 "../src/worm.vala"
		worm_properties_set_raw_up (_tmp10_, worm_get_raw_key (self, _tmp13_));
#line 8135 "worm.c"
	}
#line 1523 "../src/worm.vala"
	_tmp14_ = properties;
#line 1523 "../src/worm.vala"
	_tmp15_ = worm_properties_get_raw_up (_tmp14_);
#line 1523 "../src/worm.vala"
	_tmp16_ = _tmp15_;
#line 1523 "../src/worm.vala"
	if (keycode == ((guint) _tmp16_)) {
#line 8145 "worm.c"
		WormDirection _tmp17_;
#line 1525 "../src/worm.vala"
		_tmp17_ = self->priv->_direction;
#line 1525 "../src/worm.vala"
		if (_tmp17_ == WORM_DIRECTION_DOWN) {
#line 8151 "worm.c"
			WormDirection _tmp18_;
#line 1527 "../src/worm.vala"
			worm_direction_set (self, worm_uturn (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_UP));
#line 1528 "../src/worm.vala"
			_tmp18_ = self->priv->_direction;
#line 1528 "../src/worm.vala"
			if (_tmp18_ != WORM_DIRECTION_UP) {
#line 1529 "../src/worm.vala"
				worm_queue_keypress (self, WORM_DIRECTION_UP);
#line 8161 "worm.c"
			}
#line 1530 "../src/worm.vala"
			result = TRUE;
#line 1530 "../src/worm.vala"
			_g_object_unref0 (properties);
#line 1530 "../src/worm.vala"
			return result;
#line 8169 "worm.c"
		} else {
#line 1532 "../src/worm.vala"
			if (worm_can_move_direction (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_UP)) {
#line 1534 "../src/worm.vala"
				worm_direction_set (self, WORM_DIRECTION_UP);
#line 1535 "../src/worm.vala"
				result = TRUE;
#line 1535 "../src/worm.vala"
				_g_object_unref0 (properties);
#line 1535 "../src/worm.vala"
				return result;
#line 8181 "worm.c"
			}
		}
	}
#line 1538 "../src/worm.vala"
	_tmp19_ = properties;
#line 1538 "../src/worm.vala"
	_tmp20_ = worm_properties_get_raw_down (_tmp19_);
#line 1538 "../src/worm.vala"
	_tmp21_ = _tmp20_;
#line 1538 "../src/worm.vala"
	if (_tmp21_ < 0) {
#line 8193 "worm.c"
		WormProperties* _tmp22_;
		WormProperties* _tmp23_;
		guint _tmp24_;
		guint _tmp25_;
#line 1539 "../src/worm.vala"
		_tmp22_ = properties;
#line 1539 "../src/worm.vala"
		_tmp23_ = properties;
#line 1539 "../src/worm.vala"
		_tmp24_ = worm_properties_get_down (_tmp23_);
#line 1539 "../src/worm.vala"
		_tmp25_ = _tmp24_;
#line 1539 "../src/worm.vala"
		worm_properties_set_raw_down (_tmp22_, worm_get_raw_key (self, _tmp25_));
#line 8208 "worm.c"
	}
#line 1540 "../src/worm.vala"
	_tmp26_ = properties;
#line 1540 "../src/worm.vala"
	_tmp27_ = worm_properties_get_raw_down (_tmp26_);
#line 1540 "../src/worm.vala"
	_tmp28_ = _tmp27_;
#line 1540 "../src/worm.vala"
	if (keycode == ((guint) _tmp28_)) {
#line 8218 "worm.c"
		WormDirection _tmp29_;
#line 1542 "../src/worm.vala"
		_tmp29_ = self->priv->_direction;
#line 1542 "../src/worm.vala"
		if (_tmp29_ == WORM_DIRECTION_UP) {
#line 8224 "worm.c"
			WormDirection _tmp30_;
#line 1544 "../src/worm.vala"
			worm_direction_set (self, worm_uturn (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_DOWN));
#line 1545 "../src/worm.vala"
			_tmp30_ = self->priv->_direction;
#line 1545 "../src/worm.vala"
			if (_tmp30_ != WORM_DIRECTION_DOWN) {
#line 1546 "../src/worm.vala"
				worm_queue_keypress (self, WORM_DIRECTION_DOWN);
#line 8234 "worm.c"
			}
#line 1547 "../src/worm.vala"
			result = TRUE;
#line 1547 "../src/worm.vala"
			_g_object_unref0 (properties);
#line 1547 "../src/worm.vala"
			return result;
#line 8242 "worm.c"
		} else {
#line 1549 "../src/worm.vala"
			if (worm_can_move_direction (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_DOWN)) {
#line 1551 "../src/worm.vala"
				worm_direction_set (self, WORM_DIRECTION_DOWN);
#line 1552 "../src/worm.vala"
				result = TRUE;
#line 1552 "../src/worm.vala"
				_g_object_unref0 (properties);
#line 1552 "../src/worm.vala"
				return result;
#line 8254 "worm.c"
			}
		}
	}
#line 1555 "../src/worm.vala"
	_tmp31_ = properties;
#line 1555 "../src/worm.vala"
	_tmp32_ = worm_properties_get_raw_right (_tmp31_);
#line 1555 "../src/worm.vala"
	_tmp33_ = _tmp32_;
#line 1555 "../src/worm.vala"
	if (_tmp33_ < 0) {
#line 8266 "worm.c"
		WormProperties* _tmp34_;
		WormProperties* _tmp35_;
		guint _tmp36_;
		guint _tmp37_;
#line 1556 "../src/worm.vala"
		_tmp34_ = properties;
#line 1556 "../src/worm.vala"
		_tmp35_ = properties;
#line 1556 "../src/worm.vala"
		_tmp36_ = worm_properties_get_right (_tmp35_);
#line 1556 "../src/worm.vala"
		_tmp37_ = _tmp36_;
#line 1556 "../src/worm.vala"
		worm_properties_set_raw_right (_tmp34_, worm_get_raw_key (self, _tmp37_));
#line 8281 "worm.c"
	}
#line 1557 "../src/worm.vala"
	_tmp38_ = properties;
#line 1557 "../src/worm.vala"
	_tmp39_ = worm_properties_get_raw_right (_tmp38_);
#line 1557 "../src/worm.vala"
	_tmp40_ = _tmp39_;
#line 1557 "../src/worm.vala"
	if (keycode == ((guint) _tmp40_)) {
#line 8291 "worm.c"
		WormDirection _tmp41_;
#line 1559 "../src/worm.vala"
		_tmp41_ = self->priv->_direction;
#line 1559 "../src/worm.vala"
		if (_tmp41_ == WORM_DIRECTION_LEFT) {
#line 8297 "worm.c"
			WormDirection _tmp42_;
#line 1561 "../src/worm.vala"
			worm_direction_set (self, worm_uturn (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_RIGHT));
#line 1562 "../src/worm.vala"
			_tmp42_ = self->priv->_direction;
#line 1562 "../src/worm.vala"
			if (_tmp42_ != WORM_DIRECTION_RIGHT) {
#line 1563 "../src/worm.vala"
				worm_queue_keypress (self, WORM_DIRECTION_RIGHT);
#line 8307 "worm.c"
			}
#line 1564 "../src/worm.vala"
			result = TRUE;
#line 1564 "../src/worm.vala"
			_g_object_unref0 (properties);
#line 1564 "../src/worm.vala"
			return result;
#line 8315 "worm.c"
		} else {
#line 1566 "../src/worm.vala"
			if (worm_can_move_direction (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_RIGHT)) {
#line 1568 "../src/worm.vala"
				worm_direction_set (self, WORM_DIRECTION_RIGHT);
#line 1569 "../src/worm.vala"
				result = TRUE;
#line 1569 "../src/worm.vala"
				_g_object_unref0 (properties);
#line 1569 "../src/worm.vala"
				return result;
#line 8327 "worm.c"
			}
		}
	}
#line 1572 "../src/worm.vala"
	_tmp43_ = properties;
#line 1572 "../src/worm.vala"
	_tmp44_ = worm_properties_get_raw_left (_tmp43_);
#line 1572 "../src/worm.vala"
	_tmp45_ = _tmp44_;
#line 1572 "../src/worm.vala"
	if (_tmp45_ < 0) {
#line 8339 "worm.c"
		WormProperties* _tmp46_;
		WormProperties* _tmp47_;
		guint _tmp48_;
		guint _tmp49_;
#line 1573 "../src/worm.vala"
		_tmp46_ = properties;
#line 1573 "../src/worm.vala"
		_tmp47_ = properties;
#line 1573 "../src/worm.vala"
		_tmp48_ = worm_properties_get_left (_tmp47_);
#line 1573 "../src/worm.vala"
		_tmp49_ = _tmp48_;
#line 1573 "../src/worm.vala"
		worm_properties_set_raw_left (_tmp46_, worm_get_raw_key (self, _tmp49_));
#line 8354 "worm.c"
	}
#line 1574 "../src/worm.vala"
	_tmp50_ = properties;
#line 1574 "../src/worm.vala"
	_tmp51_ = worm_properties_get_raw_left (_tmp50_);
#line 1574 "../src/worm.vala"
	_tmp52_ = _tmp51_;
#line 1574 "../src/worm.vala"
	if (keycode == ((guint) _tmp52_)) {
#line 8364 "worm.c"
		WormDirection _tmp53_;
#line 1576 "../src/worm.vala"
		_tmp53_ = self->priv->_direction;
#line 1576 "../src/worm.vala"
		if (_tmp53_ == WORM_DIRECTION_RIGHT) {
#line 8370 "worm.c"
			WormDirection _tmp54_;
#line 1578 "../src/worm.vala"
			worm_direction_set (self, worm_uturn (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_LEFT));
#line 1579 "../src/worm.vala"
			_tmp54_ = self->priv->_direction;
#line 1579 "../src/worm.vala"
			if (_tmp54_ != WORM_DIRECTION_LEFT) {
#line 1580 "../src/worm.vala"
				worm_queue_keypress (self, WORM_DIRECTION_LEFT);
#line 8380 "worm.c"
			}
#line 1581 "../src/worm.vala"
			result = TRUE;
#line 1581 "../src/worm.vala"
			_g_object_unref0 (properties);
#line 1581 "../src/worm.vala"
			return result;
#line 8388 "worm.c"
		} else {
#line 1583 "../src/worm.vala"
			if (worm_can_move_direction (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_LEFT)) {
#line 1585 "../src/worm.vala"
				worm_direction_set (self, WORM_DIRECTION_LEFT);
#line 1586 "../src/worm.vala"
				result = TRUE;
#line 1586 "../src/worm.vala"
				_g_object_unref0 (properties);
#line 1586 "../src/worm.vala"
				return result;
#line 8400 "worm.c"
			}
		}
	}
#line 1590 "../src/worm.vala"
	result = FALSE;
#line 1590 "../src/worm.vala"
	_g_object_unref0 (properties);
#line 1590 "../src/worm.vala"
	return result;
#line 8410 "worm.c"
}

static void
worm_queue_keypress (Worm* self,
                     WormDirection dir)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayQueue* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GeeArrayQueue* _tmp6_;
#line 1593 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1598 "../src/worm.vala"
	_tmp1_ = self->priv->key_queue;
#line 1598 "../src/worm.vala"
	_tmp2_ = gee_array_queue_get_is_empty (_tmp1_);
#line 1598 "../src/worm.vala"
	_tmp3_ = _tmp2_;
#line 1598 "../src/worm.vala"
	if (!_tmp3_) {
#line 8432 "worm.c"
		GeeArrayQueue* _tmp4_;
		gpointer _tmp5_;
#line 1598 "../src/worm.vala"
		_tmp4_ = self->priv->key_queue;
#line 1598 "../src/worm.vala"
		_tmp5_ = gee_abstract_queue_peek ((GeeAbstractQueue*) _tmp4_);
#line 1598 "../src/worm.vala"
		_tmp0_ = dir == ((WormDirection) ((gintptr) _tmp5_));
#line 8441 "worm.c"
	} else {
#line 1598 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 8445 "worm.c"
	}
#line 1598 "../src/worm.vala"
	if (_tmp0_) {
#line 1599 "../src/worm.vala"
		return;
#line 8451 "worm.c"
	}
#line 1601 "../src/worm.vala"
	_tmp6_ = self->priv->key_queue;
#line 1601 "../src/worm.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, (gpointer) ((gintptr) dir));
#line 8457 "worm.c"
}

static void
worm_dequeue_keypress (Worm* self)
{
	GeeArrayQueue* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeArrayQueue* _tmp3_;
	gpointer _tmp4_;
#line 1604 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1604 "../src/worm.vala"
	_tmp0_ = self->priv->key_queue;
#line 1604 "../src/worm.vala"
	_tmp1_ = gee_array_queue_get_is_empty (_tmp0_);
#line 1604 "../src/worm.vala"
	_tmp2_ = _tmp1_;
#line 1604 "../src/worm.vala"
	_vala_return_if_fail (!_tmp2_, "!key_queue.is_empty");
#line 1607 "../src/worm.vala"
	_tmp3_ = self->priv->key_queue;
#line 1607 "../src/worm.vala"
	_tmp4_ = gee_abstract_queue_poll ((GeeAbstractQueue*) _tmp3_);
#line 1607 "../src/worm.vala"
	worm_direction_set (self, (WormDirection) ((gintptr) _tmp4_));
#line 8484 "worm.c"
}

static void
_vala_array_add6 (Position* * array,
                  gint* length,
                  gint* size,
                  const Position* value)
{
#line 1642 "../src/worm.vala"
	if ((*length) == (*size)) {
#line 1642 "../src/worm.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1642 "../src/worm.vala"
		*array = g_renew (Position, *array, *size);
#line 8499 "worm.c"
	}
#line 1642 "../src/worm.vala"
	(*array)[(*length)++] = *value;
#line 8503 "worm.c"
}

static gint
worm_ai_deadend (gint* board,
                 gint board_length1,
                 gint board_length2,
                 WormMap* worm_map,
                 Position* position,
                 gint length)
{
	Position* p = NULL;
	Position _tmp0_;
	Position* _tmp1_;
	gint p_length1;
	gint _p_size_;
	gint _tmp27_ = 0;
	Position* _tmp28_;
	gint _tmp28__length1;
	gint result;
#line 1628 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, 0);
#line 1628 "../src/worm.vala"
	g_return_val_if_fail (position != NULL, 0);
#line 1630 "../src/worm.vala"
	_tmp0_ = *position;
#line 1630 "../src/worm.vala"
	_tmp1_ = g_new0 (Position, 1);
#line 1630 "../src/worm.vala"
	_tmp1_[0] = _tmp0_;
#line 1630 "../src/worm.vala"
	p = _tmp1_;
#line 1630 "../src/worm.vala"
	p_length1 = 1;
#line 1630 "../src/worm.vala"
	_p_size_ = p_length1;
#line 8539 "worm.c"
	{
		guint i = 0U;
#line 1631 "../src/worm.vala"
		i = (guint) 0;
#line 8544 "worm.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1631 "../src/worm.vala"
			_tmp2_ = TRUE;
#line 1631 "../src/worm.vala"
			while (TRUE) {
#line 8551 "worm.c"
				gboolean _tmp4_ = FALSE;
				Position* _tmp5_;
				gint _tmp5__length1;
#line 1631 "../src/worm.vala"
				if (!_tmp2_) {
#line 8557 "worm.c"
					guint _tmp3_;
#line 1631 "../src/worm.vala"
					_tmp3_ = i;
#line 1631 "../src/worm.vala"
					i = _tmp3_ + 1;
#line 8563 "worm.c"
				}
#line 1631 "../src/worm.vala"
				_tmp2_ = FALSE;
#line 1631 "../src/worm.vala"
				_tmp5_ = p;
#line 1631 "../src/worm.vala"
				_tmp5__length1 = p_length1;
#line 1631 "../src/worm.vala"
				if (((guint) _tmp5__length1) > i) {
#line 8573 "worm.c"
					Position* _tmp6_;
					gint _tmp6__length1;
#line 1631 "../src/worm.vala"
					_tmp6_ = p;
#line 1631 "../src/worm.vala"
					_tmp6__length1 = p_length1;
#line 1631 "../src/worm.vala"
					_tmp4_ = (_tmp6__length1 - 1) < length;
#line 8582 "worm.c"
				} else {
#line 1631 "../src/worm.vala"
					_tmp4_ = FALSE;
#line 8586 "worm.c"
				}
#line 1631 "../src/worm.vala"
				if (!_tmp4_) {
#line 1631 "../src/worm.vala"
					break;
#line 8592 "worm.c"
				}
				{
					guint dir = 0U;
#line 1633 "../src/worm.vala"
					dir = (guint) 4;
#line 8598 "worm.c"
					{
						gboolean _tmp7_ = FALSE;
#line 1633 "../src/worm.vala"
						_tmp7_ = TRUE;
#line 1633 "../src/worm.vala"
						while (TRUE) {
#line 8605 "worm.c"
							gboolean _tmp9_ = FALSE;
							Position new_position = {0};
							Position* _tmp11_;
							gint _tmp11__length1;
							Position _tmp12_;
							gint _tmp13_;
							gint _tmp14_;
							gboolean _tmp15_ = FALSE;
							gboolean _tmp16_ = FALSE;
							guint* _tmp17_;
							gint _tmp17__length1;
							gint _tmp17__length2;
							Position _tmp18_;
							Position _tmp19_;
							guint _tmp20_;
#line 1633 "../src/worm.vala"
							if (!_tmp7_) {
#line 8623 "worm.c"
								guint _tmp8_;
#line 1633 "../src/worm.vala"
								_tmp8_ = dir;
#line 1633 "../src/worm.vala"
								dir = _tmp8_ - 1;
#line 8629 "worm.c"
							}
#line 1633 "../src/worm.vala"
							_tmp7_ = FALSE;
#line 1633 "../src/worm.vala"
							if (dir > ((guint) 0)) {
#line 8635 "worm.c"
								Position* _tmp10_;
								gint _tmp10__length1;
#line 1633 "../src/worm.vala"
								_tmp10_ = p;
#line 1633 "../src/worm.vala"
								_tmp10__length1 = p_length1;
#line 1633 "../src/worm.vala"
								_tmp9_ = (_tmp10__length1 - 1) < length;
#line 8644 "worm.c"
							} else {
#line 1633 "../src/worm.vala"
								_tmp9_ = FALSE;
#line 8648 "worm.c"
							}
#line 1633 "../src/worm.vala"
							if (!_tmp9_) {
#line 1633 "../src/worm.vala"
								break;
#line 8654 "worm.c"
							}
#line 1635 "../src/worm.vala"
							_tmp11_ = p;
#line 1635 "../src/worm.vala"
							_tmp11__length1 = p_length1;
#line 1635 "../src/worm.vala"
							_tmp12_ = _tmp11_[i];
#line 1635 "../src/worm.vala"
							new_position = _tmp12_;
#line 1636 "../src/worm.vala"
							_tmp13_ = board_length1;
#line 1636 "../src/worm.vala"
							_tmp14_ = board_length2;
#line 1636 "../src/worm.vala"
							position_move (&new_position, (WormDirection) dir, (guint8) _tmp13_, (guint8) _tmp14_);
#line 1637 "../src/worm.vala"
							_tmp17_ = worm_deadend_board;
#line 1637 "../src/worm.vala"
							_tmp17__length1 = worm_deadend_board_length1;
#line 1637 "../src/worm.vala"
							_tmp17__length2 = worm_deadend_board_length2;
#line 1637 "../src/worm.vala"
							_tmp18_ = new_position;
#line 1637 "../src/worm.vala"
							_tmp19_ = new_position;
#line 1637 "../src/worm.vala"
							_tmp20_ = _tmp17_[(_tmp18_.x * _tmp17__length2) + _tmp19_.y];
#line 1637 "../src/worm.vala"
							if (_tmp20_ != worm_deadend_runnumber) {
#line 8684 "worm.c"
								Position _tmp21_;
#line 1638 "../src/worm.vala"
								_tmp21_ = new_position;
#line 1638 "../src/worm.vala"
								_tmp16_ = !worm_is_board_position_occupied (&_tmp21_, board, (gint) board_length1, (gint) board_length2);
#line 8690 "worm.c"
							} else {
#line 1637 "../src/worm.vala"
								_tmp16_ = FALSE;
#line 8694 "worm.c"
							}
#line 1637 "../src/worm.vala"
							if (_tmp16_) {
#line 8698 "worm.c"
								Position _tmp22_;
#line 1639 "../src/worm.vala"
								_tmp22_ = new_position;
#line 1639 "../src/worm.vala"
								_tmp15_ = !worm_map_contain_position (worm_map, &_tmp22_);
#line 8704 "worm.c"
							} else {
#line 1637 "../src/worm.vala"
								_tmp15_ = FALSE;
#line 8708 "worm.c"
							}
#line 1637 "../src/worm.vala"
							if (_tmp15_) {
#line 8712 "worm.c"
								guint* _tmp23_;
								gint _tmp23__length1;
								gint _tmp23__length2;
								Position _tmp24_;
								Position _tmp25_;
								Position _tmp26_;
#line 1641 "../src/worm.vala"
								_tmp23_ = worm_deadend_board;
#line 1641 "../src/worm.vala"
								_tmp23__length1 = worm_deadend_board_length1;
#line 1641 "../src/worm.vala"
								_tmp23__length2 = worm_deadend_board_length2;
#line 1641 "../src/worm.vala"
								_tmp24_ = new_position;
#line 1641 "../src/worm.vala"
								_tmp25_ = new_position;
#line 1641 "../src/worm.vala"
								_tmp23_[(_tmp24_.x * _tmp23__length2) + _tmp25_.y] = worm_deadend_runnumber;
#line 1642 "../src/worm.vala"
								_tmp26_ = new_position;
#line 1642 "../src/worm.vala"
								_vala_array_add6 (&p, &p_length1, &_p_size_, &_tmp26_);
#line 8735 "worm.c"
							}
						}
					}
				}
			}
		}
	}
#line 1646 "../src/worm.vala"
	_tmp28_ = p;
#line 1646 "../src/worm.vala"
	_tmp28__length1 = p_length1;
#line 1646 "../src/worm.vala"
	if ((_tmp28__length1 - 1) > length) {
#line 1646 "../src/worm.vala"
		_tmp27_ = 0;
#line 8751 "worm.c"
	} else {
		Position* _tmp29_;
		gint _tmp29__length1;
#line 1646 "../src/worm.vala"
		_tmp29_ = p;
#line 1646 "../src/worm.vala"
		_tmp29__length1 = p_length1;
#line 1646 "../src/worm.vala"
		_tmp27_ = length - (_tmp29__length1 - 1);
#line 8761 "worm.c"
	}
#line 1646 "../src/worm.vala"
	result = _tmp27_;
#line 1646 "../src/worm.vala"
	p = (g_free (p), NULL);
#line 1646 "../src/worm.vala"
	return result;
#line 8769 "worm.c"
}

static gint
worm_ai_deadend_after (gint* board,
                       gint board_length1,
                       gint board_length2,
                       GeeLinkedList* worms,
                       WormMap* worm_map,
                       Position* old_position,
                       WormDirection direction,
                       gint length)
{
	guint8 width = 0U;
	gint _tmp0_;
	guint8 height = 0U;
	gint _tmp1_;
	guint _tmp2_;
	Position new_position = {0};
	Position _tmp47_;
	guint* _tmp48_;
	gint _tmp48__length1;
	gint _tmp48__length2;
	Position _tmp49_;
	Position _tmp50_;
	guint* _tmp51_;
	gint _tmp51__length1;
	gint _tmp51__length2;
	Position _tmp52_;
	Position _tmp53_;
	gint cl = 0;
	Position _tmp54_;
	gint result;
#line 1658 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, 0);
#line 1658 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, 0);
#line 1658 "../src/worm.vala"
	g_return_val_if_fail (old_position != NULL, 0);
#line 1660 "../src/worm.vala"
	_tmp0_ = board_length1;
#line 1660 "../src/worm.vala"
	width = (guint8) _tmp0_;
#line 1661 "../src/worm.vala"
	_tmp1_ = board_length2;
#line 1661 "../src/worm.vala"
	height = (guint8) _tmp1_;
#line 1663 "../src/worm.vala"
	worm_deadend_runnumber = worm_deadend_runnumber + 1;
#line 1663 "../src/worm.vala"
	_tmp2_ = worm_deadend_runnumber;
#line 1663 "../src/worm.vala"
	if (_tmp2_ == ((guint) 0)) {
#line 8822 "worm.c"
		guint _tmp12_;
		{
			gint x = 0;
#line 1665 "../src/worm.vala"
			x = 0;
#line 8828 "worm.c"
			{
				gboolean _tmp3_ = FALSE;
#line 1665 "../src/worm.vala"
				_tmp3_ = TRUE;
#line 1665 "../src/worm.vala"
				while (TRUE) {
#line 8835 "worm.c"
					guint* _tmp5_;
					gint _tmp5__length1;
					gint _tmp5__length2;
					gint _tmp6_;
#line 1665 "../src/worm.vala"
					if (!_tmp3_) {
#line 8842 "worm.c"
						gint _tmp4_;
#line 1665 "../src/worm.vala"
						_tmp4_ = x;
#line 1665 "../src/worm.vala"
						x = _tmp4_ + 1;
#line 8848 "worm.c"
					}
#line 1665 "../src/worm.vala"
					_tmp3_ = FALSE;
#line 1665 "../src/worm.vala"
					_tmp5_ = worm_deadend_board;
#line 1665 "../src/worm.vala"
					_tmp5__length1 = worm_deadend_board_length1;
#line 1665 "../src/worm.vala"
					_tmp5__length2 = worm_deadend_board_length2;
#line 1665 "../src/worm.vala"
					_tmp6_ = _tmp5__length1;
#line 1665 "../src/worm.vala"
					if (!(x < _tmp6_)) {
#line 1665 "../src/worm.vala"
						break;
#line 8864 "worm.c"
					}
					{
						gint y = 0;
#line 1666 "../src/worm.vala"
						y = 0;
#line 8870 "worm.c"
						{
							gboolean _tmp7_ = FALSE;
#line 1666 "../src/worm.vala"
							_tmp7_ = TRUE;
#line 1666 "../src/worm.vala"
							while (TRUE) {
#line 8877 "worm.c"
								guint* _tmp9_;
								gint _tmp9__length1;
								gint _tmp9__length2;
								gint _tmp10_;
								guint* _tmp11_;
								gint _tmp11__length1;
								gint _tmp11__length2;
#line 1666 "../src/worm.vala"
								if (!_tmp7_) {
#line 8887 "worm.c"
									gint _tmp8_;
#line 1666 "../src/worm.vala"
									_tmp8_ = y;
#line 1666 "../src/worm.vala"
									y = _tmp8_ + 1;
#line 8893 "worm.c"
								}
#line 1666 "../src/worm.vala"
								_tmp7_ = FALSE;
#line 1666 "../src/worm.vala"
								_tmp9_ = worm_deadend_board;
#line 1666 "../src/worm.vala"
								_tmp9__length1 = worm_deadend_board_length1;
#line 1666 "../src/worm.vala"
								_tmp9__length2 = worm_deadend_board_length2;
#line 1666 "../src/worm.vala"
								_tmp10_ = _tmp9__length2;
#line 1666 "../src/worm.vala"
								if (!(y < _tmp10_)) {
#line 1666 "../src/worm.vala"
									break;
#line 8909 "worm.c"
								}
#line 1667 "../src/worm.vala"
								_tmp11_ = worm_deadend_board;
#line 1667 "../src/worm.vala"
								_tmp11__length1 = worm_deadend_board_length1;
#line 1667 "../src/worm.vala"
								_tmp11__length2 = worm_deadend_board_length2;
#line 1667 "../src/worm.vala"
								_tmp11_[(x * _tmp11__length2) + y] = worm_deadend_runnumber;
#line 8919 "worm.c"
							}
						}
					}
				}
			}
		}
#line 1668 "../src/worm.vala"
		_tmp12_ = worm_deadend_runnumber;
#line 1668 "../src/worm.vala"
		worm_deadend_runnumber = _tmp12_ + 1;
#line 8930 "worm.c"
	}
	{
		gint i = 0;
		gint _tmp13_;
		gint _tmp14_;
#line 1671 "../src/worm.vala"
		_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) worms);
#line 1671 "../src/worm.vala"
		_tmp14_ = _tmp13_;
#line 1671 "../src/worm.vala"
		i = _tmp14_ - 1;
#line 8942 "worm.c"
		{
			gboolean _tmp15_ = FALSE;
#line 1671 "../src/worm.vala"
			_tmp15_ = TRUE;
#line 1671 "../src/worm.vala"
			while (TRUE) {
#line 8949 "worm.c"
				gboolean _tmp17_ = FALSE;
				gpointer _tmp18_;
				Worm* _tmp19_;
				gboolean _tmp20_;
#line 1671 "../src/worm.vala"
				if (!_tmp15_) {
#line 8956 "worm.c"
					gint _tmp16_;
#line 1671 "../src/worm.vala"
					_tmp16_ = i;
#line 1671 "../src/worm.vala"
					i = _tmp16_ - 1;
#line 8962 "worm.c"
				}
#line 1671 "../src/worm.vala"
				_tmp15_ = FALSE;
#line 1671 "../src/worm.vala"
				if (!(i >= 0)) {
#line 1671 "../src/worm.vala"
					break;
#line 8970 "worm.c"
				}
#line 1673 "../src/worm.vala"
				_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
#line 1673 "../src/worm.vala"
				_tmp19_ = (Worm*) _tmp18_;
#line 1673 "../src/worm.vala"
				_tmp20_ = !_tmp19_->is_stopped;
#line 1673 "../src/worm.vala"
				_g_object_unref0 (_tmp19_);
#line 1673 "../src/worm.vala"
				if (_tmp20_) {
#line 8982 "worm.c"
					gpointer _tmp21_;
					Worm* _tmp22_;
					WormPositions* _tmp23_;
					gboolean _tmp24_;
					gboolean _tmp25_;
#line 1673 "../src/worm.vala"
					_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
#line 1673 "../src/worm.vala"
					_tmp22_ = (Worm*) _tmp21_;
#line 1673 "../src/worm.vala"
					_tmp23_ = _tmp22_->list;
#line 1673 "../src/worm.vala"
					_tmp24_ = gee_collection_get_is_empty ((GeeCollection*) _tmp23_);
#line 1673 "../src/worm.vala"
					_tmp25_ = _tmp24_;
#line 1673 "../src/worm.vala"
					_tmp17_ = !_tmp25_;
#line 1673 "../src/worm.vala"
					_g_object_unref0 (_tmp22_);
#line 9002 "worm.c"
				} else {
#line 1673 "../src/worm.vala"
					_tmp17_ = FALSE;
#line 9006 "worm.c"
				}
#line 1673 "../src/worm.vala"
				if (_tmp17_) {
#line 9010 "worm.c"
					guint8 target_x = 0U;
					gpointer _tmp26_;
					Worm* _tmp27_;
					Position _tmp28_ = {0};
					Position _tmp29_;
					guint8 _tmp30_;
					guint8 target_y = 0U;
					gpointer _tmp31_;
					Worm* _tmp32_;
					Position _tmp33_ = {0};
					Position _tmp34_;
					guint8 _tmp35_;
					gboolean _tmp36_ = FALSE;
					Position _tmp37_;
#line 1675 "../src/worm.vala"
					_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
#line 1675 "../src/worm.vala"
					_tmp27_ = (Worm*) _tmp26_;
#line 1675 "../src/worm.vala"
					worm_get_head (_tmp27_, &_tmp28_);
#line 1675 "../src/worm.vala"
					_tmp29_ = _tmp28_;
#line 1675 "../src/worm.vala"
					_tmp30_ = _tmp29_.x;
#line 1675 "../src/worm.vala"
					_g_object_unref0 (_tmp27_);
#line 1675 "../src/worm.vala"
					target_x = _tmp30_;
#line 1676 "../src/worm.vala"
					_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
#line 1676 "../src/worm.vala"
					_tmp32_ = (Worm*) _tmp31_;
#line 1676 "../src/worm.vala"
					worm_get_head (_tmp32_, &_tmp33_);
#line 1676 "../src/worm.vala"
					_tmp34_ = _tmp33_;
#line 1676 "../src/worm.vala"
					_tmp35_ = _tmp34_.y;
#line 1676 "../src/worm.vala"
					_g_object_unref0 (_tmp32_);
#line 1676 "../src/worm.vala"
					target_y = _tmp35_;
#line 1677 "../src/worm.vala"
					_tmp37_ = *old_position;
#line 1677 "../src/worm.vala"
					if (target_x == _tmp37_.x) {
#line 9057 "worm.c"
						Position _tmp38_;
#line 1678 "../src/worm.vala"
						_tmp38_ = *old_position;
#line 1678 "../src/worm.vala"
						_tmp36_ = target_y == _tmp38_.y;
#line 9063 "worm.c"
					} else {
#line 1677 "../src/worm.vala"
						_tmp36_ = FALSE;
#line 9067 "worm.c"
					}
#line 1677 "../src/worm.vala"
					if (_tmp36_) {
#line 1679 "../src/worm.vala"
						continue;
#line 9073 "worm.c"
					}
#line 1681 "../src/worm.vala"
					if (((gint) target_x) > 0) {
#line 9077 "worm.c"
						guint* _tmp39_;
						gint _tmp39__length1;
						gint _tmp39__length2;
#line 1681 "../src/worm.vala"
						_tmp39_ = worm_deadend_board;
#line 1681 "../src/worm.vala"
						_tmp39__length1 = worm_deadend_board_length1;
#line 1681 "../src/worm.vala"
						_tmp39__length2 = worm_deadend_board_length2;
#line 1681 "../src/worm.vala"
						_tmp39_[((target_x - 1) * _tmp39__length2) + target_y] = worm_deadend_runnumber;
#line 9089 "worm.c"
					} else {
						guint* _tmp40_;
						gint _tmp40__length1;
						gint _tmp40__length2;
#line 1682 "../src/worm.vala"
						_tmp40_ = worm_deadend_board;
#line 1682 "../src/worm.vala"
						_tmp40__length1 = worm_deadend_board_length1;
#line 1682 "../src/worm.vala"
						_tmp40__length2 = worm_deadend_board_length2;
#line 1682 "../src/worm.vala"
						_tmp40_[((width - 1) * _tmp40__length2) + target_y] = worm_deadend_runnumber;
#line 9102 "worm.c"
					}
#line 1683 "../src/worm.vala"
					if (((gint) target_y) > 0) {
#line 9106 "worm.c"
						guint* _tmp41_;
						gint _tmp41__length1;
						gint _tmp41__length2;
#line 1683 "../src/worm.vala"
						_tmp41_ = worm_deadend_board;
#line 1683 "../src/worm.vala"
						_tmp41__length1 = worm_deadend_board_length1;
#line 1683 "../src/worm.vala"
						_tmp41__length2 = worm_deadend_board_length2;
#line 1683 "../src/worm.vala"
						_tmp41_[(target_x * _tmp41__length2) + (target_y - 1)] = worm_deadend_runnumber;
#line 9118 "worm.c"
					} else {
						guint* _tmp42_;
						gint _tmp42__length1;
						gint _tmp42__length2;
#line 1684 "../src/worm.vala"
						_tmp42_ = worm_deadend_board;
#line 1684 "../src/worm.vala"
						_tmp42__length1 = worm_deadend_board_length1;
#line 1684 "../src/worm.vala"
						_tmp42__length2 = worm_deadend_board_length2;
#line 1684 "../src/worm.vala"
						_tmp42_[(target_x * _tmp42__length2) + (height - 1)] = worm_deadend_runnumber;
#line 9131 "worm.c"
					}
#line 1685 "../src/worm.vala"
					if (((gint) target_x) < (width - 1)) {
#line 9135 "worm.c"
						guint* _tmp43_;
						gint _tmp43__length1;
						gint _tmp43__length2;
#line 1685 "../src/worm.vala"
						_tmp43_ = worm_deadend_board;
#line 1685 "../src/worm.vala"
						_tmp43__length1 = worm_deadend_board_length1;
#line 1685 "../src/worm.vala"
						_tmp43__length2 = worm_deadend_board_length2;
#line 1685 "../src/worm.vala"
						_tmp43_[((target_x + 1) * _tmp43__length2) + target_y] = worm_deadend_runnumber;
#line 9147 "worm.c"
					} else {
						guint* _tmp44_;
						gint _tmp44__length1;
						gint _tmp44__length2;
#line 1686 "../src/worm.vala"
						_tmp44_ = worm_deadend_board;
#line 1686 "../src/worm.vala"
						_tmp44__length1 = worm_deadend_board_length1;
#line 1686 "../src/worm.vala"
						_tmp44__length2 = worm_deadend_board_length2;
#line 1686 "../src/worm.vala"
						_tmp44_[(0 * _tmp44__length2) + target_y] = worm_deadend_runnumber;
#line 9160 "worm.c"
					}
#line 1687 "../src/worm.vala"
					if (((gint) target_y) < (height - 1)) {
#line 9164 "worm.c"
						guint* _tmp45_;
						gint _tmp45__length1;
						gint _tmp45__length2;
#line 1687 "../src/worm.vala"
						_tmp45_ = worm_deadend_board;
#line 1687 "../src/worm.vala"
						_tmp45__length1 = worm_deadend_board_length1;
#line 1687 "../src/worm.vala"
						_tmp45__length2 = worm_deadend_board_length2;
#line 1687 "../src/worm.vala"
						_tmp45_[(target_x * _tmp45__length2) + (target_y + 1)] = worm_deadend_runnumber;
#line 9176 "worm.c"
					} else {
						guint* _tmp46_;
						gint _tmp46__length1;
						gint _tmp46__length2;
#line 1688 "../src/worm.vala"
						_tmp46_ = worm_deadend_board;
#line 1688 "../src/worm.vala"
						_tmp46__length1 = worm_deadend_board_length1;
#line 1688 "../src/worm.vala"
						_tmp46__length2 = worm_deadend_board_length2;
#line 1688 "../src/worm.vala"
						_tmp46_[(target_x * _tmp46__length2) + 0] = worm_deadend_runnumber;
#line 9189 "worm.c"
					}
				}
			}
		}
	}
#line 1692 "../src/worm.vala"
	_tmp47_ = *old_position;
#line 1692 "../src/worm.vala"
	new_position = _tmp47_;
#line 1693 "../src/worm.vala"
	position_move (&new_position, direction, width, height);
#line 1695 "../src/worm.vala"
	_tmp48_ = worm_deadend_board;
#line 1695 "../src/worm.vala"
	_tmp48__length1 = worm_deadend_board_length1;
#line 1695 "../src/worm.vala"
	_tmp48__length2 = worm_deadend_board_length2;
#line 1695 "../src/worm.vala"
	_tmp49_ = *old_position;
#line 1695 "../src/worm.vala"
	_tmp50_ = *old_position;
#line 1695 "../src/worm.vala"
	_tmp48_[(_tmp49_.x * _tmp48__length2) + _tmp50_.y] = worm_deadend_runnumber;
#line 1696 "../src/worm.vala"
	_tmp51_ = worm_deadend_board;
#line 1696 "../src/worm.vala"
	_tmp51__length1 = worm_deadend_board_length1;
#line 1696 "../src/worm.vala"
	_tmp51__length2 = worm_deadend_board_length2;
#line 1696 "../src/worm.vala"
	_tmp52_ = new_position;
#line 1696 "../src/worm.vala"
	_tmp53_ = new_position;
#line 1696 "../src/worm.vala"
	_tmp51_[(_tmp52_.x * _tmp51__length2) + _tmp53_.y] = worm_deadend_runnumber;
#line 1698 "../src/worm.vala"
	cl = (length * length) / 16;
#line 1699 "../src/worm.vala"
	if (cl < ((gint) width)) {
#line 1700 "../src/worm.vala"
		cl = (gint) width;
#line 9231 "worm.c"
	}
#line 1702 "../src/worm.vala"
	_tmp54_ = new_position;
#line 1702 "../src/worm.vala"
	result = worm_ai_deadend (board, (gint) board_length1, (gint) board_length2, worm_map, &_tmp54_, cl);
#line 1702 "../src/worm.vala"
	return result;
#line 9239 "worm.c"
}

static inline gboolean
worm_ai_too_close (Worm* self,
                   GeeLinkedList* worms,
                   WormDirection direction)
{
	gboolean result;
#line 1709 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1709 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 9252 "worm.c"
	{
		GeeLinkedList* _worm_list = NULL;
		gint _worm_size = 0;
		GeeLinkedList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _worm_index = 0;
#line 1711 "../src/worm.vala"
		_worm_list = worms;
#line 1711 "../src/worm.vala"
		_tmp0_ = _worm_list;
#line 1711 "../src/worm.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 1711 "../src/worm.vala"
		_tmp2_ = _tmp1_;
#line 1711 "../src/worm.vala"
		_worm_size = _tmp2_;
#line 1711 "../src/worm.vala"
		_worm_index = -1;
#line 1711 "../src/worm.vala"
		while (TRUE) {
#line 9274 "worm.c"
			gint _tmp3_;
			gint _tmp4_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			gboolean _tmp7_ = FALSE;
			gboolean _tmp8_ = FALSE;
			Worm* _tmp9_;
			gint16 dx = 0;
			Position _tmp15_ = {0};
			Position _tmp16_;
			Worm* _tmp17_;
			Position _tmp18_ = {0};
			Position _tmp19_;
			gint16 dy = 0;
			Position _tmp20_ = {0};
			Position _tmp21_;
			Worm* _tmp22_;
			Position _tmp23_ = {0};
			Position _tmp24_;
#line 1711 "../src/worm.vala"
			_worm_index = _worm_index + 1;
#line 1711 "../src/worm.vala"
			_tmp3_ = _worm_index;
#line 1711 "../src/worm.vala"
			_tmp4_ = _worm_size;
#line 1711 "../src/worm.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 1711 "../src/worm.vala"
				break;
#line 9305 "worm.c"
			}
#line 1711 "../src/worm.vala"
			_tmp5_ = _worm_list;
#line 1711 "../src/worm.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _worm_index);
#line 1711 "../src/worm.vala"
			worm = (Worm*) _tmp6_;
#line 1713 "../src/worm.vala"
			_tmp9_ = worm;
#line 1713 "../src/worm.vala"
			if (_tmp9_ == self) {
#line 1713 "../src/worm.vala"
				_tmp8_ = TRUE;
#line 9319 "worm.c"
			} else {
				Worm* _tmp10_;
#line 1713 "../src/worm.vala"
				_tmp10_ = worm;
#line 1713 "../src/worm.vala"
				_tmp8_ = _tmp10_->is_stopped;
#line 9326 "worm.c"
			}
#line 1713 "../src/worm.vala"
			if (_tmp8_) {
#line 1713 "../src/worm.vala"
				_tmp7_ = TRUE;
#line 9332 "worm.c"
			} else {
				Worm* _tmp11_;
				WormPositions* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
#line 1713 "../src/worm.vala"
				_tmp11_ = worm;
#line 1713 "../src/worm.vala"
				_tmp12_ = _tmp11_->list;
#line 1713 "../src/worm.vala"
				_tmp13_ = gee_collection_get_is_empty ((GeeCollection*) _tmp12_);
#line 1713 "../src/worm.vala"
				_tmp14_ = _tmp13_;
#line 1713 "../src/worm.vala"
				_tmp7_ = _tmp14_;
#line 9348 "worm.c"
			}
#line 1713 "../src/worm.vala"
			if (_tmp7_) {
#line 1714 "../src/worm.vala"
				_g_object_unref0 (worm);
#line 1714 "../src/worm.vala"
				continue;
#line 9356 "worm.c"
			}
#line 1716 "../src/worm.vala"
			worm_get_head (self, &_tmp15_);
#line 1716 "../src/worm.vala"
			_tmp16_ = _tmp15_;
#line 1716 "../src/worm.vala"
			_tmp17_ = worm;
#line 1716 "../src/worm.vala"
			worm_get_head (_tmp17_, &_tmp18_);
#line 1716 "../src/worm.vala"
			_tmp19_ = _tmp18_;
#line 1716 "../src/worm.vala"
			dx = ((gint16) _tmp16_.x) - ((gint16) _tmp19_.x);
#line 1717 "../src/worm.vala"
			worm_get_head (self, &_tmp20_);
#line 1717 "../src/worm.vala"
			_tmp21_ = _tmp20_;
#line 1717 "../src/worm.vala"
			_tmp22_ = worm;
#line 1717 "../src/worm.vala"
			worm_get_head (_tmp22_, &_tmp23_);
#line 1717 "../src/worm.vala"
			_tmp24_ = _tmp23_;
#line 1717 "../src/worm.vala"
			dy = ((gint16) _tmp21_.y) - ((gint16) _tmp24_.y);
#line 1718 "../src/worm.vala"
			switch (direction) {
#line 1718 "../src/worm.vala"
				case WORM_DIRECTION_UP:
#line 9386 "worm.c"
				{
					gboolean _tmp25_ = FALSE;
					gboolean _tmp26_ = FALSE;
					gboolean _tmp27_ = FALSE;
#line 1721 "../src/worm.vala"
					if (((gint) dy) > 0) {
#line 1721 "../src/worm.vala"
						_tmp27_ = ((gint) dy) <= 3;
#line 9395 "worm.c"
					} else {
#line 1721 "../src/worm.vala"
						_tmp27_ = FALSE;
#line 9399 "worm.c"
					}
#line 1721 "../src/worm.vala"
					if (_tmp27_) {
#line 1721 "../src/worm.vala"
						_tmp26_ = ((gint) dx) >= -1;
#line 9405 "worm.c"
					} else {
#line 1721 "../src/worm.vala"
						_tmp26_ = FALSE;
#line 9409 "worm.c"
					}
#line 1721 "../src/worm.vala"
					if (_tmp26_) {
#line 1721 "../src/worm.vala"
						_tmp25_ = ((gint) dx) <= 1;
#line 9415 "worm.c"
					} else {
#line 1721 "../src/worm.vala"
						_tmp25_ = FALSE;
#line 9419 "worm.c"
					}
#line 1721 "../src/worm.vala"
					if (_tmp25_) {
#line 1722 "../src/worm.vala"
						result = TRUE;
#line 1722 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 1722 "../src/worm.vala"
						return result;
#line 9429 "worm.c"
					}
#line 1723 "../src/worm.vala"
					break;
#line 9433 "worm.c"
				}
#line 1718 "../src/worm.vala"
				case WORM_DIRECTION_DOWN:
#line 9437 "worm.c"
				{
					gboolean _tmp28_ = FALSE;
					gboolean _tmp29_ = FALSE;
					gboolean _tmp30_ = FALSE;
#line 1726 "../src/worm.vala"
					if (((gint) dy) < 0) {
#line 1726 "../src/worm.vala"
						_tmp30_ = ((gint) dy) >= -3;
#line 9446 "worm.c"
					} else {
#line 1726 "../src/worm.vala"
						_tmp30_ = FALSE;
#line 9450 "worm.c"
					}
#line 1726 "../src/worm.vala"
					if (_tmp30_) {
#line 1726 "../src/worm.vala"
						_tmp29_ = ((gint) dx) >= -1;
#line 9456 "worm.c"
					} else {
#line 1726 "../src/worm.vala"
						_tmp29_ = FALSE;
#line 9460 "worm.c"
					}
#line 1726 "../src/worm.vala"
					if (_tmp29_) {
#line 1726 "../src/worm.vala"
						_tmp28_ = ((gint) dx) <= 1;
#line 9466 "worm.c"
					} else {
#line 1726 "../src/worm.vala"
						_tmp28_ = FALSE;
#line 9470 "worm.c"
					}
#line 1726 "../src/worm.vala"
					if (_tmp28_) {
#line 1727 "../src/worm.vala"
						result = TRUE;
#line 1727 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 1727 "../src/worm.vala"
						return result;
#line 9480 "worm.c"
					}
#line 1728 "../src/worm.vala"
					break;
#line 9484 "worm.c"
				}
#line 1718 "../src/worm.vala"
				case WORM_DIRECTION_LEFT:
#line 9488 "worm.c"
				{
					gboolean _tmp31_ = FALSE;
					gboolean _tmp32_ = FALSE;
					gboolean _tmp33_ = FALSE;
#line 1731 "../src/worm.vala"
					if (((gint) dx) > 0) {
#line 1731 "../src/worm.vala"
						_tmp33_ = ((gint) dx) <= 3;
#line 9497 "worm.c"
					} else {
#line 1731 "../src/worm.vala"
						_tmp33_ = FALSE;
#line 9501 "worm.c"
					}
#line 1731 "../src/worm.vala"
					if (_tmp33_) {
#line 1731 "../src/worm.vala"
						_tmp32_ = ((gint) dy) >= -1;
#line 9507 "worm.c"
					} else {
#line 1731 "../src/worm.vala"
						_tmp32_ = FALSE;
#line 9511 "worm.c"
					}
#line 1731 "../src/worm.vala"
					if (_tmp32_) {
#line 1731 "../src/worm.vala"
						_tmp31_ = ((gint) dy) <= 1;
#line 9517 "worm.c"
					} else {
#line 1731 "../src/worm.vala"
						_tmp31_ = FALSE;
#line 9521 "worm.c"
					}
#line 1731 "../src/worm.vala"
					if (_tmp31_) {
#line 1732 "../src/worm.vala"
						result = TRUE;
#line 1732 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 1732 "../src/worm.vala"
						return result;
#line 9531 "worm.c"
					}
#line 1733 "../src/worm.vala"
					break;
#line 9535 "worm.c"
				}
#line 1718 "../src/worm.vala"
				case WORM_DIRECTION_RIGHT:
#line 9539 "worm.c"
				{
					gboolean _tmp34_ = FALSE;
					gboolean _tmp35_ = FALSE;
					gboolean _tmp36_ = FALSE;
#line 1736 "../src/worm.vala"
					if (((gint) dx) < 0) {
#line 1736 "../src/worm.vala"
						_tmp36_ = ((gint) dx) >= -3;
#line 9548 "worm.c"
					} else {
#line 1736 "../src/worm.vala"
						_tmp36_ = FALSE;
#line 9552 "worm.c"
					}
#line 1736 "../src/worm.vala"
					if (_tmp36_) {
#line 1736 "../src/worm.vala"
						_tmp35_ = ((gint) dy) >= -1;
#line 9558 "worm.c"
					} else {
#line 1736 "../src/worm.vala"
						_tmp35_ = FALSE;
#line 9562 "worm.c"
					}
#line 1736 "../src/worm.vala"
					if (_tmp35_) {
#line 1736 "../src/worm.vala"
						_tmp34_ = ((gint) dy) <= 1;
#line 9568 "worm.c"
					} else {
#line 1736 "../src/worm.vala"
						_tmp34_ = FALSE;
#line 9572 "worm.c"
					}
#line 1736 "../src/worm.vala"
					if (_tmp34_) {
#line 1737 "../src/worm.vala"
						result = TRUE;
#line 1737 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 1737 "../src/worm.vala"
						return result;
#line 9582 "worm.c"
					}
#line 1738 "../src/worm.vala"
					break;
#line 9586 "worm.c"
				}
				default:
				{
#line 1741 "../src/worm.vala"
					g_assert_not_reached ();
#line 9592 "worm.c"
				}
			}
#line 1711 "../src/worm.vala"
			_g_object_unref0 (worm);
#line 9597 "worm.c"
		}
	}
#line 1744 "../src/worm.vala"
	result = FALSE;
#line 1744 "../src/worm.vala"
	return result;
#line 9604 "worm.c"
}

gboolean
worm_ai_is_bonus_more_attractive (Worm* self,
                                  BonusType b0,
                                  gint64 d0,
                                  BonusType b1,
                                  gint64 d1)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean result;
#line 1747 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1750 "../src/worm.vala"
	if (BONUS_TYPE_LIFE == b0) {
#line 1750 "../src/worm.vala"
		_tmp3_ = BONUS_TYPE_LIFE == b1;
#line 9625 "worm.c"
	} else {
#line 1750 "../src/worm.vala"
		_tmp3_ = FALSE;
#line 9629 "worm.c"
	}
#line 1750 "../src/worm.vala"
	if (_tmp3_) {
#line 1750 "../src/worm.vala"
		_tmp2_ = TRUE;
#line 9635 "worm.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 1751 "../src/worm.vala"
		if (BONUS_TYPE_LIFE != b0) {
#line 1751 "../src/worm.vala"
			_tmp4_ = BONUS_TYPE_LIFE != b1;
#line 9642 "worm.c"
		} else {
#line 1751 "../src/worm.vala"
			_tmp4_ = FALSE;
#line 9646 "worm.c"
		}
#line 1751 "../src/worm.vala"
		_tmp2_ = _tmp4_;
#line 9650 "worm.c"
	}
#line 1750 "../src/worm.vala"
	if (_tmp2_) {
#line 1751 "../src/worm.vala"
		_tmp1_ = d0 < d1;
#line 9656 "worm.c"
	} else {
#line 1750 "../src/worm.vala"
		_tmp1_ = FALSE;
#line 9660 "worm.c"
	}
#line 1750 "../src/worm.vala"
	if (_tmp1_) {
#line 1750 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 9666 "worm.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 1752 "../src/worm.vala"
		if (BONUS_TYPE_LIFE == b0) {
#line 1752 "../src/worm.vala"
			_tmp5_ = BONUS_TYPE_LIFE != b1;
#line 9673 "worm.c"
		} else {
#line 1752 "../src/worm.vala"
			_tmp5_ = FALSE;
#line 9677 "worm.c"
		}
#line 1752 "../src/worm.vala"
		_tmp0_ = _tmp5_;
#line 9681 "worm.c"
	}
#line 1750 "../src/worm.vala"
	result = _tmp0_;
#line 1750 "../src/worm.vala"
	return result;
#line 9687 "worm.c"
}

gboolean
worm_ai_can_see_bonus (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       Position* origin,
                       Bonus* bonus,
                       WormDirection direction)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	Position _tmp4_;
	guint8 _tmp5_;
	guint8 _tmp6_;
	Slice* slice = NULL;
	Slice* _tmp31_;
	Slice* _tmp32_;
	Slice* _tmp33_;
	Position _tmp34_;
	guint8 _tmp35_;
	guint8 _tmp36_;
	guint8 _tmp37_;
	guint8 _tmp38_;
	Slice* _tmp39_;
	gboolean result;
#line 1755 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1755 "../src/worm.vala"
	g_return_val_if_fail (origin != NULL, FALSE);
#line 1755 "../src/worm.vala"
	g_return_val_if_fail (bonus != NULL, FALSE);
#line 1757 "../src/worm.vala"
	_tmp4_ = *origin;
#line 1757 "../src/worm.vala"
	_tmp5_ = bonus_get_x (bonus);
#line 1757 "../src/worm.vala"
	_tmp6_ = _tmp5_;
#line 1757 "../src/worm.vala"
	if (_tmp4_.x == _tmp6_) {
#line 9731 "worm.c"
		Position _tmp7_;
		guint8 _tmp8_;
		guint8 _tmp9_;
#line 1757 "../src/worm.vala"
		_tmp7_ = *origin;
#line 1757 "../src/worm.vala"
		_tmp8_ = bonus_get_y (bonus);
#line 1757 "../src/worm.vala"
		_tmp9_ = _tmp8_;
#line 1757 "../src/worm.vala"
		_tmp3_ = _tmp7_.y == _tmp9_;
#line 9743 "worm.c"
	} else {
#line 1757 "../src/worm.vala"
		_tmp3_ = FALSE;
#line 9747 "worm.c"
	}
#line 1757 "../src/worm.vala"
	if (_tmp3_) {
#line 1757 "../src/worm.vala"
		_tmp2_ = TRUE;
#line 9753 "worm.c"
	} else {
		gboolean _tmp10_ = FALSE;
		Position _tmp11_;
		guint8 _tmp12_;
		guint8 _tmp13_;
#line 1758 "../src/worm.vala"
		_tmp11_ = *origin;
#line 1758 "../src/worm.vala"
		_tmp12_ = bonus_get_x (bonus);
#line 1758 "../src/worm.vala"
		_tmp13_ = _tmp12_;
#line 1758 "../src/worm.vala"
		if (((gint) _tmp11_.x) == (_tmp13_ + 1)) {
#line 9767 "worm.c"
			Position _tmp14_;
			guint8 _tmp15_;
			guint8 _tmp16_;
#line 1758 "../src/worm.vala"
			_tmp14_ = *origin;
#line 1758 "../src/worm.vala"
			_tmp15_ = bonus_get_y (bonus);
#line 1758 "../src/worm.vala"
			_tmp16_ = _tmp15_;
#line 1758 "../src/worm.vala"
			_tmp10_ = _tmp14_.y == _tmp16_;
#line 9779 "worm.c"
		} else {
#line 1758 "../src/worm.vala"
			_tmp10_ = FALSE;
#line 9783 "worm.c"
		}
#line 1758 "../src/worm.vala"
		_tmp2_ = _tmp10_;
#line 9787 "worm.c"
	}
#line 1757 "../src/worm.vala"
	if (_tmp2_) {
#line 1757 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 9793 "worm.c"
	} else {
		gboolean _tmp17_ = FALSE;
		Position _tmp18_;
		guint8 _tmp19_;
		guint8 _tmp20_;
#line 1759 "../src/worm.vala"
		_tmp18_ = *origin;
#line 1759 "../src/worm.vala"
		_tmp19_ = bonus_get_x (bonus);
#line 1759 "../src/worm.vala"
		_tmp20_ = _tmp19_;
#line 1759 "../src/worm.vala"
		if (_tmp18_.x == _tmp20_) {
#line 9807 "worm.c"
			Position _tmp21_;
			guint8 _tmp22_;
			guint8 _tmp23_;
#line 1759 "../src/worm.vala"
			_tmp21_ = *origin;
#line 1759 "../src/worm.vala"
			_tmp22_ = bonus_get_y (bonus);
#line 1759 "../src/worm.vala"
			_tmp23_ = _tmp22_;
#line 1759 "../src/worm.vala"
			_tmp17_ = ((gint) _tmp21_.y) == (_tmp23_ + 1);
#line 9819 "worm.c"
		} else {
#line 1759 "../src/worm.vala"
			_tmp17_ = FALSE;
#line 9823 "worm.c"
		}
#line 1759 "../src/worm.vala"
		_tmp1_ = _tmp17_;
#line 9827 "worm.c"
	}
#line 1757 "../src/worm.vala"
	if (_tmp1_) {
#line 1757 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 9833 "worm.c"
	} else {
		gboolean _tmp24_ = FALSE;
		Position _tmp25_;
		guint8 _tmp26_;
		guint8 _tmp27_;
#line 1760 "../src/worm.vala"
		_tmp25_ = *origin;
#line 1760 "../src/worm.vala"
		_tmp26_ = bonus_get_x (bonus);
#line 1760 "../src/worm.vala"
		_tmp27_ = _tmp26_;
#line 1760 "../src/worm.vala"
		if (((gint) _tmp25_.x) == (_tmp27_ + 1)) {
#line 9847 "worm.c"
			Position _tmp28_;
			guint8 _tmp29_;
			guint8 _tmp30_;
#line 1760 "../src/worm.vala"
			_tmp28_ = *origin;
#line 1760 "../src/worm.vala"
			_tmp29_ = bonus_get_y (bonus);
#line 1760 "../src/worm.vala"
			_tmp30_ = _tmp29_;
#line 1760 "../src/worm.vala"
			_tmp24_ = ((gint) _tmp28_.y) == (_tmp30_ + 1);
#line 9859 "worm.c"
		} else {
#line 1760 "../src/worm.vala"
			_tmp24_ = FALSE;
#line 9863 "worm.c"
		}
#line 1760 "../src/worm.vala"
		_tmp0_ = _tmp24_;
#line 9867 "worm.c"
	}
#line 1757 "../src/worm.vala"
	if (_tmp0_) {
#line 1761 "../src/worm.vala"
		result = TRUE;
#line 1761 "../src/worm.vala"
		return result;
#line 9875 "worm.c"
	}
#line 1762 "../src/worm.vala"
	_tmp31_ = slice_new (NULL);
#line 1762 "../src/worm.vala"
	slice = _tmp31_;
#line 1764 "../src/worm.vala"
	_tmp32_ = slice;
#line 1764 "../src/worm.vala"
	slice_set_direction_view (_tmp32_, direction, board, (gint) board_length1, (gint) board_length2);
#line 1766 "../src/worm.vala"
	_tmp33_ = slice;
#line 1766 "../src/worm.vala"
	_tmp34_ = *origin;
#line 1766 "../src/worm.vala"
	_tmp35_ = bonus_get_x (bonus);
#line 1766 "../src/worm.vala"
	_tmp36_ = _tmp35_;
#line 1766 "../src/worm.vala"
	_tmp37_ = bonus_get_y (bonus);
#line 1766 "../src/worm.vala"
	_tmp38_ = _tmp37_;
#line 1766 "../src/worm.vala"
	slice_intersection_by_position (_tmp33_, &_tmp34_, _tmp36_, _tmp38_, 2);
#line 1767 "../src/worm.vala"
	_tmp39_ = slice;
#line 1767 "../src/worm.vala"
	result = !slice_is_empty (_tmp39_);
#line 1767 "../src/worm.vala"
	_g_object_unref0 (slice);
#line 1767 "../src/worm.vala"
	return result;
#line 9907 "worm.c"
}

gint64
worm_ai_count_distance_to_a_bonus_in_direction (Worm* self,
                                                gint* board,
                                                gint board_length1,
                                                gint board_length2,
                                                WormMap* worm_map,
                                                Position* origin,
                                                WormDirection direction,
                                                BonusType* bonus_type)
{
	BonusType _vala_bonus_type = 0;
	gint64 bonus_distance = 0LL;
	Slice* slice = NULL;
	Slice* _tmp0_;
	gint64 result;
#line 1770 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 1770 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, 0LL);
#line 1770 "../src/worm.vala"
	g_return_val_if_fail (origin != NULL, 0LL);
#line 1791 "../src/worm.vala"
	bonus_distance = G_MAXINT64;
#line 1792 "../src/worm.vala"
	_vala_bonus_type = (BonusType) -1;
#line 1794 "../src/worm.vala"
	_tmp0_ = slice_new (NULL);
#line 1794 "../src/worm.vala"
	slice = _tmp0_;
#line 9939 "worm.c"
	{
		GeeList* _b_list = NULL;
		WormGetBonusesType _tmp1_;
		gpointer _tmp1__target;
		GeeList* _tmp2_;
		gint _b_size = 0;
		GeeList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _b_index = 0;
#line 1795 "../src/worm.vala"
		_tmp1_ = self->priv->get_bonuses;
#line 1795 "../src/worm.vala"
		_tmp1__target = self->priv->get_bonuses_target;
#line 1795 "../src/worm.vala"
		_tmp2_ = _tmp1_ (_tmp1__target);
#line 1795 "../src/worm.vala"
		_b_list = _tmp2_;
#line 1795 "../src/worm.vala"
		_tmp3_ = _b_list;
#line 1795 "../src/worm.vala"
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 1795 "../src/worm.vala"
		_tmp5_ = _tmp4_;
#line 1795 "../src/worm.vala"
		_b_size = _tmp5_;
#line 1795 "../src/worm.vala"
		_b_index = -1;
#line 1795 "../src/worm.vala"
		while (TRUE) {
#line 9970 "worm.c"
			gint _tmp6_;
			gint _tmp7_;
			Bonus* b = NULL;
			GeeList* _tmp8_;
			gpointer _tmp9_;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
#line 1795 "../src/worm.vala"
			_b_index = _b_index + 1;
#line 1795 "../src/worm.vala"
			_tmp6_ = _b_index;
#line 1795 "../src/worm.vala"
			_tmp7_ = _b_size;
#line 1795 "../src/worm.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 1795 "../src/worm.vala"
				break;
#line 9988 "worm.c"
			}
#line 1795 "../src/worm.vala"
			_tmp8_ = _b_list;
#line 1795 "../src/worm.vala"
			_tmp9_ = gee_list_get (_tmp8_, _b_index);
#line 1795 "../src/worm.vala"
			b = (Bonus*) _tmp9_;
#line 1797 "../src/worm.vala"
			if (BONUS_TYPE_LIFE == _vala_bonus_type) {
#line 9998 "worm.c"
				Bonus* _tmp12_;
				BonusType _tmp13_;
				BonusType _tmp14_;
#line 1797 "../src/worm.vala"
				_tmp12_ = b;
#line 1797 "../src/worm.vala"
				_tmp13_ = bonus_get_bonus_type (_tmp12_);
#line 1797 "../src/worm.vala"
				_tmp14_ = _tmp13_;
#line 1797 "../src/worm.vala"
				_tmp11_ = BONUS_TYPE_LIFE == _tmp14_;
#line 10010 "worm.c"
			} else {
#line 1797 "../src/worm.vala"
				_tmp11_ = FALSE;
#line 10014 "worm.c"
			}
#line 1797 "../src/worm.vala"
			if (_tmp11_) {
#line 1797 "../src/worm.vala"
				_tmp10_ = TRUE;
#line 10020 "worm.c"
			} else {
				gboolean _tmp15_ = FALSE;
#line 1798 "../src/worm.vala"
				if (BONUS_TYPE_LIFE != _vala_bonus_type) {
#line 10025 "worm.c"
					gboolean _tmp16_ = FALSE;
					gboolean _tmp17_ = FALSE;
					gboolean _tmp18_ = FALSE;
					Bonus* _tmp19_;
					BonusType _tmp20_;
					BonusType _tmp21_;
#line 1799 "../src/worm.vala"
					_tmp19_ = b;
#line 1799 "../src/worm.vala"
					_tmp20_ = bonus_get_bonus_type (_tmp19_);
#line 1799 "../src/worm.vala"
					_tmp21_ = _tmp20_;
#line 1799 "../src/worm.vala"
					if (BONUS_TYPE_REGULAR == _tmp21_) {
#line 1799 "../src/worm.vala"
						_tmp18_ = TRUE;
#line 10042 "worm.c"
					} else {
						Bonus* _tmp22_;
						BonusType _tmp23_;
						BonusType _tmp24_;
#line 1799 "../src/worm.vala"
						_tmp22_ = b;
#line 1799 "../src/worm.vala"
						_tmp23_ = bonus_get_bonus_type (_tmp22_);
#line 1799 "../src/worm.vala"
						_tmp24_ = _tmp23_;
#line 1799 "../src/worm.vala"
						_tmp18_ = BONUS_TYPE_DOUBLE == _tmp24_;
#line 10055 "worm.c"
					}
#line 1799 "../src/worm.vala"
					if (_tmp18_) {
#line 1799 "../src/worm.vala"
						_tmp17_ = TRUE;
#line 10061 "worm.c"
					} else {
						Bonus* _tmp25_;
						BonusType _tmp26_;
						BonusType _tmp27_;
#line 1800 "../src/worm.vala"
						_tmp25_ = b;
#line 1800 "../src/worm.vala"
						_tmp26_ = bonus_get_bonus_type (_tmp25_);
#line 1800 "../src/worm.vala"
						_tmp27_ = _tmp26_;
#line 1800 "../src/worm.vala"
						_tmp17_ = BONUS_TYPE_LIFE == _tmp27_;
#line 10074 "worm.c"
					}
#line 1798 "../src/worm.vala"
					if (_tmp17_) {
#line 1799 "../src/worm.vala"
						_tmp16_ = TRUE;
#line 10080 "worm.c"
					} else {
						Bonus* _tmp28_;
						BonusType _tmp29_;
						BonusType _tmp30_;
#line 1800 "../src/worm.vala"
						_tmp28_ = b;
#line 1800 "../src/worm.vala"
						_tmp29_ = bonus_get_bonus_type (_tmp28_);
#line 1800 "../src/worm.vala"
						_tmp30_ = _tmp29_;
#line 1800 "../src/worm.vala"
						_tmp16_ = BONUS_TYPE_REVERSE == _tmp30_;
#line 10093 "worm.c"
					}
#line 1798 "../src/worm.vala"
					_tmp15_ = _tmp16_;
#line 10097 "worm.c"
				} else {
#line 1798 "../src/worm.vala"
					_tmp15_ = FALSE;
#line 10101 "worm.c"
				}
#line 1798 "../src/worm.vala"
				_tmp10_ = _tmp15_;
#line 10105 "worm.c"
			}
#line 1797 "../src/worm.vala"
			if (_tmp10_) {
#line 10109 "worm.c"
				Slice* _tmp31_;
				Slice* _tmp32_;
				Position _tmp33_;
				Bonus* _tmp34_;
				guint8 _tmp35_;
				guint8 _tmp36_;
				Bonus* _tmp37_;
				guint8 _tmp38_;
				guint8 _tmp39_;
				Slice* _tmp40_;
#line 1803 "../src/worm.vala"
				_tmp31_ = slice;
#line 1803 "../src/worm.vala"
				slice_set_direction_view (_tmp31_, direction, board, (gint) board_length1, (gint) board_length2);
#line 1805 "../src/worm.vala"
				_tmp32_ = slice;
#line 1805 "../src/worm.vala"
				_tmp33_ = *origin;
#line 1805 "../src/worm.vala"
				_tmp34_ = b;
#line 1805 "../src/worm.vala"
				_tmp35_ = bonus_get_x (_tmp34_);
#line 1805 "../src/worm.vala"
				_tmp36_ = _tmp35_;
#line 1805 "../src/worm.vala"
				_tmp37_ = b;
#line 1805 "../src/worm.vala"
				_tmp38_ = bonus_get_y (_tmp37_);
#line 1805 "../src/worm.vala"
				_tmp39_ = _tmp38_;
#line 1805 "../src/worm.vala"
				slice_intersection_by_position (_tmp32_, &_tmp33_, _tmp36_, _tmp39_, 2);
#line 1806 "../src/worm.vala"
				_tmp40_ = slice;
#line 1806 "../src/worm.vala"
				if (!slice_is_empty (_tmp40_)) {
#line 10146 "worm.c"
					gint64 distance = 0LL;
					Slice* _tmp41_;
					Position _tmp42_;
					Bonus* _tmp43_;
					gboolean _tmp44_ = FALSE;
#line 1809 "../src/worm.vala"
					_tmp41_ = slice;
#line 1809 "../src/worm.vala"
					_tmp42_ = *origin;
#line 1809 "../src/worm.vala"
					_tmp43_ = b;
#line 1809 "../src/worm.vala"
					distance = slice_is_visible (_tmp41_, &_tmp42_, board, (gint) board_length1, (gint) board_length2, worm_map, _tmp43_);
#line 1812 "../src/worm.vala"
					if (distance < bonus_distance) {
#line 10162 "worm.c"
						Position _tmp45_;
						Position _tmp46_ = {0};
						Bonus* _tmp47_;
#line 1813 "../src/worm.vala"
						_tmp45_ = *origin;
#line 1813 "../src/worm.vala"
						worm_get_position_after_direction_move (self, &_tmp45_, direction, &_tmp46_);
#line 1813 "../src/worm.vala"
						_tmp47_ = b;
#line 1813 "../src/worm.vala"
						_tmp44_ = worm_ai_can_see_bonus (self, board, (gint) board_length1, (gint) board_length2, &_tmp46_, _tmp47_, direction);
#line 10174 "worm.c"
					} else {
#line 1812 "../src/worm.vala"
						_tmp44_ = FALSE;
#line 10178 "worm.c"
					}
#line 1812 "../src/worm.vala"
					if (_tmp44_) {
#line 10182 "worm.c"
						Bonus* _tmp48_;
						BonusType _tmp49_;
						BonusType _tmp50_;
#line 1815 "../src/worm.vala"
						bonus_distance = distance;
#line 1816 "../src/worm.vala"
						_tmp48_ = b;
#line 1816 "../src/worm.vala"
						_tmp49_ = bonus_get_bonus_type (_tmp48_);
#line 1816 "../src/worm.vala"
						_tmp50_ = _tmp49_;
#line 1816 "../src/worm.vala"
						_vala_bonus_type = _tmp50_;
#line 10196 "worm.c"
					}
				}
			}
#line 1795 "../src/worm.vala"
			_g_object_unref0 (b);
#line 10202 "worm.c"
		}
#line 1795 "../src/worm.vala"
		_g_object_unref0 (_b_list);
#line 10206 "worm.c"
	}
#line 1822 "../src/worm.vala"
	result = bonus_distance;
#line 1822 "../src/worm.vala"
	_g_object_unref0 (slice);
#line 1822 "../src/worm.vala"
	if (bonus_type) {
#line 1822 "../src/worm.vala"
		*bonus_type = _vala_bonus_type;
#line 10216 "worm.c"
	}
#line 1822 "../src/worm.vala"
	return result;
#line 10220 "worm.c"
}

void
worm_ai_move (Worm* self,
              gint* board,
              gint board_length1,
              gint board_length2,
              GeeLinkedList* worms)
{
	WormMap* worm_map = NULL;
	guint8 _tmp0_;
	guint8 _tmp1_;
	WormMap* _tmp2_;
	BonusType bonus_type = 0;
	gint64 shortest_distance = 0LL;
	WormDirection shortest_dir = 0;
	WormDirection _tmp3_;
	BonusType shortest_bonus_type = 0;
	WormDirection dir[3] = {0};
	WormDirection _tmp4_;
	WormDirection _tmp5_;
	WormDirection _tmp6_;
	WormDirection _tmp7_[3] = {0};
	WormDirection bonus_dir = 0;
	WormDirection best_dir = 0;
	gint64 best_yet = 0LL;
	WormDirection _tmp38_;
	gint _tmp39_ = 0;
	WormDirection* _tmp40_;
#line 1826 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1826 "../src/worm.vala"
	g_return_if_fail (worms != NULL);
#line 1828 "../src/worm.vala"
	_tmp0_ = self->priv->_width;
#line 1828 "../src/worm.vala"
	_tmp1_ = self->priv->_height;
#line 1828 "../src/worm.vala"
	_tmp2_ = worm_map_new ((GeeList*) worms, _tmp0_, _tmp1_);
#line 1828 "../src/worm.vala"
	worm_map = _tmp2_;
#line 1832 "../src/worm.vala"
	shortest_distance = G_MAXINT64;
#line 1833 "../src/worm.vala"
	_tmp3_ = self->priv->_direction;
#line 1833 "../src/worm.vala"
	shortest_dir = _tmp3_;
#line 1834 "../src/worm.vala"
	shortest_bonus_type = (BonusType) -1;
#line 1836 "../src/worm.vala"
	_tmp4_ = self->priv->_direction;
#line 1836 "../src/worm.vala"
	_tmp5_ = self->priv->_direction;
#line 1836 "../src/worm.vala"
	_tmp6_ = self->priv->_direction;
#line 1836 "../src/worm.vala"
	_tmp7_[0] = _tmp4_;
#line 1836 "../src/worm.vala"
	_tmp7_[1] = worm_direction_turn_left (_tmp5_);
#line 1836 "../src/worm.vala"
	_tmp7_[2] = worm_direction_turn_right (_tmp6_);
#line 1836 "../src/worm.vala"
	memcpy (dir, _tmp7_, 3 * sizeof (WormDirection));
#line 10284 "worm.c"
	{
		WormDirection* direction_collection = NULL;
		gint direction_collection_length1 = 0;
		gint _direction_collection_size_ = 0;
		gint direction_it = 0;
#line 1837 "../src/worm.vala"
		direction_collection = dir;
#line 1837 "../src/worm.vala"
		direction_collection_length1 = 3;
#line 1837 "../src/worm.vala"
		for (direction_it = 0; direction_it < direction_collection_length1; direction_it = direction_it + 1) {
#line 10296 "worm.c"
			WormDirection direction = 0;
#line 1837 "../src/worm.vala"
			direction = direction_collection[direction_it];
#line 10300 "worm.c"
			{
				gint64 d = 0LL;
				WormMap* _tmp8_;
				Position _tmp9_ = {0};
				Position _tmp10_;
				BonusType _tmp11_ = 0;
				gint64 _tmp12_;
				gboolean _tmp13_ = FALSE;
#line 1839 "../src/worm.vala"
				_tmp8_ = worm_map;
#line 1839 "../src/worm.vala"
				worm_get_head (self, &_tmp9_);
#line 1839 "../src/worm.vala"
				_tmp10_ = _tmp9_;
#line 1839 "../src/worm.vala"
				_tmp12_ = worm_ai_count_distance_to_a_bonus_in_direction (self, board, (gint) board_length1, (gint) board_length2, _tmp8_, &_tmp10_, direction, &_tmp11_);
#line 1839 "../src/worm.vala"
				bonus_type = _tmp11_;
#line 1839 "../src/worm.vala"
				d = _tmp12_;
#line 1840 "../src/worm.vala"
				if (worm_ai_is_bonus_more_attractive (self, bonus_type, d, shortest_bonus_type, shortest_distance)) {
#line 1841 "../src/worm.vala"
					_tmp13_ = worm_can_move_direction (self, board, (gint) board_length1, (gint) board_length2, worms, direction);
#line 10325 "worm.c"
				} else {
#line 1840 "../src/worm.vala"
					_tmp13_ = FALSE;
#line 10329 "worm.c"
				}
#line 1840 "../src/worm.vala"
				if (_tmp13_) {
#line 1843 "../src/worm.vala"
					shortest_distance = d;
#line 1844 "../src/worm.vala"
					shortest_dir = direction;
#line 1845 "../src/worm.vala"
					shortest_bonus_type = bonus_type;
#line 10339 "worm.c"
				}
			}
		}
	}
#line 1849 "../src/worm.vala"
	if (shortest_distance >= G_MAXINT64) {
#line 10346 "worm.c"
		WormDirection start_direction[4] = {0};
		WormDirection _tmp14_;
		WormDirection _tmp15_;
		WormDirection _tmp16_;
		WormDirection _tmp17_;
		WormDirection _tmp18_[4] = {0};
		WormDirection look_direction[4] = {0};
		WormDirection _tmp19_;
		WormDirection _tmp20_;
		WormDirection _tmp21_;
		WormDirection _tmp22_;
		WormDirection _tmp23_[4] = {0};
		gint64 d = 0LL;
#line 1852 "../src/worm.vala"
		_tmp14_ = self->priv->_direction;
#line 1852 "../src/worm.vala"
		_tmp15_ = self->priv->_direction;
#line 1852 "../src/worm.vala"
		_tmp16_ = self->priv->_direction;
#line 1852 "../src/worm.vala"
		_tmp17_ = self->priv->_direction;
#line 1852 "../src/worm.vala"
		_tmp18_[0] = _tmp14_;
#line 1852 "../src/worm.vala"
		_tmp18_[1] = _tmp15_;
#line 1852 "../src/worm.vala"
		_tmp18_[2] = worm_direction_turn_right (_tmp16_);
#line 1852 "../src/worm.vala"
		_tmp18_[3] = worm_direction_turn_left (_tmp17_);
#line 1852 "../src/worm.vala"
		memcpy (start_direction, _tmp18_, 4 * sizeof (WormDirection));
#line 1853 "../src/worm.vala"
		_tmp19_ = self->priv->_direction;
#line 1853 "../src/worm.vala"
		_tmp20_ = self->priv->_direction;
#line 1853 "../src/worm.vala"
		_tmp21_ = self->priv->_direction;
#line 1853 "../src/worm.vala"
		_tmp22_ = self->priv->_direction;
#line 1853 "../src/worm.vala"
		_tmp23_[0] = worm_direction_turn_left (_tmp19_);
#line 1853 "../src/worm.vala"
		_tmp23_[1] = worm_direction_turn_right (_tmp20_);
#line 1853 "../src/worm.vala"
		_tmp23_[2] = _tmp21_;
#line 1853 "../src/worm.vala"
		_tmp23_[3] = _tmp22_;
#line 1853 "../src/worm.vala"
		memcpy (look_direction, _tmp23_, 4 * sizeof (WormDirection));
#line 10396 "worm.c"
		{
			gint i = 0;
#line 1855 "../src/worm.vala"
			i = 0;
#line 10401 "worm.c"
			{
				gboolean _tmp24_ = FALSE;
#line 1855 "../src/worm.vala"
				_tmp24_ = TRUE;
#line 1855 "../src/worm.vala"
				while (TRUE) {
#line 10408 "worm.c"
					WormMap* _tmp26_;
					Position _tmp27_ = {0};
					Position _tmp28_;
					WormDirection _tmp29_;
					Position _tmp30_ = {0};
					WormDirection _tmp31_;
					BonusType _tmp32_ = 0;
					gint64 _tmp33_;
#line 1855 "../src/worm.vala"
					if (!_tmp24_) {
#line 10419 "worm.c"
						gint _tmp25_;
#line 1855 "../src/worm.vala"
						_tmp25_ = i;
#line 1855 "../src/worm.vala"
						i = _tmp25_ + 1;
#line 10425 "worm.c"
					}
#line 1855 "../src/worm.vala"
					_tmp24_ = FALSE;
#line 1855 "../src/worm.vala"
					if (!(i < 4)) {
#line 1855 "../src/worm.vala"
						break;
#line 10433 "worm.c"
					}
#line 1857 "../src/worm.vala"
					_tmp26_ = worm_map;
#line 1857 "../src/worm.vala"
					worm_get_head (self, &_tmp27_);
#line 1857 "../src/worm.vala"
					_tmp28_ = _tmp27_;
#line 1857 "../src/worm.vala"
					_tmp29_ = start_direction[i];
#line 1857 "../src/worm.vala"
					worm_get_position_after_direction_move (self, &_tmp28_, _tmp29_, &_tmp30_);
#line 1857 "../src/worm.vala"
					_tmp31_ = look_direction[i];
#line 1857 "../src/worm.vala"
					_tmp33_ = worm_ai_count_distance_to_a_bonus_in_direction (self, board, (gint) board_length1, (gint) board_length2, _tmp26_, &_tmp30_, _tmp31_, &_tmp32_);
#line 1857 "../src/worm.vala"
					bonus_type = _tmp32_;
#line 1857 "../src/worm.vala"
					d = _tmp33_;
#line 1859 "../src/worm.vala"
					if (worm_ai_is_bonus_more_attractive (self, bonus_type, d, shortest_bonus_type, shortest_distance)) {
#line 10455 "worm.c"
						WormDirection _tmp34_;
#line 1861 "../src/worm.vala"
						shortest_distance = d + 1;
#line 1862 "../src/worm.vala"
						_tmp34_ = start_direction[i];
#line 1862 "../src/worm.vala"
						shortest_dir = _tmp34_;
#line 1863 "../src/worm.vala"
						shortest_bonus_type = bonus_type;
#line 10465 "worm.c"
					}
				}
			}
		}
	}
#line 1868 "../src/worm.vala"
	bonus_type = shortest_bonus_type;
#line 1869 "../src/worm.vala"
	if (shortest_distance >= G_MAXINT64) {
#line 1872 "../src/worm.vala"
		if (g_random_int_range ((gint32) 0, (gint32) 30) == ((gint32) 1)) {
#line 10477 "worm.c"
			WormDirection _tmp35_ = 0;
#line 1873 "../src/worm.vala"
			if (g_random_boolean ()) {
#line 10481 "worm.c"
				WormDirection _tmp36_;
#line 1873 "../src/worm.vala"
				_tmp36_ = self->priv->_direction;
#line 1873 "../src/worm.vala"
				_tmp35_ = worm_direction_turn_right (_tmp36_);
#line 10487 "worm.c"
			} else {
				WormDirection _tmp37_;
#line 1873 "../src/worm.vala"
				_tmp37_ = self->priv->_direction;
#line 1873 "../src/worm.vala"
				_tmp35_ = worm_direction_turn_left (_tmp37_);
#line 10494 "worm.c"
			}
#line 1873 "../src/worm.vala"
			shortest_dir = _tmp35_;
#line 10498 "worm.c"
		}
	}
#line 1887 "../src/worm.vala"
	bonus_dir = shortest_dir;
#line 1888 "../src/worm.vala"
	best_dir = WORM_DIRECTION_NONE;
#line 1889 "../src/worm.vala"
	best_yet = G_MAXINT64;
#line 1890 "../src/worm.vala"
	_tmp38_ = dir[0];
#line 1890 "../src/worm.vala"
	_tmp40_ = worm_direction_get_space_fill_array (_tmp38_, &_tmp39_);
#line 10511 "worm.c"
	{
		WormDirection* direction_collection = NULL;
		gint direction_collection_length1 = 0;
		gint _direction_collection_size_ = 0;
		gint direction_it = 0;
#line 1890 "../src/worm.vala"
		direction_collection = _tmp40_;
#line 1890 "../src/worm.vala"
		direction_collection_length1 = _tmp39_;
#line 1890 "../src/worm.vala"
		for (direction_it = 0; direction_it < direction_collection_length1; direction_it = direction_it + 1) {
#line 10523 "worm.c"
			WormDirection direction = 0;
#line 1890 "../src/worm.vala"
			direction = direction_collection[direction_it];
#line 10527 "worm.c"
			{
				gint this_len = 0;
				gboolean _tmp41_ = FALSE;
				gboolean _tmp53_ = FALSE;
#line 1892 "../src/worm.vala"
				this_len = 0;
#line 1894 "../src/worm.vala"
				if (direction == bonus_dir) {
#line 1894 "../src/worm.vala"
					_tmp41_ = BONUS_TYPE_LIFE == bonus_type;
#line 10538 "worm.c"
				} else {
#line 1894 "../src/worm.vala"
					_tmp41_ = FALSE;
#line 10542 "worm.c"
				}
#line 1894 "../src/worm.vala"
				if (!_tmp41_) {
#line 10546 "worm.c"
					WormMap* _tmp42_;
					Position _tmp43_ = {0};
					Position _tmp44_;
					Position _tmp45_ = {0};
					WormMap* _tmp47_;
					Position _tmp48_ = {0};
					Position _tmp49_;
					gint _tmp50_;
					gint _tmp51_;
					gint _tmp52_;
#line 1898 "../src/worm.vala"
					_tmp42_ = worm_map;
#line 1898 "../src/worm.vala"
					worm_get_head (self, &_tmp43_);
#line 1898 "../src/worm.vala"
					_tmp44_ = _tmp43_;
#line 1898 "../src/worm.vala"
					worm_get_position_after_direction_move (self, &_tmp44_, direction, &_tmp45_);
#line 1898 "../src/worm.vala"
					if (!worm_can_move_to_map (self, board, (gint) board_length1, (gint) board_length2, _tmp42_, &_tmp45_)) {
#line 10567 "worm.c"
						gint _tmp46_;
#line 1899 "../src/worm.vala"
						_tmp46_ = self->priv->_capacity;
#line 1899 "../src/worm.vala"
						this_len += _tmp46_;
#line 10573 "worm.c"
					}
#line 1901 "../src/worm.vala"
					if (worm_ai_too_close (self, worms, direction)) {
#line 1902 "../src/worm.vala"
						this_len += 4;
#line 10579 "worm.c"
					}
#line 1904 "../src/worm.vala"
					_tmp47_ = worm_map;
#line 1904 "../src/worm.vala"
					worm_get_head (self, &_tmp48_);
#line 1904 "../src/worm.vala"
					_tmp49_ = _tmp48_;
#line 1904 "../src/worm.vala"
					_tmp50_ = worm_get_length (self);
#line 1904 "../src/worm.vala"
					_tmp51_ = _tmp50_;
#line 1904 "../src/worm.vala"
					_tmp52_ = self->priv->_change;
#line 1904 "../src/worm.vala"
					this_len += worm_ai_deadend_after (board, (gint) board_length1, (gint) board_length2, worms, _tmp47_, &_tmp49_, direction, _tmp51_ + _tmp52_);
#line 10595 "worm.c"
				}
#line 1906 "../src/worm.vala"
				if (direction == bonus_dir) {
#line 1906 "../src/worm.vala"
					_tmp53_ = this_len <= 0;
#line 10601 "worm.c"
				} else {
#line 1906 "../src/worm.vala"
					_tmp53_ = FALSE;
#line 10605 "worm.c"
				}
#line 1906 "../src/worm.vala"
				if (_tmp53_) {
#line 1907 "../src/worm.vala"
					this_len -= 100;
#line 10611 "worm.c"
				}
#line 1914 "../src/worm.vala"
				if (this_len <= 0) {
#line 1915 "../src/worm.vala"
					this_len -= (gint) g_random_int_range ((gint32) 0, (gint32) 100);
#line 10617 "worm.c"
				}
#line 1916 "../src/worm.vala"
				if (((gint64) this_len) < best_yet) {
#line 1918 "../src/worm.vala"
					best_yet = (gint64) this_len;
#line 1919 "../src/worm.vala"
					best_dir = direction;
#line 10625 "worm.c"
				}
			}
		}
#line 1890 "../src/worm.vala"
		direction_collection = (g_free (direction_collection), NULL);
#line 10631 "worm.c"
	}
#line 1924 "../src/worm.vala"
	worm_set_direction (self, best_dir);
#line 1826 "../src/worm.vala"
	_g_object_unref0 (worm_map);
#line 10637 "worm.c"
}

void
worm_get_starting_position (Worm* self,
                            Position * result)
{
	Position _tmp0_;
#line 1104 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1104 "../src/worm.vala"
	_tmp0_ = self->priv->_starting_position;
#line 1104 "../src/worm.vala"
	*result = _tmp0_;
#line 1104 "../src/worm.vala"
	return;
#line 10653 "worm.c"
}

static gboolean
_position_equal (const Position * s1,
                 const Position * s2)
{
#line 1104 "../src/worm.vala"
	if (s1 == s2) {
#line 1104 "../src/worm.vala"
		return TRUE;
#line 10664 "worm.c"
	}
#line 1104 "../src/worm.vala"
	if (s1 == NULL) {
#line 1104 "../src/worm.vala"
		return FALSE;
#line 10670 "worm.c"
	}
#line 1104 "../src/worm.vala"
	if (s2 == NULL) {
#line 1104 "../src/worm.vala"
		return FALSE;
#line 10676 "worm.c"
	}
#line 1104 "../src/worm.vala"
	if (s1->x != s2->x) {
#line 1104 "../src/worm.vala"
		return FALSE;
#line 10682 "worm.c"
	}
#line 1104 "../src/worm.vala"
	if (s1->y != s2->y) {
#line 1104 "../src/worm.vala"
		return FALSE;
#line 10688 "worm.c"
	}
#line 1104 "../src/worm.vala"
	return TRUE;
#line 10692 "worm.c"
}

static void
worm_set_starting_position (Worm* self,
                            Position * value)
{
	Position old_value;
#line 1104 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1104 "../src/worm.vala"
	worm_get_starting_position (self, &old_value);
#line 1104 "../src/worm.vala"
	if (_position_equal (value, &old_value) != TRUE) {
#line 10706 "worm.c"
		Position _tmp0_;
#line 1104 "../src/worm.vala"
		_tmp0_ = *value;
#line 1104 "../src/worm.vala"
		self->priv->_starting_position = _tmp0_;
#line 1104 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_STARTING_POSITION_PROPERTY]);
#line 10714 "worm.c"
	}
}

gint
worm_get_id (Worm* self)
{
	gint result;
#line 1106 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1106 "../src/worm.vala"
	result = self->priv->_id;
#line 1106 "../src/worm.vala"
	return result;
#line 10728 "worm.c"
}

static void
worm_set_id (Worm* self,
             gint value)
{
	gint old_value;
#line 1106 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1106 "../src/worm.vala"
	old_value = worm_get_id (self);
#line 1106 "../src/worm.vala"
	if (old_value != value) {
#line 1106 "../src/worm.vala"
		self->priv->_id = value;
#line 1106 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_ID_PROPERTY]);
#line 10746 "worm.c"
	}
}

gboolean
worm_get_is_materialized (Worm* self)
{
	gboolean result;
#line 1113 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1113 "../src/worm.vala"
	result = self->priv->rounds_to_stay_dematerialized <= 0;
#line 1113 "../src/worm.vala"
	return result;
#line 10760 "worm.c"
}

guint8
worm_get_lives (Worm* self)
{
	guint8 result;
#line 1115 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1115 "../src/worm.vala"
	result = self->priv->_lives;
#line 1115 "../src/worm.vala"
	return result;
#line 10773 "worm.c"
}

void
worm_set_lives (Worm* self,
                guint8 value)
{
	guint8 old_value;
#line 1115 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1115 "../src/worm.vala"
	old_value = worm_get_lives (self);
#line 1115 "../src/worm.vala"
	if (old_value != value) {
#line 1115 "../src/worm.vala"
		self->priv->_lives = value;
#line 1115 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_LIVES_PROPERTY]);
#line 10791 "worm.c"
	}
}

gint
worm_get_change (Worm* self)
{
	gint result;
#line 1116 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1116 "../src/worm.vala"
	result = self->priv->_change;
#line 1116 "../src/worm.vala"
	return result;
#line 10805 "worm.c"
}

void
worm_set_change (Worm* self,
                 gint value)
{
	gint old_value;
#line 1116 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1116 "../src/worm.vala"
	old_value = worm_get_change (self);
#line 1116 "../src/worm.vala"
	if (old_value != value) {
#line 1116 "../src/worm.vala"
		self->priv->_change = value;
#line 1116 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_CHANGE_PROPERTY]);
#line 10823 "worm.c"
	}
}

gint
worm_get_score (Worm* self)
{
	gint result;
#line 1117 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1117 "../src/worm.vala"
	result = self->priv->_score;
#line 1117 "../src/worm.vala"
	return result;
#line 10837 "worm.c"
}

void
worm_set_score (Worm* self,
                gint value)
{
	gint old_value;
#line 1117 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1117 "../src/worm.vala"
	old_value = worm_get_score (self);
#line 1117 "../src/worm.vala"
	if (old_value != value) {
#line 1117 "../src/worm.vala"
		self->priv->_score = value;
#line 1117 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_SCORE_PROPERTY]);
#line 10855 "worm.c"
	}
}

gint
worm_get_length (Worm* self)
{
	gint result;
	WormPositions* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 1121 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1121 "../src/worm.vala"
	_tmp0_ = self->list;
#line 1121 "../src/worm.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 1121 "../src/worm.vala"
	_tmp2_ = _tmp1_;
#line 1121 "../src/worm.vala"
	result = _tmp2_;
#line 1121 "../src/worm.vala"
	return result;
#line 10878 "worm.c"
}

void
worm_get_head (Worm* self,
               Position * result)
{
	Position head = {0};
	WormPositions* _tmp0_;
	Position _tmp1_ = {0};
	Position _tmp2_;
#line 1126 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1128 "../src/worm.vala"
	_tmp0_ = self->list;
#line 1128 "../src/worm.vala"
	worm_positions_get_head (_tmp0_, &_tmp1_);
#line 1128 "../src/worm.vala"
	head = _tmp1_;
#line 1129 "../src/worm.vala"
	_tmp2_ = head;
#line 1129 "../src/worm.vala"
	*result = _tmp2_;
#line 1129 "../src/worm.vala"
	return;
#line 10903 "worm.c"
}

static void
worm_set_head (Worm* self,
               Position * value)
{
	WormPositions* _tmp0_;
	Position _tmp1_;
#line 1131 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1133 "../src/worm.vala"
	_tmp0_ = self->list;
#line 1133 "../src/worm.vala"
	_tmp1_ = *value;
#line 1133 "../src/worm.vala"
	worm_positions_set_head (_tmp0_, &_tmp1_);
#line 1131 "../src/worm.vala"
	g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_HEAD_PROPERTY]);
#line 10922 "worm.c"
}

WormDirection
worm_get_direction (Worm* self)
{
	WormDirection result;
#line 1137 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1137 "../src/worm.vala"
	result = self->priv->_direction;
#line 1137 "../src/worm.vala"
	return result;
#line 10935 "worm.c"
}

static void
worm_set_direction (Worm* self,
                    WormDirection value)
{
	WormDirection old_value;
#line 1137 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1137 "../src/worm.vala"
	old_value = worm_get_direction (self);
#line 1137 "../src/worm.vala"
	if (old_value != value) {
#line 1137 "../src/worm.vala"
		self->priv->_direction = value;
#line 1137 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_DIRECTION_PROPERTY]);
#line 10953 "worm.c"
	}
}

static guint8
worm_get_width (Worm* self)
{
	guint8 result;
#line 1155 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1155 "../src/worm.vala"
	result = self->priv->_width;
#line 1155 "../src/worm.vala"
	return result;
#line 10967 "worm.c"
}

static void
worm_set_width (Worm* self,
                guint8 value)
{
	guint8 old_value;
#line 1155 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1155 "../src/worm.vala"
	old_value = worm_get_width (self);
#line 1155 "../src/worm.vala"
	if (old_value != value) {
#line 1155 "../src/worm.vala"
		self->priv->_width = value;
#line 1155 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_WIDTH_PROPERTY]);
#line 10985 "worm.c"
	}
}

static guint8
worm_get_height (Worm* self)
{
	guint8 result;
#line 1156 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1156 "../src/worm.vala"
	result = self->priv->_height;
#line 1156 "../src/worm.vala"
	return result;
#line 10999 "worm.c"
}

static void
worm_set_height (Worm* self,
                 guint8 value)
{
	guint8 old_value;
#line 1156 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1156 "../src/worm.vala"
	old_value = worm_get_height (self);
#line 1156 "../src/worm.vala"
	if (old_value != value) {
#line 1156 "../src/worm.vala"
		self->priv->_height = value;
#line 1156 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_HEIGHT_PROPERTY]);
#line 11017 "worm.c"
	}
}

static gint
worm_get_capacity (Worm* self)
{
	gint result;
#line 1157 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1157 "../src/worm.vala"
	result = self->priv->_capacity;
#line 1157 "../src/worm.vala"
	return result;
#line 11031 "worm.c"
}

static void
worm_set_capacity (Worm* self,
                   gint value)
{
	gint old_value;
#line 1157 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1157 "../src/worm.vala"
	old_value = worm_get_capacity (self);
#line 1157 "../src/worm.vala"
	if (old_value != value) {
#line 1157 "../src/worm.vala"
		self->priv->_capacity = value;
#line 1157 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_CAPACITY_PROPERTY]);
#line 11049 "worm.c"
	}
}

static GObject *
worm_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Worm * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint* _tmp2_;
#line 1159 "../src/worm.vala"
	parent_class = G_OBJECT_CLASS (worm_parent_class);
#line 1159 "../src/worm.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 1159 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM, Worm);
#line 1161 "../src/worm.vala"
	_tmp0_ = self->priv->_width;
#line 1161 "../src/worm.vala"
	_tmp1_ = self->priv->_height;
#line 1161 "../src/worm.vala"
	_tmp2_ = g_new0 (guint, _tmp0_ * _tmp1_);
#line 1161 "../src/worm.vala"
	worm_deadend_board = (g_free (worm_deadend_board), NULL);
#line 1161 "../src/worm.vala"
	worm_deadend_board = _tmp2_;
#line 1161 "../src/worm.vala"
	worm_deadend_board_length1 = _tmp0_;
#line 1161 "../src/worm.vala"
	worm_deadend_board_length2 = _tmp1_;
#line 1159 "../src/worm.vala"
	return obj;
#line 11086 "worm.c"
}

static void
worm_class_init (WormClass * klass,
                 gpointer klass_data)
{
#line 1096 "../src/worm.vala"
	worm_parent_class = g_type_class_peek_parent (klass);
#line 1096 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &Worm_private_offset);
#line 1096 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_worm_get_property;
#line 1096 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_worm_set_property;
#line 1096 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->constructor = worm_constructor;
#line 1096 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->finalize = worm_finalize;
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_STARTING_POSITION_PROPERTY, worm_properties[WORM_STARTING_POSITION_PROPERTY] = g_param_spec_boxed ("starting-position", "starting-position", "starting-position", TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_ID_PROPERTY, worm_properties[WORM_ID_PROPERTY] = g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_IS_MATERIALIZED_PROPERTY, worm_properties[WORM_IS_MATERIALIZED_PROPERTY] = g_param_spec_boolean ("is-materialized", "is-materialized", "is-materialized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LIVES_PROPERTY, worm_properties[WORM_LIVES_PROPERTY] = g_param_spec_uchar ("lives", "lives", "lives", 0, G_MAXUINT8, WORM_STARTING_LIVES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_CHANGE_PROPERTY, worm_properties[WORM_CHANGE_PROPERTY] = g_param_spec_int ("change", "change", "change", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_SCORE_PROPERTY, worm_properties[WORM_SCORE_PROPERTY] = g_param_spec_int ("score", "score", "score", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LENGTH_PROPERTY, worm_properties[WORM_LENGTH_PROPERTY] = g_param_spec_int ("length", "length", "length", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_HEAD_PROPERTY, worm_properties[WORM_HEAD_PROPERTY] = g_param_spec_boxed ("head", "head", "head", TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_DIRECTION_PROPERTY, worm_properties[WORM_DIRECTION_PROPERTY] = g_param_spec_enum ("direction", "direction", "direction", TYPE_WORM_DIRECTION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_WIDTH_PROPERTY, worm_properties[WORM_WIDTH_PROPERTY] = g_param_spec_uchar ("width", "width", "width", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_HEIGHT_PROPERTY, worm_properties[WORM_HEIGHT_PROPERTY] = g_param_spec_uchar ("height", "height", "height", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1096 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_CAPACITY_PROPERTY, worm_properties[WORM_CAPACITY_PROPERTY] = g_param_spec_int ("capacity", "capacity", "capacity", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1096 "../src/worm.vala"
	worm_signals[WORM_BONUS_FOUND_SIGNAL] = g_signal_new ("bonus-found", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 11131 "worm.c"
}

static void
worm_instance_init (Worm * self,
                    gpointer klass)
{
	GeeArrayQueue* _tmp0_;
	WormPositions* _tmp1_;
	GeeArrayList* _tmp2_;
#line 1096 "../src/worm.vala"
	self->priv = worm_get_instance_private (self);
#line 1109 "../src/worm.vala"
	self->keypress = FALSE;
#line 1111 "../src/worm.vala"
	self->is_stopped = FALSE;
#line 1115 "../src/worm.vala"
	self->priv->_lives = WORM_STARTING_LIVES;
#line 1116 "../src/worm.vala"
	self->priv->_change = 0;
#line 1117 "../src/worm.vala"
	self->priv->_score = 0;
#line 1141 "../src/worm.vala"
	_tmp0_ = gee_array_queue_new (TYPE_WORM_DIRECTION, NULL, NULL, NULL, NULL, NULL);
#line 1141 "../src/worm.vala"
	self->priv->key_queue = _tmp0_;
#line 1143 "../src/worm.vala"
	_tmp1_ = worm_positions_new ();
#line 1143 "../src/worm.vala"
	self->list = _tmp1_;
#line 1144 "../src/worm.vala"
	_tmp2_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
#line 1144 "../src/worm.vala"
	self->priv->bonus_eaten = _tmp2_;
#line 1447 "../src/worm.vala"
	self->priv->LastUturnA = FALSE;
#line 11167 "worm.c"
}

static void
worm_finalize (GObject * obj)
{
	Worm * self;
#line 1096 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM, Worm);
#line 1141 "../src/worm.vala"
	_g_object_unref0 (self->priv->key_queue);
#line 1143 "../src/worm.vala"
	_g_object_unref0 (self->list);
#line 1144 "../src/worm.vala"
	_g_object_unref0 (self->priv->bonus_eaten);
#line 1151 "../src/worm.vala"
	(self->priv->get_other_worms_target_destroy_notify == NULL) ? NULL : (self->priv->get_other_worms_target_destroy_notify (self->priv->get_other_worms_target), NULL);
#line 1151 "../src/worm.vala"
	self->priv->get_other_worms = NULL;
#line 1151 "../src/worm.vala"
	self->priv->get_other_worms_target = NULL;
#line 1151 "../src/worm.vala"
	self->priv->get_other_worms_target_destroy_notify = NULL;
#line 1153 "../src/worm.vala"
	(self->priv->get_bonuses_target_destroy_notify == NULL) ? NULL : (self->priv->get_bonuses_target_destroy_notify (self->priv->get_bonuses_target), NULL);
#line 1153 "../src/worm.vala"
	self->priv->get_bonuses = NULL;
#line 1153 "../src/worm.vala"
	self->priv->get_bonuses_target = NULL;
#line 1153 "../src/worm.vala"
	self->priv->get_bonuses_target_destroy_notify = NULL;
#line 1096 "../src/worm.vala"
	G_OBJECT_CLASS (worm_parent_class)->finalize (obj);
#line 11200 "worm.c"
}

 G_GNUC_NO_INLINE static GType
worm_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Worm), 0, (GInstanceInitFunc) worm_instance_init, NULL };
	GType worm_type_id;
	worm_type_id = g_type_register_static (G_TYPE_OBJECT, "Worm", &g_define_type_info, 0);
	Worm_private_offset = g_type_add_instance_private (worm_type_id, sizeof (WormPrivate));
	return worm_type_id;
}

GType
worm_get_type (void)
{
	static gsize worm_type_id__once = 0;
	if (g_once_init_enter (&worm_type_id__once)) {
		GType worm_type_id;
		worm_type_id = worm_get_type_once ();
		g_once_init_leave (&worm_type_id__once, worm_type_id);
	}
	return worm_type_id__once;
}

static void
_vala_worm_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM, Worm);
#line 1096 "../src/worm.vala"
	switch (property_id) {
#line 1096 "../src/worm.vala"
		case WORM_STARTING_POSITION_PROPERTY:
#line 11237 "worm.c"
		{
			Position boxed;
#line 1096 "../src/worm.vala"
			worm_get_starting_position (self, &boxed);
#line 1096 "../src/worm.vala"
			g_value_set_boxed (value, &boxed);
#line 11244 "worm.c"
		}
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_ID_PROPERTY:
#line 1096 "../src/worm.vala"
		g_value_set_int (value, worm_get_id (self));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_IS_MATERIALIZED_PROPERTY:
#line 1096 "../src/worm.vala"
		g_value_set_boolean (value, worm_get_is_materialized (self));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_LIVES_PROPERTY:
#line 1096 "../src/worm.vala"
		g_value_set_uchar (value, worm_get_lives (self));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_CHANGE_PROPERTY:
#line 1096 "../src/worm.vala"
		g_value_set_int (value, worm_get_change (self));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_SCORE_PROPERTY:
#line 1096 "../src/worm.vala"
		g_value_set_int (value, worm_get_score (self));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_LENGTH_PROPERTY:
#line 1096 "../src/worm.vala"
		g_value_set_int (value, worm_get_length (self));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_HEAD_PROPERTY:
#line 11286 "worm.c"
		{
			Position boxed;
#line 1096 "../src/worm.vala"
			worm_get_head (self, &boxed);
#line 1096 "../src/worm.vala"
			g_value_set_boxed (value, &boxed);
#line 11293 "worm.c"
		}
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_DIRECTION_PROPERTY:
#line 1096 "../src/worm.vala"
		g_value_set_enum (value, worm_get_direction (self));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_WIDTH_PROPERTY:
#line 1096 "../src/worm.vala"
		g_value_set_uchar (value, worm_get_width (self));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_HEIGHT_PROPERTY:
#line 1096 "../src/worm.vala"
		g_value_set_uchar (value, worm_get_height (self));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_CAPACITY_PROPERTY:
#line 1096 "../src/worm.vala"
		g_value_set_int (value, worm_get_capacity (self));
#line 1096 "../src/worm.vala"
		break;
#line 11321 "worm.c"
		default:
#line 1096 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1096 "../src/worm.vala"
		break;
#line 11327 "worm.c"
	}
}

static void
_vala_worm_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM, Worm);
#line 1096 "../src/worm.vala"
	switch (property_id) {
#line 1096 "../src/worm.vala"
		case WORM_STARTING_POSITION_PROPERTY:
#line 1096 "../src/worm.vala"
		worm_set_starting_position (self, g_value_get_boxed (value));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_ID_PROPERTY:
#line 1096 "../src/worm.vala"
		worm_set_id (self, g_value_get_int (value));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_LIVES_PROPERTY:
#line 1096 "../src/worm.vala"
		worm_set_lives (self, g_value_get_uchar (value));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_CHANGE_PROPERTY:
#line 1096 "../src/worm.vala"
		worm_set_change (self, g_value_get_int (value));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_SCORE_PROPERTY:
#line 1096 "../src/worm.vala"
		worm_set_score (self, g_value_get_int (value));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_HEAD_PROPERTY:
#line 1096 "../src/worm.vala"
		worm_set_head (self, g_value_get_boxed (value));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_DIRECTION_PROPERTY:
#line 1096 "../src/worm.vala"
		worm_set_direction (self, g_value_get_enum (value));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_WIDTH_PROPERTY:
#line 1096 "../src/worm.vala"
		worm_set_width (self, g_value_get_uchar (value));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_HEIGHT_PROPERTY:
#line 1096 "../src/worm.vala"
		worm_set_height (self, g_value_get_uchar (value));
#line 1096 "../src/worm.vala"
		break;
#line 1096 "../src/worm.vala"
		case WORM_CAPACITY_PROPERTY:
#line 1096 "../src/worm.vala"
		worm_set_capacity (self, g_value_get_int (value));
#line 1096 "../src/worm.vala"
		break;
#line 11401 "worm.c"
		default:
#line 1096 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1096 "../src/worm.vala"
		break;
#line 11407 "worm.c"
	}
}

